--RECONNECT "petshop";

USE "MSPetShop";

CREATE TABLE "Account" (
	"UserId" varchar(20) PRIMARY KEY,
	"Email" varchar(80) NOT NULL,
	"FirstName" varchar(80) NOT NULL,
	"LastName" varchar(80) NOT NULL,
	"Status" varchar(2) NULL,
	"Addr1" varchar(80) NOT NULL,
	"Addr2" varchar(80) NULL,
	"City" varchar(80) NOT NULL,
	"State" varchar(80) NOT NULL,
	"Zip" varchar(20) NOT NULL,
	"Country" varchar(20) NOT NULL,
	"Phone" varchar(20) NOT NULL
);

CREATE TABLE "BannerData" (
	"FavCategory" varchar(80) PRIMARY KEY,
	"BannerData" varchar(255) NULL
);

CREATE TABLE "Category" (
	"CatId" varchar(10) PRIMARY KEY,
	"Name" varchar(80) NULL,
	"Descn" varchar(255) NULL
);

CREATE TABLE "Inventory" (
	"ItemId" varchar(10) PRIMARY KEY,
	"Qty" int NOT NULL
);

CREATE TABLE "Product" (
	"ProductId" varchar(10) PRIMARY KEY,
	"Category" varchar(10) NOT NULL REFERENCES "Category"("CatId"),
	"Name" varchar(80) NULL,
	"Descn" varchar(255) NULL
);

CREATE TABLE "Profile" (
	"UserId" varchar(20) PRIMARY KEY,
	"LangPref" varchar(80) NOT NULL,
	"FavCategory" varchar(30) NULL,
	"MyListOpt" int NULL,
	"BannerOpt" int NULL
);

CREATE TABLE "SignOn" (
	"UserName" varchar(20) PRIMARY KEY,
	"Password" varchar(20) NOT NULL
);

CREATE TABLE "Supplier" (
	"SuppId" int PRIMARY KEY,
	"Name" varchar(80) NULL,
	"Status" varchar(2) NOT NULL,
	"Addr1" varchar(80) NULL,
	"Addr2" varchar(80) NULL,
	"City" varchar(80) NULL,
	"State" varchar(80) NULL,
	"Zip" varchar(5) NULL,
	"Phone" varchar(40) NULL
);

CREATE TABLE "Item" (
	"ItemId" varchar(10) PRIMARY KEY,
	"ProductId" varchar(10) NOT NULL REFERENCES "Product"("ProductId"),
	"ListPrice" decimal(10, 2) NULL,
	"UnitCost" decimal(10, 2) NULL,
	"Supplier" int NULL REFERENCES "Supplier"("SuppId"),
	"Status" varchar(2) NULL,
	"Attr1" varchar(80) NULL,
	"Attr2" varchar(80) NULL,
	"Attr3" varchar(80) NULL,
	"Attr4" varchar(80) NULL,
	"Attr5" varchar(80) NULL
);

CREATE INDEX "IxItem" ON "Item"("ProductId", "ItemId", "ListPrice", "Attr1");
CREATE INDEX "IxProduct1" ON "Product"("Name");
CREATE INDEX "IxProduct2" ON "Product"("Category");
CREATE INDEX "IxProduct3" ON "Product"("Category", "Name");
CREATE INDEX "IxProduct4" ON "Product"("Category", "ProductId", "Name");
