<%@ Page Language="c#" CodeBehind="ShoppingCart.aspx.cs" Inherits="PetShop.Web.ShoppingCart" EnableSessionState="true" EnableViewState="true" AutoEventWireup="false" %>
<%@ Register TagPrefix="Controls" Namespace="PetShop.Web.Controls" Assembly="PetShop.Web" %>
<html>
	<head>
		<title>Shopping Cart</title>
		<link rel="stylesheet" href="Styles.css">
	</head>
	<body>
		<table class="maxTable" cellpadding="0" cellspacing="0">
			<tr valign="top">
				<td>
					<controls:header id="header" runat="server" />
					<blockquote>
						<form id="frmCart" method="post" runat="server">
							<table cellpadding="0" cellspacing="0">
								<tr valign="top">
									<td class="cart">
										<span class="title">Shopping Cart</span><p>
										<controls:viewstatepager id="cart" runat="server" pagesize="4" emptytext="Your cart is empty." onpageindexchanged="CartPageChanged" onitemcommand="CommandClicked">
											<headertemplate>
												<table cellpadding="0" cellspacing="0">
													<tr class="gridHead">
														<td>&nbsp;</td>
														<td>Item ID</td>
														<td>Product</td>
														<td>In Stock</td>
														<td>Price</td>
														<td>Quantity</td>
														<td>Subtotal</td>
													</tr>
											</headertemplate>
											<itemtemplate>
												<tr class="gridItem">
													<td><asp:imagebutton id="btnRemove" runat="server" imageurl="Images/buttonRemove.gif" alternatetext="Remove" commandargument='<%# DataBinder.Eval(Container.DataItem, "Item.Id") %>' /></td>
													<td><%# DataBinder.Eval(Container.DataItem, "Item.Id") %></td>
													<td><a href="ItemDetails.aspx?itemId=<%# DataBinder.Eval(Container.DataItem, "Item.Id") %>"><%# DataBinder.Eval(Container.DataItem, "Item.ProductName") %></a></td>
													<td><%# DataBinder.Eval(Container.DataItem, "InStock") %></td>
													<td class="num"><%# DataBinder.Eval(Container.DataItem, "Item.Price", "{0:c}") %></td>
													<td><asp:textbox id="txtQty" runat="server" text='<%# DataBinder.Eval(Container.DataItem, "Quantity") %>' columns="3" maxlength="5" cssclass="num" /></td>
													<td class="num"><%# DataBinder.Eval(Container.DataItem, "Subtotal", "{0:c}") %></td>
												</tr>
											</itemtemplate>
											<footertemplate>
													<tr class="gridFoot">
														<td><asp:imagebutton id="btnUpdate" runat="server" imageurl="Images/buttonUpdate.gif" alternatetext="Update" commandname="update"/></td>
														<td class="num" colspan="6"><span class="label">Total:</span><%= Total.ToString("c") %></td>
													</tr>
												</table>
											</footertemplate>
										</controls:viewstatepager>
										<p><a id="link" runat="server" href="Checkout.aspx"><img src="Images/buttonCheckout.gif" alt="Proceed to Checkout"></a>
									</td>
									<td>
										<controls:viewstatepager id="favorites" runat="server" pagesize="3" onpageindexchanged="FavoritesPageChanged" visible="false">
											<headertemplate>
												<span class="title">Pet Favorites</span><p>
												<table cellpadding="0" cellspacing="0">
													<tr class="gridHead">
														<td>Shop for more of your favorite pets here.</td>
													</tr>
											</headertemplate>
											<itemtemplate>
												<tr class="gridItem">
													<td><a href="Items.aspx?productId=<%# DataBinder.Eval(Container.DataItem, "Id") %>"><%# DataBinder.Eval(Container.DataItem, "Name") %> (<%# DataBinder.Eval(Container.DataItem, "Id") %>)</a></td>
												</tr>
											</itemtemplate>
											<footertemplate>
												</table>
											</footertemplate>
										</controls:viewstatepager>
									</td>
								</tr>
							</table>
						</form>
					</blockquote>				
				</td>
			</tr>
			<tr valign="bottom">
				<td><controls:footer id="footer" runat="server" visible="false" /></td>
			</tr>
		</table>
	</body>
</html>