--  
--  $Id: tpcwdrop.sql,v 1.2 2006/08/16 07:58:09 source Exp $
--
--  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)
--  project.
--  
--  Copyright (C) 1998-2006 OpenLink Software
--  
--  This project is free software; you can redistribute it and/or modify it
--  under the terms of the GNU General Public License as published by the
--  Free Software Foundation; only version 2 of the License, dated June 1991.
--  
--  This program is distributed in the hope that it will be useful, but
--  WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
--  General Public License for more details.
--  
--  You should have received a copy of the GNU General Public License along
--  with this program; if not, write to the Free Software Foundation, Inc.,
--  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
--  
--  

create procedure EXEC_41000_I (in _expn varchar)
{
  declare _state, _message varchar;
  declare _retries integer;
  _state := '';
  _retries := 0;
  while(1)
    {
      exec (_expn, _state, _message);
      if (_state <> '41000')
	return;
      if (_retries > 10)
	signal ('41000', concat ('Continuous deadlocks in\n', _expn, '\n'));
      _retries := _retries+1;
    }
}
;

--  Foreign Key for the Reference ITEM
EXEC_41000_I('ALTER TABLE ITEM DROP CONSTRAINT ITEM_AUTHOR_FK');
EXEC_41000_I('ALTER TABLE ITEM DROP CONSTRAINT ITEM_RELATED1_FK');
EXEC_41000_I('ALTER TABLE ITEM DROP CONSTRAINT ITEM_RELATED2_FK');
EXEC_41000_I('ALTER TABLE ITEM DROP CONSTRAINT ITEM_RELATED3_FK');
EXEC_41000_I('ALTER TABLE ITEM DROP CONSTRAINT ITEM_RELATED4_FK');
EXEC_41000_I('ALTER TABLE ITEM DROP CONSTRAINT ITEM_RELATED5_FK');

--  Foreign Key for the Reference Customer
EXEC_41000_I('ALTER TABLE CUSTOMER DROP CONSTRAINT CUSTOMER_ADDRESS_FK');

--  Foreign Key for the Reference ORDERS
EXEC_41000_I('ALTER TABLE ORDERS DROP CONSTRAINT ORDER_CUSTOMER_FK');
EXEC_41000_I('ALTER TABLE ORDERS DROP CONSTRAINT ORDER_BILLADDRESS_FK');
EXEC_41000_I('ALTER TABLE ORDERS DROP CONSTRAINT ORDER_SHIPADDRESS_FK');


--  Foreign Key for the Reference ORDER_LINE
EXEC_41000_I('ALTER TABLE ORDER_LINE DROP CONSTRAINT ORDERLINE_ORDERS_FK');
EXEC_41000_I('ALTER TABLE ORDER_LINE DROP CONSTRAINT ORDERLINE_ITEM_FK');


--  Foreign Key for the Reference CC_XACTS (CreditCardTransaction)
EXEC_41000_I('ALTER TABLE CC_XACTS DROP CONSTRAINT CREDITCARDTRANSACTION_ORDERS_FK');
EXEC_41000_I('ALTER TABLE CC_XACTS DROP CONSTRAINT CREDITCARDTRANSACTION_COUNTRY_FK');


--  Foreign Key for the Reference ADDRESS
EXEC_41000_I('ALTER TABLE ADDRESS DROP CONSTRAINT ADDRESS_COUNTRY_FK');


--  Foreign Key for the Reference CART
EXEC_41000_I('ALTER TABLE CART DROP CONSTRAINT CART_CUSTOMER_FK');

--  Foreign Key for the Reference CART_ITEM
EXEC_41000_I('ALTER TABLE CART_ITEM DROP CONSTRAINT CARTITEM_CART_FK');
EXEC_41000_I('ALTER TABLE CART_ITEM DROP CONSTRAINT CARTITEM_ITEM_FK');

EXEC_41000_I('DROP INDEX ITEM_RELATED1_INDEX');
EXEC_41000_I('DROP INDEX ITEM_RELATED2_INDEX');
EXEC_41000_I('DROP INDEX ITEM_RELATED3_INDEX');
EXEC_41000_I('DROP INDEX ITEM_RELATED4_INDEX');
EXEC_41000_I('DROP INDEX ITEM_RELATED5_INDEX');
EXEC_41000_I('DROP TABLE ITEM');

EXEC_41000_I('DROP TABLE COUNTRY');

EXEC_41000_I('DROP TABLE AUTHOR');

EXEC_41000_I('DROP INDEX CUSTOMER_ADDRESS_INDEX');
EXEC_41000_I('DROP TABLE CUSTOMER');


EXEC_41000_I('DROP INDEX ORDER_CUSTOMER_INDEX');
EXEC_41000_I('DROP INDEX ORDERS_BILLADDRESS_INDEX');
EXEC_41000_I('DROP INDEX ORDERS_SHIPADDRESS_INDEX');
EXEC_41000_I('DROP TABLE ORDERS');


EXEC_41000_I('DROP INDEX ORDERLINE_ITEM_INDEX');
EXEC_41000_I('DROP INDEX ORDERLINE_ORDER_INDEX');
EXEC_41000_I('DROP TABLE ORDER_LINE');


EXEC_41000_I('DROP INDEX CREDITCARDTRANSACTION_COUNTRY_INDEX');
EXEC_41000_I('DROP TABLE CC_XACTS');


EXEC_41000_I('DROP INDEX ADDRESS_COUNTRY_INDEX');
EXEC_41000_I('DROP TABLE ADDRESS');


EXEC_41000_I('DROP INDEX CART_CUSTOMER_INDEX');
EXEC_41000_I('DROP TABLE CART');


EXEC_41000_I('DROP INDEX CARTITEM_ITEM_INDEX');
EXEC_41000_I('DROP INDEX CARTITEM_CART_INDEX');
EXEC_41000_I('DROP TABLE CART_ITEM');


