#include "sqlnode.h"
#include "sqlfn.h"
#include "sqltype.h"

/* vsp_auth.sql */

static const char *proc0 = 
"create procedure\n"
"islwsp (in ch integer)\n"
"{\n"
"if (32 = ch or 8 = ch)\n"
"{\n"
"return (1);\n"
"}\n"
"else\n"
"{\n"
"return (0);\n"
"}\n"
"}\n"
"--src vsp_auth.sql:47\n";

static const char *proc1 = 
"create procedure\n"
"issep (in ch integer)\n"
"{\n"
"if (islwsp(ch) or 44 = ch or 10 = ch or 13 = ch)\n"
"{\n"
"return (1);\n"
"}\n"
"else\n"
"{\n"
"return (0);\n"
"}\n"
"}\n"
"--src vsp_auth.sql:62\n";

static const char *proc2 = 
"create procedure\n"
"skip_lwsp (in str varchar, in pos integer, in len integer)\n"
"{\n"
"declare inx integer;\n"
"\n"
"inx := pos;\n"
"\n"
"while (inx < len and islwsp (aref (str, inx)))\n"
"{\n"
"inx := inx + 1;\n"
"}\n"
"return (inx);\n"
"}\n"
"--src vsp_auth.sql:77\n";

static const char *proc3 = 
"create procedure\n"
"skip_sep (in str varchar, in pos integer, in len integer)\n"
"{\n"
"declare inx integer;\n"
"declare c integer;\n"
"\n"
"inx := pos;\n"
"\n"
"while (inx < len and issep (aref (str, inx)))\n"
"{\n"
"inx := inx + 1;\n"
"}\n"
"\n"
"return (inx);\n"
"}\n"
"--src vsp_auth.sql:93\n";

static const char *proc4 = 
"create procedure\n"
"skip_quote (in str varchar, in pos integer, in len integer)\n"
"{\n"
"declare inx integer;\n"
"\n"
"inx := pos;\n"
"\n"
"while (inx < len and 34 <> aref (str, inx))\n"
"{\n"
"inx := inx + 1;\n"
"}\n"
"return (inx + 1);\n"
"}\n"
"--src vsp_auth.sql:111\n";

static const char *proc5 = 
"create procedure\n"
"vsp_auth_next_tok (in str varchar, inout pos integer, in len integer)\n"
"{\n"
"declare start, inx integer;\n"
"declare quote integer;\n"
"declare reading_val integer;\n"
"declare c integer;\n"
"\n"
"start := skip_sep (str, pos, len);\n"
"inx := start;\n"
"\n"
"reading_val := 0;\n"
"quote := 0;\n"
"\n"
"if (61 = aref (str, inx))\n"
"{\n"
"reading_val := 1;\n"
"inx := inx + 1;\n"
"}\n"
"\n"
"while (inx < len)\n"
"{\n"
"c := aref (str, inx);\n"
"\n"
"\n"
"\n"
"if (34 = c)\n"
"{\n"
"if (quote)\n"
"{\n"
"pos := inx + 1;\n"
"return (vector (\'value\', subseq (str, start, inx)));\n"
"}\n"
"else\n"
"{\n"
"quote := 1;\n"
"start := inx + 1;\n"
"goto cont;\n"
"}\n"
"}\n"
"if (not quote)\n"
"{\n"
"\n"
"\n"
"if (61 = c)\n"
"{\n"
"pos := inx + 1;\n"
"return (vector (\'name\', subseq (str, start, inx)));\n"
"}\n"
"if (issep (c))\n"
"{\n"
"pos := inx + 1;\n"
"if (reading_val)\n"
"{\n"
"return (vector (\'value\', subseq (str, start, inx)));\n"
"}\n"
"else\n"
"{\n"
"return (vector (\'single\', subseq (str, start, inx)));\n"
"}\n"
"}\n"
"}\n"
"cont:\n"
"\n"
"inx := inx + 1;\n"
"}\n"
"return (null);\n"
"}\n"
"--src vsp_auth.sql:135\n";

static const char *proc6 = 
"create procedure\n"
"vsp_auth_vec_compose (in str varchar, in meth varchar)\n"
"{\n"
"\n"
"declare reading_name varchar;\n"
"declare cred, authtype, vec varchar;\n"
"declare i, start, pos, len integer;\n"
"\n"
"declare tok varchar;\n"
"\n"
"len := length (str);\n"
"pos := strcasestr (str, \'Authorization:\')+14;\n"
"\n"
"tok := vsp_auth_next_tok (str, pos, len);\n"
"\n"
"if (aref (tok, 0) <> \'single\')\n"
"return (null);\n"
"\n"
"authtype := aref(tok, 1);\n"
"\n"
"if (\'basic\' = lcase (authtype))\n"
"{\n"
"\n"
"declare start_pos integer;\n"
"pos := skip_sep (str, pos, len);\n"
"start_pos := pos;\n"
"while (0 = issep (aref (str, pos)))\n"
"{\n"
"pos := pos + 1;\n"
"}\n"
"tok := sprintf (\'%s\', decode_base64 (subseq (str, start_pos, pos)));\n"
"if (length (tok) < 2)\n"
"return (0);\n"
"i := strchr(tok, \':\');\n"
"return (vector (\'authtype\', \'basic\',\n"
"\'username\', \"LEFT\" (tok, i),\n"
"\'pass\', \"RIGHT\" (tok, length (tok) - 1 - i)));\n"
"}\n"
"\n"
"vec := make_array (26,\'any\');\n"
"\n"
"aset (vec, 0, \'method\');\n"
"aset (vec, 1, meth);\n"
"aset (vec, 2, \'authtype\');\n"
"aset (vec, 3, authtype);\n"
"\n"
"i := 4;\n"
"\n"
"while (1)\n"
"{\n"
"tok := vsp_auth_next_tok (str, pos, len);\n"
"\n"
"if (tok is null)\n"
"return (vec);\n"
"\n"
"\n"
"aset (vec, i, aref(tok, 1));\n"
"\n"
"i := i + 1;\n"
"}\n"
"}\n"
"--src vsp_auth.sql:206\n";

static const char *proc7 = 
" create procedure\n"
"vsp_auth_vec (in lines varchar)\n"
"{\n"
"\n"
"declare line varchar;\n"
"declare nlines integer;\n"
"declare inx integer;\n"
"declare pos, len integer;\n"
"declare meth varchar;\n"
"\n"
"inx := 0;\n"
"nlines := length (lines);\n"
"\n"
"\n"
"\n"
"\n"
"pos := 0;\n"
"len := length (aref (lines, 0));\n"
"meth := (aref (vsp_auth_next_tok (aref (lines, 0), pos, len), 1));\n"
"\n"
"while (inx < nlines)\n"
"{\n"
"line := aref (lines, inx);\n"
"\n"
"if (strcasestr (line, \'Authorization:\') is not null)\n"
"return (vsp_auth_vec_compose (line, meth));\n"
"inx := inx + 1;\n"
"}\n"
"return (0);\n"
"}\n"
"--src vsp_auth.sql:271\n";

static const char *proc8 = 
"create procedure\n"
"vsp_ua_skip_lwsp (inout str varchar)\n"
"{\n"
"return (subseq (str, skip_lwsp (str, 0, length (str)), length (str)));\n"
"}\n"
"--src vsp_auth.sql:303\n";

static const char *proc9 = 
"create procedure\n"
"vsp_ua_match_hdr (inout lines any, in match_str varchar)\n"
"{\n"
"declare idx, len integer;\n"
"declare line varchar;\n"
"\n"
"idx := 0;\n"
"len := length (lines);\n"
"\n"
"while (idx < len)\n"
"{\n"
"line := aref (lines, idx);\n"
"if (matches_like (line, match_str))\n"
"return (vsp_ua_skip_lwsp (aref (split_and_decode (line, 0, \'=_\\n:\'), 1)));\n"
"inc (idx);\n"
"}\n"
"return \'\';\n"
"}\n"
"--src vsp_auth.sql:311\n";

static const char *proc10 = 
"create procedure\n"
"vsp_ua_prop_init ()\n"
"{\n"
"\n"
"return (vector (\'has_basic_auth\', \'has_digest_auth\',\n"
"\'is_msie\', \'has_frames\',\n"
"\'has_tables\', \'has_css1\',\n"
"\'has_css2\', \'has_xml\',\n"
"\'browser_level\', \'ua_platform\',\n"
"\'is_robot\', \'is_dav_client\'));\n"
"}\n"
"--src vsp_auth.sql:333\n";

static const char *proc11 = 
" create procedure\n"
"vsp_calculate_digest (in username varchar, in pass varchar, in auth_vec any)\n"
"{\n"
"declare A1, A2, gen_resp varchar;\n"
"declare auth_type varchar;\n"
"\n"
"if (not isarray (auth_vec))\n"
"return null;\n"
"\n"
"auth_type := lower (get_keyword (\'authtype\', auth_vec, \'\'));\n"
"\n"
"gen_resp := null;\n"
"\n"
"if (\'digest\' = auth_type)\n"
"{\n"
"A1 := sprintf (\'%s:%s:%s\', username, get_keyword (\'realm\', auth_vec, \'\'), pass);\n"
"A1 := md5 (A1);\n"
"\n"
"A2 := sprintf (\'%s:%s\', get_keyword(\'method\', auth_vec), get_keyword (\'uri\', auth_vec, \'\'));\n"
"\n"
"A2 := md5 (A2);\n"
"\n"
"gen_resp := sprintf (\'%s:%s:%s:%s:%s:%s\', A1, get_keyword (\'nonce\', auth_vec, \'\'),\n"
"get_keyword (\'nc\', auth_vec, \'\'),\n"
"get_keyword (\'cnonce\', auth_vec, \'\'),\n"
"get_keyword (\'qop\', auth_vec, \'\'), A2);\n"
"\n"
"gen_resp := md5 (gen_resp);\n"
"}\n"
"return gen_resp;\n"
"}\n"
"--src vsp_auth.sql:347\n";

static const char *proc12 = 
"create procedure\n"
"vsp_ua_vec_init ()\n"
"{\n"
"return (vector (\n"
"\'Mozilla/4*(compatible; MSIE 6*Windows*\',\n"
"vector (\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'True\',\n"
"6, \'Win32\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/4*(compatible; MSIE 5*Windows*\',\n"
"vector (\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'True\',\n"
"5, \'Win32\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/4*(compatible; MSIE 4*Windows*\',\n"
"vector (\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"4, \'Win32\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/4*(compatible; MSIE 6*Linux*Opera [7-9]*\',\n"
"vector (\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"4, \'Linux\',\n"
"\'False\', \'False\'),\n"
"\'*(compatible; MSIE*\',\n"
"vector (\'False\', \'False\',\n"
"\'True\', \'False\',\n"
"\'True\', \'False\',\n"
"\'False\', \'False\',\n"
"2, \'Win32\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/4.*Windows*\',\n"
"vector (\'True\', \'False\',\n"
"\'False\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"4, \'Win32\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/5.*Windows*\',\n"
"vector (\'True\', \'False\',\n"
"\'False\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'True\',\n"
"5, \'Win32\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/4.*Linux*\',\n"
"vector (\'True\', \'False\',\n"
"\'False\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"4, \'Linux\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/5.*Linux*\',\n"
"vector (\'True\', \'False\',\n"
"\'False\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'True\',\n"
"5, \'Linux\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/4.*Macintosh*\',\n"
"vector (\'True\', \'False\',\n"
"\'False\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"4, \'Mac\',\n"
"\'False\', \'False\'),\n"
"\'Mozilla/5.*Macintosh*\',\n"
"vector (\'True\', \'False\',\n"
"\'False\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'True\',\n"
"5, \'Mac\',\n"
"\'False\', \'False\'),\n"
"\'Lynx/2*\',\n"
"vector (\'True\', \'False\',\n"
"\'False\', \'True\',\n"
"\'True\', \'False\',\n"
"\'False\', \'False\',\n"
"2, \'NA\',\n"
"\'False\', \'False\'),\n"
"\'Microsoft Data Access Internet Publishing Provider DAV*\',\n"
"vector (\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"\'False\', \'False\',\n"
"\'False\', \'False\',\n"
"0, \'Win32\',\n"
"\'False\', \'True\'),\n"
"\'cadaver/*\',\n"
"vector (\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"\'False\', \'False\',\n"
"\'False\', \'False\',\n"
"0, \'NA\',\n"
"\'False\', \'True\'),\n"
"\'Opera/4*\',\n"
"vector (\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'True\', \'True\',\n"
"\'False\', \'False\',\n"
"4, \'Linux\',\n"
"\'False\', \'False\'),\n"
"\'*\',\n"
"vector (\'False\', \'False\',\n"
"\'False\', \'False\',\n"
"\'False\', \'False\',\n"
"\'False\', \'False\',\n"
"1, \'NA\',\n"
"\'False\', \'False\')));\n"
"}\n"
"--src vsp_auth.sql:380\n";

static const char *proc13 = 
"create procedure\n"
"vsp_ua_get_prop (in prop_name varchar, inout ua_id varchar, inout prop_map any, inout ua_vec any)\n"
"{\n"
"\n"
"\n"
"declare idx, prop_idx integer;\n"
"declare ua_vec_len integer;\n"
"\n"
"\n"
"ua_vec_len := length (ua_vec);\n"
"prop_idx := 0;\n"
"\n"
"while (prop_idx <= length (prop_map) and aref (prop_map, prop_idx) <> prop_name)\n"
"{\n"
"inc (prop_idx);\n"
"}\n"
"\n"
"return (aref (vsp_ua_get_prop_list (ua_id, prop_map, ua_vec), prop_idx));\n"
"}\n"
"--src vsp_auth.sql:504\n";

static const char *proc14 = 
" create procedure\n"
"vsp_ua_get_props (in prop_name varchar, in lines any)\n"
"{\n"
"return vsp_ua_get_prop (prop_name, vsp_ua_id (lines), vsp_ua_prop_init (), vsp_ua_vec_init ());\n"
"}\n"
"--src vsp_auth.sql:527\n";

static const char *proc15 = 
"create procedure\n"
"vsp_ua_get_prop_list (inout ua_id varchar, inout prop_map any, inout ua_vec any)\n"
"{\n"
"\n"
"declare idx, prop_idx integer;\n"
"declare ua_vec_len integer;\n"
"\n"
"ua_vec_len := length (ua_vec);\n"
"idx := 0;\n"
"\n"
"while (idx < ua_vec_len)\n"
"{\n"
"\n"
"if (matches_like (ua_id, aref (ua_vec, idx)))\n"
"{\n"
"\n"
"return (aref (ua_vec, idx + 1));\n"
"}\n"
"idx := idx + 2;\n"
"}\n"
"}\n"
"--src vsp_auth.sql:539\n";

static const char *proc16 = 
"create procedure\n"
"inc (inout i integer)\n"
"{\n"
"i := i + 1;\n"
"}\n"
"--src vsp_auth.sql:563\n";

static const char *proc17 = 
"create procedure\n"
"vsp_ua_prop_tbl (inout prop_list any, inout prop_map any)\n"
"{\n"
"\n"
"declare idx, len integer;\n"
"len := length (prop_map);\n"
"idx := 0;\n"
"\n"
"\n"
"\n"
"\n"
"http (\'<table border=\"1\">\');\n"
"while (idx < len)\n"
"{\n"
"http (\'<tr><td>\');\n"
"http (aref (prop_map, idx));\n"
"http (\'</td><td>\');\n"
"http (cast (aref (prop_list, idx) as varchar));\n"
"http (\'</td></tr>\');\n"
"inc (idx);\n"
"}\n"
"http (\'</table>\');\n"
"}\n"
"--src vsp_auth.sql:571\n";

static const char *proc18 = 
"create procedure\n"
"vsp_ua_id (in lines any)\n"
"{\n"
"return (vsp_ua_match_hdr (lines, \'%[Uu]ser-[Aa]gent: %\'));\n"
"}\n"
"--src vsp_auth.sql:597\n";

static const char *proc19 = 
"create procedure\n"
"vsp_ua_match_hdr_1 (inout lines any, in match_str varchar)\n"
"{\n"
"declare idx, jdx, len integer;\n"
"declare line varchar;\n"
"declare dbg integer;\n"
"\n"
"idx := 0;\n"
"len := length (lines);\n"
"jdx := 0;\n"
"\n"
"while (idx < len)\n"
"{\n"
"line := aref (lines, idx);\n"
"if (matches_like (line, match_str))\n"
"{\n"
"\n"
"len := length (line);\n"
"vsp_ua_next_tok (line, \':\', jdx);\n"
"inc (jdx);\n"
"return (subseq (line, skip_lwsp (line, jdx, len), len));\n"
"}\n"
"inc (idx);\n"
"}\n"
"return (null);\n"
"}\n"
"--src vsp_auth.sql:609\n";

static const char *proc20 = 
"create procedure\n"
"vsp_ua_get_cookie_str (in lines any)\n"
"{\n"
"return (vsp_ua_match_hdr_1 (lines, \'%[Cc]ookie:%\'));\n"
"}\n"
"--src vsp_auth.sql:638\n";

static const char *proc21 = 
"create procedure\n"
"vsp_ua_next_cookie (in cook_str varchar, inout inx integer)\n"
"{\n"
"return vector();\n"
"}\n"
"--src vsp_auth.sql:650\n";

static const char *proc22 = 
" create procedure\n"
"vsp_ua_set_cookie (in cook_str varchar)\n"
"{\n"
"http_header (concat (http_header_get (),\n"
"cook_str));\n"
"}\n"
"--src vsp_auth.sql:663\n";

static const char *proc23 = 
"create procedure\n"
"vsp_ua_app_cookie (in cook_str varchar,\n"
"in name varchar,\n"
"in value varchar,\n"
"in domain varchar,\n"
"in path varchar,\n"
"in expires varchar,\n"
"in secure varchar) returns varchar\n"
"{\n"
"declare tmp varchar;\n"
"\n"
"tmp := concat (cook_str, \', \',\n"
"name, \'=\', value, \';\');\n"
"if (\'\' <> expires)\n"
"tmp := concat (tmp, \',expires=\', expires);\n"
"\n"
"if (\'\' <> domain)\n"
"tmp := concat (tmp, \',domain=\', domain);\n"
"\n"
"if (\'\' <> path)\n"
"tmp := concat (tmp, \',path=\', path);\n"
"\n"
"if (\'\' <> secure)\n"
"tmp := concat (tmp, \' secure\');\n"
"\n"
"return (tmp);\n"
"}\n"
"--src vsp_auth.sql:672\n";

static const char *proc24 = 
" create procedure\n"
"vsp_auth_get (in realm varchar, in domain varchar,\n"
"in nonce varchar, in opaque varchar,\n"
"in stale varchar, inout lines any, in allow_basic integer)\n"
"{\n"
"\n"
"declare hdr varchar;\n"
"declare ua_id varchar;\n"
"declare foo varchar;\n"
"declare require_encrypted integer;\n"
"\n"
"ua_id := vsp_ua_id (lines);\n"
"\n"
"http_request_status (\'HTTP/1.1 401 Unauthorized\');\n"
"require_encrypted := sys_stat (\'sql_encryption_on_password\');\n"
"if (require_encrypted = 1 or require_encrypted = 2)\n"
"require_encrypted := 0;\n"
"else\n"
"require_encrypted := 1;\n"
"\n"
"if (require_encrypted and (\'True\' = vsp_ua_get_prop (\'has_digest_auth\',\n"
"ua_id, vsp_ua_prop_init (),\n"
"vsp_ua_vec_init ()) or 0 = allow_basic))\n"
"{\n"
"\n"
"hdr := sprintf (\'WWW-Authenticate: Digest realm=\"%s\", domain=\"%s\", nonce=\"%s\", opaque=\"%s\", stale=\"%s\", qop=\"auth\", algorithm=\"MD5\"\\r\\n\',\n"
"coalesce (realm, \'\'),\n"
"coalesce (domain, \'\'),\n"
"coalesce (nonce, \'\'),\n"
"coalesce (opaque, \'\'),\n"
"coalesce (stale, \'\'));\n"
"\n"
"http_header(concat (coalesce (http_header_get (), \'\'), hdr));\n"
"return 0;\n"
"}\n"
"hdr := sprintf (\'WWW-Authenticate: Basic realm=\"%s\"\\r\\n\', coalesce (realm, \'\'));\n"
"http_header (concat (coalesce (http_header_get (), \'\'), hdr));\n"
"return 0;\n"
"}\n"
"--src vsp_auth.sql:703\n";

static const char *proc25 = 
" create procedure\n"
"vsp_auth_verify_pass (in auth_vec varchar,\n"
"in username varchar,\n"
"in realm varchar,\n"
"in uri varchar,\n"
"in nonce varchar,\n"
"in nc varchar,\n"
"in cnonce varchar,\n"
"in qop varchar,\n"
"in pass varchar)\n"
"\n"
"{\n"
"\n"
"return http_auth_verify (auth_vec, username, realm, uri, nonce, nc, cnonce, qop, pass);\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"}\n"
"--src vsp_auth.sql:750\n";

static const char *proc26 = 
"create procedure\n"
"vsp_ua_next_tok (in str varchar, in sep varchar, inout inx integer)\n"
"{\n"
"declare len integer;\n"
"declare tok_st integer;\n"
"\n"
"len := length (str);\n"
"\n"
"while (not isnull (strchr (sep, aref (str, inx))))\n"
"{\n"
"if (inx = len)\n"
"return (NULL);\n"
"\n"
"inx := inx + 1;\n"
"}\n"
"\n"
"tok_st := inx;\n"
"\n"
"while (isnull (strchr (sep, aref (str, inx))))\n"
"{\n"
"inx := inx + 1;\n"
"}\n"
"return subseq (str, tok_st, inx);\n"
"}\n"
"--src vsp_auth.sql:816\n";

static const char *proc27 = 
" create procedure\n"
"vsp_ua_get_cookie_vec (in lines any)\n"
"{\n"
"declare cook_vec any;\n"
"declare cook_str varchar;\n"
"declare inx integer;\n"
"declare tok varchar;\n"
"\n"
"inx := 0;\n"
"cook_vec := vector ();\n"
"\n"
"\n"
"cook_str := vsp_ua_get_cookie_str (lines);\n"
"\n"
"\n"
"\n"
"if (cook_str is null)\n"
"return (vector ());\n"
"\n"
"while (1)\n"
"{\n"
"tok := vsp_ua_next_tok (cook_str, \' \\t=;\\r\\n\', inx);\n"
"\n"
"if (tok is null)\n"
"goto nd;\n"
"cook_vec := vector_concat (cook_vec, vector (tok));\n"
"}\n"
"nd:\n"
"if (0 <> mod (length (cook_vec), 2))\n"
"return (vector ());\n"
"return (cook_vec);\n"
"}\n"
"--src vsp_auth.sql:844\n";

static const char *proc28 = 
" create procedure\n"
"vsp_ua_make_cookie (in name varchar,\n"
"in value varchar,\n"
"in expires datetime,\n"
"in domain varchar,\n"
"in path varchar,\n"
"in secure integer)\n"
"{\n"
"declare tmp varchar;\n"
"\n"
"tmp := concat (\'Set-cookie: \', name, \'=\', value, \'\');\n"
"\n"
"if (expires is not null)\n"
"{\n"
"tmp := concat (tmp, \'; expires=\', soap_print_box (expires, \'\', 1),\'\');\n"
"}\n"
"if (\'\' <> domain)\n"
"tmp := concat (tmp, \'; domain=\', domain, \'\');\n"
"\n"
"if (\'\' <> path)\n"
"tmp := concat (tmp, \'; path=\', path,\'\');\n"
"\n"
"if (0 <> secure)\n"
"tmp := concat (tmp, \' secure\');\n"
"\n"
"\n"
"\n"
"tmp := concat (tmp, \'\\r\\n\');\n"
"return (tmp);\n"
"}\n"
"--src vsp_auth.sql:879\n";

/* snapshot_repl.sql */

static const char *tbl0 = 
"create table SYS_SNAPSHOT (\n"
"SN_NAME varchar(255) NOT NULL,\n"
"SN_QUERY varchar(1024) NOT NULL,\n"
"SN_LAST_TS datetime,\n"
"SN_IS_INCREMENTAL integer,\n"
"SN_SOURCE_TABLE varchar(255),\n"
"SN_LAST_UPD_BM varchar,\n"
"primary key (SN_NAME)\n"
")\n";

static const char *alter0 = 
"alter table SYS_SNAPSHOT add SN_LAST_UPD_BM varchar\n";

static const char *tbl1 = 
"create table SYS_SNAPSHOT_LOG (\n"
"SNL_SOURCE	varchar (320) NOT NULL,\n"
"SNL_RLOG	varchar (320) NOT NULL,\n"
"SNL_RPLOG	varchar (320) NOT NULL,\n"
"primary key (SNL_SOURCE)\n"
")\n"
"create unique index SNL_RLOG on DB.DBA.SYS_SNAPSHOT_LOG (SNL_RLOG)\n"
"create unique index SNL_RPLOG on DB.DBA.SYS_SNAPSHOT_LOG (SNL_RPLOG)\n";

static const char *proc29 = 
"create procedure repl_undot_name (in id varchar)\n"
"{\n"
"declare last_dot_inx integer;\n"
"last_dot_inx := strrchr(id, \'.\');\n"
"if (last_dot_inx > 0)\n"
"return subseq(sprintf(\'%s\', id), last_dot_inx + 1);\n"
"else\n"
"return id;\n"
"}\n"
"--src snapshot_repl.sql:51\n";

static const char *proc30 = 
"create procedure REPL_OFFSET_TIME (\n"
"in _last_ts datetime, in _reg_var varchar, in _default_offset integer)\n"
"returns datetime\n"
"{\n"
"if (_last_ts is null)\n"
"return null;\n"
"\n"
"declare v any;\n"
"v := registry_get (_reg_var);\n"
"declare n integer;\n"
"if (v = 0 or (n := atoi(v)) = 0)\n"
"n := _default_offset;\n"
"\n"
"declare _starttime datetime;\n"
"_starttime := dateadd (\'minute\', -n, _last_ts);\n"
"\n"
"return _starttime;\n"
"}\n"
"--src snapshot_repl.sql:63\n";

static const char *proc31 = 
"create procedure REPL_FQNAME (in _tbl varchar)\n"
"{\n"
"declare _parts any;\n"
"_parts := vector (\'\', \'\', \'\');\n"
"declare _ix, _len integer;\n"
"_ix := 0;\n"
"_len := length (_parts);\n"
"while (_ix < _len)\n"
"{\n"
"declare _p any;\n"
"_p := name_part (_tbl, _ix);\n"
"if (_p <> 0)\n"
"_parts[_ix] := sprintf (\'\"%I\"\', _p);\n"
"_ix := _ix + 1;\n"
"}\n"
"return concat (_parts[0], \'.\', _parts[1], \'.\', _parts[2]);\n"
"}\n"
"--src snapshot_repl.sql:85\n";

static const char *proc32 = 
"create procedure REPL_ORIGIN (in _rowguid varchar)\n"
"{\n"
"declare _delim_pos integer;\n"
"\n"
"_delim_pos := strchr (_rowguid, \'@\');\n"
"if (_delim_pos is not null)\n"
"return substring (_rowguid, 1, _delim_pos);\n"
"return null;\n"
"}\n"
"--src snapshot_repl.sql:104\n";

static const char *proc33 = 
"create procedure REPL_SET_ORIGIN (\n"
"in _rowguid varchar, in _origin varchar := null)\n"
"{\n"
"if (_origin is null)\n"
"_origin := repl_this_server();\n"
"\n"
"declare _delim_pos integer;\n"
"_delim_pos := strchr (_rowguid, \'@\');\n"
"if (_delim_pos is not null)\n"
"_rowguid := subseq (_rowguid, _delim_pos + 1);\n"
"return concat (_origin, \'@\', _rowguid);\n"
"}\n"
"--src snapshot_repl.sql:115\n";

static const char *tbl2 = 
"create table DB.DBA.SYS_SNAPSHOT_PUB (\n"
"SP_ITEM varchar,\n"
"SP_TYPE integer,\n"
"SP_LAST_TS datetime,\n"
"\n"
"primary key (SP_ITEM, SP_TYPE)\n"
")\n";

static const char *other0 = 
"grant select on DB.DBA.SYS_SNAPSHOT_PUB to PUBLIC\n";
static const char *tbl3 = 
"create table DB.DBA.SYS_SNAPSHOT_SUB (\n"
"SS_SERVER varchar,\n"
"SS_ITEM varchar,\n"
"SS_TYPE integer,\n"
"SS_LAST_PULL_TS datetime,\n"
"SS_LAST_PUSH_TS datetime,\n"
"\n"
"primary key (SS_SERVER, SS_ITEM, SS_TYPE)\n"
")\n";

static const char *other1 = 
"grant select on DB.DBA.SYS_SNAPSHOT_SUB to PUBLIC\n";
static const char *tbl4 = 
"create table DB.DBA.SYS_SNAPSHOT_CR (\n"
"CR_ID         integer,\n"
"CR_TABLE_NAME varchar,\n"
"CR_TYPE       char,\n"
"CR_PROC       varchar,\n"
"CR_ORDER      integer,\n"
"\n"
"primary key (CR_ID)\n"
")\n";

static const char *other2 = 
"grant select on DB.DBA.SYS_SNAPSHOT_CR to PUBLIC\n";
static const char *tbl5 = 
"create table DB.DBA.SYS_DAV_CR (\n"
"CR_ID         integer,\n"
"CR_COL_NAME   varchar,\n"
"CR_PROC       varchar,\n"
"CR_ORDER      integer,\n"
"\n"
"primary key (CR_ID)\n"
")\n";

static const char *other3 = 
"grant select on DB.DBA.SYS_DAV_CR to PUBLIC\n";
static const char *tbl6 = 
"create table DB.DBA.SYS_REPL_POSTPONED_RES (\n"
"POSTPONED_RES_ID integer identity primary key,\n"
"POSTPONED_RES_TS timestamp,\n"
"\n"
"LOCKED_COL_ID integer,\n"
"LOCKED_RES_ID integer,\n"
"\n"
"RES_COLPATH varchar,\n"
"RES_NAME varchar,\n"
"RES_CONTENT long varbinary,\n"
"RES_TYPE varchar,\n"
"RES_PERMS varchar,\n"
"RES_UNAME varchar,\n"
"RES_GNAME varchar,\n"
"RES_CR_TIME datetime,\n"
"RES_MOD_TIME datetime,\n"
"RES_ROWGUID varchar,\n"
"\n"
"RES_CR_COLNAME varchar,\n"
"\n"
"RES_EMAIL varchar,\n"
"RES_ORIGIN varchar,\n"
"RES_OLD_ROWGUID varchar)\n"
"create index SYS_REPL_POSTPONED_LOCKED_COL_ID on DB.DBA.SYS_REPL_POSTPONED_RES (LOCKED_COL_ID)\n"
"create index SYS_REPL_POSTPONED_LOCKED_RES_ID on DB.DBA.SYS_REPL_POSTPONED_RES (LOCKED_RES_ID)\n";

static const char *proc34 = 
"create procedure REPL_COLTYPE_PS (\n"
"in _coltype varchar,\n"
"in _col_dtp integer, in _col_prec integer, in _col_scale integer)\n"
"returns varchar\n"
"{\n"
"if ((_col_dtp = 181 or _col_dtp = 182 or _col_dtp = 192 or\n"
"_col_dtp = 222 or _col_dtp = 225)\n"
"and _col_prec is not null and _col_prec <> 0)\n"
"{\n"
"\n"
"declare _pos integer;\n"
"declare _len_spec varchar;\n"
"_pos := strstr (_coltype, \'()\');\n"
"_len_spec := sprintf (\'(%d)\', _col_prec);\n"
"if (_pos is null)\n"
"_coltype := concat (_coltype, _len_spec);\n"
"else\n"
"{\n"
"declare _prefix, _suffix varchar;\n"
"_prefix := subseq (_coltype, 0, _pos);\n"
"_suffix := subseq (_coltype, _pos + 2);\n"
"_coltype := concat (_prefix, _len_spec, _suffix);\n"
"}\n"
"}\n"
"else if (_col_dtp = 219)\n"
"{\n"
"\n"
"if (_col_prec < _col_scale)\n"
"_col_scale := 0;\n"
"_coltype := concat (_coltype, sprintf(\'(%d, %d)\', _col_prec, _col_scale));\n"
"}\n"
"return _coltype;\n"
"}\n"
"--src snapshot_repl.sql:240\n";

static const char *proc35 = 
"create procedure REPL_COLTYPE (in _col any) returns varchar\n"
"{\n"
"declare _col_dtp, _col_prec, _col_scale integer;\n"
"_col_dtp := aref (_col, 1);\n"
"_col_scale := aref (_col, 2);\n"
"_col_prec := aref (_col, 3);\n"
"\n"
"if (_col_dtp = 219)\n"
"{\n"
"if (_col_scale > 15)\n"
"_col_scale := 15;\n"
"if (_col_prec > 40)\n"
"_col_prec := 40;\n"
"}\n"
"return REPL_COLTYPE_PS (\n"
"dv_type_title(_col_dtp), _col_dtp, _col_prec, _col_scale);\n"
"}\n"
"--src snapshot_repl.sql:275\n";

static const char *proc36 = 
"create procedure REPL_REMOTE_TYPES_RAW (in _dsn varchar)\n"
"returns any\n"
"{\n"
"declare _remote_types, _remote_types_info any;\n"
"_remote_types := vector ();\n"
"_remote_types_info := sql_gettypeinfo (_dsn);\n"
"\n"
"declare _type_info any;\n"
"declare _sql_dtp integer;\n"
"declare _type_title varchar;\n"
"declare _idx, _len integer;\n"
"_idx := 0;\n"
"_len := length (_remote_types_info);\n"
"while (_idx < _len)\n"
"{\n"
"_type_info := _remote_types_info[_idx];\n"
"_sql_dtp := _type_info[1];\n"
"_type_title := _type_info[0];\n"
"REPL_ENSURE_MAPPING (_remote_types, _type_info[1], _type_info[0], _type_info);\n"
"_idx := _idx + 1;\n"
"}\n"
"return _remote_types;\n"
"}\n"
"--src snapshot_repl.sql:298\n";

static const char *proc37 = 
"create procedure REPL_REMOTE_TYPES (\n"
"in _dsn varchar, in _dbms_name varchar := null)\n"
"returns any\n"
"{\n"
"declare _remote_types any;\n"
"_remote_types := REPL_REMOTE_TYPES_RAW (_dsn);\n"
"\n"
"\n"
"if (_dbms_name is null)\n"
"_dbms_name := get_keyword (17, vdd_dsn_info(_dsn), \'\');\n"
"if (strstr (_dbms_name, \'SQL Server\') is not null or\n"
"strstr (_dbms_name, \'S Q L   S e r v e r\') is not null)\n"
"{\n"
"REPL_ENSURE_MAPPING (_remote_types, 8, \'float\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 9, \'datetime\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 10, \'datetime\');\n"
"}\n"
"else if (strstr (upper (_dbms_name), \'ORACLE\') is not null)\n"
"{\n"
"REPL_ENSURE_MAPPING (_remote_types, -10, \'NCLOB\');\n"
"REPL_ENSURE_MAPPING (_remote_types, -9, \'NVARCHAR2\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 2, \'NUMERIC\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 4, \'INTEGER\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 5, \'SMALLINT\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 7, \'FLOAT\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 9, \'DATE\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 10, \'DATE\');\n"
"}\n"
"else if (strstr (_dbms_name, \'DB2\') is not null)\n"
"{\n"
"REPL_ENSURE_MAPPING (_remote_types, -10, \'DBCLOB\');\n"
"REPL_ENSURE_MAPPING (_remote_types, -9, \'VARCHAR () FOR MIXED DATA\');\n"
"\n"
"REPL_OVERRIDE_MAPPING (_remote_types, -4, \'BLOB\');\n"
"REPL_OVERRIDE_MAPPING (_remote_types, -1, \'CLOB\');\n"
"}\n"
"else if (strstr (_dbms_name, \'Informix\') is not null)\n"
"{\n"
"\n"
"REPL_ENSURE_MAPPING (_remote_types, -10, \'TEXT\');\n"
"REPL_ENSURE_MAPPING (_remote_types, -9, \'NVARCHAR\');\n"
"REPL_ENSURE_MAPPING (_remote_types, -3, \'BYTE\');\n"
"REPL_ENSURE_MAPPING (_remote_types, 2, \'DECIMAL\');\n"
"}\n"
"return _remote_types;\n"
"}\n"
"--src snapshot_repl.sql:349\n";

static const char *proc38 = 
"create procedure REPL_PK_COLS (in _tbl varchar)\n"
"{\n"
"declare cr_pk cursor for\n"
"select\n"
"sc.\"COLUMN\",\n"
"sc.\"COL_DTP\",\n"
"sc.\"COL_SCALE\",\n"
"sc.\"COL_PREC\"\n"
"from\n"
"DB.DBA.SYS_KEYS k,\n"
"DB.DBA.SYS_KEY_PARTS kp, DB.DBA.SYS_COLS sc\n"
"where\n"
"upper(k.KEY_TABLE) = upper(_tbl) and\n"
"__any_grants(k.KEY_TABLE) and\n"
"k.KEY_IS_MAIN = 1 and\n"
"k.KEY_MIGRATE_TO is NULL and\n"
"kp.KP_KEY_ID = k.KEY_ID and\n"
"kp.KP_NTH < k.KEY_DECL_PARTS and\n"
"sc.COL_ID = kp.KP_COL\n"
"and sc.\"COLUMN\" <> \'_IDN\'\n"
"order by\n"
"kp.KP_NTH;\n"
"declare _pk_cols any;\n"
"declare _col_name varchar;\n"
"declare _col_dtp, _col_scale, _col_prec integer;\n"
"\n"
"_pk_cols := vector ();\n"
"open cr_pk;\n"
"whenever not found goto done;\n"
"while (1)\n"
"{\n"
"fetch cr_pk into _col_name, _col_dtp, _col_scale, _col_prec;\n"
"_col_name := repl_undot_name (_col_name);\n"
"_pk_cols := vector_concat (\n"
"_pk_cols, vector (vector (_col_name, _col_dtp, _col_scale, _col_prec)));\n"
"}\n"
"done:\n"
"close cr_pk;\n"
"return _pk_cols;\n"
"}\n"
"--src snapshot_repl.sql:398\n";

static const char *proc39 = 
"create procedure REPL_ALL_COLS (in _tbl varchar)\n"
"{\n"
"declare _stmt varchar;\n"
"declare _stat, _msg varchar;\n"
"declare _src_comp any;\n"
"_stmt := sprintf (\'select * from %s where 1 = 0\', REPL_FQNAME (_tbl));\n"
"_stat := \'00000\';\n"
"_msg := \'\';\n"
"if (0 <> exec(_stmt, _stat, _msg, vector(), 1, _src_comp, null))\n"
"signal (\'37000\', concat (\'The table \'\'\', _tbl, \'\'\' doesn\'\'t exist\'), \'TR044\');\n"
"\n"
"declare _cols, _col any;\n"
"declare _ix, _len integer;\n"
"_cols := vector();\n"
"_ix := 0;\n"
"_len := length (_src_comp[0]);\n"
"while (_ix < _len)\n"
"{\n"
"_col := _src_comp[0][_ix];\n"
"_cols := vector_concat (_cols,\n"
"vector (vector (repl_undot_name (_col[0]), _col[1], _col[2], _col[3])));\n"
"_ix := _ix + 1;\n"
"}\n"
"\n"
"return _cols;\n"
"}\n"
"--src snapshot_repl.sql:440\n";

static const char *proc40 = 
"create procedure REPL_TBL_COLS (in _tbl varchar)\n"
"{\n"
"declare _cols, _col any;\n"
"declare _col_name varchar;\n"
"declare _tbl_cols varchar;\n"
"declare _ix, _len integer;\n"
"_cols := REPL_ALL_COLS (_tbl);\n"
"_tbl_cols := \'\';\n"
"_ix := 0;\n"
"_len := length (_cols);\n"
"while (_ix < _len)\n"
"{\n"
"_col := aref (_cols, _ix);\n"
"_col_name := aref (_col, 0);\n"
"\n"
"_tbl_cols := concat (_tbl_cols, sprintf (\'\"%I\"\', _col_name));\n"
"if (_ix + 1 < _len)\n"
"_tbl_cols := concat (_tbl_cols, \', \');\n"
"_ix := _ix + 1;\n"
"}\n"
"return _tbl_cols;\n"
"}\n"
"--src snapshot_repl.sql:468\n";

static const char *proc41 = 
"create procedure REPL_COMPLETE_COLNAME (in _colname varchar)\n"
"returns varchar\n"
"{\n"
"declare _len integer;\n"
"_len := length (_colname);\n"
"if (_len > 0 and subseq (_colname, _len - 1) <> \'/\')\n"
"_colname := concat (_colname, \'/\');\n"
"return _colname;\n"
"}\n"
"--src snapshot_repl.sql:494\n";

static const char *tbl7 = 
"create table WS.WS.RPLOG_SYS_DAV_RES (\n"
"SOURCE varchar,\n"
"TARGET varchar,\n"
"RLOG_ROWGUID varchar,\n"
"SNAPTIME datetime,\n"
"primary key (SOURCE, TARGET, RLOG_ROWGUID)\n"
")\n";

static const char *proc42 = 
"create procedure REPL_DAV_STORE_RES_INT (\n"
"in _res_colname varchar, in _res_name varchar, inout _res_content any,\n"
"in _res_type varchar, in _res_perms varchar,\n"
"in _res_uname varchar, in _res_gname varchar,\n"
"in _res_cr_time datetime, in _res_mod_time datetime, in _rowguid varchar,\n"
"in _cr_colname varchar, in _res_email varchar,\n"
"in _origin varchar, in _old_rowguid varchar,\n"
"in _res_col integer, inout _backup_colid integer)\n"
"{\n"
"declare _rc integer;\n"
"\n"
"if (_res_col is null and (_res_col := DAV_SEARCH_ID (_res_colname, \'c\')) < 0)\n"
"{\n"
"\n"
"return _res_col;\n"
"}\n"
"declare _res_rowguid varchar;\n"
"_res_rowguid := _rowguid;\n"
"\n"
"\n"
"\n"
"\n"
"declare _locked_id integer;\n"
"declare _locked_type char;\n"
"_locked_id := DAV_SEARCH_ID (concat (_res_colname, _res_name), \'r\');\n"
"_locked_type := \'R\';\n"
"if (DAV_IS_LOCKED_INT (_locked_id, _locked_type) > 0)\n"
"{\n"
"\n"
"declare _locked_col_id integer;\n"
"declare _locked_res_id integer;\n"
"if (_locked_type = \'R\')\n"
"{\n"
"_locked_col_id := null;\n"
"_locked_res_id := _locked_id;\n"
"}\n"
"else\n"
"{\n"
"_locked_col_id := _locked_id;\n"
"_locked_res_id := null;\n"
"}\n"
"\n"
"delete from DB.DBA.SYS_REPL_POSTPONED_RES where RES_COLPATH = _res_content and RES_NAME = _res_name;\n"
"insert into DB.DBA.SYS_REPL_POSTPONED_RES (\n"
"LOCKED_COL_ID, LOCKED_RES_ID,\n"
"RES_COLPATH, RES_NAME, RES_CONTENT, RES_TYPE, RES_PERMS,\n"
"RES_UNAME, RES_GNAME, RES_CR_TIME, RES_MOD_TIME, RES_ROWGUID,\n"
"RES_CR_COLNAME, RES_EMAIL, RES_ORIGIN, RES_OLD_ROWGUID)\n"
"values (_locked_col_id, _locked_res_id, _res_colname, _res_name,\n"
"_res_content, _res_type, _res_perms, _res_uname, _res_gname,\n"
"_res_cr_time, _res_mod_time, _rowguid,\n"
"_cr_colname, _res_email, _origin, _old_rowguid);\n"
"return 0;\n"
"}\n"
"\n"
"if (_cr_colname is not null)\n"
"{\n"
"\n"
"declare _loc_content any;\n"
"declare _loc_perms, _loc_type, _loc_rowguid varchar;\n"
"declare _loc_cr_time, _loc_mod_time datetime;\n"
"declare _loc_uname, _loc_email, _loc_gname varchar;\n"
"declare _notify_email varchar;\n"
"\n"
"declare _do_backup, _do_notify integer;\n"
"declare _notify_text varchar;\n"
"_do_backup := null;\n"
"_do_notify := null;\n"
"_notify_email := null;\n"
"_notify_text := null;\n"
"\n"
"whenever not found goto store_resource;\n"
"select RES_CONTENT, RES_PERMS, RES_TYPE, RES_CR_TIME, RES_MOD_TIME,\n"
"ROWGUID, U_NAME, U_E_MAIL, G_NAME\n"
"into _loc_content, _loc_perms, _loc_type,\n"
"_loc_cr_time, _loc_mod_time, _loc_rowguid,\n"
"_loc_uname, _loc_email, _loc_gname\n"
"from WS.WS.SYS_DAV_RES\n"
"left join WS.WS.SYS_DAV_USER on (RES_OWNER = U_ID)\n"
"left join WS.WS.SYS_DAV_GROUP on (RES_GROUP = G_ID)\n"
"where RES_COL = _res_col and RES_NAME = _res_name;\n"
"\n"
"if (_loc_rowguid = _old_rowguid)\n"
"{\n"
"\n"
"goto store_resource;\n"
"}\n"
"\n"
"for select CR_PROC as _cr_proc from DB.DBA.SYS_DAV_CR\n"
"where CR_COL_NAME = _cr_colname order by CR_ORDER do\n"
"{\n"
"\n"
"_rc := call (_cr_proc) (\n"
"_res_col, _res_name, _res_email,\n"
"_res_content, _res_type, _res_cr_time, _res_mod_time,\n"
"_res_uname, _res_gname,\n"
"_do_backup, _do_notify, _notify_email, _notify_text);\n"
"if (_rc = 5 or _rc = 4)\n"
"{\n"
"\n"
"\n"
"if (_notify_email is null)\n"
"_notify_email := _res_email;\n"
"if (0 <> REPL_DAV_SAVE_BACKUP (\n"
"_do_backup, _do_notify, _notify_email, _notify_text,\n"
"_backup_colid, _res_colname,\n"
"_res_name, _res_content, _res_type, _res_perms,\n"
"_res_uname, _res_gname,\n"
"_res_cr_time, _res_mod_time, _res_rowguid))\n"
"return -20;\n"
"return 0;\n"
"}\n"
"else if (_rc = 3)\n"
"{\n"
"\n"
"goto publisher_wins;\n"
"}\n"
"else if (_rc = 2)\n"
"{\n"
"\n"
"_res_rowguid := REPL_SET_ORIGIN (_res_rowguid);\n"
"goto subscriber_wins;\n"
"}\n"
"else if (_rc = 1)\n"
"{\n"
"\n"
"goto subscriber_wins;\n"
"}\n"
"}\n"
"\n"
"\n"
"if (_do_backup is null)\n"
"_do_backup := 1;\n"
"if (_do_notify is null)\n"
"_do_notify := 1;\n"
"\n"
"publisher_wins:\n"
"if (_notify_email is null)\n"
"_notify_email := _res_email;\n"
"if (0 <> REPL_DAV_SAVE_BACKUP (\n"
"_do_backup, _do_notify, _notify_email, _notify_text,\n"
"_backup_colid, _res_colname,\n"
"_res_name, _res_content, _res_type, _res_perms,\n"
"_res_uname, _res_gname, _res_cr_time, _res_mod_time,\n"
"_res_rowguid))\n"
"return -20;\n"
"_res_content := _loc_content;\n"
"_res_type := _loc_type;\n"
"_res_perms := _loc_perms;\n"
"_res_uname := _loc_uname;\n"
"_res_gname := _loc_gname;\n"
"_res_cr_time := _loc_cr_time;\n"
"_res_mod_time := _loc_mod_time;\n"
"_res_rowguid := _loc_rowguid;\n"
"goto store_resource;\n"
"\n"
"subscriber_wins:\n"
"if (_notify_email is null)\n"
"_notify_email := _loc_email;\n"
"if (0 <> REPL_DAV_SAVE_BACKUP (\n"
"_do_backup, _do_notify, _loc_email, _notify_text,\n"
"_backup_colid, _res_colname,\n"
"_res_name, _loc_content, _loc_type, _loc_perms,\n"
"_loc_uname, _loc_gname, _loc_cr_time, _loc_mod_time,\n"
"_loc_rowguid))\n"
"return -20;\n"
"\n"
"store_resource:\n"
"_res_rowguid := concat (\'raw:\', _rowguid);\n"
"}\n"
"\n"
"\n"
"_rc := DAV_RES_UPLOAD_STRSES_INT (\n"
"concat (_res_colname, _res_name), _res_content, _res_type, _res_perms,\n"
"_res_uname, _res_gname, null, null, 0,\n"
"_res_cr_time, _res_mod_time, _res_rowguid);\n"
"if (_rc < 0)\n"
"{\n"
"\n"
"return _rc;\n"
"}\n"
"return 0;\n"
"}\n"
"--src snapshot_repl.sql:531\n";

static const char *proc43 = 
"create procedure REPL_DAV_STORE_RES (\n"
"in _res_colname varchar, in _res_name varchar, in _res_content any,\n"
"in _res_type varchar, in _res_perms varchar,\n"
"in _res_uname varchar, in _res_gname varchar,\n"
"in _res_cr_time datetime, in _res_mod_time datetime, in _rowguid varchar,\n"
"in _origin varchar, in _old_rowguid varchar)\n"
"{\n"
"declare _backup_colid integer;\n"
"_backup_colid := null;\n"
"return REPL_DAV_STORE_RES_INT (\n"
"_res_colname, _res_name, _res_content, _res_type, _res_perms,\n"
"_res_uname, _res_gname, _res_cr_time, _res_mod_time, _rowguid,\n"
"null, null, null, null, null, _backup_colid);\n"
"}\n"
"--src snapshot_repl.sql:716\n";

static const char *trig0 = 
"create trigger SYS_DAV_LOCK_PROCESS_POSTPONED\n"
"after delete on WS.WS.SYS_DAV_LOCK order 200 referencing old as _O\n"
"{\n"
"declare _colid integer;\n"
"declare _backup_colid integer;\n"
"_backup_colid := null;\n"
"\n"
"\n"
"declare _res_colpath, _res_name varchar;\n"
"declare _res_content varchar;\n"
"declare _res_type, _res_perms, _res_uname, _res_gname varchar;\n"
"declare _res_cr_time, _res_mod_time datetime;\n"
"declare _res_rowguid varchar;\n"
"declare _res_cr_colname, _res_email, _res_origin, _res_old_rowguid varchar;\n"
"\n"
"declare cr cursor for\n"
"select RES_COLPATH, RES_NAME,\n"
"cast (RES_CONTENT as varchar), RES_TYPE, RES_PERMS,\n"
"RES_UNAME, RES_GNAME, RES_CR_TIME, RES_MOD_TIME, RES_ROWGUID,\n"
"RES_CR_COLNAME, RES_EMAIL, RES_ORIGIN, RES_OLD_ROWGUID\n"
"from DB.DBA.SYS_REPL_POSTPONED_RES\n"
"where (_O.LOCK_PARENT_TYPE = \'C\' and LOCKED_COL_ID = _O.LOCK_PARENT_ID)\n"
"or (_O.LOCK_PARENT_TYPE = \'R\' and LOCKED_RES_ID = _O.LOCK_PARENT_ID);\n"
"\n"
"open cr (exclusive);\n"
"whenever not found goto nf;\n"
"while (1)\n"
"{\n"
"fetch cr into _res_colpath, _res_name,\n"
"_res_content, _res_type, _res_perms,\n"
"_res_uname, _res_gname, _res_cr_time, _res_mod_time, _res_rowguid,\n"
"_res_cr_colname, _res_email, _res_origin, _res_old_rowguid;\n"
"_colid := DAV_SEARCH_ID (_res_colpath, \'c\');\n"
"if (_colid < 0)\n"
"goto next;\n"
"\n"
"if (DB.DBA.REPL_DAV_STORE_RES_INT (_res_colpath, _res_name,\n"
"_res_content, _res_type, _res_perms, _res_uname, _res_gname,\n"
"_res_cr_time, _res_mod_time, _res_rowguid,\n"
"_res_cr_colname, _res_email, _res_origin, _res_old_rowguid,\n"
"_colid, _backup_colid) >= 0)\n"
"{\n"
"\n"
"delete from DB.DBA.SYS_REPL_POSTPONED_RES where current of cr;\n"
"}\n"
"next:\n"
" ;\n"
"}\n"
"nf:\n"
"close cr;\n"
"}\n"
"--src snapshot_repl.sql:732\n";

static const char *proc44 = 
"create procedure REPL_DAV_SAVE_BACKUP (\n"
"in _do_backup integer, in _do_notify integer,\n"
"in _notify_email varchar, in _notify_text varchar,\n"
"inout _backup_colid integer, in _colname varchar,\n"
"in _res_name varchar, inout _res_content any,\n"
"in _res_type varchar, in _res_perms varchar,\n"
"in _res_uname varchar, in _res_gname varchar,\n"
"in _res_cr_time datetime, in _res_mod_time datetime,\n"
"in _res_rowguid varchar)\n"
"{\n"
"if (_do_backup is null)\n"
"_do_backup := 0;\n"
"if (_do_backup <> 0)\n"
"{\n"
"\n"
"declare _backup_colname varchar;\n"
"_backup_colname := concat (_colname, \'_SYS_REPL_BACKUP/\');\n"
"if (_backup_colid is null)\n"
"{\n"
"declare _uname, _gname varchar;\n"
"declare exit handler for not found goto nf;\n"
"select U_NAME, G_NAME\n"
"into _uname, _gname\n"
"from WS.WS.SYS_DAV_COL, WS.WS.SYS_DAV_USER, WS.WS.SYS_DAV_GROUP\n"
"where COL_ID = DB.DBA.DAV_SEARCH_ID (_colname, \'c\')\n"
"and COL_OWNER = U_ID and COL_GROUP = G_ID;\n"
"goto create_backup_col;\n"
"nf:\n"
"_uname := \'dav\';\n"
"_gname := \'administrators\';\n"
"create_backup_col:\n"
"_backup_colid := DAV_COL_CREATE_INT (\n"
"_backup_colname, \'110100000R\', _uname, _gname,\n"
"null, null, 0, 0, 0);\n"
"if (_backup_colid < 0)\n"
"{\n"
"\n"
"return _backup_colid;\n"
"}\n"
"}\n"
"\n"
"\n"
"declare _max_id integer;\n"
"select coalesce (max (RES_ID) + 1, 0) into _max_id from WS.WS.SYS_DAV_RES\n"
"where RES_COL = _backup_colid;\n"
"_res_name := concat (\n"
"_backup_colname, _res_name, \'.\', sprintf (\'%d\', _max_id));\n"
"\n"
"_res_rowguid := concat (\'nolog:\', _res_rowguid);\n"
"\n"
"declare _rc integer;\n"
"_rc := DAV_RES_UPLOAD_STRSES_INT (\n"
"_res_name, _res_content, _res_type, _res_perms,\n"
"_res_uname, _res_gname, null, null, 0,\n"
"_res_cr_time, _res_mod_time, _res_rowguid);\n"
"if (_rc < 0)\n"
"{\n"
"\n"
"return _rc;\n"
"}\n"
"}\n"
"\n"
"if (_do_notify is null)\n"
"_do_notify := 0;\n"
"if (_do_notify <> 0)\n"
"{\n"
"if (_notify_text is null)\n"
"{\n"
"if (_do_backup <> 0)\n"
"{\n"
"_notify_text := sprintf (\n"
"\'Backup copy of your file saved in\n"
"\'\'%s\'\'\n"
"(server \'\'%s\'\')\',\n"
"_res_name, repl_this_server());\n"
"}\n"
"else\n"
"{\n"
"_notify_text := sprintf (\n"
"\'Your file \'\'%s\'\'\n"
"conflicted with another one and was replaced according to conflict\n"
"resolution policy (server \'\'%s\'\')\',\n"
"concat (_colname, _res_name), repl_this_server());\n"
"}\n"
"}\n"
"\n"
"\n"
"declare _stat, _msg varchar;\n"
"_stat := \'00000\';\n"
"_msg := \'\';\n"
"if (0 <> exec (\'smtp_send (null, ?, ?, ?)\', _stat, _msg,\n"
"vector (_notify_email, _notify_email, _notify_text)))\n"
"{\n"
"\n"
"return 0;\n"
"}\n"
"}\n"
"\n"
"return 0;\n"
"}\n"
"--src snapshot_repl.sql:787\n";

/* system.sql */

static const char *tbl8 = 
"create table SYS_VT_INDEX (VI_TABLE varchar, VI_INDEX varchar, VI_COL varchar,\n"
"VI_ID_COL varchar, VI_INDEX_TABLE varchar,\n"
"VI_ID_IS_PK integer, VI_ID_CONSTR varchar,\n"
"VI_OFFBAND_COLS varchar, VI_OPTIONS varchar, VI_LANGUAGE varchar,\n"
"primary key (VI_TABLE, VI_COL))\n";

static const char *proc45 = 
" create procedure SQL_PROCEDURE_COLUMNS (\n"
"in qual varchar,\n"
"in owner varchar,\n"
"in name varchar,\n"
"in col varchar,\n"
"in casemode integer,\n"
"in is_odbc3 integer\n"
")\n"
"{\n"
"declare PROCEDURE_CAT, PROCEDURE_SCHEM, PROCEDURE_NAME, COLUMN_NAME, TYPE_NAME, REMARKS varchar;\n"
"declare COLUMN_SIZE, BUFFER_LENGTH integer;\n"
"declare COLUMN_TYPE, DATA_TYPE, DECIMAL_DIGITS, NUM_PREC_RADIX, NULLABLE smallint;\n"
"\n"
"declare COLUMN_DEF, IS_NULLABLE varchar;\n"
"declare SQL_DATA_TYPE, SQL_DATETIME_SUB smallint;\n"
"declare CHAR_OCTET_LENGTH, ORDINAL_POSITION integer;\n"
"\n"
"\n"
"result_names (PROCEDURE_CAT, PROCEDURE_SCHEM, PROCEDURE_NAME, COLUMN_NAME,\n"
"COLUMN_TYPE, DATA_TYPE, TYPE_NAME, COLUMN_SIZE, BUFFER_LENGTH,\n"
"DECIMAL_DIGITS, NUM_PREC_RADIX, NULLABLE, REMARKS,\n"
"COLUMN_DEF, SQL_DATA_TYPE, SQL_DATETIME_SUB, CHAR_OCTET_LENGTH, ORDINAL_POSITION, IS_NULLABLE);\n"
"\n"
"declare full_name varchar;\n"
"declare inx, sz integer;\n"
"declare cols, elt any;\n"
"\n"
"full_name := name;\n"
"if (owner is not null)\n"
"full_name := concat (owner, \'.\', full_name);\n"
"else if (qual is not null)\n"
"full_name := concat (\'.\', full_name);\n"
"\n"
"if (qual is not null)\n"
"full_name := concat (qual, \'.\', full_name);\n"
"\n"
"for\n"
"select\n"
"P_NAME\n"
"from DB.DBA.SYS_PROCEDURES\n"
"where\n"
"either (casemode, upper (P_NAME), P_NAME) like either (casemode, upper (full_name), full_name)\n"
"do\n"
"{\n"
"cols := procedure_cols (P_NAME);\n"
"if (cols)\n"
"{\n"
"sz := length (cols);\n"
"inx := 0;\n"
"while (inx < sz)\n"
"{\n"
"elt := aref (cols, inx);\n"
"if (either (casemode, upper (aref (elt, 3)), aref (elt, 3)) like\n"
"either (casemode, upper (col), col))\n"
"{\n"
"result (\n"
"aref (elt, 0),\n"
"aref (elt, 1),\n"
"aref (elt, 2),\n"
"aref (elt, 3),\n"
"aref (elt, 4),\n"
"either (is_odbc3, dv_to_sql_type3 (aref (elt, 5)), dv_to_sql_type (aref (elt, 5))),\n"
"dv_type_title (aref (elt, 5)),\n"
"aref (elt, 7),\n"
"aref (elt, 7),\n"
"aref (elt, 6),\n"
"10,\n"
"aref (elt, 8),\n"
"NULL,\n"
"\n"
"NULL,\n"
"either (is_odbc3, dv_to_sql_type3 (aref (elt, 5)), dv_to_sql_type (aref (elt, 5))),\n"
"NULL,\n"
"aref (elt, 7),\n"
"aref (elt, 9),\n"
"either (aref (elt, 8), \'YES\', \'NO\')\n"
");\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"}\n"
"}\n"
"}\n"
"--src system.sql:31\n";

static const char *proc46 = 
" create procedure XML_URI_RESOLVE_LIKE_GET (in base_uri varchar, in rel_uri varchar, in output_charset varchar := null) returns any\n"
"{\n"
"declare s_uri any;\n"
"\n"
"if (__tag (base_uri) in (225, 226))\n"
"base_uri := charset_recode (base_uri, \'_WIDE_\', \'UTF-8\');\n"
"else\n"
"base_uri := coalesce (cast (base_uri as varchar), \'\');\n"
"if (__tag (rel_uri) in (225, 226))\n"
"rel_uri := charset_recode (rel_uri, \'_WIDE_\', \'UTF-8\');\n"
"else\n"
"rel_uri := coalesce (cast (rel_uri as varchar), \'\');\n"
"\n"
"s_uri := WS.WS.PARSE_URI (base_uri);\n"
"if (aref (s_uri, 0) = \'\')\n"
"base_uri := sprintf (\'http://%s\', base_uri);\n"
"\n"
"\n"
"\n"
"base_uri := WS.WS.EXPAND_URL (base_uri, rel_uri);\n"
"\n"
"return charset_recode (base_uri, \'UTF-8\', output_charset);\n"
"}\n"
"--src system.sql:117\n";

static const char *proc47 = 
"create function XML_URI_GET_AND_CACHE (in absolute_uri varchar)\n"
"{\n"
"declare head, content any;\n"
"whenever not found goto try_http_get;\n"
"\n"
"if (__tag (absolute_uri) in (225, 226))\n"
"absolute_uri := charset_recode (absolute_uri, \'_WIDE_\', \'UTF-8\');\n"
"else\n"
"absolute_uri := charset_recode (absolute_uri, NULL, \'UTF-8\');\n"
"select CRES_CONTENT into content from DB.DBA.SYS_CACHED_RESOURCES where CRES_URI = absolute_uri;\n"
"return content;\n"
"try_http_get:\n"
"content := http_get (absolute_uri, head);\n"
"if (aref (head, 0) not like \'% 200%\')\n"
"signal (\'H0001\', concat (\'HTTP GET failed for \', absolute_uri, \': \', aref (head, 0)));\n"
"insert into DB.DBA.SYS_CACHED_RESOURCES\n"
"(CRES_URI, CRES_CONTENT, CRES_LOADING_DATE)\n"
"values\n"
"(absolute_uri, content, now());\n"
"return content;\n"
"}\n"
"--src system.sql:142\n";

static const char *proc48 = 
" create procedure XML_URI_PARSE_VIRT (in base_uri varchar, inout table_name varchar, inout datacol_name varchar, inout pathcol_name varchar, inout path varchar)\n"
"{\n"
"declare table_start, col_start, path_start integer;\n"
"declare inx integer;\n"
"\n"
"inx := 5;\n"
"while (length (base_uri) > inx + 1 and\n"
"aref (base_uri, inx) = ascii (\'/\'))\n"
"inx := inx + 1;\n"
"table_start := inx;\n"
"path_start := locate (\':\', base_uri, table_start);\n"
"if (path_start = 0)\n"
"signal (\'HT421\', concat (\'Non-valid Virtuoso uri (missing path separator): \', base_uri));\n"
"path := subseq (base_uri, path_start);\n"
"table_name := subseq (base_uri, table_start, path_start - 1);\n"
"\n"
"col_start := strrchr (table_name, \'.\');\n"
"if (col_start is null)\n"
"signal (\'HT422\',\n"
"concat (\'Non-valid Virtuoso uri (missing data column separator in the column ref): \', base_uri));\n"
"datacol_name := subseq (table_name, col_start + 1);\n"
"table_name := subseq (table_name, 0, col_start);\n"
"\n"
"\n"
"col_start := strrchr (table_name, \'.\');\n"
"if (col_start is null)\n"
"signal (\'HT423\',\n"
"concat (\'Non-valid Virtuoso uri (missing path column separator in the column ref): \', base_uri));\n"
"pathcol_name := subseq (table_name, col_start + 1);\n"
"table_name := subseq (table_name, 0, col_start);\n"
"}\n"
"--src system.sql:167\n";

static const char *proc49 = 
"create procedure XML_URI_GET (in base_uri varchar, in rel_uri varchar)\n"
"{\n"
"declare head, str, proto varchar;\n"
"declare inx, timeout integer;\n"
"declare s_uri any;\n"
"\n"
"base_uri := XML_URI_RESOLVE_LIKE_GET (base_uri, rel_uri);\n"
"\n"
"if (__tag (base_uri) in (225, 226))\n"
"base_uri := charset_recode (base_uri, \'_WIDE_\', \'UTF-8\');\n"
"else\n"
"base_uri := charset_recode (base_uri, NULL, \'UTF-8\');\n"
"again:\n"
"s_uri := WS.WS.PARSE_URI (base_uri);\n"
"str := null;\n"
"proto := aref (s_uri, 0);\n"
"try_all:\n"
"if (proto = \'http\' or proto = \'https\')\n"
"{\n"
"declare hcli_uid, hcli_pwd any;\n"
"if (base_uri like \'http://www.w3.org/TR/%\')\n"
"return XML_URI_GET_AND_CACHE (charset_recode (base_uri, \'UTF-8\', \'_WIDE_\'));\n"
"if (base_uri like \'http://localdav.virt/%\')\n"
"{\n"
"base_uri := \'virt://WS.WS.SYS_DAV_RES.RES_FULL_PATH.RES_CONTENT:\' || subseq (base_uri, 20);\n"
"goto again;\n"
"}\n"
"whenever not found goto try_http_get;\n"
"select CRES_CONTENT into str from DB.DBA.SYS_CACHED_RESOURCES where CRES_URI = base_uri;\n"
"return str;\n"
"try_http_get:\n"
"\n"
"\n"
"hcli_uid := connection_get (\'HTTP_CLI_UID\');\n"
"hcli_pwd := connection_get (\'HTTP_CLI_PWD\');\n"
"timeout := connection_get (\'HTTP_CLI_TIMEOUT\');\n"
"declare _auth_get varchar;\n"
"if ( (hcli_pwd is null) and (hcli_uid is null) )\n"
"{\n"
"_auth_get := HTTP_GET_AUTH_INFO (base_uri);\n"
"if (_auth_get is not null)\n"
"{\n"
"hcli_uid := aref (_auth_get, 0);\n"
"hcli_pwd := aref (_auth_get, 1);\n"
"}\n"
"}\n"
"if (lcase (base_uri) like \'http://local.virt/dav/%\')\n"
"{\n"
"proto := \'virt\';\n"
"base_uri := \'virt://WS.WS.SYS_DAV_RES.RES_FULL_PATH.RES_CONTENT:\' || subseq (base_uri, 17);\n"
"goto try_all;\n"
"}\n"
"else if (proto = \'https\' or (length (hcli_uid) and length (hcli_pwd)) or (timeout is not null and timeout > 0))\n"
"{\n"
"str := http_client_ext (url=>base_uri, uid=>hcli_uid, pwd=>hcli_pwd, headers=>head, timeout=>timeout);\n"
"}\n"
"else\n"
"str := http_get (base_uri, head);\n"
"if (aref (head, 0) not like \'% 200%\')\n"
"signal (\'H0001\', concat (\'HTTP request failed: \', aref (head, 0), \'for URI \', base_uri));\n"
"}\n"
"else if (proto = \'file\')\n"
"{\n"
"inx := 5;\n"
"base_uri := charset_recode (base_uri, \'UTF-8\', NULL);\n"
"while (length (base_uri) > inx + 1 and\n"
"aref (base_uri, inx) = ascii (\'/\'))\n"
"inx := inx + 1;\n"
"str := file_to_string (concat (http_root(), \'/\' , subseq (base_uri, inx)));\n"
"}\n"
"else if (proto = \'virt\')\n"
"{\n"
"declare datacol_name, path, table_name, pathcol_name varchar;\n"
"declare path1 any;\n"
"\n"
"base_uri := charset_recode (base_uri, \'UTF-8\', NULL);\n"
"\n"
"XML_URI_PARSE_VIRT (base_uri, table_name, datacol_name, pathcol_name, path);\n"
"\n"
"declare st, msg varchar;\n"
"st := \'00000\';\n"
"\n"
"\n"
"if (__any_grants_to_user (table_name, USER, 1))\n"
"goto skip_auth;\n"
"if (0 = casemode_strcmp (table_name, \'WS.WS.SYS_DAV_RES\'))\n"
"{\n"
"declare _dav_user_id integer;\n"
"_dav_user_id := connection_get (\'DAVUserID\');\n"
"\n"
"\n"
"\n"
"\n"
"if (0 = WS.WS.CHECKPERM (WS.WS.HREF_TO_ARRAY (path, \'\'), _dav_user_id, \'100\'))\n"
"{\n"
"if (is_http_ctx() and not http_map_get (\'executable\'))\n"
"{\n"
"\n"
"DB.DBA.vsp_auth_get (\'DAV\', \'/DAV\',\n"
"md5 (datestring(now())),\n"
"md5 (\'opaakki\'),\n"
"\'false\', http_request_header (), 1);\n"
"signal (\'VSPRT\', concat (\'Not authorized to read from \', base_uri));\n"
"}\n"
"signal (\'42000\', concat (\'Not authorized to read from \', base_uri));\n"
"}\n"
"}\n"
"else\n"
"{\n"
"declare _dav_user_id integer;\n"
"_dav_user_id := connection_get (\'DAVUserID\');\n"
"if (isinteger (_dav_user_id) and 0 = __any_grants_to_user (table_name, NULL, 1))\n"
"signal (\'42000\', concat (\'Not authorized  to read from \', base_uri));\n"
"}\n"
"skip_auth:;\n"
"\n"
"path1 := path;\n"
"\n"
"{\n"
"declare tp integer;\n"
"declare cl cursor for select COL_DTP from DB.DBA.SYS_COLS\n"
"where 0 = casemode_strcmp (\"TABLE\", complete_table_name (table_name, 1))\n"
"and 0 = casemode_strcmp (\"COLUMN\", pathcol_name);\n"
"tp := 0;\n"
"whenever not found goto cl_err;\n"
"open cl (prefetch 1);\n"
"fetch cl into tp;\n"
"if (tp = 189 or tp = 188)\n"
"path1 := cast (path as integer);\n"
"else if (tp = 191 or tp = 190)\n"
"path1 := cast (path as double precision);\n"
"else if (tp = 211 or tp = 128 or tp = 129)\n"
"path1 := cast (path as datetime);\n"
"cl_err:;\n"
"close cl;\n"
"}\n"
"\n"
"exec (concat (\'select \"\', datacol_name, \'\" from \"\', table_name, \'\" where \"\', pathcol_name, \'\" = ?\'),\n"
"st, msg, vector (path1), 1, null, str);\n"
"if (st <> \'00000\')\n"
"signal (st, msg);\n"
"if (isarray (str) and length (str) > 0)\n"
"{\n"
"str := aref (str, 0);\n"
"if (isarray (str) and length (str) > 0)\n"
"str := aref (str, 0);\n"
"}\n"
"if (isblob (str))\n"
"return str;\n"
"if (isentity (str))\n"
"return str;\n"
"if (isstring (str) = 0)\n"
"{\n"
"if (0 = casemode_strcmp (table_name, \'WS.WS.SYS_DAV_RES\'))\n"
"{\n"
"declare content, type any;\n"
"declare id any;\n"
"declare rc integer;\n"
"id := DAV_SEARCH_ID (path, \'R\');\n"
"if (isinteger (id))\n"
"if (id < 0)\n"
"signal (\'42000\', concat (\'DAV doesn\'\'t contain resource with path equal to \"\', path, \'\"\'));\n"
"rc := DAV_RES_CONTENT_INT (id, content, type, 0, 0, null, null);\n"
"if (isinteger (rc))\n"
"if (rc < 0)\n"
"signal (\'42000\', concat (\'Error on reading DAV resource with path equal to \"\', path, \'\"\'));\n"
"return content;\n"
"}\n"
"signal (\'42000\', concat (\'The table \', table_name, \' doesn\'\'t have row with \',\n"
"pathcol_name, \' equal to \"\', path, \'\"\'));\n"
"}\n"
"}\n"
"else if (proto like \'x-virt-cache-%\')\n"
"{\n"
"declare content any;\n"
"whenever not found goto cache_miss;\n"
"select CRES_CONTENT into content from DB.DBA.SYS_CACHED_RESOURCES where CRES_URI = base_uri;\n"
"return content;\n"
"cache_miss:\n"
"signal (\'HT068\', sprintf (\'Resource \"%s\" not found in SYS_CACHED_RESOURCES\', base_uri));\n"
"}\n"
"else\n"
"{\n"
"signal (\'HT424\', sprintf (\'Unsupported protocol %s\', proto));\n"
"}\n"
"return str;\n"
"}\n"
"--src system.sql:202\n";

static const char *proc50 = 
"create procedure XML_URI_GET_STRING (in base_uri varchar, in rel_uri varchar)\n"
"{\n"
"declare _res any;\n"
"_res := XML_URI_GET (base_uri, rel_uri);\n"
"if (isstring (_res))\n"
"return _res;\n"
"return cast (_res as varchar);\n"
"}\n"
"--src system.sql:391\n";

static const char *proc51 = 
"create procedure XML_URI_GET_STRING_OR_ENT (in base_uri varchar, in rel_uri varchar)\n"
"{\n"
"declare _res any;\n"
"_res := XML_URI_GET (base_uri, rel_uri);\n"
"if (isstring (_res) or isentity (_res))\n"
"return _res;\n"
"return cast (_res as varchar);\n"
"}\n"
"--src system.sql:401\n";

static const char *proc52 = 
"create procedure XML_COLLECTION_DIR_LIST_LOCAL (in collection_uri varchar, in dav_path varchar, inout res any, in recursive int)\n"
"{\n"
"declare dir_list any;\n"
"declare r_dict, r_list any;\n"
"\n"
"dir_list := DAV_DIR_LIST_INT (dav_path, case recursive when 0 then 0 else 1 end, \'%\', null, null, http_dav_uid());\n"
"if (not isarray (dir_list))\n"
"return;\n"
"r_dict := dict_new (length (dir_list) + 13);\n"
"foreach (any dir_itm in dir_list) do\n"
"{\n"
"if (\'R\' = dir_itm[1])\n"
"{\n"
"declare res_id any;\n"
"declare res_path varchar;\n"
"res_id := dir_itm[4];\n"
"if (isarray (res_id))\n"
"{\n"
"res_path := DAV_SEARCH_PATH (res_id, \'R\');\n"
"if (not isstring (res_path))\n"
"res_path := dir_itm[0];\n"
"}\n"
"else\n"
"res_path := dir_itm[0];\n"
"dict_put (r_dict, res_path, 0);\n"
"}\n"
"}\n"
"r_list := dict_list_keys (r_dict, 2);\n"
"gvector_sort (r_list, 1, 0, 1);\n"
"foreach (varchar r_path in r_list) do\n"
"xq_sequencebld_acc (res, subseq (collection_uri, 0, 22) || subseq (r_path, 5));\n"
"}\n"
"--src system.sql:412\n";

static const char *proc53 = 
"create procedure XML_COLLECTION_DIR_LIST_TABLE (in collection_uri varchar, inout res any, in recursive int)\n"
"{\n"
"declare datacol_name, path, table_name, pathcol_name varchar;\n"
"\n"
"XML_URI_PARSE_VIRT (collection_uri || \':_id\', table_name, datacol_name, pathcol_name, path);\n"
"\n"
"if (__any_grants_to_user (table_name, USER, 1))\n"
"goto skip_auth;\n"
"if (0 = casemode_strcmp (table_name, \'WS.WS.SYS_DAV_RES\'))\n"
"{\n"
"signal (\'42000\', \'Access to WS.WS.SYS_DAV_RES is not allowed by virt://... collection\');\n"
"}\n"
"else\n"
"{\n"
"if (0 = __any_grants_to_user (table_name, NULL, 1))\n"
"signal (\'42000\', concat (\'Not authorized  to read from \', collection_uri));\n"
"}\n"
"skip_auth:;\n"
"\n"
"declare st, msg varchar;\n"
"declare stmt varchar;\n"
"declare rows any;\n"
"st := \'00000\';\n"
"stmt := concat (\'select \"\', pathcol_name, \'\" from \"\', table_name, \'\"\');\n"
"\n"
"exec (stmt, st, msg, null, 100, null, rows);\n"
"if (st <> \'00000\')\n"
"signal (st, msg);\n"
"if (isarray (rows))\n"
"{\n"
"foreach (any _id in rows) do\n"
"xq_sequencebld_acc (res, concat (\'virt://\', table_name, \'.\', pathcol_name, \'.\', datacol_name, \':\', cast (aref (_id, 0) as varchar)));\n"
"}\n"
"}\n"
"--src system.sql:446\n";

static const char *proc54 = 
"create procedure HTTP_GET_AUTH_INFO (in base_uri varchar)\n"
"{\n"
"declare _auth_get, hcli_uid, hcli_pwd varchar;\n"
"_auth_get := connection_get (\'HTTPAuthManager\');\n"
"if (_auth_get is not null)\n"
"{\n"
"declare _st, _msg varchar;\n"
"declare _auth_card any;\n"
"_st := \'00000\';\n"
"exec (\'select \"\' || _auth_get || \'\"(?)\', _st, _msg, vector (base_uri), 1, null, _auth_card);\n"
"if (_st <> \'00000\')\n"
"signal (_st, _msg);\n"
"if (isarray (_auth_card) and isarray (aref (_auth_card, 0)) and isarray (aref (aref (_auth_card, 0), 0) ))\n"
"{\n"
"hcli_uid := aref (aref (aref (_auth_card, 0), 0), 0);\n"
"hcli_pwd := aref (aref (aref (_auth_card, 0), 0), 1);\n"
"if (isstring (hcli_pwd) and isstring (hcli_uid))\n"
"return vector (hcli_uid, hcli_pwd);\n"
"}\n"
"signal (\'H0002\', \'Authentication callback function returned wrong authentication info\');\n"
"}\n"
"return null;\n"
"}\n"
"--src system.sql:483\n";

static const char *proc55 = 
"create procedure XML_COLLECTION_DIR_LIST_REMOTE (in host_part varchar, in auth_digest varchar, in dav_path varchar, inout res any, in recursive int)\n"
"{\n"
"declare r any;\n"
"declare b any;\n"
"declare body, hdr varchar;\n"
"declare _auth_get varchar;\n"
"\n"
"hdr := null;\n"
"if (auth_digest is null)\n"
"{\n"
"_auth_get := HTTP_GET_AUTH_INFO (dav_path);\n"
"if (_auth_get is not null)\n"
"hdr := \'Authorization: Basic \' || encode_base64 (aref (_auth_get, 0) || \':\' || aref (_auth_get, 1));\n"
"}\n"
"else\n"
"hdr := sprintf (\'Authorization: Basic %s\', auth_digest);\n"
"b := http_get (dav_path, r, \'PROPFIND\', hdr);\n"
"if (isarray (r) and (aref (r, 0) not like \'HTTP/1.1 2__%\'))\n"
"{\n"
"r := null;\n"
"b := http_get (dav_path, r, \'GET\', hdr);\n"
"if (isarray (r) and (aref (r, 0) not like \'HTTP/1.1 2__%\'))\n"
"signal (\'H0001\', concat (\'HTTP request failed: \', aref (r, 0), \'for URI \', dav_path));\n"
"b := xtree_doc (b, 2);\n"
"declare _hrefs any;\n"
"_hrefs := xpath_eval (\'//a/@href\', b, 0);\n"
"if (isarray (_hrefs)) {\n"
"foreach (varchar uri in xpath_eval (\'//a/@href\', b, 0)) do\n"
"{\n"
"uri := lcase (uri);\n"
"if (uri <> \'..\' and uri not like \'mailto:%\') {\n"
"if (uri like \'http://%\') {\n"
"xq_sequencebld_acc (res, uri);\n"
"} else {\n"
"xq_sequencebld_acc (res, dav_path || uri);\n"
"}\n"
"}\n"
"}\n"
"}\n"
"}\n"
"else\n"
"{\n"
"declare dav_part, file_part varchar;\n"
"dav_part := subseq (dav_path, length (host_part));\n"
"b := xtree_doc (b);\n"
"foreach (any uri in xpath_eval (\'distinct-values (/multistatus/response[not propstat/prop/resourcetype/collection]/href/text())\', b)) do\n"
"{\n"
"if (recursive = 0)\n"
"{\n"
"file_part := subseq (cast (uri as varchar), length (dav_part));\n"
"if (strchr (file_part, \'/\') is null)\n"
"xq_sequencebld_acc (res, host_part || cast (uri as varchar));\n"
"}\n"
"else\n"
"xq_sequencebld_acc (res, host_part || cast (uri as varchar));\n"
"\n"
"}\n"
"}\n"
"\n"
"}\n"
"--src system.sql:509\n";

static const char *proc56 = 
"create procedure XML_COLLECTION_DIR_LIST (in collection_uri any, in recursive int)\n"
"{\n"
"declare res, uri_dict any;\n"
"\n"
"if (isstring (collection_uri))\n"
"{\n"
"xq_sequencebld_init (res);\n"
"declare lcase_collection_uri varchar;\n"
"declare dir_list any;\n"
"declare dav_path varchar;\n"
"lcase_collection_uri := lcase (collection_uri);\n"
"if (lcase_collection_uri like \'http://local.virt/dav/%\')\n"
"dav_path := subseq (collection_uri, 17);\n"
"else if ((lcase_collection_uri not like \'http://%\') and (lcase_collection_uri not like \'~%\') and (lcase_collection_uri not like \'virt://%\'))\n"
"signal (\'XXXXX\', \'collection must begin with \"http://\"\');\n"
"else\n"
"dav_path := collection_uri;\n"
"if ((dav_path not like \'%/\') and (dav_path not like \'virt://%\'))\n"
"dav_path := dav_path || \'/\';\n"
"if (dav_path like \'~%\')\n"
"{\n"
"declare _home, _uname, arr varchar;\n"
"arr := split_and_decode (dav_path, 0, \'\\0\\0/\');\n"
"if (isarray (arr) and (length (arr) > 0))\n"
"_uname := subseq (aref (arr, 0), 1);\n"
"_home := (select U_HOME from SYS_USERS where U_NAME = _uname);\n"
"if (_home is null)\n"
"signal (\'XXXXX\', \'user \' || _uname || \' does not have home DAV collection\');\n"
"dav_path := subseq (_home, 0, length (_home) - 1);\n"
"declare _idx int;\n"
"_idx := 1;\n"
"while (_idx < length (arr)) {\n"
"dav_path := dav_path || \'/\' || aref (arr, _idx);\n"
"_idx := _idx + 1;\n"
"}\n"
"collection_uri := \'http://local.virt\' || dav_path;\n"
"}\n"
"if (dav_path like \'/DAV/%\')\n"
"{\n"
"XML_COLLECTION_DIR_LIST_LOCAL (collection_uri, dav_path, res, recursive);\n"
"}\n"
"else if (dav_path like \'virt://%\')\n"
"{\n"
"XML_COLLECTION_DIR_LIST_TABLE (dav_path, res, recursive);\n"
"}\n"
"else\n"
"{\n"
"declare host_part varchar;\n"
"declare hcli_uid, hcli_pwd varchar;\n"
"host_part := coalesce (regexp_match (\'http://[^:/]*(:[0-9]+)?\', dav_path), \'\');\n"
"hcli_uid := connection_get (\'HTTP_CLI_UID\');\n"
"hcli_pwd := connection_get (\'HTTP_CLI_PWD\');\n"
"XML_COLLECTION_DIR_LIST_REMOTE (host_part,\n"
"case when ((hcli_uid is not null) and (hcli_pwd is not null)) then encode_base64 (hcli_uid || \':\' || hcli_pwd) else null end,\n"
"dav_path, res, recursive);\n"
"}\n"
"xq_sequencebld_final (res);\n"
"return res;\n"
"}\n"
"}\n"
"--src system.sql:571\n";

static const char *other4 = 
"grant execute on XML_COLLECTION_DIR_LIST to public\n";
static const char *proc57 = 
"create procedure SYS_ALFANUM_NAME (in name varchar)\n"
"{\n"
"declare inx, c integer;\n"
"\n"
"inx :=0;\n"
"while (inx < length (name)) {\n"
"c := aref (name, inx);\n"
"if (not ((c >= aref (\'A\', 0) and c <= aref (\'Z\', 0))\n"
"or (c >= aref (\'a\', 0) and c <= aref (\'z\', 0))\n"
"or (c >= aref (\'0\', 0) and c <= aref (\'9\', 0))))\n"
"aset (name, inx, aref (\'_\', 0));\n"
"inx := inx + 1;\n"
"}\n"
"return name;\n"
"}\n"
"--src system.sql:637\n";

static const char *proc58 = 
" create procedure SYS_COPY_TABLE (in source_tbl varchar, in dest_tbl varchar)\n"
"{\n"
"declare src_meta, dest_meta any;\n"
"declare comm, col_list varchar;\n"
"declare inx integer;\n"
"\n"
"exec (sprintf (\'select * from \"%I\"\', source_tbl), NULL, NULL, NULL, 1, src_meta, NULL);\n"
"exec (sprintf (\'select * from \"%I\"\', dest_tbl), NULL, NULL, NULL, 1, dest_meta, NULL);\n"
"\n"
"if (0 = isarray (src_meta) or 0 = isarray (aref (src_meta, 0)))\n"
"signal (\'42S22\', sprintf (\'No columns in the source table %s\', src_meta), \'SR288\');\n"
"if (not isarray (dest_meta) or 0 = isarray (aref (src_meta, 0)))\n"
"signal (\'42S22\', sprintf (\'No columns in the source table %s\', dest_meta), \'SR289\');\n"
"\n"
"src_meta := aref (src_meta, 0);\n"
"dest_meta := aref (dest_meta, 0);\n"
"inx := 0;\n"
"\n"
"col_list := \'\';\n"
"while (inx < length (src_meta))\n"
"{\n"
"declare col any;\n"
"declare col_name varchar;\n"
"declare col_dtp integer;\n"
"declare inx1, have_match integer;\n"
"\n"
"col := aref (src_meta, inx);\n"
"col_name := aref (col, 0);\n"
"col_dtp := aref (col, 1);\n"
"\n"
"inx1 := 0;\n"
"have_match := 0;\n"
"\n"
"while (inx1 < length (dest_meta) and have_match = 0)\n"
"{\n"
"if (aref (aref (dest_meta, inx1), 0) = col_name and (aref (aref (dest_meta, inx1), 1) = col_dtp))\n"
"have_match := 1;\n"
"else\n"
"inx1 := inx1 + 1;\n"
"}\n"
"if (have_match = 0)\n"
"signal (\'42S22\', sprintf (\'The column %s in the source table %s doesn\'\'t have a match in the destination table %s\', col_name, source_tbl, dest_tbl), \'SR290\');\n"
"\n"
"if (inx > 0)\n"
"col_list := concat (col_list, \' , \');\n"
"\n"
"col_list := concat (col_list, sprintf (\'\"%I\"\', col_name));\n"
"inx := inx + 1;\n"
"}\n"
"exec (sprintf (\'insert into \"%I\" (%s) select %s from \"%I\"\', dest_tbl, col_list, col_list, source_tbl));\n"
"}\n"
"--src system.sql:676\n";

static const char *proc59 = 
" create procedure ddl_pk_fill_pk_parts (in pk_id integer, in k_id integer, in n_k_parts integer)\n"
"{\n"
"declare n_pk integer;\n"
"select KEY_N_SIGNIFICANT into n_pk from DB.DBA.SYS_KEYS where KEY_ID = pk_id;\n"
"for select KP_COL as pk_col from DB.DBA.SYS_KEY_PARTS where KP_KEY_ID = pk_id and KP_NTH < n_pk do\n"
"{\n"
"if (not (exists (select 1 from DB.DBA.SYS_KEY_PARTS where KP_KEY_ID = k_id and KP_COL = pk_col)))\n"
"{\n"
"insert into DB.DBA.SYS_KEY_PARTS (KP_KEY_ID, KP_NTH, KP_COL) values (k_id, n_k_parts, pk_col);\n"
"n_k_parts := n_k_parts + 1;\n"
"}\n"
"}\n"
"}\n"
"--src system.sql:733\n";

static const char *proc60 = 
" create procedure ddl_pk_copy_inx (in tb varchar, in ntb varchar, in nk_id integer)\n"
"{\n"
"\n"
"declare k_id integer;\n"
"for select\n"
"KEY_NAME, KEY_ID as _KEY_ID, KEY_DECL_PARTS as _KEY_DECL_PARTS,\n"
"KEY_CLUSTER_ON_ID, KEY_IS_UNIQUE, KEY_IS_OBJECT_ID\n"
"from DB.DBA.SYS_KEYS where KEY_IS_MAIN = 0 and KEY_TABLE = tb\n"
"and KEY_MIGRATE_TO is null do\n"
"{\n"
"k_id := new_key_id (0);\n"
"insert into DB.DBA.SYS_KEYS (KEY_TABLE, KEY_NAME, KEY_ID, KEY_DECL_PARTS,\n"
"KEY_CLUSTER_ON_ID, KEY_SUPER_ID, KEY_IS_UNIQUE, KEY_IS_OBJECT_ID)\n"
"values (ntb, KEY_NAME, k_id, _KEY_DECL_PARTS,\n"
"k_id, k_id, KEY_IS_UNIQUE, KEY_IS_OBJECT_ID);\n"
"\n"
"insert into DB.DBA.SYS_KEY_PARTS (KP_KEY_ID, KP_NTH, KP_COL)\n"
"select k_id, KP_NTH, (select n.COL_ID from DB.DBA.SYS_COLS n where n.\"TABLE\" = ntb and n.\"COLUMN\" = c.\"COLUMN\")\n"
"from DB.DBA.SYS_KEY_PARTS, DB.DBA.SYS_COLS c where KP_NTH < _KEY_DECL_PARTS and KP_KEY_ID = _KEY_ID\n"
"and c.COL_ID = KP_COL;\n"
"DB.DBA.ddl_pk_fill_pk_parts (nk_id, k_id, _KEY_DECL_PARTS);\n"
"if (KEY_IS_UNIQUE = 1)\n"
"update DB.DBA.SYS_KEYS set KEY_N_SIGNIFICANT = KEY_DECL_PARTS,\n"
"KEY_IS_MAIN = 0\n"
"where KEY_ID = k_id;\n"
"else\n"
"update DB.DBA.SYS_KEYS set KEY_N_SIGNIFICANT = (select count (*) from DB.DBA.SYS_KEY_PARTS where KP_KEY_ID = k_id),\n"
"KEY_IS_MAIN = 0\n"
"where KEY_ID = k_id;\n"
"}\n"
"}\n"
"--src system.sql:750\n";

static const char *proc61 = 
" create procedure ddl_pk_change_1 (in tb varchar, in cols any)\n"
"{\n"
"declare pk_id, nk_id, inx, cid integer;\n"
"declare tname, tname_esc, st, msg, pk_name varchar;\n"
"\n"
"tname := complete_table_name (\'TEMP__\', 0);\n"
"tname_esc := sprintf (\'\"%I\".\"%I\".\"%I\"\',\n"
"name_part (tname, 0), name_part (tname, 1), name_part (tname, 2));\n"
"exec (concat (\'drop table \', tname_esc), st, msg, vector ());\n"
"select KEY_ID, KEY_NAME\n"
"into pk_id, pk_name\n"
"from DB.DBA.SYS_KEYS\n"
"where KEY_TABLE = tb and KEY_IS_MAIN = 1 and KEY_MIGRATE_TO is null;\n"
"nk_id := new_key_id (0);\n"
"insert into DB.DBA.SYS_KEYS (KEY_TABLE, KEY_NAME, KEY_ID, KEY_DECL_PARTS, KEY_N_SIGNIFICANT,\n"
"KEY_CLUSTER_ON_ID, KEY_SUPER_ID, KEY_IS_MAIN, KEY_IS_UNIQUE)\n"
"values  (tname, pk_name, nk_id, length (cols), length (cols),\n"
"nk_id, nk_id, 1, 1);\n"
"declare cr cursor for select\n"
"\"COLUMN\",\n"
"COL_DTP,\n"
"COL_PREC,\n"
"COL_SCALE,\n"
"COL_CHECK,\n"
"deserialize (COL_DEFAULT),\n"
"COL_NTH,\n"
"COL_NULLABLE from DB.DBA.SYS_COLS\n"
"where concat (\'\', \"TABLE\") = tb order by COL_ID;\n"
"whenever not found goto done;\n"
"open cr;\n"
"while (1)\n"
"{\n"
"declare _col1, _col2, _col3, _col4, _col5, _col6, _col7, _col8, _col9, _col10 any;\n"
"fetch cr into  _col3, _col4, _col5, _col6, _col7, _col8, _col9, _col10;\n"
"_col1 := new_col_id (0);\n"
"_col2 := tname;\n"
"insert into DB.DBA.SYS_COLS\n"
"(COL_ID, \"TABLE\", \"COLUMN\", COL_DTP, COL_PREC, COL_SCALE, COL_CHECK, COL_DEFAULT,\n"
"COL_NTH, COL_NULLABLE)\n"
"values (_col1, _col2, _col3, _col4, _col5, _col6, _col7, serialize (_col8), _col9, _col10);\n"
"}\n"
"done:\n"
"close cr;\n"
"whenever not found default;\n"
"inx := 0;\n"
"while (inx < length (cols))\n"
"{\n"
"cid := (select COL_ID from DB.DBA.SYS_COLS where \"TABLE\" = tname and 0 = casemode_strcmp (\\COLUMN, aref (cols, inx)));\n"
"if (cid is null)\n"
"{\n"
"txn_error (6);\n"
"signal (\'42000\', concat (\'Column \', aref (cols, inx), \' not found in alter table\'));\n"
"}\n"
"insert into DB.DBA.SYS_KEY_PARTS (KP_KEY_ID, KP_NTH, KP_COL) values (nk_id, inx, cid);\n"
"inx := inx + 1;\n"
"}\n"
"DB.DBA.att_fill_non_pk_parts (tname, nk_id, inx);\n"
"DB.DBA.ddl_pk_copy_inx (tb, tname, nk_id);\n"
"__ddl_changed (tname);\n"
"DB.DBA.SYS_COPY_TABLE (tb, tname);\n"
"}\n"
"--src system.sql:785\n";

static const char *proc62 = 
" create procedure ddl_pk_change_final (in tb varchar, in cols any)\n"
"{\n"
"declare st, msg, tname, tname_esc, tb_esc varchar;\n"
"tname := complete_table_name (\'TEMP__\', 0);\n"
"tname_esc := sprintf (\'\"%I\".\"%I\".\"%I\"\',\n"
"name_part (tname, 0), name_part (tname, 1), name_part (tname, 2));\n"
"tb_esc := sprintf (\'\"%I\".\"%I\".\"%I\"\',\n"
"name_part (tb, 0), name_part (tb, 1), name_part (tb, 2));\n"
"update DB.DBA.SYS_TRIGGERS set T_TABLE = tname where T_TABLE = tb;\n"
"exec (sprintf (\'drop table %s\', tb_esc), st, msg, vector ());\n"
"update DB.DBA.SYS_TRIGGERS set T_TABLE = tb where T_TABLE = tname;\n"
"exec (sprintf (\'alter table %s rename %s\', tname_esc, tb_esc), st, msg, vector ());\n"
"commit work;\n"
"\n"
"}\n"
"--src system.sql:850\n";

static const char *proc63 = 
" create procedure ddl_pk_modify_check (in tb varchar, in cols any)\n"
"{\n"
"declare inx integer;\n"
"declare pk_id integer;\n"
"pk_id := (select KEY_ID from DB.DBA.SYS_KEYS where KEY_TABLE = tb and KEY_MIGRATE_TO is null and KEY_IS_MAIN = 1);\n"
"if (exists (select 1 from DB.DBA.SYS_KEY_SUBKEY where SUB = pk_id)\n"
"or exists (select 1 from DB.DBA.SYS_REMOTE_TABLE where RT_NAME = tb)\n"
"or exists (select 1 from DB.DBA.SYS_VT_INDEX where VI_TABLE = tb)\n"
"or exists (select 1 from DB.DBA.SYS_KEY_SUBKEY, DB.DBA.SYS_KEYS where SUPER = pk_id and KEY_ID = SUB and KEY_MIGRATE_TO is null)\n"
")\n"
"signal (\'42S11\', \'Primary key modification is prohibited if: Table is a subtable or has subtables, is attached or has a free text index\', \'SR291\');\n"
"inx := 0;\n"
"while (inx < length (cols))\n"
"{\n"
"if (not exists (select 1 from DB.DBA.SYS_KEY_PARTS, DB.DBA.SYS_COLS where  KP_KEY_ID = pk_id and COL_ID = KP_COL and\n"
"0 = casemode_strcmp (\"COLUMN\", aref (cols, inx))))\n"
"signal (\'42S22\', sprintf (\'Bad new pk column %s in list\', aref (cols, inx)), \'SR292\');\n"
"inx := inx + 1;\n"
"}\n"
"}\n"
"--src system.sql:869\n";

static const char *proc64 = 
" create procedure ddl_pk_is_changed (in tb varchar, in cols any) returns integer\n"
"{\n"
"declare inx integer;\n"
"\n"
"inx := 0;\n"
"\n"
"for select c.\"COLUMN\" as _column from\n"
"DB.DBA.SYS_COLS c, DB.DBA.SYS_KEYS k, DB.DBA.SYS_KEY_PARTS kp\n"
"where\n"
"c.COL_ID = kp.KP_COL and\n"
"kp.KP_KEY_ID = k.KEY_ID and\n"
"k.KEY_TABLE = tb and\n"
"k.KEY_IS_MAIN = 1 and\n"
"k.KEY_MIGRATE_TO is null and\n"
"kp.KP_NTH < k.KEY_N_SIGNIFICANT\n"
"order by kp.KP_NTH do\n"
"{\n"
"if (inx >= length (cols))\n"
"return 1;\n"
"if (_column <> cols[inx])\n"
"return 1;\n"
"inx := inx + 1;\n"
"}\n"
"if (inx <> length (cols))\n"
"return 1;\n"
"else\n"
"return 0;\n"
"}\n"
"--src system.sql:893\n";

static const char *proc65 = 
" create procedure ddl_pk_modify (in tb varchar, in cols any)\n"
"{\n"
"\n"
"\n"
"declare st, msg varchar;\n"
"st := \'00000\';\n"
"log_enable(0);\n"
"DB.DBA.ddl_pk_modify_check (tb, cols);\n"
"if (not DB.DBA.ddl_pk_is_changed (tb, cols))\n"
"{\n"
"log_enable (1);\n"
"return;\n"
"}\n"
"__atomic (1);\n"
"exec (\'DB.DBA.ddl_pk_change_1 (?, ?)\', st, msg, vector (tb, cols));\n"
"if (st <> \'00000\')\n"
"{\n"
"declare tname, tname_esc varchar;\n"
"tname := complete_table_name (\'TEMP__\', 0);\n"
"tname_esc := sprintf (\'\"%I\".\"%I\".\"%I\"\',\n"
"name_part (tname, 0), name_part (tname, 1), name_part (tname, 2));\n"
"declare st1, msg1 varchar;\n"
"exec (concat (\'drop table \', tname_esc), st1, msg1, vector ());\n"
"__atomic (0);\n"
"commit work;\n"
"log_enable(0);\n"
"signal (st, msg);\n"
"}\n"
"\n"
"exec (\'DB.DBA.ddl_pk_change_final (?, ?)\', st, msg, vector (tb, cols));\n"
"if (st <> \'00000\')\n"
"{\n"
"\n"
"raw_exit (1);\n"
"}\n"
"log_enable (1);\n"
"log_text (\'DB.DBA.ddl_pk_modify (?, ?)\', tb, cols);\n"
"commit work;\n"
"__atomic (0);\n"
"}\n"
"--src system.sql:925\n";

static const char *proc66 = 
"create procedure DB.DBA.fk_check_input_values (in mod integer)\n"
"{\n"
"declare ret, ret1 any;\n"
"ret1 := registry_get (\'FK_UNIQUE_CHEK\');\n"
"if (ret1 = \'ON\')\n"
"ret := 1;\n"
"else\n"
"ret := 0;\n"
"\n"
"if (mod = 1)\n"
"registry_set (\'FK_UNIQUE_CHEK\', \'ON\');\n"
"else if (mod = 0)\n"
"registry_set (\'FK_UNIQUE_CHEK\', \'OFF\');\n"
"else if (mod = -1)\n"
"{\n"
"if (not (ret1 = \'ON\' or ret1 = \'OFF\'))\n"
"registry_set (\'FK_UNIQUE_CHEK\', \'ON\');\n"
"}\n"
"else\n"
"signal (\'22023\', \'function fk_check_input_values expect -1, 0 or 1 as first parameter\', \'SR293\');\n"
"return ret;\n"
"}\n"
"--src system.sql:967\n";

static const char *other5 = 
"DB.DBA.fk_check_input_values (-1)\n";
static const char *proc67 = 
"create procedure DB.DBA.ddl_check_constraint (in pk_table varchar, in decl any)\n"
"{\n"
"declare inx, n_pc, n_pkc integer;\n"
"declare pk_col_name, uniq, col_name varchar;\n"
"declare pkc, pkcols any;\n"
"declare k_id, parts integer;\n"
"declare iu cursor for select SC.\"COLUMN\"\n"
"from  DB.DBA.SYS_KEY_PARTS KP, DB.DBA.SYS_COLS SC\n"
"where KP.KP_KEY_ID = k_id and SC.COL_ID = KP.KP_COL;\n"
"\n"
"\n"
"pkcols := aref (decl, 3);\n"
"inx := 0;\n"
"n_pc := length (pkcols);\n"
"pkc := DB.DBA.ddl_table_pk_cols (pk_table);\n"
"\n"
"n_pkc := length (pkc);\n"
"while (inx < n_pc)\n"
"{\n"
"pk_col_name := convert (varchar, aref (pkcols, inx));\n"
"if (not exists (select 1 from DB.DBA.SYS_KEY_COLUMNS\n"
"where \"KEY_TABLE\" = pk_table and 0 = casemode_strcmp (\"COLUMN\", pk_col_name)) and\n"
"not exists (select 1 from DB.DBA.SYS_COLS\n"
"where \"TABLE\" = pk_table and 0 = casemode_strcmp (\"COLUMN\", pk_col_name)))\n"
"signal (\'42S22\', sprintf (\'Foreign key references invalid column \"%s\" in referenced table \"%s\"\',\n"
"pk_col_name, pk_table), \'SR294\');\n"
"inx := inx + 1;\n"
"}\n"
"\n"
"uniq := registry_get (\'FK_UNIQUE_CHEK\');\n"
"\n"
"if (uniq <> \'ON\')\n"
"return;\n"
"\n"
"if (n_pc = n_pkc)\n"
"{\n"
"inx := 0;\n"
"while (inx < n_pc)\n"
"{\n"
"pk_col_name := convert (varchar, aref (pkcols, inx));\n"
"if (0 <> casemode_strcmp (pk_col_name, aref (pkc, inx)))\n"
"goto unq_check;\n"
"inx := inx + 1;\n"
"}\n"
"return;\n"
"}\n"
"\n"
"unq_check:\n"
"\n"
"for select KEY_ID, KEY_DECL_PARTS from DB.DBA.SYS_KEYS\n"
"where 0 = casemode_strcmp (KEY_TABLE, pk_table) and KEY_IS_MAIN = 0 and KEY_IS_UNIQUE = 1 do {\n"
"k_id := KEY_ID; parts := KEY_DECL_PARTS;\n"
"if (n_pc = parts and parts > 0)\n"
"{\n"
"whenever not found goto uk_done;\n"
"open iu;\n"
"inx := 0;\n"
"while (inx < parts)\n"
"{\n"
"pk_col_name := convert (varchar, aref (pkcols, inx));\n"
"fetch iu into col_name;\n"
"if (0 <> casemode_strcmp (pk_col_name, col_name))\n"
"goto uk_done;\n"
"inx := inx + 1;\n"
"}\n"
"uk_done:\n"
"close iu;\n"
"\n"
"if (inx = parts)\n"
"return;\n"
"}\n"
"}\n"
"\n"
"\n"
"inx := 0;\n"
"while (inx < n_pc)\n"
"{\n"
"pk_col_name := convert (varchar, aref (pkcols, inx));\n"
"if (not exists (select 1 from DB.DBA.SYS_KEY_COLUMNS where \"KEY_TABLE\" = pk_table\n"
"and 0 = casemode_strcmp (\"COLUMN\", pk_col_name) and COL_CHECK = \'I\'))\n"
"signal (\'37000\', sprintf (\'Foreign key references non-unique column \"%s\" in table \"%s\"\',\n"
"pk_col_name, pk_table), \'SR295\');\n"
"inx := inx + 1;\n"
"}\n"
"}\n"
"--src system.sql:995\n";

static const char *proc68 = 
"create procedure ddl_fk_modify (in tb varchar, in op integer, in decl any)\n"
"{\n"
"declare pkt varchar;\n"
"declare fkn any;\n"
"if (isstring (aref (decl, 2)))\n"
"pkt := complete_table_name (aref (decl, 2), 1);\n"
"else\n"
"pkt := null;\n"
"\n"
"if (op = 1 and pkt is null)\n"
"signal (\'37000\', \'To add foreign key REFERENCES should be specified\', \'SR296\');\n"
"\n"
"fkn := aref (decl, 7);\n"
"\n"
"if (op = 1)\n"
"ddl_foreign_key (tb, pkt, decl);\n"
"else if (op = 2)\n"
"{\n"
"if (pkt is not null)\n"
"{\n"
"declare inx, n_fc, n_pc integer;\n"
"declare fk_col_name, pk_col_name, fnam, fnam1, lastf varchar;\n"
"if (not exists (select 1 from DB.DBA.SYS_FOREIGN_KEYS where FK_TABLE = tb and PK_TABLE = pkt))\n"
"signal (\'42S12\', sprintf (\'Foreign key does not exist in table \"%s\" referencing table \"%s\"\', tb, pkt), \'SR297\');\n"
"\n"
"\n"
"if (0 = isarray (aref (decl, 3)) or 0 = length (aref (decl, 3)))\n"
"aset (decl, 3, ddl_table_pk_cols (pkt));\n"
"else\n"
"DB.DBA.ddl_check_constraint (pkt, decl);\n"
"\n"
"n_fc := length (aref (decl, 1));\n"
"n_pc := length (aref (decl, 3));\n"
"if (n_fc <> n_pc)\n"
"signal (\'37000\',\n"
"concat (\'Different number of referencing and referenced columns in foreign key declaration from \',\n"
"tb, \' to \', pkt), \'SQ125\');\n"
"\n"
"inx := 0; fnam := \'\';\n"
"while (inx < n_pc)\n"
"{\n"
"fk_col_name := convert (varchar, aref (aref (decl, 1), inx));\n"
"pk_col_name := convert (varchar, aref (aref (decl, 3), inx));\n"
"fnam := concat (fnam, \'_\', convert (varchar, aref (aref (decl, 1), inx)), \'_\',\n"
"convert (varchar, aref (aref (decl, 3), inx)));\n"
"inx := inx + 1;\n"
"}\n"
"\n"
"fnam1 := \'\'; lastf := \'\';\n"
"for select FK_NAME, FKCOLUMN_NAME, PKCOLUMN_NAME from DB.DBA.SYS_FOREIGN_KEYS\n"
"where FK_TABLE = tb and PK_TABLE = pkt order by KEY_SEQ do\n"
"{\n"
"if (lastf <> FK_NAME)\n"
"{\n"
"if (fnam1 = fnam)\n"
"goto dro;\n"
"else\n"
"fnam1 := \'\';\n"
"}\n"
"\n"
"lastf := FK_NAME;\n"
"fnam1 := concat (fnam1, FKCOLUMN_NAME, \'_\', PKCOLUMN_NAME);\n"
"}\n"
"dro:\n"
"\n"
"delete from DB.DBA.SYS_FOREIGN_KEYS where FK_TABLE = tb and 0 = casemode_strcmp (FK_NAME, lastf);\n"
"DB.DBA.ddl_fk_rules (pkt, null, null);\n"
"DB.DBA.ddl_fk_check_input (tb, 0);\n"
"}\n"
"else if (fkn <> 0)\n"
"{\n"
"fkn := convert (varchar, fkn);\n"
"if (exists (select 1 from DB.DBA.SYS_FOREIGN_KEYS where FK_TABLE = tb and 0 = casemode_strcmp (FK_NAME, fkn)))\n"
"{\n"
"\n"
"\n"
"\n"
"\n"
"pkt := (select distinct PK_TABLE from DB.DBA.SYS_FOREIGN_KEYS\n"
"where FK_TABLE = tb and 0 = casemode_strcmp (FK_NAME, fkn));\n"
"delete from DB.DBA.SYS_FOREIGN_KEYS where FK_TABLE = tb and 0 = casemode_strcmp (FK_NAME, fkn);\n"
"DB.DBA.ddl_fk_rules (pkt, null, null);\n"
"DB.DBA.ddl_fk_check_input (tb, 0);\n"
"}\n"
"else\n"
"signal (\'42S12\', sprintf (\'Foreign key \"%s\" does not exists\', fkn), \'SR298\');\n"
"}\n"
"else\n"
"signal (\'37000\', \'To drop foreign key should be specified NAME or REFERENCES\', \'SR299\');\n"
"}\n"
"else\n"
"signal (\'42S11\', \'To modify a foreign key first drop the old and then add the new\', \'SR300\');\n"
"}\n"
"--src system.sql:1083\n";

static const char *proc69 = 
" create procedure ddl_alter_constr (in tb varchar, in op integer, in decl any)\n"
"{\n"
"declare type integer;\n"
"declare orig_pkt varchar;\n"
"tb := complete_table_name (tb, 1);\n"
"ddl_owner_check (tb);\n"
"\n"
"type := decl[0];\n"
"if (op = 2 and length (decl) = 8 and type = 1 and 127 = __tag (aref (decl, 7)))\n"
"{\n"
"declare _name varchar;\n"
"_name := convert (varchar, decl[7]);\n"
"\n"
"if (exists (select 1 from DB.DBA.SYS_CONSTRAINTS\n"
"where C_TABLE = tb and 0 = casemode_strcmp (C_TEXT, _name)))\n"
"decl := vector (3, NULL, _name);\n"
"else if (not exists (select 1 from DB.DBA.SYS_FOREIGN_KEYS\n"
"where FK_TABLE = tb and 0 = casemode_strcmp (FK_NAME, _name)))\n"
"decl[0] := 2;\n"
"\n"
"type := decl[0];\n"
"if (type = 1)\n"
"{\n"
"whenever not found goto next;\n"
"whenever sqlstate \'*\' goto next;\n"
"orig_pkt := null;\n"
"if (not isstring (decl[2]))\n"
"select PK_TABLE into orig_pkt from DB.DBA.SYS_FOREIGN_KEYS\n"
"where FK_TABLE = tb and 0 = casemode_strcmp (FK_NAME, _name);\n"
"}\n"
"}\n"
"\n"
"next:\n"
"if (0 = type)\n"
"{\n"
"if (3 <> op)\n"
"signal (\'37000\', \'A primary key cannot be added or dropped. It can only be modified. Use alter table .. modify primary key ...\', \'SR301\');\n"
"ddl_pk_modify (tb, decl[3]);\n"
"}\n"
"else if (1 = type)\n"
"{\n"
"ddl_fk_modify (tb, op, decl);\n"
"}\n"
"else if (2 = type)\n"
"ddl_unq_modify (tb, op, decl);\n"
"else if (3 = type)\n"
"{\n"
"ddl_check_modify (tb, op, decl);\n"
"}\n"
"__REPL_DDL_FK_MODIFY_PROPAGATE (tb, op, decl, orig_pkt);\n"
"}\n"
"--src system.sql:1179\n";

static const char *proc70 = 
"create procedure ddl_unq_modify (in tb varchar, in op integer, in decl any)\n"
"{\n"
"declare nconstr, txt, cols_txt, stat, msg varchar;\n"
"declare cols any;\n"
"declare inx, len, int_name integer;\n"
"\n"
"int_name := 0;\n"
"if (length (decl) = 8 and op = 2)\n"
"nconstr := aref (decl, 7);\n"
"else\n"
"nconstr := aref (decl, 1);\n"
"\n"
"\n"
"\n"
"if (127 <> __tag (nconstr))\n"
"{\n"
"int_name := 1;\n"
"nconstr := \'\';\n"
"}\n"
"else\n"
"nconstr := convert (varchar, nconstr);\n"
"\n"
"txt := \'\'; cols_txt := \'\'; stat := \'00000\'; msg := \'\'; inx := 0;\n"
"if (int_name or op = 1)\n"
"{\n"
"cols := aref (decl, 3);\n"
"len := length (cols);\n"
"}\n"
"\n"
"if (op = 1)\n"
"{\n"
"while (inx < len)\n"
"{\n"
"cols_txt := concat (cols_txt, \',\', aref (cols, inx));\n"
"if (int_name)\n"
"nconstr := concat (nconstr, \'_\',  aref (cols, inx));\n"
"inx := inx + 1;\n"
"}\n"
"if (int_name)\n"
"{\n"
"nconstr := concat (name_part(tb,0), \'_\', name_part(tb, 1), \'_\', name_part (tb, 2), \'_UNQC\', nconstr);\n"
"nconstr := DB.DBA.SYS_ALFANUM_NAME (nconstr);\n"
"}\n"
"cols_txt := substring (cols_txt, 2, length (cols_txt));\n"
"txt := sprintf (\'CREATE UNIQUE INDEX \"%I\" ON \"%I\".\"%I\".\"%I\" (%s)\',\n"
"nconstr, name_part (tb, 0), name_part (tb, 1), name_part (tb, 2), cols_txt);\n"
"if (exec (txt, stat, msg))\n"
"signal (stat, msg);\n"
"}\n"
"else if (op = 2)\n"
"{\n"
"if (int_name)\n"
"{\n"
"while (inx < len)\n"
"{\n"
"nconstr := concat (nconstr, \'_\',  aref (cols, inx));\n"
"inx := inx + 1;\n"
"}\n"
"nconstr := concat (name_part(tb,0), \'_\', name_part(tb, 1), \'_\', name_part (tb, 2), \'_UNQC\', nconstr);\n"
"nconstr := DB.DBA.SYS_ALFANUM_NAME (nconstr);\n"
"}\n"
"if (not exists (select 1 from DB.DBA.SYS_KEYS where\n"
"0 = casemode_strcmp(KEY_TABLE, complete_table_name (tb, 0))\n"
"and 0 = casemode_strcmp (KEY_NAME, nconstr)\n"
"and KEY_IS_UNIQUE = 1))\n"
"signal (\'42S12\', sprintf (\'Constraint \"%s\" does not exists for table \"%s\"\', nconstr, tb), \'SR320\');\n"
"\n"
"txt := sprintf (\'DROP INDEX \"%I\" \"%I\".\"%I\".\"%I\"\',\n"
"nconstr, name_part (tb, 0), name_part (tb, 1), name_part (tb, 2));\n"
"if (exec (txt, stat, msg))\n"
"signal (stat, msg);\n"
"}\n"
"else\n"
"signal (\'37000\', \'To modify a unique constraint first drop the old and then add the new\', \'SR302\');\n"
"}\n"
"--src system.sql:1232\n";

static const char *proc71 = 
"create procedure ddl_check_modify (in tb varchar, in op integer, in decl any)\n"
"{\n"
"declare constr_name varchar;\n"
"declare constr_check any;\n"
"\n"
"constr_name := decl[2];\n"
"constr_check := decl[1];\n"
"\n"
"\n"
"if (op = 1)\n"
"{\n"
"declare cr cursor for\n"
"select C_ID from DB.DBA.SYS_CONSTRAINTS where C_TABLE = tb order by C_TABLE, C_ID desc;\n"
"declare last_id integer;\n"
"\n"
"if (isstring (constr_name))\n"
"{\n"
"if (exists (select 1 from DB.DBA.SYS_CONSTRAINTS WHERE C_TABLE = tb and C_TEXT = constr_name))\n"
"signal (\'22023\', concat (\'CHECK constraint \', constr_name, \' for table \', tb, \' already exists\'),\n"
"\'SR3634\');\n"
"}\n"
"\n"
"last_id := null;\n"
"{\n"
"whenever not found goto notf;\n"
"open cr (exclusive, prefetch 1);\n"
"fetch cr into last_id;\n"
"\n"
"notf:;\n"
"}\n"
"last_id := coalesce (last_id, -1) + 1;\n"
"\n"
"DDL_ENSURE_CONSTRAINT_NAME_UNIQUE (constr_name);\n"
"insert into DB.DBA.SYS_CONSTRAINTS (C_TABLE, C_ID, C_TEXT, C_MODE)\n"
"values (\n"
"tb,\n"
"last_id,\n"
"constr_name,\n"
"serialize (constr_check));\n"
"}\n"
"else if (op = 2)\n"
"{\n"
"if (isstring (constr_name))\n"
"delete from DB.DBA.SYS_CONSTRAINTS where C_TABLE = tb and C_TEXT = constr_name;\n"
"else\n"
"delete from DB.DBA.SYS_CONSTRAINTS where C_TABLE = tb and blob_to_string (C_MODE) = serialize (constr_check);\n"
"}\n"
"else if (op = 3)\n"
"{\n"
"if (isstring (constr_name))\n"
"update DB.DBA.SYS_CONSTRAINTS set C_MODE = serialize (constr_check) where C_TABLE = tb and C_TEXT = constr_name;\n"
"else\n"
"signal (\'22023\', \'Cannot MODIFY unnamed check constraints\', \'SR365\');\n"
"}\n"
"else\n"
"signal (\'22023\', \'Invalid code in ALTER TABLE (CHECK constraint)\', \'SR366\');\n"
"\n"
"if (row_count () <> 1)\n"
"{\n"
"if (isstring (constr_name))\n"
"signal (\'22023\', concat (\'CHECK Constraint \', constr_name, \' on table \', tb, \' not defined\'), \'SR367\');\n"
"else\n"
"signal (\'22023\', concat (\'unnamed CHECK Constraint on table \', tb, \' not defined\'), \'SR368\');\n"
"}\n"
"__ddl_read_constraints (tb);\n"
"}\n"
"--src system.sql:1309\n";

static const char *proc72 = 
"create procedure __HTTP_XSLT (inout _XML any, inout DOC_URI varchar, inout XSLT_URI varchar, inout PARAMS any, inout MEDIATYPE varchar, inout ENC varchar)\n"
"{\n"
"declare result any;\n"
"declare _xslt_url varchar;\n"
"if (XSLT_URI like \'precompiled:%\')\n"
"_xslt_url := substring (XSLT_URI, 13, length (XSLT_URI));\n"
"else\n"
"_xslt_url := WS.WS.EXPAND_URL (DOC_URI, XSLT_URI);\n"
"if (isarray (PARAMS))\n"
"result := xslt (_xslt_url, xml_tree_doc (xml_tree (_XML), DOC_URI), PARAMS);\n"
"else\n"
"result := xslt (_xslt_url, xml_tree_doc (xml_tree (_XML), DOC_URI));\n"
"http_output_flush ();\n"
"MEDIATYPE := xml_tree_doc_media_type(result);\n"
"ENC := xml_tree_doc_encoding (result);\n"
"http_value (result);\n"
"}\n"
"--src system.sql:1377\n";

static const char *proc73 = 
"create procedure DB.DBA.ddl_fk_rules (in pktb varchar, in drop_tb varchar, in drop_col varchar)\n"
"{\n"
"declare stmt, set_cl, whe_cl, updst, delst, thetb, pkcols, pkvars, trig_pref, skip_on_this varchar;\n"
"declare is_upd, is_del integer;\n"
"\n"
"is_upd := 0;\n"
"is_del := 0;\n"
"\n"
"DB.DBA.ddl_pk_check_input (pktb, drop_tb, drop_col);\n"
"pktb := complete_table_name (pktb, 1);\n"
"\n"
"if (drop_tb is not null)\n"
"drop_tb := complete_table_name (drop_tb, 1);\n"
"else\n"
"drop_tb := \'\';\n"
"\n"
"\n"
"if (drop_col is null)\n"
"{\n"
"skip_on_this := \'\';\n"
"drop_col := \'\';\n"
"}\n"
"else\n"
"{\n"
"skip_on_this := drop_tb;\n"
"drop_tb := \'\';\n"
"}\n"
"pkcols := \'\'; pkvars := \'\'; thetb := \'\'; set_cl := \'\'; whe_cl := \'\'; updst := \'\';\n"
"trig_pref := sprintf (\'%s_%s_%s\', DB.DBA.SYS_ALFANUM_NAME (name_part (pktb, 0)),\n"
"DB.DBA.SYS_ALFANUM_NAME (name_part (pktb, 1)),\n"
"DB.DBA.SYS_ALFANUM_NAME (name_part (pktb, 2)));\n"
"\n"
"for select distinct PKCOLUMN_NAME from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (PK_TABLE, pktb) and (UPDATE_RULE > 0 or DELETE_RULE > 0)\n"
"and 0 <> casemode_strcmp (FK_TABLE, drop_tb)\n"
"and not (0 = casemode_strcmp (FK_TABLE, skip_on_this) and 0 = casemode_strcmp (FKCOLUMN_NAME, drop_col))\n"
"do\n"
"{\n"
"pkcols := concat (pkcols, \'\"\', PKCOLUMN_NAME, \'\", \');\n"
"pkvars := concat (pkvars, \' DECLARE _VAR_\' , DB.DBA.SYS_ALFANUM_NAME (PKCOLUMN_NAME), \' VARCHAR; \\n _VAR_\',\n"
"DB.DBA.SYS_ALFANUM_NAME (PKCOLUMN_NAME), \' := O.\"\', PKCOLUMN_NAME, \'\";\\n\');\n"
"}\n"
"if (length (pkcols) > 2)\n"
"pkcols := substring (pkcols, 1, length (pkcols) - 2);\n"
"else\n"
"{\n"
"\n"
"if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = sprintf (\'%s_FK_UPDATE\', trig_pref)))\n"
"{\n"
"stmt := sprintf (\'DROP TRIGGER \"%I\".\"%I\".\"%s_FK_UPDATE\"\', name_part (pktb, 0), name_part (pktb, 1), trig_pref);\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = sprintf (\'%s_FK_DELETE\', trig_pref)))\n"
"{\n"
"stmt := sprintf (\'DROP TRIGGER \"%I\".\"%I\".\"%s_FK_DELETE\"\', name_part (pktb, 0), name_part (pktb, 1), trig_pref);\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"return;\n"
"}\n"
"\n"
"\n"
"for select FK_TABLE, FKCOLUMN_NAME, PKCOLUMN_NAME, UPDATE_RULE  from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (PK_TABLE, pktb) and UPDATE_RULE is not null and UPDATE_RULE > 0\n"
"and 0 <> casemode_strcmp (FK_TABLE, drop_tb)\n"
"and not (0 = casemode_strcmp (FK_TABLE, skip_on_this) and 0 = casemode_strcmp (FKCOLUMN_NAME, drop_col))\n"
"order by FK_TABLE do\n"
"{\n"
"\n"
"is_upd := 1;\n"
"if (FK_TABLE <> thetb and thetb <> \'\')\n"
"{\n"
"set_cl := substring (set_cl, 1, length (set_cl) - 2);\n"
"whe_cl := concat (\' WHERE \', whe_cl);\n"
"whe_cl := substring (whe_cl, 1, length (whe_cl) - 5);\n"
"updst := concat (updst, sprintf (\'  UPDATE \"%I\".\"%I\".\"%I\" SET \', name_part (thetb, 0),\n"
"name_part (thetb, 1), name_part (thetb, 2)), set_cl, whe_cl, \';\\n\');\n"
"set_cl := \'\';\n"
"whe_cl := \'\';\n"
"}\n"
"if (FK_TABLE is not null)\n"
"{\n"
"thetb := FK_TABLE;\n"
"if (UPDATE_RULE = 1)\n"
"set_cl := concat (set_cl, sprintf (\'\"%I\" = N.\"%I\", \' , FKCOLUMN_NAME, PKCOLUMN_NAME));\n"
"else if (UPDATE_RULE = 2)\n"
"set_cl := concat (set_cl, sprintf (\'\"%I\" = NULL, \' , FKCOLUMN_NAME));\n"
"else if (UPDATE_RULE = 3)\n"
"set_cl := concat (set_cl,\n"
"sprintf (\'\"%I\" = coalesce ((select deserialize (COL_DEFAULT) from DB.DBA.SYS_COLS where \"COLUMN\" = \'\'%I\'\' and \"TABLE\" = \'\'%I\'\'), NULL), \' ,\n"
"FKCOLUMN_NAME, FKCOLUMN_NAME, FK_TABLE));\n"
"\n"
"whe_cl := concat (whe_cl, sprintf (\'\"%I\" = O.\"%I\" and \' , FKCOLUMN_NAME, PKCOLUMN_NAME));\n"
"}\n"
"}\n"
"if (thetb <> \'\' and set_cl <> \'\' and whe_cl <> \'\')\n"
"{\n"
"set_cl := substring (set_cl, 1, length (set_cl) - 2);\n"
"whe_cl := concat (\' WHERE \', whe_cl);\n"
"whe_cl := substring (whe_cl, 1, length (whe_cl) - 5);\n"
"updst := concat (updst, sprintf (\'  UPDATE \"%I\".\"%I\".\"%I\" SET \', name_part (thetb, 0),\n"
"name_part (thetb, 1), name_part (thetb, 2)), set_cl, whe_cl, \';\\n\');\n"
"set_cl := \'\';\n"
"whe_cl := \'\';\n"
"}\n"
"\n"
"if (is_upd > 0)\n"
"{\n"
"stmt := sprintf (\'CREATE TRIGGER \"%s_FK_UPDATE\" AFTER UPDATE (%s)\\n ON \"%I\".\"%I\".\"%I\" ORDER 99 REFERENCING OLD AS O, NEW AS N {\\n DECLARE EXIT HANDLER FOR SQLSTATE \\\'*\\\' { ROLLBACK WORK; RESIGNAL; };\\n %s \\n }\',\n"
"trig_pref, pkcols,\n"
"name_part (pktb, 0), name_part (pktb, 1), name_part (pktb, 3), updst);\n"
"DB.DBA.execstr1 (stmt);\n"
"}\n"
"else if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = sprintf (\'%s_FK_UPDATE\', trig_pref)))\n"
"{\n"
"\n"
"stmt := sprintf (\'DROP TRIGGER \"%I\".\"%I\".\"%s_FK_UPDATE\"\', name_part (pktb, 0), name_part (pktb, 1), trig_pref);\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"delst := \'\'; thetb := \'\';\n"
"\n"
"for select FK_TABLE, FKCOLUMN_NAME, PKCOLUMN_NAME from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (PK_TABLE, pktb) and DELETE_RULE = 1\n"
"and 0 <> casemode_strcmp (FK_TABLE, drop_tb)\n"
"and not (0 = casemode_strcmp (FK_TABLE, skip_on_this) and 0 = casemode_strcmp (FKCOLUMN_NAME, drop_col))\n"
"order by FK_TABLE do\n"
"{\n"
"is_del := 1;\n"
"if (FK_TABLE <> thetb and thetb <> \'\')\n"
"{\n"
"whe_cl := concat (\' WHERE \', whe_cl);\n"
"whe_cl := substring (whe_cl, 1, length (whe_cl) - 5);\n"
"delst := concat (delst, sprintf (\'  DELETE FROM \"%I\".\"%I\".\"%I\" \', name_part (thetb, 0),\n"
"name_part (thetb, 1), name_part (thetb, 2)), whe_cl, \';\\n\');\n"
"whe_cl := \'\';\n"
"}\n"
"if (FK_TABLE is not null)\n"
"{\n"
"thetb := FK_TABLE;\n"
"whe_cl := concat (whe_cl, sprintf (\'\"%I\" = _VAR_%s and \' , FKCOLUMN_NAME, DB.DBA.SYS_ALFANUM_NAME (PKCOLUMN_NAME)));\n"
"}\n"
"}\n"
"if (thetb <> \'\' and whe_cl <> \'\')\n"
"{\n"
"whe_cl := concat (\' WHERE \', whe_cl);\n"
"whe_cl := substring (whe_cl, 1, length (whe_cl) - 5);\n"
"delst := concat (delst, sprintf (\'  DELETE FROM \"%I\".\"%I\".\"%I\" \', name_part (thetb, 0),\n"
"name_part (thetb, 1), name_part (thetb, 2)), whe_cl, \';\\n\');\n"
"set_cl := \'\';\n"
"whe_cl := \'\';\n"
"}\n"
"\n"
"updst := \'\';  thetb := \'\';\n"
"for select FK_TABLE, FKCOLUMN_NAME, PKCOLUMN_NAME, DELETE_RULE  from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (PK_TABLE, pktb) and DELETE_RULE is not null and DELETE_RULE > 1\n"
"and 0 <> casemode_strcmp (FK_TABLE, drop_tb)\n"
"and not (0 = casemode_strcmp (FK_TABLE, skip_on_this) and 0 = casemode_strcmp (FKCOLUMN_NAME, drop_col))\n"
"order by FK_TABLE do\n"
"{\n"
"is_del := 1;\n"
"if (FK_TABLE <> thetb and thetb <> \'\')\n"
"{\n"
"set_cl := substring (set_cl, 1, length (set_cl) - 2);\n"
"whe_cl := concat (\' WHERE \', whe_cl);\n"
"whe_cl := substring (whe_cl, 1, length (whe_cl) - 5);\n"
"updst := concat (updst, sprintf (\'  UPDATE \"%I\".\"%I\".\"%I\" SET \', name_part (thetb, 0),\n"
"name_part (thetb, 1), name_part (thetb, 2)), set_cl, whe_cl, \';\\n\');\n"
"set_cl := \'\';\n"
"whe_cl := \'\';\n"
"}\n"
"if (FK_TABLE is not null)\n"
"{\n"
"thetb := FK_TABLE;\n"
"if (DELETE_RULE = 2)\n"
"set_cl := concat (set_cl, sprintf (\'\"%I\" = NULL, \' , FKCOLUMN_NAME));\n"
"else if (DELETE_RULE = 3)\n"
"set_cl := concat (set_cl,\n"
"sprintf (\'\"%I\" = coalesce ((select deserialize (COL_DEFAULT) from DB.DBA.SYS_COLS where \"COLUMN\" = \'\'%I\'\' and \"TABLE\" = \'\'%I\'\'), NULL), \' ,\n"
"FKCOLUMN_NAME, FKCOLUMN_NAME, FK_TABLE));\n"
"\n"
"whe_cl := concat (whe_cl, sprintf (\'\"%I\" = _VAR_%s and \' , FKCOLUMN_NAME, DB.DBA.SYS_ALFANUM_NAME (PKCOLUMN_NAME)));\n"
"}\n"
"}\n"
"if (thetb <> \'\' and set_cl <> \'\' and whe_cl <> \'\')\n"
"{\n"
"set_cl := substring (set_cl, 1, length (set_cl) - 2);\n"
"whe_cl := concat (\' WHERE \', whe_cl);\n"
"whe_cl := substring (whe_cl, 1, length (whe_cl) - 5);\n"
"updst := concat (updst, sprintf (\'  UPDATE \"%I\".\"%I\".\"%I\" SET \', name_part (thetb, 0),\n"
"name_part (thetb, 1), name_part (thetb, 2)), set_cl, whe_cl, \';\\n\');\n"
"set_cl := \'\';\n"
"whe_cl := \'\';\n"
"}\n"
"\n"
"if (is_del > 0)\n"
"{\n"
"stmt := sprintf (\'CREATE TRIGGER \"%s_FK_DELETE\" AFTER DELETE \\n ON \"%I\".\"%I\".\"%I\" ORDER 99 referencing old as O {\\n DECLARE EXIT HANDLER FOR SQLSTATE \\\'*\\\' { ROLLBACK WORK; RESIGNAL; };\\n %s %s %s \\n}\',\n"
"trig_pref, name_part (pktb, 0), name_part (pktb, 1), name_part (pktb, 3), pkvars, delst, updst);\n"
"DB.DBA.execstr1 (stmt);\n"
"}\n"
"else if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = sprintf (\'%s_FK_DELETE\', trig_pref)))\n"
"{\n"
"\n"
"stmt := sprintf (\'DROP TRIGGER \"%I\".\"%I\".\"%s_FK_DELETE\"\', name_part (pktb, 0), name_part (pktb, 1), trig_pref);\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"}\n"
"--src system.sql:1398\n";

static const char *proc74 = 
"create procedure DB.DBA.ddl_pk_check_input (in pktb varchar, in drop_tb varchar, in drop_col varchar)\n"
"{\n"
"declare uniq, trig_pref, vars, whe, uwhe, stmt, ins, upd, fktb, skip_on_this, pku varchar;\n"
"declare _u, _d, _uc, _dc integer;\n"
"\n"
"\n"
"vars := \'\'; whe := \'\'; uwhe := \'\'; ins := \'\'; upd := \'\'; pku := \'\';\n"
"pktb := complete_table_name (pktb, 1);\n"
"trig_pref := DB.DBA.SYS_ALFANUM_NAME (pktb);\n"
"\n"
"if (drop_tb is not null)\n"
"drop_tb := complete_table_name (drop_tb, 1);\n"
"else\n"
"drop_tb := \'\';\n"
"\n"
"\n"
"if (drop_col is null)\n"
"{\n"
"skip_on_this := \'\';\n"
"drop_col := \'\';\n"
"}\n"
"else\n"
"{\n"
"skip_on_this := drop_tb;\n"
"drop_tb := \'\';\n"
"}\n"
"\n"
"_uc := 0; _dc := 0;\n"
"for select distinct FK_TABLE as fk_table_name, FK_NAME as fkname from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (PK_TABLE, pktb)\n"
"and not (0 = casemode_strcmp (FK_TABLE, PK_TABLE) and 0 = casemode_strcmp (PKCOLUMN_NAME, FKCOLUMN_NAME))\n"
"\n"
"do {\n"
"\n"
"fktb := complete_table_name (fk_table_name, 1);\n"
"_u := 0; _d := 0;\n"
"for select PKCOLUMN_NAME as pk_col_name, FKCOLUMN_NAME as fk_col_name, UPDATE_RULE, DELETE_RULE from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (PK_TABLE, pktb) and\n"
"0 = casemode_strcmp (FK_TABLE, fk_table_name)\n"
"and 0 <> casemode_strcmp (FK_TABLE, drop_tb)\n"
"and FK_NAME = fkname\n"
"and not (0 = casemode_strcmp (FK_TABLE, skip_on_this) and 0 = casemode_strcmp (FKCOLUMN_NAME, drop_col))\n"
"do\n"
"{\n"
"if (UPDATE_RULE = 0)\n"
"{\n"
"uwhe := concat (uwhe, \'\"\', fk_col_name, \'\" = O.\"\', pk_col_name, \'\" and \');\n"
"pku := concat (pku, \'N.\"\', pk_col_name, \'\" <> O.\"\', pk_col_name, \'\" or \');\n"
"_u := 1;\n"
"_uc := _uc + 1;\n"
"}\n"
"\n"
"if (DELETE_RULE = 0)\n"
"{\n"
"vars := concat (vars, \'\\n DECLARE _VAR_\', DB.DBA.SYS_ALFANUM_NAME (pk_col_name), \' ANY;\\n _VAR_\',\n"
"DB.DBA.SYS_ALFANUM_NAME (pk_col_name), sprintf (\' := O.\"%I\"\', pk_col_name), \';\\n\');\n"
"whe := concat (whe, \'\"\', fk_col_name, \'\" = _VAR_\', DB.DBA.SYS_ALFANUM_NAME (pk_col_name), \' and \');\n"
"_d := 1;\n"
"_dc := _dc + 1;\n"
"}\n"
"}\n"
"\n"
"if (_d)\n"
"{\n"
"whe := substring (whe, 1, length (whe) - 5);\n"
"ins := concat (ins, \' { \', vars, sprintf (\'if (exists (select 1 from \"%I\".\"%I\".\"%I\"\',\n"
"name_part (fk_table_name, 0), name_part (fk_table_name, 1), name_part (fk_table_name,2)),\n"
"\' WHERE \', whe, \')) \\n\',\n"
"sprintf (\'signal (\'\'S1000\'\',\'\'DELETE statement conflicted with COLUMN REFERENCE constraint \"%s\"\'\', \'\'SR304\'\');\\n\', fkname), \' } \');\n"
"}\n"
"\n"
"if (_u)\n"
"{\n"
"uwhe := substring (uwhe, 1, length (uwhe) - 5);\n"
"pku := concat (\'(\', substring (pku, 1, length (pku) - 4), \') and \');\n"
"\n"
"upd := concat (upd, sprintf (\'if (%s exists (select 1 from \"%I\".\"%I\".\"%I\"\', pku,\n"
"name_part (fktb, 0), name_part (fktb, 1), name_part (fktb,2)), \' WHERE \', uwhe, \')) \\n\',\n"
"sprintf (\'signal (\'\'S1000\'\',\'\'UPDATE statement conflicted with COLUMN REFERENCE constraint \"%s\"\'\', \'\'SR305\'\');\\n\', fkname));\n"
"}\n"
"vars := \'\'; whe := \'\'; uwhe := \'\'; pku := \'\';\n"
"}\n"
"\n"
"\n"
"if (_dc > 0)\n"
"{\n"
"stmt := concat (\'CREATE TRIGGER \', upper (trig_pref),\n"
"sprintf (\'_PK_CHECK_DELETE BEFORE DELETE ON \"%I\".\"%I\".\"%I\" order 99 referencing old as O {\\n if (\'\'ON\'\' <> registry_get (\'\'FK_UNIQUE_CHEK\'\'))\\n\\t return;\\n\', name_part (pktb, 0), name_part (pktb, 1), name_part (pktb,2)), ins, \'\\n}\\n\');\n"
"DB.DBA.execstr1 (stmt);\n"
"\n"
"}\n"
"else if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = concat (upper (trig_pref), \'_PK_CHECK_DELETE\')))\n"
"{\n"
"stmt := concat (sprintf (\'DROP TRIGGER \"%I\".\"%I\".\', name_part (pktb, 0), name_part (pktb, 1)), upper (trig_pref), \'_PK_CHECK_DELETE\');\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"\n"
"if (_uc > 0)\n"
"{\n"
"stmt := concat (\'CREATE TRIGGER \', upper (trig_pref),\n"
"sprintf (\'_PK_CHECK_UPDATE BEFORE UPDATE ON \"%I\".\"%I\".\"%I\" order 99 REFERENCING OLD AS O, NEW AS N {\\n if (\'\'ON\'\' <> registry_get (\'\'FK_UNIQUE_CHEK\'\'))\\n\\t return;\\n\',\n"
"name_part (pktb, 0), name_part (pktb, 1), name_part (pktb,2)), upd, \'\\n}\\n\');\n"
"\n"
"DB.DBA.execstr1 (stmt);\n"
"}\n"
"else if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = concat (upper (trig_pref), \'_PK_CHECK_UPDATE\')))\n"
"{\n"
"stmt := concat (sprintf (\'DROP TRIGGER \"%I\".\"%I\".\', name_part (pktb, 0), name_part (pktb, 1)), upper (trig_pref), \'_PK_CHECK_UPDATE\');\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"}\n"
"--src system.sql:1607\n";

static const char *proc75 = 
"create procedure execstr1 (in str varchar)\n"
"{\n"
"declare st, msg varchar;\n"
"st := \'00000\';\n"
"__set_user_id (\'dba\');\n"
"exec (str, st, msg, vector (), 0, null, null);\n"
"__pop_user_id ();\n"
"if (st <> \'00000\')\n"
"{\n"
"txn_error (6);\n"
"signal (st, msg);\n"
"}\n"
"}\n"
"--src system.sql:1721\n";

static const char *proc76 = 
"create procedure DB.DBA.ddl_fk_check_input (in fktb varchar, in to_drop integer)\n"
"{\n"
"declare uniq, trig_pref, vars, whe, uwhe, stmt, ins, upd, pktb, nself, uself varchar;\n"
"\n"
"vars := \'\'; whe := \'\'; uwhe := \'\'; ins := \'\'; upd := \'\';\n"
"fktb := complete_table_name (fktb, 1);\n"
"trig_pref := SYS_ALFANUM_NAME (fktb);\n"
"\n"
"if (to_drop = 1)\n"
"{\n"
"if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = concat (upper (trig_pref), \'_FK_CHECK_UPDATE\')))\n"
"{\n"
"stmt := concat (sprintf (\'DROP TRIGGER \"%I\".\"%I\".\', name_part (fktb, 0), name_part (fktb, 1)), upper (trig_pref), \'_FK_CHECK_UPDATE\');\n"
"DB.DBA.execstr (stmt);\n"
"stmt := concat (sprintf (\'DROP TRIGGER \"%I\".\"%I\".\', name_part (fktb, 0), name_part (fktb, 1)), upper (trig_pref), \'_FK_CHECK_INSERT\');\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"return;\n"
"}\n"
"\n"
"to_drop := 1;\n"
"\n"
"declare ncond, uncond	varchar;\n"
"ncond := \'\'; uncond := \'\'; nself := \'\'; uself := \'\';\n"
"for select distinct PK_TABLE as pk_table_name, FK_NAME as fkname from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (FK_TABLE, fktb)\n"
"and not (0 = casemode_strcmp (FK_TABLE, PK_TABLE) and 0 = casemode_strcmp (PKCOLUMN_NAME, FKCOLUMN_NAME))\n"
"\n"
"do {\n"
"pktb := complete_table_name (pk_table_name, 1);\n"
"for select PKCOLUMN_NAME as pk_col_name, FKCOLUMN_NAME as fk_col_name from DB.DBA.SYS_FOREIGN_KEYS\n"
"where 0 = casemode_strcmp (FK_TABLE, fktb) and\n"
"0 = casemode_strcmp (PK_TABLE, pk_table_name) and FK_NAME = fkname do\n"
"{\n"
"vars := concat (vars, \'\\n DECLARE _VAR_\', DB.DBA.SYS_ALFANUM_NAME (fk_col_name), \' ANY;\\n _VAR_\',\n"
"DB.DBA.SYS_ALFANUM_NAME (fk_col_name), sprintf (\' := N.\"%I\"\', fk_col_name), \';\\n\');\n"
"whe := concat (whe, \'\"\', pk_col_name, \'\" = _VAR_\', DB.DBA.SYS_ALFANUM_NAME (fk_col_name), \' and \');\n"
"uwhe := concat (uwhe, \'\"\', pk_col_name, \'\" = N.\"\', fk_col_name, \'\" and \');\n"
"ncond := concat (ncond, sprintf (\'_VAR_%s IS NOT NULL\', DB.DBA.SYS_ALFANUM_NAME (fk_col_name)), \' and \');\n"
"uncond := concat (uncond, sprintf (\'N.\"%I\" IS NOT NULL\', fk_col_name), \' and \');\n"
"if (0 = casemode_strcmp (fktb, pk_table_name))\n"
"{\n"
"nself := concat (nself, \' N.\"\', fk_col_name, \'\" <> N.\"\', pk_col_name, \'\" and \');\n"
"uself := concat (uself, \' N.\"\', fk_col_name, \'\" <> N.\"\', pk_col_name, \'\" and \');\n"
"}\n"
"}\n"
"whe := substring (whe, 1, length (whe) - 5);\n"
"uwhe := substring (uwhe, 1, length (uwhe) - 5);\n"
"\n"
"ins := concat (ins, vars, sprintf (\'if (%s %s not exists (select 1 from \"%I\".\"%I\".\"%I\"\',\n"
"ncond, nself, name_part (pk_table_name, 0), name_part (pk_table_name, 1), name_part (pk_table_name,2)),\n"
"\' WHERE \', whe, \')) \\n\',\n"
"sprintf (\'signal (\'\'S1000\'\',\'\'INSERT statement conflicted with FOREIGN KEY constraint referencing table \"%s\"\'\', \'\'SR306\'\');\\n\', pk_table_name));\n"
"upd := concat (upd, sprintf (\'if (%s %s not exists (select 1 from \"%I\".\"%I\".\"%I\"\',\n"
"uncond, uself, name_part (pktb, 0), name_part (pktb, 1), name_part (pktb,2)), \' WHERE \', uwhe, \')) \\n\',\n"
"sprintf (\'signal (\'\'S1000\'\',\'\'UPDATE statement conflicted with FOREIGN KEY constraint referencing table \"%s\"\'\', \'\'SR307\'\');\\n\', pk_table_name));\n"
"vars := \'\'; whe := \'\'; uwhe := \'\'; ncond := \'\'; uncond := \'\';\n"
"to_drop := 0;\n"
"}\n"
"\n"
"if (to_drop = 1)\n"
"{\n"
"if (exists (select 1 from DB.DBA.SYS_TRIGGERS where name_part (T_NAME, 2) = concat (upper (trig_pref), \'_FK_CHECK_UPDATE\')))\n"
"{\n"
"stmt := concat (sprintf (\'DROP TRIGGER \"%I\".\"%I\".\', name_part (fktb, 0), name_part (fktb, 1)), upper (trig_pref), \'_FK_CHECK_UPDATE\');\n"
"DB.DBA.execstr (stmt);\n"
"stmt := concat (sprintf (\'DROP TRIGGER \"%I\".\"%I\".\', name_part (fktb, 0), name_part (fktb, 1)), upper (trig_pref), \'_FK_CHECK_INSERT\');\n"
"DB.DBA.execstr (stmt);\n"
"}\n"
"return;\n"
"}\n"
"\n"
"stmt := concat (\'CREATE TRIGGER \', upper (trig_pref),\n"
"sprintf (\'_FK_CHECK_INSERT before insert on \"%I\".\"%I\".\"%I\" order 99 referencing new as N { if (\'\'ON\'\' <> registry_get (\'\'FK_UNIQUE_CHEK\'\')) return;\\n\',\n"
"name_part (fktb, 0), name_part (fktb, 1), name_part (fktb,2)), ins, \'\\n}\\n\');\n"
"DB.DBA.execstr1 (stmt);\n"
"stmt := concat (\'CREATE TRIGGER \', upper (trig_pref),\n"
"sprintf (\'_FK_CHECK_UPDATE before update on \"%I\".\"%I\".\"%I\" order 99 REFERENCING OLD AS O, NEW AS N { if (\'\'ON\'\' <> registry_get (\'\'FK_UNIQUE_CHEK\'\')) return;\\n\',\n"
"name_part (fktb, 0), name_part (fktb, 1), name_part (fktb,2)), upd, \'\\n}\\n\');\n"
"DB.DBA.execstr1 (stmt);\n"
"}\n"
"--src system.sql:1739\n";

static const char *proc77 = 
"create procedure DB.DBA.col_check (in tb varchar, in col varchar)\n"
"{\n"
"if (not isstring (tb) or not isstring (col))\n"
"signal (\'22023\', \'Function check_col needs string as argument\', \'SR303\');\n"
"declare ret varchar;\n"
"declare c cursor for select \"COLUMN\" from DB.DBA.SYS_COLS\n"
"where 0 = casemode_strcmp (\"TABLE\", tb) and 0 = casemode_strcmp (\"COLUMN\", col);\n"
"whenever not found goto err;\n"
"open c (prefetch 1);\n"
"fetch c into ret;\n"
"close c;\n"
"return ret;\n"
"err:;\n"
"close c;\n"
"signal (\'42S22\', sprintf (\'The column \"%s\" is not defined in the given table\', col), \'SR084\');\n"
"}\n"
"--src system.sql:1850\n";


static const char *alter1 = 
" alter table DB.DBA.SYS_VT_INDEX add VI_ID_CONSTR varchar\n";


static const char *alter2 = 
" alter table DB.DBA.SYS_VT_INDEX add VI_OFFBAND_COLS varchar\n";


static const char *alter3 = 
" alter table DB.DBA.SYS_VT_INDEX add VI_OPTIONS varchar\n";


static const char *alter4 = 
" alter table DB.DBA.SYS_VT_INDEX add VI_LANGUAGE varchar\n";


static const char *alter5 = 
" alter table DB.DBA.SYS_VT_INDEX add VI_ENCODING varchar\n";

static const char *other6 = 
"charset_define (\'MIK\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x410\\x411\\x412\\x413\\x414\\x415\\x416\\x417\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x420\\x421\\x422\\x423\\x424\\x425\\x426\\x427\\x428\\x429\\x42A\\x42B\\x42C\\x42D\\x42E\\x42F\\x430\\x431\\x432\\x433\\x434\\x435\\x436\\x437\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x440\\x441\\x442\\x443\\x444\\x445\\x446\\x447\\x448\\x449\\x44A\\x44B\\x44C\\x44D\\x44E\\x44F\\x2514\\x2534\\x252C\\x251C\\x2500\\x253C\\x2563\\x2551\\x255A\\x2554\\x2569\\x2566\\x2560\\x2550\\x256C\\x2510\\x2591\\x2592\\x2593\\x2502\\x2524\\x2116\\xA7\\x2557\\x255D\\x2518\\x250C\\x2588\\x2584\\x258C\\x2590\\x2580\\x3B1\\x3B2\\x393\\x3C0\\x3A3\\x3C3\\x3BC\\x3C4\\x3A6\\x398\\x3A9\\x3B4\\x221E\\x2205\\x2208\\x2229\\x2261\\xB1\\x2265\\x2264\\x2320\\x2321\\xF7\\x2248\\xB0\\x2219\\xB7\\x221A\\x207F\\xB2\\x25A0\\xA0\', vector (\'999\', \'CP999\'))\n";
static const char *other7 = 
"charset_define (\'WINDOWS-1250\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x20AC\\x81\\x201A\\x83\\x201E\\x2026\\x2020\\x2021\\x88\\x2030\\x160\\x2039\\x15A\\x164\\x17D\\x179\\x90\\x2018\\x2019\\x201C\\x201D\\x2022\\x2013\\x2014\\x98\\x2122\\x161\\x203A\\x15B\\x165\\x17E\\x17A\\xA0\\x2C7\\x2D8\\x141\\xA4\\x104\\xA6\\xA7\\xA8\\xA9\\x15E\\xAB\\xAC\\xAD\\xAE\\x17B\\xB0\\xB1\\x2DB\\x142\\xB4\\xB5\\xB6\\xB7\\xB8\\x105\\x15F\\xBB\\x13D\\x2DD\\x13E\\x17C\\x154\\xC1\\xC2\\x102\\xC4\\x139\\x106\\xC7\\x10C\\xC9\\x118\\xCB\\x11A\\xCD\\xCE\\x10E\\x110\\x143\\x147\\xD3\\xD4\\x150\\xD6\\xD7\\x158\\x16E\\xDA\\x170\\xDC\\xDD\\x162\\xDF\\x155\\xE1\\xE2\\x103\\xE4\\x13A\\x107\\xE7\\x10D\\xE9\\x119\\xEB\\x11B\\xED\\xEE\\x10F\\x111\\x144\\x148\\xF3\\xF4\\x151\\xF6\\xF7\\x159\\x16F\\xFA\\x171\\xFC\\xFD\\x163\\x2D9\', vector (\'CP1250\', \'MS-EE\'))\n";
static const char *other8 = 
"charset_define (\'WINDOWS-1251\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x402\\x403\\x201A\\x453\\x201E\\x2026\\x2020\\x2021\\x20AC\\x2030\\x409\\x2039\\x40A\\x40C\\x40B\\x40F\\x452\\x2018\\x2019\\x201C\\x201D\\x2022\\x2013\\x2014\\x98\\x2122\\x459\\x203A\\x45A\\x45C\\x45B\\x45F\\xA0\\x40E\\x45E\\x408\\xA4\\x490\\xA6\\xA7\\x401\\xA9\\x404\\xAB\\xAC\\xAD\\xAE\\x407\\xB0\\xB1\\x406\\x456\\x491\\xB5\\xB6\\xB7\\x451\\x2116\\x454\\xBB\\x458\\x405\\x455\\x457\\x410\\x411\\x412\\x413\\x414\\x415\\x416\\x417\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x420\\x421\\x422\\x423\\x424\\x425\\x426\\x427\\x428\\x429\\x42A\\x42B\\x42C\\x42D\\x42E\\x42F\\x430\\x431\\x432\\x433\\x434\\x435\\x436\\x437\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x440\\x441\\x442\\x443\\x444\\x445\\x446\\x447\\x448\\x449\\x44A\\x44B\\x44C\\x44D\\x44E\\x44F\', vector (\'CP1251\', \'MS-CYRL\'))\n";
static const char *other9 = 
"charset_define (\'WINDOWS-1252\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x20AC\\x81\\x201A\\x192\\x201E\\x2026\\x2020\\x2021\\x2C6\\x2030\\x160\\x2039\\x152\\x8D\\x17D\\x8F\\x90\\x2018\\x2019\\x201C\\x201D\\x2022\\x2013\\x2014\\x2DC\\x2122\\x161\\x203A\\x153\\x9D\\x17E\\x178\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\xBB\\xBC\\xBD\\xBE\\xBF\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\xD0\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\xD7\\xD8\\xD9\\xDA\\xDB\\xDC\\xDD\\xDE\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\xF0\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF\', vector (\'CP1252\', \'MS-ANSI\'))\n";
static const char *other10 = 
"charset_define (\'WINDOWS-1257\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x20AC\\x81\\x201A\\x83\\x201E\\x2026\\x2020\\x2021\\x88\\x2030\\x8A\\x2039\\x8C\\xA8\\x2C7\\xB8\\x90\\x2018\\x2019\\x201C\\x201D\\x2022\\x2013\\x2014\\x98\\x2122\\x9A\\x203A\\x9C\\xAF\\x2DB\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xD8\\xA9\\x156\\xAB\\xAC\\xAD\\xAE\\xC6\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xF8\\xB9\\x157\\xBB\\xBC\\xBD\\xBE\\xE6\\x104\\x12E\\x100\\x106\\xC4\\xC5\\x118\\x112\\x10C\\xC9\\x179\\x116\\x122\\x136\\x12A\\x13B\\x160\\x143\\x145\\xD3\\x14C\\xD5\\xD6\\xD7\\x172\\x141\\x15A\\x16A\\xDC\\x17B\\x17D\\xDF\\x105\\x12F\\x101\\x107\\xE4\\xE5\\x119\\x113\\x10D\\xE9\\x17A\\x117\\x123\\x137\\x12B\\x13C\\x161\\x144\\x146\\xF3\\x14D\\xF5\\xF6\\xF7\\x173\\x142\\x15B\\x16B\\xFC\\x17C\\x17E\\x2D9\', vector (\'CP1257\', \'WINBALTRIM\'))\n";
static const char *other11 = 
"charset_define (\'IBM437\', N\'\\x263A\\x263B\\x2665\\x2666\\x2663\\x2660\\x2022\\x25D8\\x25E6\\x25D9\\x2642\\x2640\\x266A\\x266B\\x263C\\x25B6\\x25C0\\x2195\\x203C\\xB6\\xA7\\x25AC\\x21A8\\x2191\\x2193\\x2192\\x2190\\x2310\\x2194\\x25B2\\x25BC\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\xC7\\xFC\\xE9\\xE2\\xE4\\xE0\\xE5\\xE7\\xEA\\xEB\\xE8\\xEF\\xEE\\xEC\\xC4\\xC5\\xC9\\xE6\\xC6\\xF4\\xF6\\xF2\\xFB\\xF9\\xFF\\xD6\\xDC\\xA2\\xA3\\xA5\\x20A7\\x192\\xE1\\xED\\xF3\\xFA\\xF1\\xD1\\xAA\\xBA\\xBF\\x2310\\xAC\\xBD\\xBC\\xA1\\xAB\\xBB\\x2591\\x2592\\x2593\\x2502\\x2524\\x2561\\x2562\\x2556\\x2555\\x2563\\x2551\\x2557\\x255D\\x255C\\x255B\\x2510\\x2514\\x2534\\x252C\\x251C\\x2500\\x253C\\x255E\\x255F\\x255A\\x2554\\x2569\\x2566\\x2560\\x2550\\x256C\\x2567\\x2568\\x2564\\x2565\\x2559\\x2558\\x2552\\x2553\\x256B\\x256A\\x2518\\x250C\\x2588\\x2584\\x258C\\x2590\\x2580\\x3B1\\x3B2\\x393\\x3C0\\x3A3\\x3C3\\x3BC\\x3C4\\x3A6\\x398\\x3A9\\x3B4\\x221E\\x2205\\x2208\\x2229\\x2261\\xB1\\x2265\\x2264\\x2320\\x2321\\xF7\\x2248\\xB0\\x2219\\xB7\\x221A\\x207F\\xB2\\x25A0\\xA0\', vector (\'CP437\', \'437\', \'CSPC8CODEPAGE437\'))\n";
static const char *other12 = 
"charset_define (\'IBM850\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\xC7\\xFC\\xE9\\xE2\\xE4\\xE0\\xE5\\xE7\\xEA\\xEB\\xE8\\xEF\\xEE\\xEC\\xC4\\xC5\\xC9\\xE6\\xC6\\xF4\\xF6\\xF2\\xFB\\xF9\\xFF\\xD6\\xDC\\xF8\\xA3\\xD8\\xD7\\x192\\xE1\\xED\\xF3\\xFA\\xF1\\xD1\\xAA\\xBA\\xBF\\xAE\\xAC\\xBD\\xBC\\xA1\\xAB\\xBB\\x2591\\x2592\\x2593\\x2502\\x2524\\xC1\\xC2\\xC0\\xA9\\x2563\\x2551\\x2557\\x255D\\xA2\\xA5\\x2510\\x2514\\x2534\\x252C\\x251C\\x2500\\x253C\\xE3\\xC3\\x255A\\x2554\\x2569\\x2566\\x2560\\x2550\\x256C\\xA4\\xF0\\xD0\\xCA\\xCB\\xC8\\x131\\xCD\\xCE\\xCF\\x2518\\x250C\\x2588\\x2584\\xA6\\xCC\\x2580\\xD3\\xDF\\xD4\\xD2\\xF5\\xD5\\xB5\\xFE\\xDE\\xDA\\xDB\\xD9\\xFD\\xDD\\xAF\\xB4\\xAD\\xB1\\x2017\\xBE\\xB6\\xA7\\xF7\\xB8\\xB0\\xA8\\xB7\\xB9\\xB3\\xB2\\x25A0\\xA0\', vector (\'CP850\', \'850\', \'CSPC850MULTILINGUAL\'))\n";
static const char *other13 = 
"charset_define (\'IBM852\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\xC7\\xFC\\xE9\\xE2\\xE4\\x16F\\x107\\xE7\\x142\\xEB\\x150\\x151\\xEE\\x179\\xC4\\x106\\xC9\\x139\\x13A\\xF4\\xF6\\x13D\\x13E\\x15A\\x15B\\xD6\\xDC\\x164\\x165\\x141\\xD7\\x10D\\xE1\\xED\\xF3\\xFA\\x104\\x105\\x17D\\x17E\\x118\\x119\\xAC\\x17A\\x10C\\x15F\\xAB\\xBB\\x2591\\x2592\\x2593\\x2502\\x2524\\xC1\\xC2\\x11A\\x15E\\x2563\\x2551\\x2557\\x255D\\x17B\\x17C\\x2510\\x2514\\x2534\\x252C\\x251C\\x2500\\x253C\\x102\\x103\\x255A\\x2554\\x2569\\x2566\\x2560\\x2550\\x256C\\xA4\\x111\\x110\\x10E\\xCB\\x10F\\x147\\xCD\\xCE\\x11B\\x2518\\x250C\\x2588\\x2584\\x162\\x16E\\x2580\\xD3\\xDF\\xD4\\x143\\x144\\x148\\x160\\x161\\x154\\xDA\\x155\\x170\\xFD\\xDD\\x163\\xB4\\xAD\\x2DD\\x2DB\\x2C7\\x2D8\\xA7\\xF7\\xB8\\xB0\\xA8\\x2D9\\x171\\x158\\x159\\x25A0\\xA0\', vector (\'CP852\', \'852\', \'CSPCP852\'))\n";
static const char *other14 = 
"charset_define (\'IBM855\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x452\\x402\\x453\\x403\\x451\\x401\\x454\\x404\\x455\\x405\\x456\\x406\\x457\\x407\\x458\\x408\\x459\\x409\\x45A\\x40A\\x45B\\x40B\\x45C\\x40C\\x45E\\x40E\\x45F\\x40F\\x44E\\x42E\\x44A\\x42A\\x430\\x410\\x431\\x411\\x446\\x426\\x434\\x414\\x435\\x415\\x444\\x424\\x433\\x413\\xAB\\xBB\\x2591\\x2592\\x2593\\x2502\\x2524\\x445\\x425\\x438\\x418\\x2563\\x2551\\x2557\\x255D\\x439\\x419\\x2510\\x2514\\x2534\\x252C\\x251C\\x2500\\x253C\\x43A\\x41A\\x255A\\x2554\\x2569\\x2566\\x2560\\x2550\\x256C\\xA4\\x43B\\x41B\\x43C\\x41C\\x43D\\x41D\\x43E\\x41E\\x43F\\x2518\\x250C\\x2588\\x2584\\x41F\\x44F\\x2580\\x42F\\x440\\x420\\x441\\x421\\x442\\x422\\x443\\x423\\x436\\x416\\x432\\x412\\x44C\\x42C\\x2116\\xAD\\x44B\\x42B\\x437\\x417\\x448\\x428\\x44D\\x42D\\x449\\x429\\x447\\x427\\xA7\\x25A0\\xA0\', vector (\'CP855\', \'855\', \'CSIBM855\'))\n";
static const char *other15 = 
"charset_define (\'IBM866\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x410\\x411\\x412\\x413\\x414\\x415\\x416\\x417\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x420\\x421\\x422\\x423\\x424\\x425\\x426\\x427\\x428\\x429\\x42A\\x42B\\x42C\\x42D\\x42E\\x42F\\x430\\x431\\x432\\x433\\x434\\x435\\x436\\x437\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x2591\\x2592\\x2593\\x2502\\x2524\\x2561\\x2562\\x2556\\x2555\\x2563\\x2551\\x2557\\x255D\\x255C\\x255B\\x2510\\x2514\\x2534\\x252C\\x251C\\x2500\\x253C\\x255E\\x255F\\x255A\\x2554\\x2569\\x2566\\x2560\\x2550\\x256C\\x2567\\x2568\\x2564\\x2565\\x2559\\x2558\\x2552\\x2553\\x256B\\x256A\\x2518\\x250C\\x2588\\x2584\\x258C\\x2590\\x2580\\x440\\x441\\x442\\x443\\x444\\x445\\x446\\x447\\x448\\x449\\x44A\\x44B\\x44C\\x44D\\x44E\\x44F\\x401\\x451\\x404\\x454\\x407\\x457\\x40E\\x45E\\xB0\\x2022\\xB7\\x221A\\x2116\\xA4\\x25A0\\xA0\', vector (\'CP866\', \'866\', \'CSIBM866\'))\n";
static const char *other16 = 
"charset_define (\'IBM874\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x20AC\\x81\\x82\\x83\\x84\\x2026\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x2018\\x2019\\x201C\\x201D\\x2022\\x2013\\x2014\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xE01\\xE02\\xE03\\xE04\\xE05\\xE06\\xE07\\xE08\\xE09\\xE0A\\xE0B\\xE0C\\xE0D\\xE0E\\xE0F\\xE10\\xE11\\xE12\\xE13\\xE14\\xE15\\xE16\\xE17\\xE18\\xE19\\xE1A\\xE1B\\xE1C\\xE1D\\xE1E\\xE1F\\xE20\\xE21\\xE22\\xE23\\xE24\\xE25\\xE26\\xE27\\xE28\\xE29\\xE2A\\xE2B\\xE2C\\xE2D\\xE2E\\xE2F\\xE30\\xE31\\xE32\\xE33\\xE34\\xE35\\xE36\\xE37\\xE38\\xE39\\xE3A\\xDB\\xDC\\xDD\\xDE\\xE3F\\xE40\\xE41\\xE42\\xE43\\xE44\\xE45\\xE46\\xE47\\xE48\\xE49\\xE4A\\xE4B\\xE4C\\xE4D\\xE4E\\xE4F\\xE50\\xE51\\xE52\\xE53\\xE54\\xE55\\xE56\\xE57\\xE58\\xE59\\xE5A\\xE5B\\xFC\\xFD\\xFE\\xFF\', vector (\'CP874\', \'874\'))\n";
static const char *other17 = 
"charset_define (\'GOST19768-87\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\xA4\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x401\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\x410\\x411\\x412\\x413\\x414\\x415\\x416\\x417\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x420\\x421\\x422\\x423\\x424\\x425\\x426\\x427\\x428\\x429\\x42A\\x42B\\x42C\\x42D\\x42E\\x42F\\x430\\x431\\x432\\x433\\x434\\x435\\x436\\x437\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x440\\x441\\x442\\x443\\x444\\x445\\x446\\x447\\x448\\x449\\x44A\\x44B\\x44C\\x44D\\x44E\\x44F\\xF0\\x451\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF\', NULL)\n";
static const char *other18 = 
"charset_define (\'ISO-8859-1\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\xBB\\xBC\\xBD\\xBE\\xBF\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\xD0\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\xD7\\xD8\\xD9\\xDA\\xDB\\xDC\\xDD\\xDE\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\xF0\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF\', vector (\'ISO_8859-1\', \'ISO_8859-1:1987\', \'ISO-IR-100\', \'LATIN1\', \'L1\', \'IBM819\', \'CP819\', \'819\', \'CSISOLATIN1\'))\n";
static const char *other19 = 
"charset_define (\'ISO-8859-10\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x104\\x112\\x122\\x12A\\x128\\x136\\xA7\\x13B\\x110\\x160\\x166\\x17D\\xAD\\x16A\\x14A\\xB0\\x105\\x113\\x123\\x12B\\x129\\x137\\xB7\\x13C\\x111\\x161\\x167\\x17E\\x2015\\x16B\\x14B\\x100\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\x12E\\x10C\\xC9\\x118\\xCB\\x116\\xCD\\xCE\\xCF\\xD0\\x145\\x14C\\xD3\\xD4\\xD5\\xD6\\x168\\xD8\\x172\\xDA\\xDB\\xDC\\xDD\\xDE\\xDF\\x101\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\x12F\\x10D\\xE9\\x119\\xEB\\x117\\xED\\xEE\\xEF\\xF0\\x146\\x14D\\xF3\\xF4\\xF5\\xF6\\x169\\xF8\\x173\\xFA\\xFB\\xFC\\xFD\\xFE\\x138\', vector (\'ISO_8859-10\', \'ISO_8859-10:1992\', \'ISO-IR-157\', \'L6\', \'LATIN6\', \'CSISOLATIN6\'))\n";
static const char *other20 = 
"charset_define (\'ISO-8859-11\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xE01\\xE02\\xE03\\xE04\\xE05\\xE06\\xE07\\xE08\\xE09\\xE0A\\xE0B\\xE0C\\xE0D\\xE0E\\xE0F\\xE10\\xE11\\xE12\\xE13\\xE14\\xE15\\xE16\\xE17\\xE18\\xE19\\xE1A\\xE1B\\xE1C\\xE1D\\xE1E\\xE1F\\xE20\\xE21\\xE22\\xE23\\xE24\\xE25\\xE26\\xE27\\xE28\\xE29\\xE2A\\xE2B\\xE2C\\xE2D\\xE2E\\xE2F\\xE30\\xE31\\xE32\\xE33\\xE34\\xE35\\xE36\\xE37\\xE38\\xE39\\xE3A\\xDB\\xDC\\xDD\\xDE\\xE3F\\xE40\\xE41\\xE42\\xE43\\xE44\\xE45\\xE46\\xE47\\xE48\\xE49\\xE4A\\xE4B\\xE4C\\xE4D\\xE4E\\xE4F\\xE50\\xE51\\xE52\\xE53\\xE54\\xE55\\xE56\\xE57\\xE58\\xE59\\xE5A\\xE5B\\xFC\\xFD\\xFE\\xFF\', vector (\'ISO_8859-11\'))\n";
static const char *other21 = 
"charset_define (\'ISO-8859-13\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x201D\\xA2\\xA3\\xA4\\x201E\\xA6\\xA7\\xD8\\xA9\\x156\\xAB\\xAC\\xAD\\xAE\\xC6\\xB0\\xB1\\xB2\\xB3\\x201C\\xB5\\xB6\\xB7\\xF8\\xB9\\x157\\xBB\\xBC\\xBD\\xBE\\xE6\\x104\\x12E\\x100\\x106\\xC4\\xC5\\x118\\x112\\x10C\\xC9\\x179\\x116\\x122\\x136\\x12A\\x13B\\x160\\x143\\x145\\xD3\\x14C\\xD5\\xD6\\xD7\\x172\\x141\\x15A\\x16A\\xDC\\x17B\\x17D\\xDF\\x105\\x12F\\x101\\x107\\xE4\\xE5\\x119\\x113\\x10D\\xE9\\x17A\\x117\\x123\\x137\\x12B\\x13C\\x161\\x144\\x146\\xF3\\x14D\\xF5\\xF6\\xF7\\x173\\x142\\x15B\\x16B\\xFC\\x17C\\x17E\\x2019\', vector (\'ISO_8859-13\'))\n";
static const char *other22 = 
"charset_define (\'ISO-8859-14\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x1E02\\x1E03\\xA3\\x10A\\x10B\\x1E0A\\xA7\\x1E80\\xA9\\x1E82\\x1E0B\\x1EF2\\xAD\\xAE\\x178\\x1E1E\\x1E1F\\x120\\x121\\x1E40\\x1E41\\xB6\\x1E56\\x1E81\\x1E57\\x1E83\\x1E60\\x1EF3\\x1E84\\x1E85\\x1E61\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\x174\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\x1E6A\\xD8\\xD9\\xDA\\xDB\\xDC\\xDD\\x176\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\x175\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\x1E6B\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\x177\\xFF\', vector (\'ISO_8859-14\', \'ISO_8859-14:1998\', \'LATIN8\', \'L8\', \'ISO-CELTIC\', \'ISO-IR-199\'))\n";
static const char *other23 = 
"charset_define (\'ISO-8859-15\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\x20AC\\xA5\\x160\\xA7\\x161\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\x17D\\xB5\\xB6\\xB7\\x17E\\xB9\\xBA\\xBB\\x152\\x153\\x178\\xBF\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\xD0\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\xD7\\xD8\\xD9\\xDA\\xDB\\xDC\\xDD\\xDE\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\xF0\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF\', vector (\'ISO_8859-15\'))\n";
static const char *other24 = 
"charset_define (\'ISO-8859-2\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x104\\x2D8\\x141\\xA4\\x13D\\x15A\\xA7\\xA8\\x160\\x15E\\x164\\x179\\xAD\\x17D\\x17B\\xB0\\x105\\x2DB\\x142\\xB4\\x13E\\x15B\\x2C7\\xB8\\x161\\x15F\\x165\\x17A\\x2DD\\x17E\\x17C\\x154\\xC1\\xC2\\x102\\xC4\\x139\\x106\\xC7\\x10C\\xC9\\x118\\xCB\\x11A\\xCD\\xCE\\x10E\\x110\\x143\\x147\\xD3\\xD4\\x150\\xD6\\xD7\\x158\\x16E\\xDA\\x170\\xDC\\xDD\\x162\\xDF\\x155\\xE1\\xE2\\x103\\xE4\\x13A\\x107\\xE7\\x10D\\xE9\\x119\\xEB\\x11B\\xED\\xEE\\x10F\\x111\\x144\\x148\\xF3\\xF4\\x151\\xF6\\xF7\\x159\\x16F\\xFA\\x171\\xFC\\xFD\\x163\\x2D9\', vector (\'ISO_8859-2\', \'ISO_8859-2:1987\', \'ISO-IR-101\', \'LATIN2\', \'L2\', \'CSISOLATIN2\'))\n";
static const char *other25 = 
"charset_define (\'ISO-8859-3\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x126\\x2D8\\xA3\\xA4\\xA5\\x124\\xA7\\xA8\\x130\\x15E\\x11E\\x134\\xAD\\xAE\\x17B\\xB0\\x127\\xB2\\xB3\\xB4\\xB5\\x125\\xB7\\xB8\\x131\\x15F\\x11F\\x135\\xBD\\xBE\\x17C\\xC0\\xC1\\xC2\\xC3\\xC4\\x10A\\x108\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\xD0\\xD1\\xD2\\xD3\\xD4\\x120\\xD6\\xD7\\x11C\\xD9\\xDA\\xDB\\xDC\\x16C\\x15C\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\x10B\\x109\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\xF0\\xF1\\xF2\\xF3\\xF4\\x121\\xF6\\xF7\\x11D\\xF9\\xFA\\xFB\\xFC\\x16D\\x15D\\x2D9\', vector (\'ISO_8859-3\', \'ISO_8859-3:1988\', \'ISO-IR-109\', \'LATIN3\', \'L3\', \'CSISOLATIN3\'))\n";
static const char *other26 = 
"charset_define (\'ISO-8859-4\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x104\\x138\\x156\\xA4\\x128\\x13B\\xA7\\xA8\\x160\\x112\\x122\\x166\\xAD\\x17D\\xAF\\xB0\\x105\\x2DB\\x157\\xB4\\x129\\x13C\\x2C7\\xB8\\x161\\x113\\x123\\x167\\x14A\\x17E\\x14B\\x100\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\x12E\\x10C\\xC9\\x118\\xCB\\x116\\xCD\\xCE\\x12A\\x110\\x145\\x14C\\x136\\xD4\\xD5\\xD6\\xD7\\xD8\\x172\\xDA\\xDB\\xDC\\x168\\x16A\\xDF\\x101\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\x12F\\x10D\\xE9\\x119\\xEB\\x117\\xED\\xEE\\x12B\\x111\\x146\\x14D\\x137\\xF4\\xF5\\xF6\\xF7\\xF8\\x173\\xFA\\xFB\\xFC\\x169\\x16B\\x2D9\', vector (\'ISO_8859-4\', \'ISO-IR-110\', \'LATIN4\', \'L4\', \'CSISOLATIN4\', \'ISO_8859-4:1988\'))\n";
static const char *other27 = 
"charset_define (\'ISO-8859-5\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x401\\x402\\x403\\x404\\x405\\x406\\x407\\x408\\x409\\x40A\\x40B\\x40C\\xAD\\x40E\\x40F\\x410\\x411\\x412\\x413\\x414\\x415\\x416\\x417\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x420\\x421\\x422\\x423\\x424\\x425\\x426\\x427\\x428\\x429\\x42A\\x42B\\x42C\\x42D\\x42E\\x42F\\x430\\x431\\x432\\x433\\x434\\x435\\x436\\x437\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x440\\x441\\x442\\x443\\x444\\x445\\x446\\x447\\x448\\x449\\x44A\\x44B\\x44C\\x44D\\x44E\\x44F\\x2116\\x451\\x452\\x453\\x454\\x455\\x456\\x457\\x458\\x459\\x45A\\x45B\\x45C\\xA7\\x45E\\x45F\', vector (\'ISO_8859-5\', \'CYRILLIC\', \'ISO-IR-144\', \'CSISOLATINCYRILLIC\', \'ISO_8859-5:1988\'))\n";
static const char *other28 = 
"charset_define (\'ISO-8859-6\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\x60C\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\x61B\\xBC\\xBD\\xBE\\x61F\\xC0\\x621\\x622\\x623\\x624\\x625\\x626\\x627\\x628\\x629\\x62A\\x62B\\x62C\\x62D\\x62E\\x62F\\x630\\x631\\x632\\x633\\x634\\x635\\x636\\x637\\x638\\x639\\x63A\\xDB\\xDC\\xDD\\xDE\\xDF\\x640\\x641\\x642\\x643\\x644\\x645\\x646\\x647\\x648\\x649\\x64A\\x64B\\x64C\\x64D\\x64E\\x64F\\x650\\x651\\x652\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF\', vector (\'ISO_8859-6\', \'ARABIC\', \'ISO-IR-127\', \'ECMA-114\', \'ASMO-708\', \'CSISOLATINARABIC\', \'ISO_8859-6:1987\'))\n";
static const char *other29 = 
"charset_define (\'ISO-8859-7\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x2BD\\x2BC\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\x2015\\xB0\\xB1\\xB2\\xB3\\x384\\x385\\x386\\xB7\\x388\\x389\\x38A\\xBB\\x38C\\xBD\\x38E\\x38F\\x390\\x391\\x392\\x393\\x394\\x395\\x396\\x397\\x398\\x399\\x39A\\x39B\\x39C\\x39D\\x39E\\x39F\\x3A0\\x3A1\\xD2\\x3A3\\x3A4\\x3A5\\x3A6\\x3A7\\x3A8\\x3A9\\x3AA\\x3AB\\x3AC\\x3AD\\x3AE\\x3AF\\x3B0\\x3B1\\x3B2\\x3B3\\x3B4\\x3B5\\x3B6\\x3B7\\x3B8\\x3B9\\x3BA\\x3BB\\x3BC\\x3BD\\x3BE\\x3BF\\x3C0\\x3C1\\x3C2\\x3C3\\x3C4\\x3C5\\x3C6\\x3C7\\x3C8\\x3C9\\x3CA\\x3CB\\x3CC\\x3CD\\x3CE\\xFF\', vector (\'ISO_8859-7\', \'ISO_8859-7:1987\', \'ISO-IR-126\', \'ELOT_928\', \'ECMA-118\', \'GREEK\', \'GREEK8\', \'CSISOLATINGREEK\'))\n";
static const char *other30 = 
"charset_define (\'ISO-8859-8\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xD7\\xAB\\xAC\\xAD\\xAE\\x203E\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xF7\\xBB\\xBC\\xBD\\xBE\\xBF\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\xD0\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\xD7\\xD8\\xD9\\xDA\\xDB\\xDC\\xDD\\xDE\\x2017\\x5D0\\x5D1\\x5D2\\x5D3\\x5D4\\x5D5\\x5D6\\x5D7\\x5D8\\x5D9\\x5DA\\x5DB\\x5DC\\x5DD\\x5DE\\x5DF\\x5E0\\x5E1\\x5E2\\x5E3\\x5E4\\x5E5\\x5E6\\x5E7\\x5E8\\x5E9\\x5EA\\xFB\\xFC\\xFD\\xFE\\xFF\', vector (\'ISO_8859-8\', \'ISO_8859-8:1988\', \'ISO-IR-138\', \'HEBREW\', \'CSISOLATINHEBREW\'))\n";
static const char *other31 = 
"charset_define (\'ISO-8859-9\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\xBB\\xBC\\xBD\\xBE\\xBF\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\x11E\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\xD7\\xD8\\xD9\\xDA\\xDB\\xDC\\x130\\x15E\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\x11F\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\x131\\x15F\\xFF\', vector (\'ISO_8859-9\', \'ISO_8859-9:1989\', \'LATIN5\', \'L5\', \'ISO-IR-148\', \'LATIN5\', \'L5\', \'CSISOLATIN5\'))\n";
static const char *other32 = 
"charset_define (\'KOI-0\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\xA4\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\xBB\\xBC\\xBD\\xBE\\xBF\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\xD0\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\xD7\\xD8\\xD9\\xDA\\xDB\\xDC\\xDD\\xDE\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\xF0\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF\', NULL)\n";
static const char *other33 = 
"charset_define (\'KOI-7\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\xA4\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x42E\\x410\\x411\\x426\\x414\\x415\\x424\\x413\\x425\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x42F\\x420\\x421\\x422\\x423\\x416\\x412\\x42C\\x42B\\x417\\x428\\x42D\\x429\\x427\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\xBB\\xBC\\xBD\\xBE\\xBF\\xC0\\xC1\\xC2\\xC3\\xC4\\xC5\\xC6\\xC7\\xC8\\xC9\\xCA\\xCB\\xCC\\xCD\\xCE\\xCF\\xD0\\xD1\\xD2\\xD3\\xD4\\xD5\\xD6\\xD7\\xD8\\xD9\\xDA\\xDB\\xDC\\xDD\\xDE\\xDF\\xE0\\xE1\\xE2\\xE3\\xE4\\xE5\\xE6\\xE7\\xE8\\xE9\\xEA\\xEB\\xEC\\xED\\xEE\\xEF\\xF0\\xF1\\xF2\\xF3\\xF4\\xF5\\xF6\\xF7\\xF8\\xF9\\xFA\\xFB\\xFC\\xFD\\xFE\\xFF\', NULL)\n";
static const char *other34 = 
"charset_define (\'KOI8-A\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\xA4\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\xA3\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\xB3\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\xBB\\xBC\\xBD\\xBE\\xBF\\x44E\\x430\\x431\\x446\\x434\\x435\\x444\\x433\\x445\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x44F\\x440\\x441\\x442\\x443\\x436\\x432\\x44C\\x44B\\x437\\x448\\x44D\\x449\\x447\\x44A\\x42E\\x410\\x411\\x426\\x414\\x415\\x424\\x413\\x425\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x42F\\x420\\x421\\x422\\x423\\x416\\x412\\x42C\\x42B\\x417\\x428\\x42D\\x429\\x427\\xFF\', NULL)\n";
static const char *other35 = 
"charset_define (\'KOI8-B\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\xA1\\xA2\\x451\\xA4\\xA5\\xA6\\xA7\\xA8\\xA9\\xAA\\xAB\\xAC\\xAD\\xAE\\xAF\\xB0\\xB1\\xB2\\x401\\xB4\\xB5\\xB6\\xB7\\xB8\\xB9\\xBA\\xBB\\xBC\\xBD\\xBE\\xBF\\x44E\\x430\\x431\\x446\\x434\\x435\\x444\\x433\\x445\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x44F\\x440\\x441\\x442\\x443\\x436\\x432\\x44C\\x44B\\x437\\x448\\x44D\\x449\\x447\\x44A\\x42E\\x410\\x411\\x426\\x414\\x415\\x424\\x413\\x425\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x42F\\x420\\x421\\x422\\x423\\x416\\x412\\x42C\\x42B\\x417\\x428\\x42D\\x429\\x427\\x42A\', NULL)\n";
static const char *other36 = 
"charset_define (\'KOI8-E\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x80\\x81\\x82\\x83\\x84\\x85\\x86\\x87\\x88\\x89\\x8A\\x8B\\x8C\\x8D\\x8E\\x8F\\x90\\x91\\x92\\x93\\x94\\x95\\x96\\x97\\x98\\x99\\x9A\\x9B\\x9C\\x9D\\x9E\\x9F\\xA0\\x452\\x453\\x451\\x454\\x455\\x456\\x457\\x458\\x459\\x45A\\x45B\\x45C\\xAD\\x45E\\x45F\\x2116\\x402\\x403\\x401\\x404\\x405\\x406\\x407\\x408\\x409\\x40A\\x40B\\x40C\\xA4\\x40E\\x40F\\x44E\\x430\\x431\\x446\\x434\\x435\\x444\\x433\\x445\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x44F\\x440\\x441\\x442\\x443\\x436\\x432\\x44C\\x44B\\x437\\x448\\x44D\\x449\\x447\\x44A\\x42E\\x410\\x411\\x426\\x414\\x415\\x424\\x413\\x425\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x42F\\x420\\x421\\x422\\x423\\x416\\x412\\x42C\\x42B\\x417\\x428\\x42D\\x429\\x427\\x42A\', NULL)\n";
static const char *other37 = 
"charset_define (\'KOI8-F\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x2500\\x2502\\x250C\\x2510\\x2514\\x2518\\x251C\\x2524\\x252C\\x2534\\x253C\\x2580\\x2584\\x2588\\x258C\\x2590\\x2591\\x2018\\x2019\\x201C\\x201D\\x2022\\x2013\\x2014\\xA9\\x2122\\xA0\\xBB\\xAE\\xAB\\xB7\\xA4\\xA0\\x452\\x453\\x451\\x454\\x455\\x456\\x457\\x458\\x459\\x45A\\x45B\\x45C\\x491\\x45E\\x45F\\x2116\\x402\\x403\\x401\\x404\\x405\\x406\\x407\\x408\\x409\\x40A\\x40B\\x40C\\x490\\x40E\\x40F\\x44E\\x430\\x431\\x446\\x434\\x435\\x444\\x433\\x445\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x44F\\x440\\x441\\x442\\x443\\x436\\x432\\x44C\\x44B\\x437\\x448\\x44D\\x449\\x447\\x44A\\x42E\\x410\\x411\\x426\\x414\\x415\\x424\\x413\\x425\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x42F\\x420\\x421\\x422\\x423\\x416\\x412\\x42C\\x42B\\x417\\x428\\x42D\\x429\\x427\\x42A\', NULL)\n";
static const char *other38 = 
"charset_define (\'KOI8-R\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x2500\\x2502\\x250C\\x2510\\x2514\\x2518\\x251C\\x2524\\x252C\\x2534\\x253C\\x2580\\x2584\\x2588\\x258C\\x2590\\x2591\\x2592\\x2593\\x2320\\x25A0\\x2022\\x221A\\x2248\\x2264\\x2265\\xA0\\x2321\\xB0\\xB2\\xB7\\xF7\\x2550\\x2551\\x2552\\x451\\x2553\\x2554\\x2555\\x2556\\x2557\\x2558\\x2559\\x255A\\x255B\\x255C\\x255D\\x255E\\x255F\\x2560\\x2561\\x401\\x2562\\x2563\\x2564\\x2565\\x2566\\x2567\\x2568\\x2569\\x256A\\x256B\\x256C\\xA9\\x44E\\x430\\x431\\x446\\x434\\x435\\x444\\x433\\x445\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x44F\\x440\\x441\\x442\\x443\\x436\\x432\\x44C\\x44B\\x437\\x448\\x44D\\x449\\x447\\x44A\\x42E\\x410\\x411\\x426\\x414\\x415\\x424\\x413\\x425\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x42F\\x420\\x421\\x422\\x423\\x416\\x412\\x42C\\x42B\\x417\\x428\\x42D\\x429\\x427\\x42A\', vector (\'CSKOI8R\'))\n";
static const char *other39 = 
"charset_define (\'KOI8-U\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x2500\\x2502\\x250C\\x2510\\x2514\\x2518\\x251C\\x2524\\x252C\\x2534\\x253C\\x2580\\x2584\\x2588\\x258C\\x2590\\x2591\\x2592\\x2593\\x2320\\x25A0\\x2022\\x221A\\x2248\\x2264\\x2265\\xA0\\x2321\\xB0\\xB2\\xB7\\xF7\\x2550\\x2551\\x2552\\x451\\x454\\x2554\\x456\\x457\\x2557\\x2558\\x2559\\x255A\\x255B\\x491\\x255D\\x255E\\x255F\\x2560\\x2561\\x401\\x404\\x2563\\x406\\x407\\x2566\\x2567\\x2568\\x2569\\x256A\\x490\\x256C\\xA9\\x44E\\x430\\x431\\x446\\x434\\x435\\x444\\x433\\x445\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x44F\\x440\\x441\\x442\\x443\\x436\\x432\\x44C\\x44B\\x437\\x448\\x44D\\x449\\x447\\x44A\\x42E\\x410\\x411\\x426\\x414\\x415\\x424\\x413\\x425\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x42F\\x420\\x421\\x422\\x423\\x416\\x412\\x42C\\x42B\\x417\\x428\\x42D\\x429\\x427\\x42A\', NULL)\n";
static const char *other40 = 
"charset_define (\'MAC-UKRAINIAN\', N\'\\x1\\x2\\x3\\x4\\x5\\x6\\x7\\x8\\x9\\xA\\xB\\xC\\xD\\xE\\xF\\x10\\x11\\x12\\x13\\x14\\x15\\x16\\x17\\x18\\x19\\x1A\\x1B\\x1C\\x1D\\x1E\\x1F\\x20\\x21\\x22\\x23\\x24\\x25\\x26\\x27\\x28\\x29\\x2A\\x2B\\x2C\\x2D\\x2E\\x2F\\x30\\x31\\x32\\x33\\x34\\x35\\x36\\x37\\x38\\x39\\x3A\\x3B\\x3C\\x3D\\x3E\\x3F\\x40\\x41\\x42\\x43\\x44\\x45\\x46\\x47\\x48\\x49\\x4A\\x4B\\x4C\\x4D\\x4E\\x4F\\x50\\x51\\x52\\x53\\x54\\x55\\x56\\x57\\x58\\x59\\x5A\\x5B\\x5C\\x5D\\x5E\\x5F\\x60\\x61\\x62\\x63\\x64\\x65\\x66\\x67\\x68\\x69\\x6A\\x6B\\x6C\\x6D\\x6E\\x6F\\x70\\x71\\x72\\x73\\x74\\x75\\x76\\x77\\x78\\x79\\x7A\\x7B\\x7C\\x7D\\x7E\\x7F\\x410\\x411\\x412\\x413\\x414\\x415\\x416\\x417\\x418\\x419\\x41A\\x41B\\x41C\\x41D\\x41E\\x41F\\x420\\x421\\x422\\x423\\x424\\x425\\x426\\x427\\x428\\x429\\x42A\\x42B\\x42C\\x42D\\x42E\\x42F\\x2020\\xB0\\x490\\xA3\\xA7\\x2022\\xB6\\x406\\xAE\\xA9\\x2122\\x402\\x452\\x2260\\x403\\x453\\x221E\\xB1\\x2264\\x2265\\x456\\xB5\\x491\\x408\\x404\\x454\\x407\\x457\\x409\\x459\\x40A\\x45A\\x458\\x405\\xAC\\x221A\\x192\\x2248\\x2206\\xAB\\xBB\\x2026\\xA0\\x40B\\x45B\\x40C\\x45C\\x455\\x2013\\x2014\\x201C\\x201D\\x2018\\x2019\\xF7\\x201E\\x40E\\x45E\\x40F\\x45F\\x2116\\x401\\x451\\x44F\\x430\\x431\\x432\\x433\\x434\\x435\\x436\\x437\\x438\\x439\\x43A\\x43B\\x43C\\x43D\\x43E\\x43F\\x440\\x441\\x442\\x443\\x444\\x445\\x446\\x447\\x448\\x449\\x44A\\x44B\\x44C\\x44D\\x44E\\xA4\', NULL)\n";
static const char *proc78 = 
"create procedure\n"
"scheduler_init ()\n"
"{\n"
"if (registry_get (\'__scheduler_do_now__\') = \'1\')\n"
"registry_set (\'__scheduler_do_now__\', \'c\');\n"
"else\n"
"registry_set (\'__scheduler_do_now__\', \'0\');\n"
"}\n"
"--src system.sql:1998\n";

static const char *other41 = 
"scheduler_init ()\n";
static const char *proc79 = 
" create procedure SYS_GENERATE_ALL_OPS (in col_name varchar, in col_dtp integer := 193)\n"
"{\n"
"declare func, args varchar;\n"
"func :=\n"
"case dv_type_title (col_dtp)\n"
"when \'VARCHAR\'   then \'left\'\n"
"when \'VARBINARY\' then \'left\'\n"
"when \'NVARCHAR\'  then \'left\'\n"
"else \'\'\n"
"end;\n"
"args :=\n"
"case func\n"
"when \'left\' then \', 2000\'\n"
"else \'\'\n"
"end;\n"
"return sprintf(\n"
"\' count (distinct \"%I\"), \' ||\n"
"\' %s (min (\"%I\")%s), \' ||\n"
"\' %s (max (\"%I\")%s), \' ||\n"
"\' avg (raw_length(\"%I\")), \' ||\n"
"\'count (\"%I\")\',\n"
"col_name,\n"
"func, col_name, args,\n"
"func, col_name, args,\n"
"col_name,\n"
"col_name);\n"
"}\n"
"--src system.sql:2012\n";

static const char *proc80 = 
" create procedure SYS_GENERATE_ALL_VARS (in col_name varchar, in rate varchar:=null, in n_dist_rate varchar:=null )\n"
"{\n"
"if (rate is null)\n"
"{\n"
"return sprintf (\' n_dist_%I, min_%I, max_%I, avg_len_%I, vals_%I\', col_name, col_name, col_name, col_name, col_name);\n"
"}\n"
"else\n"
"{\n"
"if (n_dist_rate is null)\n"
"{\n"
"return sprintf (\' n_dist_%I, min_%I, max_%I, avg_len_%I, vals_%I*%s\', col_name, col_name, col_name, col_name, col_name, rate);\n"
"}\n"
"else\n"
"{\n"
"return sprintf (\' n_dist_%I*%s, min_%I, max_%I, avg_len_%I, vals_%I*%s\', col_name, n_dist_rate, col_name, col_name, col_name, col_name, rate);\n"
"}\n"
"}\n"
"}\n"
"--src system.sql:2043\n";

static const char *tbl9 = 
"create table SYS_STAT_VDB_MAPPERS (\n"
"SVDM_TYPE varchar,\n"
"SVDM_PROC varchar not null,\n"
"SVDM_DBMS_NAME_MASK varchar not null,\n"
"SVDM_DBMS_VER_MASK varchar not null,\n"
"primary key (SVDM_TYPE, SVDM_DBMS_NAME_MASK, SVDM_DBMS_VER_MASK))\n";

static const char *other42 = 
" insert soft SYS_STAT_VDB_MAPPERS\n"
"(SVDM_TYPE,\n"
"SVDM_PROC,\n"
"SVDM_DBMS_NAME_MASK,\n"
"SVDM_DBMS_VER_MASK)\n"
"values\n"
"(\'SYS_COL_STAT\',\n"
"\'DB.DBA.__ORACLE_SYS_COL_STAT\',\n"
"\'%ORACLE%\',\n"
"\'%\')\n";
static const char *other43 = 
" insert soft SYS_STAT_VDB_MAPPERS\n"
"(SVDM_TYPE,\n"
"SVDM_PROC,\n"
"SVDM_DBMS_NAME_MASK,\n"
"SVDM_DBMS_VER_MASK)\n"
"values\n"
"(\'SYS_COL_STAT\',\n"
"\'DB.DBA.__VIRTUOSO_SYS_COL_STAT\',\n"
"\'%VIRTUOSO%\',\n"
"\'%\')\n";
static const char *proc81 = 
"create procedure DB.DBA.__ORACLE_SYS_COL_STAT (in DSN varchar, in RT_NAME varchar, in RT_REMOTE_NAME varchar)\n"
"returns ANY\n"
"{\n"
"\n"
"declare _meta, _res any;\n"
"\n"
"rexecute (DSN,\n"
"\'select c.COLUMN_NAME, c.NUM_DISTINCT, NULL, NULL, c.AVG_COL_LEN, t.NUM_ROWS - c.NUM_NULLS, t.NUM_ROWS \' ||\n"
"\' from ALL_TABLES t, ALL_TAB_COLUMNS c where t.TABLE_NAME = c.TABLE_NAME and t.OWNER = c.OWNER and \' ||\n"
"\'  t.OWNER = ? and t.TABLE_NAME = ?\',\n"
"NULL, NULL, vector (name_part (RT_REMOTE_NAME, 1, NULL), name_part (RT_REMOTE_NAME, 2, NULL)),\n"
"NULL, _meta, _res);\n"
"\n"
"if (isarray (_res) and length (_res) > 0 and isarray (_res[0]) and isarray (_meta) and isarray (_meta[0]))\n"
"{\n"
"declare _inx, _len integer;\n"
"_inx := 0;\n"
"_len := length (_res);\n"
"exec_result_names (_meta[0]);\n"
"while (_inx < _len)\n"
"{\n"
"exec_result (_res[_inx]);\n"
"_inx := _inx + 1;\n"
"}\n"
"}\n"
"return NULL;\n"
"}\n"
"--src system.sql:2097\n";

static const char *proc82 = 
"create procedure DB.DBA.__VIRTUOSO_SYS_COL_STAT (in DSN varchar, in RT_NAME varchar, in RT_REMOTE_NAME varchar)\n"
"returns ANY\n"
"{\n"
"\n"
"declare _meta, _res any;\n"
"\n"
"rexecute (DSN,\n"
"\'select CS_COL, CS_N_DISTINCT, encode_base64 (serialize (CS_MIN)), encode_base64 (serialize (CS_MAX)), \' ||\n"
"\' CS_AVG_LEN, CS_N_VALUES, CS_N_ROWS from ALL_COL_STAT where CS_TABLE = complete_table_name (?, 1)\',\n"
"NULL, NULL, vector (RT_REMOTE_NAME),\n"
"NULL, _meta, _res);\n"
"\n"
"if (isarray (_res) and length (_res) > 0 and isarray (_res[0]) and isarray (_meta) and isarray (_meta[0]))\n"
"{\n"
"declare _inx, _len integer;\n"
"_inx := 0;\n"
"_len := length (_res);\n"
"exec_result_names (_meta[0]);\n"
"while (_inx < _len)\n"
"{\n"
"declare _res_row any;\n"
"_res_row := _res[_inx];\n"
"_res_row[2] := deserialize (decode_base64 (_res_row[2]));\n"
"_res_row[3] := deserialize (decode_base64 (_res_row[3]));\n"
"exec_result (_res_row);\n"
"_inx := _inx + 1;\n"
"}\n"
"}\n"
"return NULL;\n"
"}\n"
"--src system.sql:2126\n";

static const char *other44 = 
" insert soft SYS_STAT_VDB_MAPPERS\n"
"(SVDM_TYPE,\n"
"SVDM_PROC,\n"
"SVDM_DBMS_NAME_MASK,\n"
"SVDM_DBMS_VER_MASK)\n"
"values\n"
"(\'SYS_COL_STAT\',\n"
"\'DB.DBA.__INFORMIX_SYS_COL_STAT\',\n"
"\'%INFORMIX%\',\n"
"\'%\')\n";
static const char *proc83 = 
"create procedure DB.DBA.__INFORMIX_SYS_COL_STAT (in DSN varchar, in RT_NAME varchar, in RT_REMOTE_NAME varchar)\n"
"{\n"
"declare _meta, _res any;\n"
"declare i_meta, i_res any;\n"
"declare CS_COL, CS_N_DISTINCT, CS_MIN, CS_MAX, CS_AVG_LEN, CS_N_VALUES, CS_N_ROWS int;\n"
"declare tabid, colid int;\n"
"\n"
"rexecute (DSN, \'select t.nrows, c.colname, c.colno, c.colmin, c.colmax, c.collength, c.coltype from systables t, syscolumns c where c.tabid = t.tabid and t.owner = ? and t.tabname = ?\',\n"
"NULL, NULL, vector (name_part (RT_REMOTE_NAME, 1, NULL), name_part (RT_REMOTE_NAME, 2, NULL)), NULL, _meta, _res);\n"
"\n"
"rexecute (DSN, \'select part1, nunique from sysindexes i, systables t where t.tabid = i.tabid and t.owner = ? and t.tabname = ?\',\n"
"NULL, NULL, vector (name_part (RT_REMOTE_NAME, 1, NULL), name_part (RT_REMOTE_NAME, 2, NULL)), NULL, i_meta, i_res);\n"
"\n"
"if (isarray (_res) and length (_res) > 0 and isarray (_res[0]) and isarray (_meta) and isarray (_meta[0]))\n"
"{\n"
"declare _len, i_len, col_type int;\n"
"declare arr, crow any;\n"
"if (isarray (i_res) and length (i_res) > 0 and isarray (i_res[0]) and isarray (i_meta) and isarray (i_meta[0]))\n"
"i_len := length (i_res);\n"
"else\n"
"i_len := 0;\n"
"\n"
"result_names (CS_COL, CS_N_DISTINCT, CS_MIN, CS_MAX, CS_AVG_LEN, CS_N_VALUES, CS_N_ROWS);\n"
"arr := make_array (7, \'any\');\n"
"_len := length (_res);\n"
"for (declare i int, i := 0; i < _len; i := i + 1)\n"
"{\n"
"crow := _res[i];\n"
"CS_N_ROWS := crow[0];\n"
"CS_COL := trim(crow[1]);\n"
"CS_AVG_LEN := crow[5];\n"
"CS_N_VALUES := CS_N_ROWS;\n"
"CS_N_DISTINCT := CS_N_ROWS / 10;\n"
"col_type := mod (crow[6], 256);\n"
"\n"
"if (col_type = 5 or col_type = 8)\n"
"{\n"
"CS_AVG_LEN := crow[5]/256;\n"
"}\n"
"\n"
"if (col_type = 0 or col_type = 13 or col_type = 15 or col_type = 16)\n"
"{\n"
"if (crow[5] > 0)\n"
"{\n"
"CS_AVG_LEN := mod (crow[5], 256);\n"
"}\n"
"else\n"
"{\n"
"CS_AVG_LEN := mod ((crow[5] + 65536), 256);\n"
"}\n"
"}\n"
"else if (col_type = 10 or col_type = 14)\n"
"{\n"
"CS_AVG_LEN := mod (crow[5], 256);\n"
"}\n"
"\n"
"if (col_type > 0 and col_type < 7)\n"
"{\n"
"CS_MIN := crow[3];\n"
"CS_MAX := crow[4];\n"
"}\n"
"else\n"
"{\n"
"CS_MIN := null;\n"
"CS_MAX := null;\n"
"}\n"
"\n"
"for (declare j int, j := 0; j < i_len; j := j + 1)\n"
"{\n"
"if (i_res[j][0] = crow[2])\n"
"{\n"
"CS_N_DISTINCT := i_res[j][1];\n"
"j := i_len;\n"
"}\n"
"}\n"
"\n"
"if (cs_n_distinct is null) cs_n_distinct := cs_n_rows;\n"
"result (CS_COL, CS_N_DISTINCT, CS_MIN, CS_MAX, CS_AVG_LEN, CS_N_VALUES, CS_N_ROWS);\n"
"}\n"
"}\n"
"return null;\n"
"}\n"
"--src system.sql:2172\n";

static const char *proc84 = 
"create procedure SYS_STAT_VDB_SYNC ()\n"
"{\n"
"declare _ds_conn_str any;\n"
"for select RT_DSN, RT_REMOTE_NAME, DS_CONN_STR, RT_NAME\n"
"from DB.DBA.SYS_REMOTE_TABLE, DB.DBA.SYS_DATA_SOURCE where RT_DSN = DS_DSN do\n"
"{\n"
"declare rc int;\n"
"_ds_conn_str := deserialize (DS_CONN_STR);\n"
"rc := SYS_STAT_ANALYZE_VDB (RT_DSN, RT_REMOTE_NAME, _ds_conn_str, RT_NAME, 10, 1);\n"
"if (rc = 1)\n"
"{\n"
"commit work;\n"
"}\n"
"}\n"
"}\n"
"--src system.sql:2257\n";

static const char *proc85 = 
" create procedure SYS_STAT_ANALYZE_VDB (\n"
"in _ds_dsn varchar,\n"
"in _rt_remote_name varchar,\n"
"in _ds_conn_str any,\n"
"in tb_name varchar,\n"
"in perc_trsh int := 0,\n"
"in logerr int := 0\n"
")\n"
"{\n"
"declare vdb_stats_mapper varchar;\n"
"declare exit handler for sqlstate \'*\', NOT FOUND { goto map_done; };\n"
"declare _dbms_name, _dbms_ver varchar;\n"
"_dbms_name := get_keyword (17, _ds_conn_str, \'\');\n"
"_dbms_ver := get_keyword (18, _ds_conn_str, \'\');\n"
"\n"
"vdb_stats_mapper := NULL;\n"
"select top 1 SVDM_PROC into vdb_stats_mapper from SYS_STAT_VDB_MAPPERS\n"
"where\n"
"SVDM_TYPE = \'SYS_COL_STAT\' and\n"
"upper (_dbms_name) like SVDM_DBMS_NAME_MASK and\n"
"upper (_dbms_ver) like SVDM_DBMS_VER_MASK;\n"
"\n"
"if (vdb_stats_mapper is null)\n"
"goto map_done;\n"
"\n"
"declare res, _stat, _meta, _err any;\n"
"_stat := \'00000\';\n"
"if (0 <> exec (sprintf (\'\"%I\" (?, ? ,?)\', vdb_stats_mapper),\n"
"_stat, _err, vector (_ds_dsn, tb_name, _rt_remote_name), 10000, _meta, res))\n"
"goto map_done;\n"
"\n"
"if (not isarray (res))\n"
"goto map_done;\n"
"\n"
"if (length (res) = 0)\n"
"goto map_done;\n"
"\n"
"if (not isarray (res[0]))\n"
"goto map_done;\n"
"\n"
"if (length (res[0]) < 7)\n"
"goto map_done;\n"
"\n"
"if (perc_trsh > 0)\n"
"{\n"
"foreach (any elm in res) do\n"
"{\n"
"declare col_name varchar;\n"
"declare nrows, n_distinct int;\n"
"declare onrows, on_distinct int;\n"
"declare _percent, _base int;\n"
"\n"
"\n"
"col_name := elm[0];\n"
"n_distinct := elm[1];\n"
"nrows := elm[6];\n"
"\n"
"whenever not found goto update_stats;\n"
"select CS_N_DISTINCT, CS_N_ROWS into on_distinct, onrows\n"
"from DB.DBA.SYS_COL_STAT where CS_TABLE = tb_name and CS_COL = col_name;\n"
"\n"
"if (nrows <> onrows)\n"
"{\n"
"_base := __min (onrows, nrows);\n"
"if (_base > 0)\n"
"_percent := ((abs (nrows - onrows)*100)/_base);\n"
"else\n"
"_percent := 100;\n"
"if (_percent >= perc_trsh)\n"
"goto update_stats;\n"
"}\n"
"\n"
"if (n_distinct <> on_distinct)\n"
"{\n"
"_base := __min (n_distinct, on_distinct);\n"
"if (_base > 0)\n"
"_percent := ((abs (n_distinct - on_distinct)*100)/_base);\n"
"else\n"
"_percent := 100;\n"
"if (_percent >= perc_trsh)\n"
"goto update_stats;\n"
"}\n"
"\n"
"}\n"
"return 0;\n"
"}\n"
"update_stats:;\n"
"declare res_len, res_inx integer;\n"
"res_len := length (res);\n"
"res_inx := 0;\n"
"delete from DB.DBA.SYS_COL_STAT where CS_TABLE = tb_name;\n"
"while (res_inx < res_len)\n"
"{\n"
"declare rr, _min, _max any;\n"
"rr := res[res_inx];\n"
"_min := rr[2];\n"
"_max := rr[3];\n"
"\n"
"if (isstring (_min) or iswidestring (_min) or isbinary (_min))\n"
"_min := left (_min, 1000);\n"
"if (isstring (_max) or iswidestring (_max) or isbinary (_max))\n"
"_max := left (_max, 1000);\n"
"insert into DB.DBA.SYS_COL_STAT\n"
"(CS_TABLE, CS_COL, CS_N_DISTINCT, CS_MIN, CS_MAX, CS_AVG_LEN, CS_N_VALUES, CS_N_ROWS)\n"
"values\n"
"(tb_name, rr[0], rr[1], _min, _max, rr[4], rr[5], rr[6]);\n"
"res_inx := res_inx + 1;\n"
"}\n"
"__ddl_changed (tb_name);\n"
"\n"
"if (logerr)\n"
"{\n"
"log_message (sprintf (\'The statistics for table %s has been changed\', tb_name));\n"
"}\n"
"return 1;\n"
"map_done:;\n"
"if (logerr and isstring (_stat) and  _stat <> \'00000\')\n"
"log_message (sprintf (\'Can\\\'t contact to the DSN \"%s\" to refresh statistics on table \"%s\"\', _ds_dsn, tb_name));\n"
"\n"
"return 0;\n"
"}\n"
"--src system.sql:2276\n";

static const char *proc86 = 
" create procedure SYS_STAT_ANALYZE (in tb_name varchar, in pcnt integer:=5, in ignore_vdb integer:=1)\n"
"{\n"
"declare stmt, proc_name varchar;\n"
"declare proc any;\n"
"declare cr cursor for\n"
"select c.\"COLUMN\", c.COL_DTP\n"
"from DB.DBA.SYS_KEYS k, DB.DBA.SYS_KEY_PARTS kp, DB.DBA.SYS_COLS c\n"
"where\n"
"k.KEY_TABLE = tb_name and\n"
"c.\"COLUMN\" <> \'_IDN\' and\n"
"k.KEY_IS_MAIN = 1 and\n"
"k.KEY_MIGRATE_TO is null and\n"
"kp.KP_KEY_ID = k.KEY_ID and\n"
"COL_ID = KP_COL and\n"
"COL_DTP not in (125, 131, 132, 134, 254);\n"
"declare rc integer;\n"
"declare is_vdb integer;\n"
"declare tot_count integer;\n"
"declare _ds_dsn, _rt_remote_name varchar;\n"
"declare _ds_conn_str any;\n"
"\n"
"_ds_dsn := _rt_remote_name := NULL;\n"
"{\n"
"declare exit handler for not found { _ds_dsn := _rt_remote_name := NULL; };\n"
"\n"
"select RT_DSN, RT_REMOTE_NAME, deserialize (DS_CONN_STR)\n"
"into _ds_dsn, _rt_remote_name, _ds_conn_str\n"
"from DB.DBA.SYS_REMOTE_TABLE, DB.DBA.SYS_DATA_SOURCE\n"
"where RT_NAME = tb_name and RT_DSN = DS_DSN;\n"
"}\n"
"\n"
"if (_ds_dsn is null)\n"
"is_vdb := 0;\n"
"else\n"
"is_vdb := 1;\n"
"\n"
"if (is_vdb and ignore_vdb)\n"
"return;\n"
"\n"
"rc := 0;\n"
"\n"
"if (pcnt > 0)\n"
"rc := SYS_STAT_ANALYZE_VDB (_ds_dsn, _rt_remote_name, _ds_conn_str, tb_name);\n"
"\n"
"\n"
"if (rc = 1)\n"
"return;\n"
"\n"
"connection_set (\'rnd-stat-rate\', 0.0);\n"
"\n"
"proc := string_output ();\n"
"proc_name := sprintf (\'\"%I\"..\"STAT_ANALYZE_%I_%I\"\',\n"
"name_part (tb_name, 0),\n"
"name_part (tb_name, 1),\n"
"name_part (tb_name, 2));\n"
"http (sprintf (\'create procedure %s () { \\n\', proc_name), proc);\n"
"http (\'set isolation=\'\'uncommitted\'\'; \\n\', proc);\n"
"http (sprintf (\'delete from DB.DBA.SYS_COL_STAT where CS_TABLE = \'\'%S\'\'; \\n\', tb_name), proc);\n"
"open cr;\n"
"whenever not found goto done;\n"
"declare all_ops varchar;\n"
"declare all_vars varchar;\n"
"\n"
"all_ops := \'\';\n"
"all_vars := \'\';\n"
"\n"
"while (1)\n"
"{\n"
"declare col_name, stat, msg varchar;\n"
"declare col_dtp integer;\n"
"fetch cr into col_name, col_dtp;\n"
"http (sprintf (\' declare n_dist_%I integer; \\n\', col_name), proc);\n"
"http (sprintf (\' declare min_%I any; \\n\', col_name), proc);\n"
"http (sprintf (\' declare max_%I any; \\n\', col_name), proc);\n"
"http (sprintf (\' declare avg_len_%I integer; \\n\', col_name), proc);\n"
"http (sprintf (\' declare vals_%I integer; \\n\', col_name), proc);\n"
"\n"
"if (all_ops = \'\')\n"
"{\n"
"all_ops := SYS_GENERATE_ALL_OPS (col_name, col_dtp);\n"
"all_vars := SYS_GENERATE_ALL_VARS (col_name);\n"
"}\n"
"else\n"
"{\n"
"all_ops := concat (all_ops, \',\', SYS_GENERATE_ALL_OPS (col_name, col_dtp));\n"
"all_vars := concat (all_vars, \',\', SYS_GENERATE_ALL_VARS (col_name));\n"
"}\n"
"}\n"
"done:\n"
"close cr;\n"
"if (all_ops = \'\')\n"
"goto fin;\n"
"\n"
"http (\'declare n_rows varchar; \\n\', proc);\n"
"\n"
"if (pcnt)\n"
"{\n"
"if (is_vdb = 1)\n"
"{\n"
"http (\'declare tot_count integer;\\n\', proc);\n"
"http (sprintf (\'tot_count := DB.DBA.__VD_GET_SQLSTATS_COUNT (\'\'%S\'\', \'\'%S\'\');\\n\',\n"
"_ds_dsn, _rt_remote_name), proc);\n"
"http (\'if (tot_count is NULL)\\n\', proc);\n"
"http (\'{\\n\', proc);\n"
"http (sprintf (\'  declare cr_count cursor for select count (*) from \"%I\".\"%I\".\"%I\";\\n\',\n"
"name_part (tb_name, 0),\n"
"name_part (tb_name, 1),\n"
"name_part (tb_name, 2)), proc);\n"
"http (\'  open cr_count;\\n fetch cr_count into tot_count;\\n close cr_count;\\n\', proc);\n"
"http (\'}\\n\', proc);\n"
"http (\'declare cr2 cursor for \\n\', proc);\n"
"http (sprintf (\'select %s, count (*) from (select top 1000 * from \\\"%I\\\".\\\"%I\\\".\\\"%I\\\") f; \\n\',\n"
"all_ops,\n"
"name_part (tb_name, 0),\n"
"name_part (tb_name, 1),\n"
"name_part (tb_name, 2)), proc);\n"
"}\n"
"else\n"
"{\n"
"http (\'declare cr2 cursor for \\n\', proc);\n"
"http (sprintf (\'select %s, count (*) from \"%I\".\"%I\".\"%I\" table option ( random %d ); \\n\',\n"
"all_ops,\n"
"name_part (tb_name, 0),\n"
"name_part (tb_name, 1),\n"
"name_part (tb_name, 2),\n"
"pcnt), proc);\n"
"}\n"
"}\n"
"else\n"
"{\n"
"http (\'declare cr2 cursor for \\n\', proc);\n"
"http (sprintf (\'select %s, count (*) from \"%I\".\"%I\".\"%I\"; \\n\',\n"
"all_ops,\n"
"name_part (tb_name, 0),\n"
"name_part (tb_name, 1),\n"
"name_part (tb_name, 2)), proc);\n"
"}\n"
"\n"
"\n"
"http (\'open cr2; \\n\', proc);\n"
"http (sprintf (\'fetch cr2 into %s, n_rows; \\n\', all_vars) , proc);\n"
"\n"
"\n"
"open cr;\n"
"whenever not found goto done2;\n"
"\n"
"if (pcnt)\n"
"{\n"
"http (\' declare rate float; \\n\', proc);\n"
"http (\' declare ndist_rate float; \\n\', proc);\n"
"if (is_vdb = 1)\n"
"{\n"
"http (\' if (tot_count > 1000) rate := tot_count / 1000.0; \\n\', proc);\n"
"http (\' else rate := 1; \\n\', proc);\n"
"}\n"
"else\n"
"{\n"
"http (\' rate := connection_get (\\\'rnd-stat-rate\\\'); \\n\', proc);\n"
"}\n"
"}\n"
"while (1)\n"
"{\n"
"declare col_name varchar;\n"
"declare col_dtp integer;\n"
"fetch cr into col_name, col_dtp;\n"
"\n"
"if (pcnt)\n"
"{\n"
"http (sprintf (\' if (rate = 0 AND vals_%I <> 0 ) { rate := 1; }; \\n\', col_name), proc);\n"
"http (sprintf (\' if (n_dist_%I < 20) { ndist_rate := 1; } else {ndist_rate := rate; }; \\n\', col_name), proc);\n"
"\n"
"http (\'insert into DB.DBA.SYS_COL_STAT (CS_TABLE,CS_COL,CS_N_DISTINCT,CS_MIN,CS_MAX, CS_AVG_LEN, CS_N_VALUES,CS_N_ROWS) \', proc);\n"
"http (sprintf (\'values (\\\'%S\\\',\\\'%S\\\',%s, n_rows * %s); \\n\',\n"
"tb_name, col_name, SYS_GENERATE_ALL_VARS (col_name, \'rate\', \'ndist_rate\'), \'rate\'), proc);\n"
"}\n"
"else\n"
"{\n"
"http (\'insert into DB.DBA.SYS_COL_STAT (CS_TABLE,CS_COL,CS_N_DISTINCT,CS_MIN,CS_MAX, CS_AVG_LEN, CS_N_VALUES,CS_N_ROWS) \', proc);\n"
"http (sprintf (\'values (\\\'%S\\\',\\\'%S\\\',%s, n_rows); \\n\',\n"
"tb_name, col_name, SYS_GENERATE_ALL_VARS (col_name)), proc);\n"
"}\n"
"\n"
"}\n"
"done2:\n"
"http (\'close cr2; \\n\', proc);\n"
"close cr;\n"
"fin:\n"
"\n"
"\n"
"http (sprintf (\'__ddl_changed (\'\'%S\'\'); \\n\', tb_name), proc);\n"
"http (\'}\\n\', proc);\n"
"\n"
"proc := string_output_string (proc);\n"
"\n"
"exec (proc, NULL, NULL);\n"
"exec (sprintf (\'%s ()\', proc_name), NULL, NULL);\n"
"exec (sprintf (\'drop procedure %s\', proc_name), NULL, NULL);\n"
"}\n"
"--src system.sql:2401\n";

static const char *proc87 = 
" create procedure SYS_DB_STAT (in pcnt integer:=null, in ignore_vdb integer:=1)\n"
"{\n"
"declare cnt integer;\n"
"cnt:=0;\n"
"if (pcnt is null) pcnt := 5;\n"
"for select distinct (KEY_TABLE) as TB_NAME from SYS_KEYS where\n"
"not exists (\n"
"select * from SYS_VIEWS where KEY_TABLE = V_NAME\n"
") do {\n"
"if (TB_NAME <> \'DB.DBA.SYS_COL_STAT\')\n"
"{\n"
"SYS_STAT_ANALYZE (TB_NAME, pcnt, ignore_vdb);\n"
"cnt := cnt + 1;\n"
"}\n"
"}\n"
"return cnt;\n"
"}\n"
"--src system.sql:2603\n";

static const char *proc88 = 
" create procedure SYS_STAT_HISTOGRAM (in tb_name varchar, in col_name varchar,\n"
"in n_buckets integer, in prec integer := 1)\n"
"{\n"
"declare proc any;\n"
"declare proc_name,escaped_tb_name varchar;\n"
"declare is_inx, is_analyzed integer;\n"
"\n"
"select count (*) into is_analyzed from DB.DBA.SYS_COL_STAT where CS_TABLE = tb_name and CS_COL = col_name;\n"
"\n"
"select count (*) into is_inx from DB.DBA.SYS_KEYS, DB.DBA.SYS_KEY_PARTS, DB.DBA.SYS_COLS\n"
"where\n"
"KP_KEY_ID = KEY_ID and\n"
"KP_NTH = 0 and\n"
"KP_COL = COL_ID and\n"
"KEY_TABLE = tb_name and\n"
"\"COLUMN\" = col_name;\n"
"\n"
"proc_name := sprintf (\'\"%I\"..\"STAT_HIST_%I_%I_%I\"\',\n"
"name_part (tb_name, 0),\n"
"name_part (tb_name, 1),\n"
"name_part (tb_name, 2),\n"
"col_name);\n"
"escaped_tb_name := sprintf (\'\"%I\".\"%I\".\"%I\"\',\n"
"name_part (tb_name, 0),\n"
"name_part (tb_name, 1),\n"
"name_part (tb_name, 2));\n"
"proc := string_output();\n"
"http (sprintf (\'create procedure %s (in n_buckets integer := %d, in prec integer := %d) {\\n\',\n"
"proc_name, n_buckets, prec), proc);\n"
"http (\'declare row_cnt, inx, last_inx integer; \\n\', proc);\n"
"http (\'declare _column_val any; \\n\', proc);\n"
"http (\'set isolation=\'\'uncommitted\'\'; \\n\', proc);\n"
"http (\'inx := 0; \\n\', proc);\n"
"http (sprintf (\n"
"\'delete from DB.DBA.SYS_COL_HIST where CH_TABLE = \'\'%S\'\' and CH_COL = \'\'%S\'\'; \\n\',\n"
"tb_name, col_name), proc);\n"
"if (is_inx = 0)\n"
"{\n"
"http (\'row_cnt := 0; \\n\', proc);\n"
"http (sprintf (\n"
"\'for select \"%I\" from %s where \\n\',\n"
"col_name, escaped_tb_name), proc);\n"
"http (sprintf (\n"
"\' (row_cnt := row_cnt + 1, mod (row_cnt - 1, prec, \"%I\")) = 0 order by \"%I\" do\\n{\\n\',\n"
"col_name, col_name), proc);\n"
"http (sprintf (\n"
"\'  _column_val := \"%I\"; \', col_name), proc);\n"
"http (\'if (mod (inx, (row_cnt / n_buckets) / prec) = 0) \\n{\\n\', proc);\n"
"}\n"
"else\n"
"{\n"
"http (sprintf (\'select count (*) into row_cnt from %s; \\n\',\n"
"escaped_tb_name), proc);\n"
"http (sprintf (\n"
"\'for select \"%I\" from %s order by \"%I\" do \\n{\\n\',\n"
"col_name, escaped_tb_name, col_name), proc);\n"
"http (\'if (mod (inx, prec) = 0 and mod (inx, row_cnt / (n_buckets * prec)) = 0)\\n{\\n\', proc);\n"
"}\n"
"http (\'insert into DB.DBA.SYS_COL_HIST (CH_TABLE, CH_COL, CH_NTH_SAMPLE, CH_VALUE) values\\n\', proc);\n"
"http (sprintf (\n"
"\' (\'\'%S\'\', \'\'%S\'\', inx, \"%I\"); \\n\',\n"
"tb_name, col_name, col_name), proc);\n"
"http (\'last_inx := inx;\\n}\\n inx := inx + 1;\\n}\\n\', proc);\n"
"http (\'if (row_cnt > 0 and last_inx < inx)\\n\', proc);\n"
"http (\'insert into DB.DBA.SYS_COL_HIST (CH_TABLE, CH_COL, CH_NTH_SAMPLE, CH_VALUE) values\\n\', proc);\n"
"http (sprintf (\n"
"\' (\'\'%S\'\', \'\'%S\'\', inx, _column_val); \\n\',\n"
"tb_name, col_name), proc);\n"
"if (is_analyzed > 0)\n"
"http (sprintf (\n"
"\'__ddl_changed (\'\'%S\'\');\\n\',\n"
"tb_name), proc);\n"
"http (\'}\', proc);\n"
"proc := string_output_string (proc);\n"
"exec (proc);\n"
"exec (sprintf (\'%s ()\', proc_name));\n"
"exec (sprintf (\'drop procedure %s\', proc_name));\n"
"\n"
"if (is_analyzed = 0)\n"
"DB..SYS_STAT_ANALYZE (tb_name, prec);\n"
"}\n"
"--src system.sql:2623\n";

static const char *tbl10 = 
"create table\n"
"DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME varchar,\n"
"SDT_SCH long varchar,\n"
"SDT_SOAP_SCH long varchar,\n"
"SDT_TYPE integer,\n"
"SDT_UDT varchar,\n"
"primary key (SDT_NAME, SDT_TYPE))\n";


static const char *proc89 = 
" create procedure\n"
"DB.DBA.SOAP_DATATYPES_UPGRADE ()\n"
"{\n"
"if (exists (select 1 from SYS_COLS where \\TABLE = \'DB.DBA.SYS_SOAP_DATATYPES\' and \\COLUMN = \'SDT_TYPE\') and\n"
"exists (select 1 from SYS_COLS where \\TABLE = \'DB.DBA.SYS_SOAP_DATATYPES\' and \\COLUMN = \'SDT_UDT\') )\n"
"return;\n"
"log_message (\'Upgrading the SYS_SOAP_DATATYPES table\');\n"
"execstr (\'alter table DB.DBA.SYS_SOAP_DATATYPES rename DB.DBA.SYS_SOAP_DATATYPES_OLD\');\n"
"execstr (\'create table DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME varchar, SDT_SCH long varchar, SDT_SOAP_SCH long varchar, SDT_TYPE integer, SDT_UDT varchar, primary key (SDT_NAME, SDT_TYPE))\');\n"
"execstr (\'insert into DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME, SDT_SCH, SDT_SOAP_SCH, SDT_TYPE) select (case when strrchr (SDT_NAME, \'\':\'\') is null then concat (\'\'services.wsdl:\'\',SDT_NAME) else SDT_NAME end) , SDT_SCH, SDT_SOAP_SCH, 0 from DB.DBA.SYS_SOAP_DATATYPES_OLD\');\n"
"}\n"
"--src system.sql:2717\n";


static const char *other45 = 
" DB.DBA.SOAP_DATATYPES_UPGRADE ()\n";

static const char *proc90 = 
" create procedure\n"
"soap_dt_define (in name varchar, in sch varchar, in udt_name varchar := null)\n"
"{\n"
"declare xt, xte any;\n"
"declare is_elem integer;\n"
"xt := NULL; xte := null; is_elem := 0;\n"
"if (sch is not null)\n"
"{\n"
"declare err, name1, tns varchar;\n"
"if (isentity (sch))\n"
"xte := sch;\n"
"else\n"
"xte := xml_tree_doc (xml_tree (sch));\n"
"xt := xslt (\'http://local.virt/soap_sch\', xte, vector (\'udt_struct\', case when isstring(udt_name) then 1 else 0 end));\n"
"err := xpath_eval (\'string(//@error)\', xt, 1);\n"
"if (xpath_eval (\'/element\', xte, 1) is not null)\n"
"is_elem := 1;\n"
"if (xpath_eval (\'/attribute\', xte, 1) is not null)\n"
"is_elem := -1;\n"
"err := cast (err as varchar);\n"
"if (err <> \'\')\n"
"signal (\'22023\', err, \'SODT1\');\n"
"name1 := cast(xpath_eval (\'string(/@name)\', xt, 1) as varchar);\n"
"tns := cast(xpath_eval (\'string(/@targetNamespace)\', xte, 1) as varchar);\n"
"if (tns is null or tns = \'\')\n"
"name := name1;\n"
"else\n"
"name := sprintf (\'%s:%s\', tns, name1);\n"
"insert replacing DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME,SDT_SCH,SDT_TYPE, SDT_UDT)\n"
"values (name, sch, is_elem, udt_name);\n"
"{\n"
"declare cmpl, cname, cname2,  sch2 varchar;\n"
"cmpl := xpath_eval (\'/element/complexType\', xte, 1);\n"
"\n"
"if (cmpl is not null)\n"
"{\n"
"cname := sprintf (\'elementType__%s\', name1);\n"
"if (tns is null or tns = \'\')\n"
"cname2 := cname;\n"
"else\n"
"cname2 := sprintf (\'%s:%s\', tns, cname);\n"
"sch2 := xslt (\'http://local.virt/soap_sch\', cmpl, vector (\'type_name\', cname));\n"
"__soap_dt_define (cname2, sch2, sch2, 0, udt_name);\n"
"insert replacing DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME,SDT_SCH, SDT_TYPE, SDT_UDT) values (cname2, sch2, 0, udt_name);\n"
"}\n"
"}\n"
"}\n"
"else\n"
"delete from DB.DBA.SYS_SOAP_DATATYPES where SDT_NAME = name;\n"
"__soap_dt_define (name, xt, xte, is_elem, udt_name);\n"
"return name;\n"
"}\n"
"--src system.sql:2735\n";

static const char *proc91 = 
" create procedure SET_IDENTITY_COLUMN (in tbl_name varchar, in col_name varchar, in num integer)\n"
"{\n"
"if (not exists (select 1 from DB.DBA.SYS_COLS where \"TABLE\" = tbl_name and \"COLUMN\" = col_name))\n"
"{\n"
"if (not exists (select 1 from DB.DBA.SYS_COLS where \"TABLE\" = tbl_name))\n"
"signal (\'10050\', concat (\'No table \', tbl_name, \' in call to SET_IDENTITY_COLUMN\'));\n"
"else\n"
"signal (\'10050\', concat (\'No column \', col_name, \' in table \', tbl_name, \' in call to SET_IDENTITY_COLUMN\'));\n"
"}\n"
"return sequence_set (concat (name_part (tbl_name, 0, \'DB\'), \'.\',\n"
"name_part (tbl_name, 1, user), \'.\', tbl_name, \'.\', col_name), num, 0);\n"
"}\n"
"--src system.sql:2792\n";

static const char *proc92 = 
" create procedure GET_IDENTITY_COLUMN (in tbl_name varchar, in col_name varchar, in no_check int := 0)\n"
"{\n"
"if (no_check = 0 and not exists (select 1 from DB.DBA.SYS_COLS where \"TABLE\" = tbl_name and \"COLUMN\" = col_name))\n"
"{\n"
"if (not exists (select 1 from DB.DBA.SYS_COLS where \"TABLE\" = tbl_name))\n"
"signal (\'10050\', concat (\'No table \', tbl_name, \' in call to GET_IDENTITY_COLUMN\'));\n"
"else\n"
"signal (\'10050\', concat (\'No column \', col_name, \' in table \', tbl_name, \' in call to GET_IDENTITY_COLUMN\'));\n"
"}\n"
"return sequence_set (concat (name_part (tbl_name, 0, \'DB\'), \'.\',\n"
"name_part (tbl_name, 1, user), \'.\', tbl_name, \'.\', col_name), 0, 2);\n"
"}\n"
"--src system.sql:2807\n";

static const char *other46 = 
"xml_add_system_path(\'file://system/\')\n";
static const char *proc93 = 
"create procedure\n"
"DAV_USER_SET_PASSWORD (in name varchar, in passwd varchar)\n"
"{\n"
"USER_PASSWORD_SET (name, passwd);\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"}\n"
"--src system.sql:2825\n";

static const char *proc94 = 
" create procedure DB.DBA.HTTP_CLIENT (\n"
"in url varchar,\n"
"in uid varchar := null,\n"
"in pwd varchar := null,\n"
"in http_method varchar := \'GET\',\n"
"in http_headers varchar := null,\n"
"in body varchar := null,\n"
"in cert_file varchar := null,\n"
"in cert_pwd varchar := null,\n"
"in timeout int := null\n"
")\n"
"{\n"
"\n"
"if (cert_file is null and url like \'https://%\')\n"
"cert_file := \'1\';\n"
"return http_client_internal (url, uid, pwd, http_method, http_headers, body, cert_file, cert_pwd, null, timeout);\n"
"}\n"
"--src system.sql:2843\n";

static const char *proc95 = 
" create procedure DB.DBA.HTTP_CLIENT_EXT (\n"
"in url varchar,\n"
"in uid varchar := null,\n"
"in pwd varchar := null,\n"
"in http_method varchar := \'GET\',\n"
"in http_headers varchar := null,\n"
"in body varchar := null,\n"
"in cert_file varchar := null,\n"
"in cert_pwd varchar := null,\n"
"inout headers any,\n"
"in timeout int := null\n"
")\n"
"{\n"
"\n"
"if (cert_file is null and url like \'https://%\')\n"
"cert_file := \'1\';\n"
"return http_client_internal (url, uid, pwd, http_method, http_headers, body, cert_file, cert_pwd, headers, timeout);\n"
"}\n"
"--src system.sql:2863\n";

static const char *proc96 = 
"create procedure vsmx_user_check (in name varchar, in pass varchar)\n"
"{\n"
"return 1;\n"
"}\n"
"--src system.sql:2883\n";

static const char *proc97 = 
" create procedure\n"
"DB.DBA.SOAP_VSMX (in path any, in params any, in lines any)\n"
"{ ?>\n"
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"\n"
"\"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n"
"<HTML>\n"
"<HEAD>\n"
"<STYLE>\n"
"BODY\n"
"{\n"
"MARGIN-TOP: 0px;\n"
"FONT-SIZE: 80%;\n"
"MARGIN-LEFT: 0em;\n"
"COLOR: #000000;\n"
"MARGIN-RIGHT: 0em;\n"
"FONT-FAMILY: Verdana, \'MS Serif\', Serif;\n"
"BACKGROUND-COLOR: #ffffff\n"
"}\n"
".head1\n"
"{\n"
"PADDING-BOTTOM: 5px;\n"
"MARGIN-LEFT: -3em;\n"
"COLOR: #191970;\n"
"LINE-HEIGHT: normal;\n"
"MARGIN-RIGHT: -3em;\n"
"PADDING-TOP: 5px;\n"
"BORDER-BOTTOM: navy thin solid;\n"
"FONT-FAMILY: Verdana, Arial, Helvetica, Lucida, Sans-Serif;\n"
"BACKGROUND-COLOR: skyblue;\n"
"TEXT-ALIGN: right\n"
"}\n"
"DIV.foot\n"
"{\n"
"CLEAR: left;\n"
"BORDER-TOP: lightslategray thin solid;\n"
"FONT-SIZE: 10px;\n"
"LINE-HEIGHT: normal;\n"
"FONT-FAMILY: Verdana, Arial, Helvetica, Lucida, Sans-Serif;\n"
"TEXT-ALIGN: right\n"
"}\n"
"H1\n"
"{\n"
"PADDING-RIGHT: 3em;\n"
"MARGIN-TOP: 5px;\n"
"FONT-SIZE: 185%;\n"
"MARGIN-BOTTOM: 5px;\n"
"MARGIN-LEFT: 0em\n"
"}\n"
"A\n"
"{\n"
"COLOR: blue;\n"
"TEXT-DECORATION: none\n"
"}\n"
"A:hover\n"
"{\n"
"TEXT-DECORATION: underline\n"
"}\n"
".operation\n"
"{\n"
"PADDING-RIGHT: 10px;\n"
"PADDING-LEFT: 30px;\n"
"PADDING-BOTTOM: 10px;\n"
"PADDING-TOP: 10px;\n"
"VERTICAL-ALIGN: top;\n"
"}\n"
".soaplist\n"
"{\n"
"VERTICAL-ALIGN: top;\n"
"PADDING-RIGHT: 5px;\n"
"PADDING-LEFT: 25px;\n"
"PADDING-BOTTOM: 10px;\n"
"MARGIN: 0px;\n"
"WIDTH: 225px;\n"
"PADDING-TOP: 10px;\n"
"BACKGROUND-COLOR: gainsboro\n"
"}\n"
".soapdesc\n"
"{\n"
"FONT-SIZE: 90%;\n"
"FONT-FAMILY: Tahoma\n"
"}\n"
"INPUT\n"
"{\n"
"BORDER-RIGHT: silver 1px solid;\n"
"BORDER-TOP: silver 1px solid;\n"
"BORDER-LEFT: silver 1px solid;\n"
"BORDER-BOTTOM: silver 1px solid;\n"
"FONT-FAMILY: Tahoma\n"
"}\n"
".btns\n"
"{\n"
"TEXT-ALIGN: right\n"
"}\n"
"TABLE.service\n"
"{\n"
"BORDER-RIGHT: #ebebeb 1px solid;\n"
"BORDER-TOP: #ebebeb 1px solid;\n"
"BORDER-LEFT: #ebebeb 1px solid;\n"
"BORDER-BOTTOM: #ebebeb 1px solid;\n"
"FONT-FAMILY: Tahoma\n"
"}\n"
"TH.service\n"
"{\n"
"BACKGROUND-COLOR: silver;\n"
"TEXT-ALIGN: left\n"
"}\n"
"H2\n"
"{\n"
"FONT-SIZE: 150%;\n"
"MARGIN-LEFT: -20px\n"
"}\n"
"H3\n"
"{\n"
"FONT-SIZE: 120%;\n"
"MARGIN-BOTTOM: 0px;\n"
"MARGIN-LEFT: -10px\n"
"}\n"
".soapli\n"
"{\n"
"PADDING-BOTTOM: 5px;\n"
"TEXT-INDENT: -20px\n"
"}\n"
"TD.service\n"
"{\n"
"BACKGROUND-COLOR: #f0f0f0\n"
"}\n"
".response\n"
"{\n"
"BORDER-RIGHT: #f0f0f0 1px solid;\n"
"PADDING-RIGHT: 2px;\n"
"BORDER-TOP: #f0f0f0 1px solid;\n"
"PADDING-LEFT: 2px;\n"
"PADDING-BOTTOM: 2px;\n"
"BORDER-LEFT: #f0f0f0 1px solid;\n"
"PADDING-TOP: 2px;\n"
"BORDER-BOTTOM: #f0f0f0 1px solid\n"
"}\n"
".details\n"
"{\n"
"PADDING-RIGHT: 2px;\n"
"PADDING-LEFT: 30px;\n"
"PADDING-BOTTOM: 2px;\n"
"PADDING-TOP: 10px;\n"
"BACKGROUND-COLOR: #f0f0f0;\n"
"TEXT-ALIGN: left\n"
"}\n"
".level1\n"
"{\n"
"COLOR: blue\n"
"}\n"
".level2\n"
"{\n"
"COLOR: red\n"
"}\n"
".level3\n"
"{\n"
"COLOR: green\n"
"}\n"
".level4\n"
"{\n"
"COLOR: teal\n"
"}\n"
".attribname\n"
"{\n"
"TEXT-ALIGN: right;\n"
"}\n"
".attrib\n"
"{\n"
"COLOR: #990000\n"
"}\n"
"</STYLE>\n"
"<TITLE>Web Service Testing</TITLE>\n"
"</HEAD>\n"
"<BODY>\n"
"<DIV class=\"head1\"><H1>Web Services Test Page (VSMX)</H1></DIV>\n"
"<?vsp\n"
"declare this_page varchar;\n"
"declare wsdl any;\n"
"declare inx, len, _u_id integer;\n"
"this_page := \'services.vsmx\';\n"
"set http_charset=\'UTF-8\';\n"
"http_header (\'Cache-Control: no-cache, must-revalidate\\r\\nPragma: no-cache\\r\\nExpires: Thu, 01 Dec 1994 01:02:03 GMT\\r\\n\');\n"
"\n"
"?>\n"
"<DIV class=\"soappage\">\n"
"<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n"
"<TR><TD class=\"soaplist\">\n"
"<H2>Services Available</H2>\n"
"<?vsp\n"
"declare xt any;\n"
"wsdl := soap_wsdl();\n"
"if (not (registry_get (\'old_vsmx\') = \'1\') and isstring (file_stat (http_root()||\'/vsmx/oper.vspx\')))\n"
"{\n"
"declare sid any;\n"
"sid := vspx_sid_generate ();\n"
"insert into VSPX_SESSION (VS_REALM, VS_SID, VS_UID, VS_STATE, VS_EXPIRY)\n"
"values (\'vsmx\', sid, null,\n"
"serialize (vector (\'wsdl\', wsdl, \'loc\', WS.WS.EXPAND_URL (HTTP_REQUESTED_URL(),\'services.wsdl\'))),\n"
"now ());\n"
"http_request_status (\'HTTP/1.1 302 Found\');\n"
"http_header (sprintf (\'Location: /vsmx/oper.vspx?sid=%s&realm=vsmx\\r\\n\', sid));\n"
"http_rewrite ();\n"
"return;\n"
"}\n"
"xt := xml_tree_doc (wsdl);\n"
"inx := 0;\n"
"_u_id := (select top 1 U_ID from DB.DBA.SYS_USERS where U_NAME = http_map_get (\'soap_uid\'));\n"
"for select 0 as TP, P_NAME as operation, coalesce (P_TEXT, blob_to_string (P_MORE)) as content\n"
"from DB.DBA.SYS_PROCEDURES where (name_part (P_NAME, 0) = http_map_get (\'soap_qual\')\n"
"and name_part (P_NAME,1) = http_map_get (\'soap_uid\'))\n"
"or exists (select 1 from DB.DBA.SYS_GRANTS where G_USER = _u_id and G_OP = 32 and G_OBJECT = P_NAME)\n"
"\n"
"union select 0 as TP, G_OBJECT as operation, \'\' as content from DB.DBA.SYS_GRANTS where\n"
"G_USER = _u_id and G_OP = 32 and __proc_exists (G_OBJECT) is not null\n"
"and not exists (select 1 from DB.DBA.SYS_PROCEDURES where G_OBJECT = P_NAME)\n"
"\n"
"union select 1 as TP, M_NAME as operation, blob_to_string (M_TEXT) as content\n"
"from DB.DBA.SYS_METHODS, DB.DBA.SYS_USER_TYPES where M_ID = UT_ID and\n"
"exists (select 1 from DB.DBA.SYS_GRANTS where G_USER = _u_id and G_OP = 32 and G_OBJECT = UT_NAME)\n"
"do\n"
"{\n"
"declare comments, title, elm, operation1, q, o varchar;\n"
"\n"
"q := name_part (operation, 0);\n"
"o := name_part (operation, 1);\n"
"\n"
"if (TP = 1)\n"
"operation1 := operation;\n"
"else if ((length (q) + length (o) + 3) < length (operation))\n"
"operation1 := substring (operation, length (q) + length (o) + 3, length (operation));\n"
"else\n"
"goto nxt;\n"
"\n"
"operation := operation1;\n"
"\n"
"elm := xpath_eval (sprintf (\'/definitions/portType/operation[@name = \\\'%s\\\']\', operation), xt);\n"
"if (elm is null)\n"
"goto nxt;\n"
"title := regexp_match (\'--##.*\', content);\n"
"if (title is null)\n"
"title := \'\';\n"
"else\n"
"title := substring (title, 5, length (title));\n"
"?>\n"
"<DIV class=\"soapli\"><A href=\"<?=this_page?>?operation=<?=operation?>\"><?=operation?></A><BR />\n"
"<SPAN class=\"soapdesc\"><?=title?></SPAN></DIV>\n"
"<?vsp\n"
"inx := inx + 1;\n"
"nxt:;\n"
"}\n"
"?>\n"
"</TD>\n"
"<TD class=\"operation\">\n"
"<?vsp\n"
"\n"
"if ({?\'operation\'} is not null )\n"
"{\n"
"declare xe, pars any;\n"
"declare xps, url varchar;\n"
"wsdl := soap_wsdl();\n"
"xe := xml_tree_doc (wsdl);\n"
"if (xpath_eval (sprintf (\'/definitions/binding/operation[@name=\"%s\"]/operation[@style=\"document\"]\', {?\'operation\'}), xe) is null)\n"
"{\n"
"xps := sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part\', {?\'operation\'});\n"
"}\n"
"else if (xpath_eval (sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part[@name=\"parameters\"]\', {?\'operation\'}), xe) is not null)\n"
"{\n"
"declare elm_name any;\n"
"declare pos int;\n"
"\n"
"xps := sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part/@element\', {?\'operation\'});\n"
"elm_name := cast (xpath_eval (xps, xe) as varchar);\n"
"pos := strrchr (elm_name, \':\');\n"
"if (pos is not null)\n"
"{\n"
"elm_name := subseq (elm_name, pos + 1, length (elm_name));\n"
"}\n"
"xps := sprintf (\'/definitions/types/schema/element[@name = \"%s\"]//element\', elm_name);\n"
"}\n"
"else\n"
"{\n"
"xps := sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part\', {?\'operation\'});\n"
"}\n"
"\n"
"pars := xpath_eval (xps, xe, 0);\n"
"url := cast (xpath_eval (\'/definitions/service/port/address/@location\', xe, 1) as varchar);\n"
"len := length (pars);\n"
"inx := 0;\n"
"?>\n"
"<H2><?={?\'operation\'}?></H2>\n"
"<H3>Details</H3>\n"
"<P>The service end point is: <?=url?></P>\n"
"<P>The WSDL end point is: <A href=\"<?=url?>/services.wsdl\"><?=url?>/services.wsdl</A></P>\n"
"<H3>Test</H3>\n"
"<FORM method=\"POST\" action=\"<?=this_page?>\">\n"
"<INPUT type=\"hidden\" name=\"operation\" value=\"<?={?\'operation\'}?>\" >\n"
"<INPUT type=\"hidden\" name=\"url\" value=\"<?=url?>\" >\n"
"<TABLE class=\"service\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\">\n"
"<TR>\n"
"<TH class=\"service\">Parameter</TH>\n"
"<TH class=\"service\">Value</TH>\n"
"<TH class=\"service\">Type</TH>\n"
"</TR>\n"
"<?vsp\n"
"while (inx < len)\n"
"{\n"
"declare n, t varchar;\n"
"n := xpath_eval (\'@name\', pars[inx], 1);\n"
"t := xpath_eval (\'@type\', pars[inx], 1);\n"
"n := cast (n as varchar); t := cast (t as varchar);\n"
"if (t like \'http://www.w3.org/____/XMLSchema:%\')\n"
"{\n"
"t := substring (t, length (\'http://www.w3.org/____/XMLSchema:\') + 1, length (t));\n"
"t := concat (\'xsd:\', t);\n"
"}\n"
"else if (strchr (t, \':\') is not null and t not like \'xsd:%\')\n"
"{\n"
"declare colon integer;\n"
"colon := strrchr (t, \':\');\n"
"t := substring (t, colon + 1, length (t));\n"
"t := concat (\'s\', t);\n"
"}\n"
"?>\n"
"<TR>\n"
"<TD class=\"service\"><?=n?></TD>\n"
"<?vsp if (t like \'xsd:%\') { ?>\n"
"<TD class=\"service\"><input type=\"text\" name=\"<?=n?>\" size=\"40\" /></TD>\n"
"<?vsp } else { ?>\n"
"<TD class=\"service\"><textarea name=\"<?=n?>\" rows=10 cols=\"40\"><?vsp\n"
"if (t like \'_:%\' and t not like \'_:ArrayOf%\')\n"
"{\n"
"declare struct, t1 any;\n"
"declare i, l integer;\n"
"t1 := substring (t, 3, length (t));\n"
"xps :=\n"
"sprintf (\'/definitions/types/schema/complexType[@name = \'\'%s\'\']/*/element/@name\', t1);\n"
"struct := xpath_eval (xps, xe, 0);\n"
"i := 0; l := length (struct);\n"
"while (i < l)\n"
"{\n"
"http (cast (struct[i] as varchar));\n"
"http (\'=\\r\\n\');\n"
"i := i + 1;\n"
"}\n"
"}\n"
"?></textarea></TD>\n"
"<?vsp } ?>\n"
"<TD class=\"service\"><SPAN class=\"datatype\"><?=t?></SPAN>\n"
"<input type=\"hidden\" name=\"<?=n?>_type\" value=\"<?=t?>\"></TD>\n"
"</TR>\n"
"<?vsp\n"
"inx := inx + 1;\n"
"}\n"
"if (not inx)\n"
"{\n"
"?>\n"
"<TR><TD class=\"service\" colspan=\"2\">No input parameters are required for this service.</TD></TR>\n"
"<?vsp\n"
"}\n"
"?>\n"
"<TR><TD class=\"btns\" colspan=\"2\"><input type=\"submit\" name=\"callit\" value=\"Invoke\"></TD></TR>\n"
"</TABLE>\n"
"</form>\n"
"<?vsp\n"
"}\n"
"\n"
"if ({?\'operation\'} is not null and {?\'callit\'} is not null)\n"
"{\n"
"declare hinfo, result, ver, pars1, _url any;\n"
"declare xe, xps, pars any;\n"
"wsdl := soap_wsdl();\n"
"xe := xml_tree_doc (wsdl);\n"
"_url := {?\'url\'};\n"
"hinfo := WS.WS.PARSE_URI ({?\'url\'});\n"
"\n"
"if (xpath_eval (sprintf (\'/definitions/binding/operation[@name=\"%s\"]/operation[@style=\"document\"]\', {?\'operation\'}), xe) is null)\n"
"{\n"
"xps := sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part\', {?\'operation\'});\n"
"}\n"
"else if (xpath_eval (sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part[@name=\"parameters\"]\', {?\'operation\'}), xe) is not null)\n"
"{\n"
"declare elm_name any;\n"
"declare pos int;\n"
"\n"
"xps := sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part/@element\', {?\'operation\'});\n"
"elm_name := cast (xpath_eval (xps, xe) as varchar);\n"
"pos := strrchr (elm_name, \':\');\n"
"if (pos is not null)\n"
"{\n"
"elm_name := subseq (elm_name, pos + 1, length (elm_name));\n"
"}\n"
"xps := sprintf (\'/definitions/types/schema/element[@name = \"%s\"]//element\', elm_name);\n"
"}\n"
"else\n"
"{\n"
"xps := sprintf (\'/definitions/message[@name = \\\'%sRequest\\\']/part\', {?\'operation\'});\n"
"}\n"
"pars := xpath_eval (xps, xe, 0);\n"
"len := length (pars);\n"
"inx := 0;\n"
"pars1 := vector ();\n"
"while (inx < len)\n"
"{\n"
"declare exit handler for sqlstate \'*\' {\n"
"result := xml_tree_doc (sprintf (\'<Error>\n"
"<Code>%V\n"
"</Code>\n"
"<Message>%V\n"
"</Message>\n"
"</Error>\', __SQL_STATE, __SQL_MESSAGE));\n"
"goto err;\n"
"};\n"
"declare n, t, v, va varchar;\n"
"n := xpath_eval (\'@name\', pars[inx], 1);\n"
"t := xpath_eval (\'@type\', pars[inx], 1);\n"
"n := cast (n as varchar); t := cast (t as varchar);\n"
"if (t like \'http://www.w3.org/____/XMLSchema:%\')\n"
"{\n"
"t := substring (t, length (\'http://www.w3.org/____/XMLSchema:\') + 1, length (t));\n"
"t := concat (\'xsd:\', t);\n"
"}\n"
"else if (strchr (t, \':\') is not null and t not like \'xsd:%\')\n"
"{\n"
"declare colon integer;\n"
"colon := strrchr (t, \':\');\n"
"t := substring (t, colon + 1, length (t));\n"
"t := concat (\'s\', t);\n"
"}\n"
"v := get_keyword (n, params);\n"
"if (t like \'_:ArrayOf%\')\n"
"{\n"
"v := replace (v, \'\\r\\n\', \'\\n\');\n"
"va := split_and_decode (v, 0, \'\\0\\0\\n\');\n"
"pars1 := vector_concat (pars1, vector (n, va));\n"
"}\n"
"else if (t like \'_:%\')\n"
"{\n"
"declare r, struct, rstr any;\n"
"declare i, l integer;\n"
"v := replace (v, \'\\r\\n\', \'\\n\');\n"
"va := coalesce (split_and_decode (v, 0, \'\\0\\0\\n=\'), vector ());\n"
"t := substring (t, 3, length (t));\n"
"xps :=\n"
"sprintf (\'/definitions/types/schema/complexType[@name = \'\'%s\'\']/*/element/@name\', t);\n"
"struct := xpath_eval (xps, xe, 0);\n"
"i := 0; l := length (struct);\n"
"rstr := vector (composite(), \'<soap_box_structure>\');\n"
"while (i < l)\n"
"{\n"
"declare part nvarchar;\n"
"part := get_keyword (struct[i], va);\n"
"part := charset_recode (part,\'UTF-8\',\'_WIDE_\');\n"
"rstr := vector_concat (rstr, vector (cast (struct[i] as varchar), part));\n"
"i := i + 1;\n"
"}\n"
"pars1 := vector_concat (pars1, vector (n, rstr));\n"
"}\n"
"else if (t like \'%:dateTime\')\n"
"{\n"
"v := charset_recode (v,\'UTF-8\',\'_WIDE_\');\n"
"v := cast (v as varchar);\n"
"v := cast (v as datetime);\n"
"pars1 := vector_concat (pars1, vector (n, v));\n"
"}\n"
"else\n"
"{\n"
"v := charset_recode (v,\'UTF-8\',\'_WIDE_\');\n"
"pars1 := vector_concat (pars1, vector (n, v));\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"\n"
"ver := 11;\n"
"{\n"
"declare exit handler for sqlstate \'*\' {\n"
"result := xml_tree_doc (sprintf (\'<Error>\n"
"<Code>%V\n"
"</Code>\n"
"<Message>%V\n"
"</Message>\n"
"</Error>\', __SQL_STATE, __SQL_MESSAGE));\n"
"goto err;\n"
"};\n"
"if (atoi (cfg_item_value (virtuoso_ini_path(), \'HTTPServer\', \'ServerThreads\')) < 2)\n"
"{\n"
"result := xml_tree_doc (sprintf (\'<Error>\n"
"<Code>%V\n"
"</Code>\n"
"<Message>%V\n"
"</Message>\n"
"</Error>\', \'42000\', \'At least two HTTP threads must be available\'));\n"
"goto err;\n"
"}\n"
"else\n"
"{\n"
"result := DB.DBA.SOAP_CLIENT (url=>_url, operation=>{?\'operation\'}, parameters=>pars1, version=>ver);\n"
"}\n"
"}\n"
"\n"
"if (ver = 11)\n"
"{\n"
"if (result[0][0] <> \' root\')\n"
"result := vector (vector(\' root\'), result);\n"
"result := xml_tree_doc (result);\n"
"}\n"
"else\n"
"{\n"
"result := xml_tree_doc (sprintf (\'<Error>\n"
"<Code>%V\n"
"</Code>\n"
"<Message>%V\n"
"</Message>\n"
"</Error>\', ver[1], ver[2]));\n"
"}\n"
"err:;\n"
"declare ses any;\n"
"ses := xslt (\'__soap_vsmx\', result, vector (\'service\', {?\'operation\'}));\n"
"http_value (ses);\n"
"}\n"
"\n"
"?>\n"
"</TD></TR></TABLE>\n"
"</DIV>\n"
"<DIV class=\"foot\"><SPAN class=\"foot\">Virtuoso Universal Server <?=sys_stat(\'st_dbms_ver\')?> - Copyright&copy; 1999-2004 OpenLink Software.</SPAN></DIV>\n"
"</BODY>\n"
"</HTML>\n"
"<?vsp\n"
"}\n"
"--src system.sql:2890\n";


static const char *other47 = 
" xslt_sheet (\'__soap_vsmx\', xml_tree_doc(\'<?xml version=\"1.0\"?>\n"
"<xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\">\n"
"<xsl:output method=\"html\" indent=\"yes\" encoding=\"UTF-8\" />\n"
"<xsl:param name=\"service\" select=\"\'\'\'\'\" />\n"
"<xsl:param name=\"ret_uri\" select=\"\'\'services.vsmx\'\'\" />\n"
"<xsl:template match=\"/\">\n"
"<H3>Response</H3>\n"
"<BR />\n"
"<DIV class=\"response\"><xsl:apply-templates select=\"*\">\n"
"<xsl:with-param name=\"level\">1</xsl:with-param></xsl:apply-templates></DIV>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*\"><xsl:param name=\"level\" />\n"
"<DIV class=\"details\">\n"
"<SPAN><xsl:attribute name=\"class\">level<xsl:value-of select=\"$level\" /></xsl:attribute>\n"
"<xsl:value-of select=\"local-name()\"/>:</SPAN>\n"
"<xsl:if test=\"$level > 1\">\n"
"<SPAN class=\"data\"><xsl:value-of select=\"text()\"/>\n"
"<xsl:if test=\"@*\">\n"
"<BR /><TABLE border=\"0\" cellpadding=\"0\" cellspacing=\"2\">\n"
"<xsl:for-each select=\"@*\">\n"
"<xsl:if test=\"(namespace-uri(.) != \'\'urn:schemas-microsoft-com:datatypes\'\')\n"
"and (namespace-uri(.) != \'\'http://www.w3.org/2001/XMLSchema-instance\'\')\n"
"and (namespace-uri(.) != \'\'http://schemas.xmlsoap.org/soap/encoding/\'\')\n"
"and (namespace-uri(.) != \'\'urn:schemas-openlink-com:xml-sql\'\')\">\n"
"<TR><TD class=\"attribname\"><xsl:value-of select=\"local-name()\" />=</TD>\n"
"<TD class=\"attrib\">\"<xsl:value-of select=\".\" />\"</TD></TR>\n"
"</xsl:if>\n"
"</xsl:for-each>\n"
"</TABLE>\n"
"</xsl:if>\n"
"</SPAN>\n"
"</xsl:if>\n"
"<xsl:apply-templates select=\"*\">\n"
"<xsl:with-param name=\"level\"><xsl:value-of select=\"$level+1\" /></xsl:with-param>\n"
"</xsl:apply-templates>\n"
"</DIV>\n"
"</xsl:template>\n"
"</xsl:stylesheet>\')\n"
")\n";
static const char *proc98 = 
"create procedure WSDL_EXPAND (in _base_url any, in rsv any, inout schem any, inout defs any, inout ret any)\n"
"{\n"
"declare idx, len, idx1, len1, use_cache integer;\n"
"declare _location, _what varchar;\n"
"declare _new, _import, _base, sch, t1, t2 any;\n"
"\n"
"if (not isarray (schem)) schem := vector ();\n"
"if (not isarray (defs))  defs := vector ();\n"
"if (not rsv is NULL)  _base_url := WS.WS.EXPAND_URL (_base_url, rsv);\n"
"\n"
"use_cache := 0;\n"
"\n"
"_base := WSDL_GET (_base_url, use_cache);\n"
"\n"
"if (rsv is NULL)  ret := _base;\n"
"\n"
"sch := xpath_eval (\'/definitions/import\', _base, 0);\n"
"\n"
"if (length (t1 := xpath_eval (\'/definitions/types/schema\', _base, 0)) > 0) schem := vector_concat (t1, schem);\n"
"if (length (t2 := xpath_eval (\'/definitions\', _base, 0)) > 0) defs := vector_concat (defs, t2);\n"
"\n"
"idx := 0; len := length (sch);\n"
"while (idx < len)\n"
"{\n"
"_location := cast (xpath_eval (\'@location\', sch[idx], 1) as varchar);\n"
"_import := WSDL_GET (WS.WS.EXPAND_URL (_base_url, _location), use_cache);\n"
"_new := xpath_eval (\'/definitions/import\', _import, 0);\n"
"if (length (t1 := xpath_eval (\'/definitions/types/schema\', _import, 0))>0) schem := vector_concat (schem, t1);\n"
"if (length (t2 := xpath_eval (\'/definitions\', _import, 0)) > 0) defs := vector_concat (defs, t2);\n"
"len1 := length (_new); idx1 := 0;\n"
"if (length (_new) > 0)\n"
"{\n"
"while (idx1 < len1)\n"
"{\n"
"_what := cast (xpath_eval (\'@location\', _new[0], 1) as varchar);\n"
"_base_url := WS.WS.EXPAND_URL (_base_url, _location);\n"
"WSDL_EXPAND (_base_url, _what, schem, defs, ret);\n"
"idx1 := idx1 + 1;\n"
"}\n"
"}\n"
"idx := idx + 1;\n"
"}\n"
"}\n"
"--src system.sql:3463\n";

static const char *proc99 = 
" create procedure\n"
"DB.DBA.SOAP_WSDL_IMPORT (in url varchar, in mode_wsdl integer := 1, in wire_dump integer := 0, in drop_module integer := 0)\n"
"{\n"
"declare wsdl, xp, xt, uri, hinfo, sch, ret, pt any;\n"
"declare i, l, i1, l1, is_literal integer;\n"
"declare err, name, tns, mname, stmt, transport varchar;\n"
"declare port_name, port_name_last any;\n"
"declare tt, dmod varchar;\n"
"\n"
"WSDL_EXPAND (url, NULL, sch, pt, wsdl);\n"
"\n"
"i1 := 0; l1 := length (sch);\n"
"while (i1 < l1)\n"
"{\n"
"xp := xpath_eval (\'complexType\', sch[i1], 0);\n"
"tns := xpath_eval (\'@targetNamespace\', sch[i1], 1);\n"
"if (tns is not null)\n"
"{\n"
"tns := cast (tns as varchar);\n"
"tns := concat (tns, \':\');\n"
"}\n"
"else\n"
"tns := \'\';\n"
"\n"
"i := 0; l := length (xp);\n"
"while (i < l)\n"
"{\n"
"xt := xslt (\'http://local.virt/soap_sch\', xp[i]);\n"
"err := xpath_eval (\'string(//@error)\', xt, 1);\n"
"err := cast (err as varchar);\n"
"if (err <> \'\')\n"
"{\n"
"rollback work;\n"
"signal (\'22023\', err, \'SODT1\');\n"
"}\n"
"name := cast(xpath_eval (\'string(/complexType/@name)\', xt, 1) as varchar);\n"
"if (not exists (select 1 from DB.DBA.SYS_SOAP_DATATYPES where SDT_NAME = concat (tns, name) and SDT_TYPE = 0))\n"
"{\n"
"insert soft DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME,SDT_SCH,SDT_TYPE) values (concat(tns, name), xt, 0);\n"
"__soap_dt_define (concat(tns, name), xt);\n"
"}\n"
"i := i + 1;\n"
"}\n"
"xp := xpath_eval (\'element\', sch[i1], 0);\n"
"i := 0; l := length (xp);\n"
"while (i < l)\n"
"{\n"
"xt := xslt (\'http://local.virt/soap_sch\', xp[i], vector (\'target_Namespace\', rtrim(tns, \':\')));\n"
"err := xpath_eval (\'string(//@error)\', xt, 1);\n"
"err := cast (err as varchar);\n"
"if (err <> \'\')\n"
"{\n"
"rollback work;\n"
"signal (\'22023\', err, \'SODT1\');\n"
"}\n"
"name := cast(xpath_eval (\'string(/element/@name)\', xt, 1) as varchar);\n"
"if (not exists (select 1 from DB.DBA.SYS_SOAP_DATATYPES where SDT_NAME = concat (tns, name) and SDT_TYPE = 1))\n"
"{\n"
"insert soft DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME,SDT_SCH,SDT_TYPE) values (concat(tns, name), xt, 1);\n"
"__soap_dt_define (concat(tns, name), xt, NULL, 1);\n"
"}\n"
"\n"
"{\n"
"declare cmpl, cname, cname2,  sch2 varchar;\n"
"cmpl := xpath_eval (sprintf (\'element[%d]/complexType[*]\', (i+1)), sch[i1], 1);\n"
"\n"
"if (cmpl is not null)\n"
"{\n"
"declare name1 varchar;\n"
"name1 := cast(xpath_eval (sprintf (\'string(element[%d]/@name)\' , (i+1)), sch[i1], 1) as varchar);\n"
"cname := sprintf (\'elementType__%s\', name1);\n"
"if (tns is null or tns = \'\')\n"
"cname2 := cname;\n"
"else\n"
"cname2 := sprintf (\'%s%s\', tns, cname);\n"
"sch2 := xslt (\'http://local.virt/soap_sch\', cmpl,\n"
"vector (\'type_name\', cname, \'target_Namespace\', rtrim(tns, \':\')));\n"
"__soap_dt_define (cname2, sch2, sch2, 0);\n"
"insert replacing DB.DBA.SYS_SOAP_DATATYPES (SDT_NAME,SDT_SCH, SDT_TYPE) values (cname2, sch2, 0);\n"
"}\n"
"}\n"
"i := i + 1;\n"
"}\n"
"i1 := i1 + 1;\n"
"}\n"
"declare extens any;\n"
"declare ns_ext nvarchar;\n"
"extens := xpath_eval (\'[xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"] //*[@wsdl:required = \"true\"]\', wsdl, 0);\n"
"i1 := 0; l1 := length (extens);\n"
"while (i1 < l1)\n"
"{\n"
"ns_ext := xpath_eval (\'namespace-uri(.)\', extens[i1], 1);\n"
"if (ns_ext <> N\'http://schemas.xmlsoap.org/wsdl/soap/\')\n"
"{\n"
"rollback work;\n"
"signal (\'22023\', \'Not supported extensibility element\', \'SODT2\');\n"
"}\n"
"i1 := i1 + 1;\n"
"}\n"
"\n"
"\n"
"mname := cast (xpath_eval (\'/definitions/service/@name\', wsdl, 1) as varchar);\n"
"uri := cast (xpath_eval (\'[xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"] /definitions/service/port/soap:address/@location\', wsdl, 1) as varchar);\n"
"hinfo := WS.WS.PARSE_URI (uri);\n"
"\n"
"stmt := concat (\'CREATE MODULE \', DB.DBA.SYS_ALFANUM_NAME (mname), \' {\\r\\n\');\n"
"dmod := concat (\'DROP MODULE \', DB.DBA.SYS_ALFANUM_NAME (mname));\n"
"ret := vector (mname);\n"
"i1 := 0; l1 := length (pt);\n"
"while (i1 < l1)\n"
"{\n"
"if (not port_name is NULL or port_name <> 0) port_name_last := port_name;\n"
"port_name := cast (xpath_eval (\'/definitions/portType/@name\', pt[i1], 1) as varchar);\n"
"if (port_name is NULL) goto new_loop;\n"
"if ((port_name_last <> port_name) and\n"
"(port_name_last <> \'0\') and\n"
"(port_name_last <> 0) and\n"
"(not port_name_last is NULL))\n"
"port_name := port_name_last;\n"
"tt := sprintf (\'[xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"] /definitions/binding[@type like \'\'%s\'\']/soap:binding/@transport\', concat (\'%\', port_name));\n"
"if (transport := FIND_WSDL (pt, tt) is NULL) goto new_loop;\n"
"tt := sprintf (\'/definitions/portType[@name like \'\'%s\'\']/operation\', port_name);\n"
"xp := xpath_eval (tt, pt[i1], 0);\n"
"i := 0; l := length (xp);\n"
"while (i < l)\n"
"{\n"
"declare i_message, o_message, i_parm, o_parm any;\n"
"declare o_name, o_ns, soap_action, _ins, _out varchar;\n"
"declare colon, j, k integer;\n"
"declare ppars, res_pars varchar;\n"
"declare encoded any;\n"
"\n"
"o_name := cast (xpath_eval (\'@name\', xp[i], 1) as varchar);\n"
"\n"
"i_message := cast (xpath_eval (\'input/@message\', xp[i], 1) as varchar);\n"
"o_message := cast (xpath_eval (\'output/@message\', xp[i], 1) as varchar);\n"
"\n"
"colon := strrchr (i_message, \':\');\n"
"if (colon is not null)\n"
"i_message := substring (i_message, colon+2, length (i_message));\n"
"colon := strrchr (o_message, \':\');\n"
"if (colon is not null)\n"
"o_message := substring (o_message, colon+2, length (o_message));\n"
"\n"
"tt := sprintf (\'/definitions/message[@name like \'\'%s\'\']/part\', concat (\'%\', i_message));\n"
"i_parm := FIND_WSDL(pt ,tt);\n"
"\n"
"tt := sprintf (\'/definitions/message[@name like \'\'%s\'\']/part\', concat (\'%\', o_message));\n"
"o_parm := FIND_WSDL(pt ,tt);\n"
"\n"
"ppars := \'\'; res_pars := vector ();\n"
"_ins := \'\'; _out := \'\';\n"
"\n"
"\n"
"\n"
"declare have_in_par integer;\n"
"j := 0; k := length (i_parm); have_in_par := 0;\n"
"is_literal := 0;\n"
"while (j < k)\n"
"{\n"
"declare par, typ varchar;\n"
"par := cast (xpath_eval (\'@name\', i_parm[j]) as varchar);\n"
"typ := cast (xpath_eval (\'@type\', i_parm[j]) as varchar);\n"
"if (typ is NULL)\n"
"{\n"
"typ := cast (xpath_eval (\'@element\', i_parm[j]) as varchar);\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"is_literal := 1;\n"
"}\n"
"if (j > 0)\n"
"{\n"
"_ins := concat (_ins, \',\');\n"
"ppars := concat (ppars, \',\');\n"
"}\n"
"_ins := concat (_ins, \'IN _\', par, \' any __soap_type \'\'\',typ ,\'\'\'\');\n"
"ppars := concat (ppars, sprintf (\'vector(\'\'%s\'\', \'\'%s\'\'), _\', par, typ), par);\n"
"res_pars := vector_concat (res_pars, vector (concat (\'_\', par), typ));\n"
"j := j + 1;\n"
"}\n"
"have_in_par := j;\n"
"\n"
"\n"
"\n"
"j := 0; k := length (o_parm);\n"
"while (j < k)\n"
"{\n"
"declare par, typ varchar;\n"
"par := cast (xpath_eval (\'@name\', o_parm[j]) as varchar);\n"
"typ := cast (xpath_eval (\'@type\', o_parm[j]) as varchar);\n"
"if (j > 0 or have_in_par > 0)\n"
"{\n"
"_out := concat (_out, \',\');\n"
"}\n"
"_out := concat (_out, \'OUT _\', par ,\' any __soap_type \'\'\',typ ,\'\'\'\');\n"
"\n"
"j := j + 1;\n"
"}\n"
"\n"
"stmt := concat (stmt, \'\\r\\n PROCEDURE \', o_name, \' (\', _ins);\n"
"\n"
"ret := vector_concat (ret, vector(o_name, res_pars));\n"
"o_ns := cast (xpath_eval (\n"
"sprintf (\'/definitions/binding/operation[@name = \'\'%s\'\']/input/body/@namespace\',\n"
"o_name), wsdl, 1) as varchar);\n"
"soap_action :=\n"
"cast (xpath_eval (\n"
"sprintf (\'/definitions/binding/operation[@name = \'\'%s\'\']/operation/@soapAction\',\n"
"o_name), wsdl, 1) as varchar);\n"
"\n"
"encoded := cast (xpath_eval (\n"
"sprintf (\'[xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"] /definitions/binding/operation[@name = \'\'%s\'\']/input/soap:body/@use\',\n"
"o_name), wsdl, 1) as varchar);\n"
"\n"
"if (encoded is not null and encoded = \'literal\')\n"
"{\n"
"encoded := 1;\n"
"is_literal := 1;\n"
"}\n"
"else\n"
"encoded := 0;\n"
"\n"
"if (wire_dump)\n"
"encoded := encoded + 2;\n"
"\n"
"if (soap_action is null or soap_action = \'\')\n"
"{\n"
"soap_action := \'\"\"\';\n"
"}\n"
"else\n"
"{\n"
"soap_action := concat (\'\"\',trim (soap_action, \'\" \'),\'\"\');\n"
"}\n"
"\n"
"if (length (o_ns))\n"
"o_ns := sprintf (\'\'\'%s\'\'\', o_ns);\n"
"else\n"
"o_ns := \'NULL\';\n"
"\n"
"soap_action := sprintf (\'\'\'%s\'\'\', soap_action);\n"
"\n"
"if (not mode_wsdl)\n"
"stmt := concat (stmt, _out);\n"
"\n"
"if (is_literal)\n"
"stmt := concat (stmt, \') \\n returns any __soap_doc \'\'__VOID__\'\'\\n\');\n"
"else\n"
"stmt := concat (stmt, \') \\n returns any __soap_type \'\'__VOID__\'\'\\n\');\n"
"\n"
"if (mode_wsdl)\n"
"{\n"
"stmt := concat (stmt, \'{\\n  declare res, ver any;\\n  ver:=11;\\n  \');\n"
"stmt := concat (stmt,\n"
"sprintf (\'res := soap_call_new (\'\'%s\'\',\'\'%s\'\',\\n    %s, \'\'%s\'\', vector (%s), ver, NULL, NULL, %s, %d);\\n\',\n"
"hinfo[1], hinfo[2], o_ns, o_name, ppars, soap_action, encoded));\n"
"stmt := concat (stmt, \'  if (ver <> 11) signal (ver[1], ver[2]); \\r\\n return res; };  \');\n"
"}\n"
"else\n"
"{\n"
"stmt := concat (stmt, \'{ \\n declare ret any; \\n return ret; \\n} ;\\n\');\n"
"}\n"
"\n"
"i := i + 1;\n"
"}\n"
"new_loop:\n"
"i1 := i1 + 1;\n"
"}\n"
"stmt := concat (stmt, \'  \\r\\n} \\n\');\n"
"\n"
"if (length (stmt) > 7)\n"
"{\n"
"if (drop_module)\n"
"{\n"
"declare st1, ms1 varchar;\n"
"st1 := \'00000\';\n"
"exec (dmod, st1, ms1);\n"
"}\n"
"DB.DBA.EXEC_STMT (stmt, 0);\n"
"}\n"
"else\n"
"ret := NULL;\n"
"return ret;\n"
"}\n"
"--src system.sql:3510\n";

static const char *proc100 = 
"create procedure FIND_WSDL (in _all any, in _what varchar)\n"
"{\n"
"declare idx, len integer;\n"
"declare ret any;\n"
"\n"
"len := length (_all);\n"
"idx := 0;\n"
"\n"
"while (idx < len)\n"
"{\n"
"ret := xpath_eval (_what, _all[idx], 0);\n"
"if (length (ret) > 0)\n"
"return ret;\n"
"idx := idx + 1;\n"
"}\n"
"\n"
"return NULL;\n"
"}\n"
"--src system.sql:3798\n";

static const char *proc101 = 
"create procedure WSDL_GET (in uri varchar, in _mode integer)\n"
"{\n"
"declare _hdr, _ret any;\n"
"\n"
"\n"
"_ret := xml_uri_get (uri, \'\');\n"
"_ret := xml_tree_doc (_ret);\n"
"return _ret;\n"
"}\n"
"--src system.sql:3819\n";

static const char *proc102 = 
" create procedure SQL_PROCEDURE_COLUMNSW (\n"
"in qual varchar,\n"
"in owner varchar,\n"
"in name varchar,\n"
"in col varchar,\n"
"in casemode integer,\n"
"in is_odbc3 integer\n"
")\n"
"{\n"
"declare PROCEDURE_CAT, PROCEDURE_SCHEM, PROCEDURE_NAME, COLUMN_NAME, TYPE_NAME, REMARKS nvarchar;\n"
"declare COLUMN_SIZE, BUFFER_LENGTH integer;\n"
"declare COLUMN_TYPE, DATA_TYPE, DECIMAL_DIGITS, NUM_PREC_RADIX, NULLABLE smallint;\n"
"\n"
"declare COLUMN_DEF, IS_NULLABLE nvarchar;\n"
"declare SQL_DATA_TYPE, SQL_DATETIME_SUB smallint;\n"
"declare CHAR_OCTET_LENGTH, ORDINAL_POSITION integer;\n"
"\n"
"\n"
"result_names (PROCEDURE_CAT, PROCEDURE_SCHEM, PROCEDURE_NAME, COLUMN_NAME,\n"
"COLUMN_TYPE, DATA_TYPE, TYPE_NAME, COLUMN_SIZE, BUFFER_LENGTH,\n"
"DECIMAL_DIGITS, NUM_PREC_RADIX, NULLABLE, REMARKS,\n"
"COLUMN_DEF, SQL_DATA_TYPE, SQL_DATETIME_SUB, CHAR_OCTET_LENGTH, ORDINAL_POSITION, IS_NULLABLE);\n"
"\n"
"declare full_name varchar;\n"
"declare inx, sz integer;\n"
"declare cols, elt any;\n"
"\n"
"full_name := name;\n"
"if (owner is not null)\n"
"full_name := concat (owner, \'.\', full_name);\n"
"else if (qual is not null)\n"
"full_name := concat (\'.\', full_name);\n"
"\n"
"if (qual is not null)\n"
"full_name := concat (qual, \'.\', full_name);\n"
"\n"
"for\n"
"select\n"
"P_NAME\n"
"from DB.DBA.SYS_PROCEDURES\n"
"where\n"
"either (casemode,\n"
"charset_recode (upper (charset_recode (P_NAME, \'UTF-8\', \'_WIDE_\')), \'_WIDE_\', \'UTF-8\'),\n"
"P_NAME) like\n"
"either (casemode, charset_recode (upper (charset_recode (full_name, \'UTF-8\', \'_WIDE_\')), \'_WIDE_\', \'UTF-8\'), full_name)\n"
"and __proc_exists (P_NAME) is not null\n"
"do\n"
"{\n"
"cols := procedure_cols (P_NAME);\n"
"if (cols)\n"
"{\n"
"sz := length (cols);\n"
"inx := 0;\n"
"while (inx < sz)\n"
"{\n"
"elt := aref (cols, inx);\n"
"if (either (casemode, upper (aref (elt, 3)), aref (elt, 3)) like\n"
"either (casemode, upper (col), col))\n"
"{\n"
"result (\n"
"charset_recode (aref (elt, 0), \'UTF-8\', \'_WIDE_\'),\n"
"charset_recode (aref (elt, 1), \'UTF-8\', \'_WIDE_\'),\n"
"charset_recode (aref (elt, 2), \'UTF-8\', \'_WIDE_\'),\n"
"charset_recode (aref (elt, 3), \'UTF-8\', \'_WIDE_\'),\n"
"aref (elt, 4),\n"
"either (is_odbc3, dv_to_sql_type3 (aref (elt, 5)), dv_to_sql_type (aref (elt, 5))),\n"
"dv_type_title (aref (elt, 5)),\n"
"aref (elt, 7),\n"
"aref (elt, 7),\n"
"aref (elt, 6),\n"
"10,\n"
"aref (elt, 8),\n"
"NULL,\n"
"\n"
"NULL,\n"
"either (is_odbc3, dv_to_sql_type3 (aref (elt, 5)), dv_to_sql_type (aref (elt, 5))),\n"
"NULL,\n"
"aref (elt, 7),\n"
"aref (elt, 9),\n"
"either (aref (elt, 8), \'YES\', \'NO\')\n"
");\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"}\n"
"}\n"
"}\n"
"--src system.sql:3832\n";

static const char *proc103 = 
"create procedure\n"
"DB.DBA.__XML_TEMPLATE (in path any, in params any, in lines any, in enc any := null)\n"
"{\n"
"declare xt any;\n"
"declare xslt, f varchar;\n"
"\n"
"f := concat (http_root (), http_physical_path ());\n"
"if ({?\'template\'} is not null and not isstring (file_stat (f, 3)))\n"
"xt := xtree_doc({?\'template\'}, 0);\n"
"else\n"
"xt := xtree_doc(file_to_string (f), 0);\n"
"\n"
"if (enc is not null)\n"
"{\n"
"if (is_http_ctx ())\n"
"{\n"
"set http_charset=enc;\n"
"}\n"
"else\n"
"xml_tree_doc_encoding (xt, enc);\n"
"}\n"
"else\n"
"enc := current_charset ();\n"
"\n"
"\n"
"__set_user_id (http_map_get (\'vsp_uid\'));\n"
"xslt := xml_template (xt, params);\n"
"\n"
"\n"
"if (xslt is not null)\n"
"{\n"
"if (xslt = \'__xml_template_default\')\n"
"xslt := \'precompiled:__xml_template_default\';\n"
"else if ({?\'__base_url\'} is not null)\n"
"xslt := WS.WS.EXPAND_URL ({?\'__base_url\'}, xslt);\n"
"else\n"
"xslt := WS.WS.EXPAND_URL (concat (\'file:\', http_physical_path ()), xslt);\n"
"http_xslt (xslt);\n"
"}\n"
"\n"
"if ({?\'contenttype\'} is not null)\n"
"http_header (sprintf (\'Content-type: %s; charset=\"%s\"\\r\\nCache-Control: no-cache, must-revalidate\\r\\nPragma: no-cache\\r\\nExpires: Thu, 01 Dec 1994 01:02:03 GMT\\r\\n\', {?\'contenttype\'}, enc));\n"
"else if (xslt is null)\n"
"http_header (sprintf (\'Content-type: text/xml; charset=\"%s\"\\r\\nCache-Control: no-cache, must-revalidate\\r\\nPragma: no-cache\\r\\nExpires: Thu, 01 Dec 1994 01:02:03 GMT\\r\\n\', enc));\n"
"if ({?\'content-filename\'} is not null)\n"
"{\n"
"http_header (concat (http_header_get (), sprintf (\'Content-Disposition: inline; filename=\"%s\"\\r\\n\', {?\'content-filename\'})));\n"
"}\n"
"__pop_user_id ();\n"
"}\n"
"--src system.sql:3923\n";


static const char *proc104 = 
" create procedure vt_upgrade_text_index (\n"
"in tb varchar,\n"
"in is_xml integer := -1,\n"
"in _func integer :=  -1,\n"
"in _lang varchar := \'*ini*\',\n"
"in _enc varchar := \'*ini*\')\n"
"{\n"
"declare text_id_col, kn, func, ufunc, col, obd, vtlog_suff, tb_suff varchar;\n"
"declare t1, t2, t3 any;\n"
"declare f_xml integer;\n"
"\n"
"if (_lang is null)\n"
"_lang := \'*ini*\';\n"
"\n"
"if (_enc is null)\n"
"_enc := \'*ini*\';\n"
"\n"
"tb := complete_table_name ((tb), 1);\n"
"\n"
"vtlog_suff := concat (name_part (tb, 0), \'_\', name_part (tb, 1), \'_\', name_part (tb, 2));\n"
"tb_suff := DB.DBA.SYS_ALFANUM_NAME (vtlog_suff);\n"
"\n"
"\n"
"if (not exists (select 1 from DB.DBA.SYS_KEYS where 0 = casemode_strcmp (KEY_TABLE,  tb)))\n"
"{\n"
"signal (\'42S02\', sprintf (\'No table \'\'%s\'\' in create text index\', tb), \'FT021\');\n"
"}\n"
"\n"
"if (not exists (select 1 from DB.DBA.SYS_VT_INDEX where 0 = casemode_strcmp (VI_TABLE,  tb)))\n"
"{\n"
"signal (\'42S01\', \'Text index is not defined for table\', \'FT022\');\n"
"}\n"
"\n"
"select  VI_COL, VI_ID_COL, deserialize(VI_OFFBAND_COLS), VI_LANGUAGE, VI_ENCODING\n"
"into col, text_id_col, obd, _lang, _enc from SYS_VT_INDEX where VI_TABLE = tb;\n"
"\n"
"func := null;\n"
"ufunc := null;\n"
"\n"
"if (_func = 1 or _func < 0)\n"
"{\n"
"func := coalesce ((select P_NAME from DB.DBA.SYS_PROCEDURES where\n"
"0 =  casemode_strcmp (P_NAME, sprintf (\'%s_%s_INDEX_HOOK\', tb, col))), NULL);\n"
"if (func is null)\n"
"func := __proc_exists (sprintf (\'%s_%s_INDEX_HOOK\', tb, col));\n"
"\n"
"ufunc := coalesce ((select P_NAME from DB.DBA.SYS_PROCEDURES where\n"
"0 = casemode_strcmp (P_NAME, sprintf (\'%s_%s_UNINDEX_HOOK\', tb, col))), NULL);\n"
"\n"
"if (ufunc is null)\n"
"ufunc := __proc_exists (sprintf (\'%s_%s_UNINDEX_HOOK\', tb, col));\n"
"}\n"
"\n"
"if (_func < 0 and (func is null or ufunc is null))\n"
"{\n"
"func := null;\n"
"ufunc := null;\n"
"}\n"
"\n"
"if (_func = 1 and (func is null or ufunc is null))\n"
"signal (\'37000\', \'The hook functions are not available.\', \'FT023\');\n"
"\n"
"whenever not found goto eof;\n"
"select coalesce (T_TEXT, blob_to_string (T_MORE)) into t1 from SYS_TRIGGERS\n"
"where T_TABLE = tb and T_NAME like concat (\'%.\', tb_suff, \'_VTI_log\');\n"
"select coalesce (T_TEXT, blob_to_string (T_MORE)) into t2 from SYS_TRIGGERS\n"
"where T_TABLE = tb and T_NAME like concat (\'%.\', tb_suff, \'_VTU_log\');\n"
"select coalesce (T_TEXT, blob_to_string (T_MORE)) into t3 from SYS_TRIGGERS\n"
"where T_TABLE = tb and T_NAME like concat (\'%.\', tb_suff, \'_VTD_log\');\n"
"eof:\n"
"\n"
"f_xml := 0;\n"
"if (isstring (t1) and strstr (t1, \'(1 = 1)\') is not null)\n"
"f_xml := f_xml + 1;\n"
"if (isstring (t2) and strstr (t2, \'(1 = 1)\') is not null)\n"
"f_xml := f_xml + 1;\n"
"if (isstring (t3) and strstr (t3, \'(1 = 1)\') is not null)\n"
"f_xml := f_xml + 1;\n"
"\n"
"if (_func < 0 and isstring (t1) and isstring (func) and strstr (t1, name_part (func, 2)) is null)\n"
"{\n"
"func := NULL;\n"
"ufunc := NULL;\n"
"}\n"
"if (_func < 0 and isstring (t3) and isstring (ufunc) and strstr (t3, name_part (ufunc, 2)) is null)\n"
"{\n"
"func := NULL;\n"
"ufunc := NULL;\n"
"}\n"
"\n"
"if (is_xml < 0 and f_xml = 3)\n"
"is_xml := 1;\n"
"else if (is_xml < 0)\n"
"is_xml := 0;\n"
"\n"
"if (tb = \'DB.DBA.MAIL_MESSAGE\' or\n"
"tb = \'DB.DBA.NEWS_MSG\' or\n"
"tb = \'WS.WS.SYS_DAV_RES\')\n"
"is_xml := 2;\n"
"\n"
"if (_lang is null)\n"
"_lang := \'*ini*\';\n"
"\n"
"if (_enc is null)\n"
"_enc := \'*ini*\';\n"
"declare hits_proc varchar;\n"
"hits_proc := NULL;\n"
"for select coalesce (P_TEXT, blob_to_string (P_MORE)) as txt from DB.DBA.SYS_PROCEDURES\n"
"where 0 = casemode_strcmp (P_NAME, concat (name_part (tb,0),\'.\',name_part(tb,1),\'.VT_HITS_\', name_part (tb, 2))) do\n"
"{\n"
"hits_proc := txt;\n"
"}\n"
"\n"
"\n"
"DB.DBA.vt_free_text_proc_gen (tb, text_id_col, col, is_xml, obd, func, ufunc, _lang, _enc);\n"
"DB.DBA.vt_create_update_log (tb, is_xml, 1, obd, func, ufunc, _lang, _enc, 0);\n"
"if (hits_proc is not null)\n"
"DB.DBA.execstr (hits_proc);\n"
"return 0;\n"
"}\n"
"--src system.sql:3976\n";


static const char *proc105 = 
" create procedure\n"
"VT_INDEX_UPGRADE ()\n"
"{\n"
"declare st, msg varchar;\n"
"declare ver, db_ver any;\n"
"ver := registry_get (\'__FTI_VERSION__\');\n"
"db_ver := sys_stat (\'db_ver_string\');\n"
"db_ver := atoi (replace (db_ver, \'.\', \'\'));\n"
"if (not isstring (ver))\n"
"ver := 0;\n"
"else\n"
"ver := atoi (ver);\n"
"\n"
"if (ver > 2204)\n"
"return;\n"
"\n"
"registry_set (\'__FTI_VERSION__\', \'2205\');\n"
"\n"
"if (db_ver > 250)\n"
"return;\n"
"\n"
"log_message (\'Upgrading the old type text indexes\');\n"
"for select VI_TABLE from DB.DBA.SYS_VT_INDEX do\n"
"{\n"
"declare tablename, vtlog_suff,q,o varchar;\n"
"tablename := VI_TABLE;\n"
"q := name_part (tablename, 0);\n"
"o := name_part (tablename, 1);\n"
"tablename := complete_table_name ((tablename), 1);\n"
"vtlog_suff := concat (name_part (tablename, 0), \'_\', name_part (tablename, 1), \'_\', name_part (tablename, 2));\n"
"if ((not exists\n"
"(select 1 from SYS_COLS where \\COLUMN = \'VT_GZ_WORDUMP\' and \\TABLE =\n"
"sprintf (\'%s.%s.VTLOG_%s\', q, o, vtlog_suff)))\n"
"or (not exists\n"
"(select 1 from SYS_COLS where \\COLUMN = \'VT_OFFBAND_DATA\' and \\TABLE =\n"
"sprintf (\'%s.%s.VTLOG_%s\', q, o, vtlog_suff))))\n"
"{\n"
"log_message (\n"
"sprintf (\'The text index on table %s can\'\'t be upgraded, please drop the index and recreate\', VI_TABLE));\n"
"}\n"
"else\n"
"{\n"
"\n"
"vt_upgrade_text_index (VI_TABLE);\n"
"}\n"
"}\n"
"}\n"
"--src system.sql:4099\n";


static const char *other48 = 
" VT_INDEX_UPGRADE ()\n";
static const char *proc106 = 
" create procedure\n"
"DB.DBA.XQ_TEMPLATE (inout q varchar, inout ctx varchar, inout ses any, inout map_schema any)\n"
"{\n"
"declare res, qry, uri, doc any;\n"
"declare i, l integer;\n"
"if (isstring (map_schema))\n"
"qry := sprintf (\'for $r in xmlview(\"%s\")%s return $r\', map_schema, q);\n"
"else\n"
"qry := q;\n"
"\n"
"if (isstring (ctx) and length (ctx))\n"
"{\n"
"uri := DB.DBA.XML_URI_RESOLVE_LIKE_GET (\'\', ctx);\n"
"doc := DB.DBA.XML_URI_GET (\'\', uri);\n"
"doc := xtree_doc (doc, 0, uri);\n"
"}\n"
"else\n"
"{\n"
"doc := xper_doc(\'<blank/>\', 0, ctx);\n"
"}\n"
"\n"
"res := xquery_eval (qry, doc, 0);\n"
"i := 0; l := length (res);\n"
"while (i<l)\n"
"{\n"
"http_value (res[i], NULL, ses);\n"
"i := i + 1;\n"
"}\n"
"}\n"
"--src system.sql:4154\n";

static const char *proc107 = 
" create procedure\n"
"DB.DBA.SQLX_OR_SPARQL_TEMPLATE (inout q varchar, inout params any, inout ses any, inout q_type any)\n"
"{\n"
"declare h, res, qry any;\n"
"qry := q;\n"
"\n"
"if (q_type)\n"
"{\n"
"declare arr, _text, decl, i, l any;\n"
"_text := substring (qry, 7, length (qry));\n"
"arr := sparql_lex_analyze (_text);\n"
"l := length (arr)-2;\n"
"for (i := 0; i < l; i := i + 1)\n"
"{\n"
"declare elm any;\n"
"if (isstring (arr[i][2]) and isstring (arr[i+1][2]) and isstring (arr[i+2][2]))\n"
"{\n"
"elm := lower (arr[i][2]);\n"
"if (elm = \'define\' and lower (arr[i+1][2]) = \'output:format\')\n"
"{\n"
"if (upper (arr[i+2][2]) = \'\"RDF/XML\"\')\n"
"goto done;\n"
"else\n"
"signal (\'22023\', \'The output:format must be RDF/XML\');\n"
"}\n"
"}\n"
"}\n"
"qry := \'SPARQL define output:format \"RDF/XML\" \' || _text;\n"
"done:;\n"
"}\n"
"\n"
"exec (qry,  null, null, params, 0, null, null, h);\n"
"while (0 = exec_next(h, null, null, res))\n"
"{\n"
"if (isarray (res) and length (res))\n"
"{\n"
"foreach (any elm in res) do\n"
"{\n"
"if (isentity (elm))\n"
"http_value (elm, null, ses);\n"
"else if (isstring (elm) or __tag (elm) = 185)\n"
"http (elm, ses);\n"
"}\n"
"}\n"
"}\n"
"exec_close (h);\n"
"params := 0;\n"
"return;\n"
"}\n"
"--src system.sql:4186\n";


static const char *other49 = 
" xslt_sheet (\'__xml_template_default\', xml_tree_doc (xml_tree(\n"
"\'<?xml version=\"1.0\"?>\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\" >\n"
"<xsl:output method=\"html\"/>\n"
"<xsl:template match=\"/\">\n"
"<HTML>\n"
"<title>Search results</title>\n"
"<BODY>\n"
"<H4>Search results</H4>\n"
"<TABLE BOREDER=\"0\">\n"
"<xsl:apply-templates select=\"*\" />\n"
"</TABLE>\n"
"</BODY>\n"
"</HTML>\n"
"</xsl:template>\n"
"<xsl:template match=\"resource\">\n"
"<TR>\n"
"<TD><b>Document:</b></TD><TD><A><xsl:attribute name=\"HREF\"><xsl:value-of select=\"@name\"/></xsl:attribute><xsl:value-of select=\"@name\"/></A></TD>\n"
"</TR>\n"
"<TR>\n"
"<TD><b>Last Modified:</b></TD>\n"
"<TD><xsl:value-of select=\"substring (@modified ,1, 19)\"/></TD>\n"
"</TR>\n"
"<TR>\n"
"<TD><b>Size:</b></TD>\n"
"<TD><xsl:value-of select=\"@length\"/> bytes</TD>\n"
"</TR>\n"
"<TR>\n"
"<TD colspan=\"2\">&nbsp;</TD>\n"
"</TR>\n"
"</xsl:template>\n"
"</xsl:stylesheet>\'))\n"
")\n";
static const char *proc108 = 
"create procedure\n"
"cov_store (in f varchar, in add_line integer := 0)\n"
"{\n"
"declare i, l, i1, l1 integer;\n"
"declare arr, arr1 any;\n"
"declare result varchar;\n"
"declare ses any;\n"
"arr1 := pldbg_stats (NULL, add_line, null, 1);\n"
"if (length (arr1) < 1)\n"
"return NULL;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" ?>\\n<pl_stats>\', ses);\n"
"i1:=0; l1:=length(arr1);\n"
"while (i1 < l1)\n"
"{\n"
"arr := arr1[i1];\n"
"if (length (arr))\n"
"{\n"
"declare tag_name, udt_name any;\n"
"tag_name := \'proc\';\n"
"udt_name := \'\';\n"
"if (length (arr[0]) > 5 and arr[0][5] is not null)\n"
"{\n"
"tag_name := \'method\';\n"
"udt_name := sprintf (\' class=\"%V\"\', arr[0][5]);\n"
"}\n"
"if (add_line)\n"
"result := sprintf (\'\\n\\t<%s name=\"%V\" calls=\"%08d\" file=\"%V\" lct=\"%d\" time=\"%d\" self=\"%d\" %s>\', tag_name, arr[0][0], arr[0][2], arr[0][1], arr[0][3], arr[0][4], arr[0][6], udt_name);\n"
"else\n"
"result := sprintf (\'\\n\\t<%s name=\"%V\" calls=\"%08d\" file=\"%V\" time=\"%d\" self=\"%d\" %s>\', tag_name, arr[0][0], arr[0][2], arr[0][1], arr[0][4], arr[0][6], udt_name);\n"
"i := 0;\n"
"l := length (arr[1]);\n"
"while (i < l)\n"
"{\n"
"if (add_line)\n"
"result := concat (result, sprintf (\'\\n\\t\\t<line no=\"%06d\" ctr=\"%06d\"><![CDATA[%s]]></line>\', arr[1][i][0], arr[1][i][1], replace(replace(arr[1][i][2], \'\"\', \'\'\'\'), \']]>\', \']]>]]<![CDATA[>\')));\n"
"else\n"
"result := concat (result, sprintf (\'\\n\\t\\t<line no=\"%06d\" ctr=\"%06d\" />\', arr[1][i][0], arr[1][i][1]));\n"
"i := i + 1;\n"
"}\n"
"i := 0;\n"
"l := length (arr[2]);\n"
"while (i < l)\n"
"{\n"
"result := concat (result, sprintf (\'\\n\\t\\t<caller name=\"%V\" ct=\"%06d\" />\', arr[2][i][0], arr[2][i][1]));\n"
"i := i + 1;\n"
"}\n"
"result := concat (result, sprintf(\'\\n\\t</%s>\', tag_name));\n"
"http (result, ses);\n"
"}\n"
"i1 := i1+ 1;\n"
"}\n"
"http (\'</pl_stats>\', ses);\n"
"string_to_file (f, ses, -2);\n"
"}\n"
"--src system.sql:4274\n";

static const char *proc109 = 
"create procedure\n"
"cov_load (in f varchar)\n"
"{\n"
"declare rep varchar;\n"
"declare xt any;\n"
"declare xp any;\n"
"declare i, j, k, l integer;\n"
"if (not isstring (file_stat (f, 3)))\n"
"return;\n"
"rep := file_to_string (f);\n"
"xt := xml_tree_doc (rep);\n"
"xp := xpath_eval (\'/pl_stats/proc|/pl_stats/method\', xt, 0);\n"
"i := 0; l := length (xp);\n"
"while (i < l)\n"
"{\n"
"declare name, udt varchar;\n"
"declare calls, tim, sel integer;\n"
"declare lin, cal, res, lins, cals any;\n"
"name := cast (xpath_eval (\'@name\',xp[i], 1) as varchar);\n"
"udt := cast (xpath_eval (\'@class\',xp[i], 1) as varchar);\n"
"calls := cast (xpath_eval (\'@calls\',xp[i], 1) as integer);\n"
"tim := cast (xpath_eval (\'@time\',xp[i], 1) as integer);\n"
"sel := cast (xpath_eval (\'@self\',xp[i], 1) as integer);\n"
"if (tim is null) tim := 0;\n"
"if (sel is null) sel := 0;\n"
"lin := xpath_eval (\'line\', xp[i], 0);\n"
"cal := xpath_eval (\'caller\', xp[i], 0);\n"
"res := vector (vector (name, \'unnamed\', calls, tim, udt, sel));\n"
"j := 0; k := length (lin);\n"
"lins := vector ();\n"
"while (j < k)\n"
"{\n"
"declare line_no, cnt integer;\n"
"line_no := cast (xpath_eval (\'@no\',lin[j], 1) as integer);\n"
"cnt := cast (xpath_eval (\'@ctr\', lin[j], 1) as integer);\n"
"lins := vector_concat (lins, vector (vector (line_no, cnt)));\n"
"j := j + 1;\n"
"}\n"
"\n"
"j := 0; k := length (cal);\n"
"cals := vector ();\n"
"while (j < k)\n"
"{\n"
"declare cnt integer;\n"
"declare caller varchar;\n"
"caller := cast (xpath_eval (\'@name\',cal[j], 1) as varchar);\n"
"cnt := cast (xpath_eval (\'@ct\', cal[j], 1) as integer);\n"
"cals := vector_concat (cals, vector (vector (caller, cnt)));\n"
"j := j + 1;\n"
"}\n"
"res := vector_concat (res, vector(lins), vector(cals));\n"
"pldbg_stats_load (res);\n"
"i := i + 1;\n"
"}\n"
"}\n"
"--src system.sql:4332\n";

static const char *proc110 = 
"create procedure\n"
"cov_report (in f varchar, in odir varchar)\n"
"{\n"
"\n"
"declare r, s, xt, files, fls, xe any;\n"
"declare i, l integer;\n"
"if (odir not like \'%/\')\n"
"odir := concat (odir, \'/\');\n"
"xe := xml_tree_doc (file_to_string (f));\n"
"xt := xpath_eval (\'/pl_stats/*/@file\', xe, 0);\n"
"files := vector ();\n"
"fls := \'<files>\';\n"
"i := 0; l := length (xt);\n"
"while (i < l)\n"
"{\n"
"declare elm varchar;\n"
"elm := cast (xt[i] as varchar);\n"
"if (not position (elm, files))\n"
"{\n"
"files := vector_concat (files, vector (elm));\n"
"fls := fls || sprintf (\'<file name=\"%s\"/>\', elm);\n"
"}\n"
"i := i + 1;\n"
"}\n"
"fls := fls || \'</files>\';\n"
"i := 0; l := length (files);\n"
"while (i < l)\n"
"{\n"
"declare fname varchar;\n"
"r := xslt (\'http://local.virt/cov_report\', xe, vector (\'file_name\', files[i]));\n"
"s := string_output ();\n"
"http_value (r, null, s);\n"
"fname := files[i];\n"
"fname := replace (fname, \'\\\\\', \'/\');\n"
"if (strrchr (fname, \'/\') is not null)\n"
"fname := subseq (fname, strrchr (fname, \'/\') + 1);\n"
"string_to_file (concat(odir,fname,\'.cov\'), s, -2);\n"
"i := i + 1;\n"
"}\n"
"r := xslt (\'http://local.virt/cov_time\', xe, vector (\'files\', xtree_doc (fls)));\n"
"s := string_output ();\n"
"http_value (r, null, s);\n"
"string_to_file (concat(odir,\'profile\',\'.prof\'), s, -2);\n"
"}\n"
"--src system.sql:4390\n";

static const char *proc111 = 
"create procedure\n"
"vd_remote_proc_wrapper (in _dsn varchar, in pro varchar, in dest varchar, in meta any, out state varchar, out msg varchar, in make_rset integer := 0, in descr varchar := \'\')\n"
"{\n"
"declare pars any;\n"
"declare q,o,n, par, typ, rname, _comment, stmt1, rcols, rcols1, rcols2, remote_st varchar;\n"
"declare q1,o1,n1, cmn1, rset varchar;\n"
"declare have_rset, posit, i, l integer;\n"
"declare loop_str varchar;\n"
"\n"
"declare infos, dbms, driv any;\n"
"infos := vector ();\n"
"if (_dsn <> \'\')\n"
"{\n"
"whenever not found goto nfnd;\n"
"select deserialize (DS_CONN_STR) into infos from DB.DBA.SYS_DATA_SOURCE where DS_DSN = _dsn;\n"
"nfnd:;\n"
"}\n"
"\n"
"dbms := upper (get_keyword (17, infos, \'\'));\n"
"driv := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"q := name_part (dest, 0);\n"
"o := name_part (dest, 1);\n"
"n := name_part (dest, 2);\n"
"\n"
"_comment := coalesce (descr, \'\');\n"
"\n"
"if (_comment <> \'\')\n"
"_comment := concat (\'\\-\\-##\', _comment, \'\');\n"
"\n"
"q1 := name_part (pro, 0);\n"
"o1 := name_part (pro, 1);\n"
"n1 := name_part (pro, 2);\n"
"\n"
"have_rset := 0;\n"
"rset := \', {resultset 1000, \';\n"
"stmt1 := sprintf (\'create procedure \"%I\".\"%I\".\"%I\" (\', q,o,n);\n"
"rcols := \'\'; rcols1 := \'\'; rcols2 := \'\'; posit := 0;\n"
"if (q1 = \'\')\n"
"{\n"
"if (dbms like \'%ORACLE%\' and (driv like \'MSORCL32.DLL%\' or driv like \'OPLODBC.SO\'))\n"
"rname := concat (o1,\'.\',n1);\n"
"else\n"
"rname := quote_dotted (_dsn, concat (o1,\'.\',n1));\n"
"remote_st := sprintf (\'{call %s (\', rname);\n"
"}\n"
"else\n"
"{\n"
"declare pro1 varchar;\n"
"pro1 := pro;\n"
"if (pro1 like \'%;%\')\n"
"{\n"
"declare semi integer;\n"
"declare pro2, num2 varchar;\n"
"semi := strrchr (pro, \';\');\n"
"pro2 := pro1; num2 := \'\';\n"
"if (semi is not null)\n"
"{\n"
"pro2 := subseq (pro1, 0, semi);\n"
"num2 := subseq (pro1, semi, length (pro1));\n"
"}\n"
"rname := quote_dotted (_dsn, pro2);\n"
"rname := concat (rname, num2);\n"
"}\n"
"else\n"
"rname := quote_dotted (_dsn, pro1);\n"
"remote_st := sprintf (\'{call %s (\', rname);\n"
"}\n"
"\n"
"declare br integer;\n"
"if (isarray (meta))\n"
"pars := meta;\n"
"else\n"
"pars := vector ();\n"
"i := 0; l := length (pars); br := 0;\n"
"while (i < l)\n"
"{\n"
"declare t, na, dt, st varchar;\n"
"na := pars [i][1];\n"
"t := pars [i][0];\n"
"\n"
"dt := pars [i][2];\n"
"st := pars [i][3];\n"
"\n"
"if (t = \'RESULTSET\' and dbms like \'%ORACLE%\')\n"
"{\n"
"rset := concat (rset, na, \',\');\n"
"have_rset := 1;\n"
"goto nexti;\n"
"}\n"
"\n"
"if (t = \'RETURNS\')\n"
"{\n"
"br := 1;\n"
"}\n"
"else if (t <> \'RESULTSET\')\n"
"{\n"
"stmt1 := concat (stmt1, t, \' \', na, \' \', dt);\n"
"rcols := concat (rcols, na, \',\');\n"
"if (t = \'IN\')\n"
"rcols1 := concat (rcols1, na, \',\');\n"
"else\n"
"rcols1 := concat (rcols1, sprintf (\'vector (\'\'%s\'\', \'\'%s\'\', 0, %s),\',t,dt,na));\n"
"if (t <> \'IN\')\n"
"rcols2 := concat (rcols2, na, sprintf (\' := params[%d] ;\', posit));\n"
"posit := posit + 1;\n"
"remote_st := concat (remote_st, \'?,\');\n"
"}\n"
"if (st <> \'\')\n"
"{\n"
"if (t <> \'RETURNS\')\n"
"stmt1 := concat (stmt1, \' __soap_type \'\'\', st, \'\'\'\');\n"
"}\n"
"if (t <> \'RETURNS\')\n"
"stmt1 := concat (stmt1, \',\');\n"
"nexti:\n"
"i := i + 1;\n"
"}\n"
"stmt1 := trim (stmt1, \', \');\n"
"remote_st := trim (remote_st, \', \');\n"
"\n"
"if (have_rset)\n"
"{\n"
"rset := rtrim (rset, \', \');\n"
"rset := concat (rset, \'}\');\n"
"remote_st := concat (remote_st, rset);\n"
"}\n"
"\n"
"remote_st := concat (remote_st, \')\');\n"
"if (remote_st like \'%()\')\n"
"remote_st := trim (remote_st,\')(\');\n"
"rcols := trim (rcols, \', \');\n"
"\n"
"rcols1 := rtrim (rcols1, \', \');\n"
"\n"
"if (make_rset)\n"
"loop_str := \'\\n if (isarray (mdta) and isarray (dta)) { exec_result_names(mdta[0]);\\ndeclare i, l integer;\\ni := 0; l := length (dta);\\n while(i<l) {\\n   exec_result(dta[i]);\\n   i:=i+1;\\n } }\';\n"
"else\n"
"loop_str := \'\\nreturn dta;\';\n"
"\n"
"remote_st := remote_st || \'}\';\n"
"\n"
"stmt1 := concat (stmt1, sprintf ( \') returns any array array\\n{ \\n\\-\\-PL Wrapper for remote procedure\\n%s\\n\\-\\-\"DSN:%s PROCEDURE:%s\"\\ndeclare dta, mdta any; \\ndeclare params any; \\nparams := vector (%s); \\nset_user_id (\'\'dba\'\');\\nrexecute (%s, %s, NULL, NULL, params, 0, mdta, dta); \\n%s\\n%s\\n}\', _comment, _dsn, pro, rcols1, WS.WS.STR_SQL_APOS (_dsn), WS.WS.STR_SQL_APOS (remote_st), rcols2, loop_str));\n"
"state := \'00000\';\n"
"exec (stmt1, state, msg);\n"
"}\n"
"--src system.sql:4438\n";

static const char *other50 = 
"update SYS_COLS set COL_PREC = 2147483647 where COL_DTP = 125 and COL_PREC < 2147483647\n";
static const char *proc112 = 
"create procedure EXEC_STMT (in stmt_text varchar, in mode integer)\n"
"{\n"
"declare state, msg varchar;\n"
"declare meta, res any;\n"
"\n"
"if (mode)\n"
"return execstr (stmt_text);\n"
"\n"
"exec (stmt_text, state, msg, vector (), 100, meta, res);\n"
"}\n"
"--src system.sql:4590\n";

static const char *proc113 = 
" create procedure RSTMTEXEC (in dsn varchar, in stmt varchar, in max_rows integer := 0, in params_array any := null)\n"
"{\n"
"declare stmt_compilation, cursor_handle, curr_row any;\n"
"declare row_ctr integer;\n"
"\n"
"rexecute (dsn, stmt, NULL, NULL, params_array, NULL, stmt_compilation, NULL, cursor_handle);\n"
"\n"
"if (not isarray (stmt_compilation))\n"
"signal (\'22023\', \'The statement in RSTMTEXEC should have a resultset\', \'VD086\');\n"
"\n"
"exec_result_names (stmt_compilation[0]);\n"
"\n"
"row_ctr := 0;\n"
"if (max_rows >= 0)\n"
"{\n"
"while (0 = rnext (cursor_handle, curr_row))\n"
"{\n"
"if (isarray (curr_row))\n"
"exec_result (curr_row);\n"
"row_ctr := row_ctr + 1;\n"
"if (max_rows > 0 and row_ctr >= max_rows)\n"
"goto done;\n"
"}\n"
"}\n"
"done:\n"
"rclose (cursor_handle);\n"
"}\n"
"--src system.sql:4604\n";

static const char *proc114 = 
"create procedure WS.WS.DIR_INDEX_MAKE_XML (inout _sheet varchar)\n"
"{\n"
"declare dirarr, filearr, fsize, ret_xml any;\n"
"declare curdir, dirname, root, start_from, modt varchar;\n"
"declare ix, len, flen, rflen, mult integer;\n"
"fsize := vector (\'b\',\'K\',\'M\',\'G\',\'T\');\n"
"curdir := concat (http_root (), http_physical_path ());\n"
"start_from := http_path ();\n"
"root := http_root ();\n"
"ret_xml := string_output ();\n"
"dirarr := sys_dirlist (curdir, 0, null, 1);\n"
"filearr := sys_dirlist (curdir, 1, null, 1);\n"
"if (curdir <> \'\\\\\' and aref (curdir, length (curdir) - 1) <> ascii (\'/\'))\n"
"curdir := concat (curdir, \'/\');\n"
"if (start_from <> \'/\' and aref (start_from, length (start_from) - 1) <> ascii (\'/\'))\n"
"start_from := concat (start_from, \'/\');\n"
"http (\'<?xml version=\"1.0\" ?>\', ret_xml);\n"
"http (sprintf (\'<PATH dir_name=\"%V\">\', start_from), ret_xml);\n"
"if (aref (root, length (root) - 1) <> ascii (\'/\'))\n"
"root := concat (root, \'/\');\n"
"if (aref (curdir, length (curdir) - 1) <> ascii (\'/\'))\n"
"curdir := concat (curdir, \'/\');\n"
"len := length (dirarr);\n"
"ix := 0;\n"
"http (\'<DIRS>\', ret_xml);\n"
"while (ix < len)\n"
"{\n"
"declare fst varchar;\n"
"dirname := aref (dirarr, ix);\n"
"fst := file_stat (concat (curdir, dirname));\n"
"if (isstring (fst))\n"
"modt := stringdate (fst);\n"
"else\n"
"modt := now();\n"
"if (dirname <> \'.\')\n"
"http (sprintf (\'<SUBDIR modify=\"%s\" name=\"%s\" />\\n\',\n"
"soap_print_box (modt, \'\', 2), dirname), ret_xml);\n"
"ix := ix + 1;\n"
"}\n"
"http (\'</DIRS><FILES>\', ret_xml);\n"
"len := length (filearr);\n"
"ix := 0;\n"
"while (ix < len)\n"
"{\n"
"dirname := aref (filearr, ix);\n"
"modt := stringdate (file_stat (concat (curdir, dirname)));\n"
"rflen := 0;\n"
"rflen := file_stat (concat (curdir, dirname), 1);\n"
"flen := atoi (rflen);\n"
"mult := 0;\n"
"if (lower (dirname) = \'folder.xsl\')\n"
"_sheet := concat (curdir, dirname);\n"
"while ((flen / 1000) > 1)\n"
"{\n"
"mult := mult + 1;\n"
"flen := flen / 1000;\n"
"}\n"
"http (sprintf (\'<FILE modify=\"%s\" rs=\"%s\" hs=\"%d %s\" name=\"%s\" />\\n\',\n"
"soap_print_box (modt, \'\', 2), rflen, flen, aref (fsize, mult), dirname), ret_xml);\n"
"ix := ix + 1;\n"
"}\n"
"http (\'</FILES></PATH>\', ret_xml);\n"
"\n"
"return string_output_string (ret_xml);\n"
"}\n"
"--src system.sql:4634\n";

static const char *other51 = 
"xslt_sheet (\'http://local.virt/dir_output\', xml_tree_doc (\'\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\">\n"
"<xsl:output method=\"text\" />\n"
"\n"
"<xsl:template match=\"PATH\">\n"
"<xsl:variable name=\"path\"><xsl:value-of select=\"@dir_name\"/></xsl:variable>\n"
"&lt;!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\"&gt;\n"
"&lt;HTML&gt;\n"
"&lt;TITLE&gt;Directory listing of <xsl:value-of select=\"$path\"/>&lt;/TITLE&gt;\n"
"&lt;BODY bgcolor=\"#FFFFFF\" fgcolor=\"#000000\"&gt;\n"
"&lt;H4&gt;Index of <xsl:value-of select=\"$path\"/>&lt;/H4&gt;\n"
"&lt;TABLE&gt;\n"
"&lt;tr&gt;&lt;td colspan=2 align=\"center\"&gt;Name&lt;/td&gt;\n"
"&lt;td align=\"center\"&gt;Last modified&lt;/td&gt;&lt;td align=\"center\"&gt;Size&lt;/td&gt;&lt;/tr&gt;\n"
"&lt;tr&gt;&lt;td colspan=5&gt;&lt;HR /&gt;&lt;/td&gt;&lt;/tr&gt;\n"
"\n"
"<xsl:apply-templates select=\"DIRS\">\n"
"<xsl:with-param name=\"f_path\" select=\"$path\"/>\n"
"</xsl:apply-templates>\n"
"\n"
"<xsl:apply-templates select=\"FILES\">\n"
"<xsl:with-param name=\"f_path\" select=\"$path\"/>\n"
"</xsl:apply-templates>\n"
"\n"
"&lt;tr&gt;&lt;td colspan=5&gt;&lt;HR /&gt;&lt;/td&gt;&lt;/tr&gt;\n"
"&lt;/TABLE&gt;\n"
"&lt;/BODY&gt;\n"
"&lt;/HTML&gt;\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"SUBDIR\">\n"
"<xsl:param name=\"f_path\" />\n"
"&lt;tr&gt;\n"
"&lt;td&gt;&lt;img src=\"/images/dir.gif\"&gt;&lt;/td&gt;\n"
"&lt;td&gt;&lt;a href=\"<xsl:value-of select=\"$f_path\"/><xsl:value-of select=\"@name\"/>/\"&gt;<xsl:value-of select=\"@name\"/>&lt;/a&gt;&lt;/td&gt;\n"
"&lt;td&gt;<xsl:value-of select=\"@modify\"/>&lt;/td&gt;&lt;td align=\"right\"&gt;-&lt;/td&gt;\n"
"&lt;/tr&gt;\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"FILE\">\n"
"<xsl:param name=\"f_path\" />\n"
"&lt;tr&gt;\n"
"&lt;td&gt;&lt;img src=\"/images/generic.gif\"&gt;&lt;/td&gt;\n"
"&lt;td&gt;&lt;a href=\"<xsl:value-of select=\"$f_path\"/><xsl:value-of select=\"@name\"/>\"&gt;<xsl:value-of select=\"@name\"/>&lt;/a&gt;&lt;/td&gt;\n"
"&lt;td&gt;<xsl:value-of select=\"@modify\"/>&lt;/td&gt;&lt;td align=\"right\"&gt;<xsl:value-of select=\"@hs\"/>&lt;/td&gt;\n"
"&lt;/tr&gt;\n"
"</xsl:template>\n"
"\n"
"</xsl:stylesheet>\'))\n";
static const char *proc115 = 
"create procedure WS.WS.DIR_INDEX_XML (in path any, in params any, in lines any)\n"
"{\n"
"declare _html, _xml, _sheet varchar;\n"
"declare _b_opt any;\n"
"\n"
"_b_opt := NULL;\n"
"\n"
"if (exists (select 1 from HTTP_PATH\n"
"where HP_LPATH = http_map_get (\'domain\') and HP_PPATH = http_map_get (\'mounted\')))\n"
"select deserialize(HP_OPTIONS) into _b_opt from HTTP_PATH\n"
"where HP_LPATH = http_map_get (\'domain\') and HP_PPATH = http_map_get (\'mounted\');\n"
"\n"
"_sheet := \'\';\n"
"_xml := xml_tree_doc (WS.WS.DIR_INDEX_MAKE_XML (_sheet));\n"
"\n"
"if (_b_opt is not NULL)\n"
"_b_opt := get_keyword (\'browse_sheet\', _b_opt, \'\');\n"
"\n"
"if (_sheet <> \'\')\n"
"{\n"
"xslt_sheet (\'http://local.virt/custom_dir_output\', xml_tree_doc (file_to_string (_sheet)));\n"
"_html := cast (xslt (\'http://local.virt/custom_dir_output\', _xml) as varchar);\n"
"}\n"
"else if (_b_opt <> \'\')\n"
"{\n"
"_b_opt := concat (http_root(), \'/\', _b_opt);\n"
"xslt_sheet (\'http://local.virt/custom_dir_output\', xml_tree_doc (file_to_string (_b_opt)));\n"
"_html := cast (xslt (\'http://local.virt/custom_dir_output\', _xml) as varchar);\n"
"}\n"
"else\n"
"_html := cast (xslt (\'http://local.virt/dir_output\', _xml) as varchar);\n"
"\n"
"return http (_html);\n"
"}\n"
"--src system.sql:4754\n";

static const char *proc116 = 
"create procedure FTI_MAKE_SEARCH_STRING_INNER (in exp varchar, inout words any)\n"
"{\n"
"declare exp1 varchar;\n"
"declare war, vt any;\n"
"declare m, n int;\n"
"\n"
"words := vector ();\n"
"\n"
"if (length (exp) < 2)\n"
"return null;\n"
"\n"
"exp := trim (exp, \' \');\n"
"\n"
"if (strchr (exp, \' \') is null)\n"
"{\n"
"words := vector (trim (exp, \'\"\'));\n"
"return concat (\'\"\', trim (exp, \'\"\'), \'\"\');\n"
"}\n"
"\n"
"\n"
"exp1 := \'\';\n"
"\n"
"if (strchr (exp, \'\"\') is not null or\n"
"strchr (exp, \'\'\'\') is not null)\n"
"{\n"
"declare tmp, w varchar;\n"
"tmp := exp;\n"
"w := regexp_match (\'[\"][^\"]+[\"]|[\'\'][^\'\']+[\'\']|[^\"\'\' ]+\', tmp, 1);\n"
"while (w is not null)\n"
"{\n"
"w := trim (w, \'\"\'\' \');\n"
"if (upper(w) not in (\'AND\', \'NOT\', \'NEAR\', \'OR\')\n"
"and length (w) > 1\n"
"and not vt_is_noise (w, \'utf-8\', \'x-any\'))\n"
"{\n"
"exp1 := concat (exp1, sprintf (\'\"%s\" AND \', w));\n"
"words := vector_concat (words, vector (w));\n"
"}\n"
"w := regexp_match (\'[\"][^\"]+[\"]|[\'\'][^\'\']+[\'\']|[^\"\'\' ]+\', tmp, 1);\n"
"}\n"
"if (length (exp1) > 6)\n"
"{\n"
"exp1 := substring (exp1, 1, length (exp1) - 5);\n"
"goto end_parse;\n"
"}\n"
"}\n"
"\n"
"vt := vt_batch (100, \'x-any\', \'UTF-8\');\n"
"vt_batch_feed (vt, exp, 0, 0);\n"
"\n"
"war := vt_batch_strings_array (vt);\n"
"words := vector ();\n"
"\n"
"m := length (war);\n"
"n := 0;\n"
"exp1 := \'(\';\n"
"while (n < m)\n"
"{\n"
"declare word1 varchar;\n"
"if (war[n] not in (\'AND\', \'NOT\', \'NEAR\', \'OR\')\n"
"and length (war[n]) > 1\n"
"and not vt_is_noise (war[n], \'utf-8\', \'x-any\'))\n"
"{\n"
"word1 := war[n];\n"
"words := vector_concat (words, vector (word1));\n"
"if (strchr (word1, \'.\') is not null\n"
"or regexp_match (\'[A-Za-z_][A-Za-z0-9_-]*\', word1) is null)\n"
"word1 := concat (\'\"\', word1, \'\"\');\n"
"exp1 := concat (exp1, word1, \' AND \');\n"
"}\n"
"n := n + 2;\n"
"}\n"
"\n"
"if (length (exp1) > 5)\n"
"{\n"
"exp1 := substring (exp1, 1, length (exp1) - 5);\n"
"exp1 := concat (exp1, \')\');\n"
"}\n"
"else\n"
"exp1 := null;\n"
"\n"
"end_parse:\n"
"return exp1;\n"
"}\n"
"--src system.sql:4790\n";

static const char *proc117 = 
"create procedure FTI_MAKE_SEARCH_STRING (in exp varchar)\n"
"{\n"
"declare words any;\n"
"return FTI_MAKE_SEARCH_STRING_INNER (exp, words);\n"
"}\n"
"--src system.sql:4876\n";

static const char *tbl11 = 
"create table DB.DBA.CLR_VAC (\n"
"VAC_DATA LONG VARCHAR,\n"
"VAC_INTERNAL_NAME VARCHAR,\n"
"VAC_REAL_NAME VARCHAR,\n"
"VAC_FULL_NAME VARCHAR,\n"
"VAC_FULL_FILE_NAME VARCHAR,\n"
"VAC_PERM_SET INTEGER,\n"
"VAC_CREATE TIMESTAMP,\n"
"primary key (VAC_INTERNAL_NAME)\n"
")\n";


static const char *other52 = 
" exec_quiet (\'create type __ANY as (__any any)\')\n";
static const char *proc118 = 
"create procedure exec_quiet (in expn varchar)\n"
"{\n"
"declare sta, msg varchar;\n"
"exec (expn, sta, msg);\n"
"}\n"
"--src system.sql:4902\n";

static const char *udt0 = 
" create type XMLType\n"
"as (\n"
"xt_ent any,\n"
"xt_schema varchar,\n"
"xt_validated integer\n"
")\n"
"method existsNode (_xpath varchar) returns integer,\n"
"method existsNode (_xpath varchar, _nsmap varchar) returns integer,\n"
"method extract (_xpath varchar) returns any,\n"
"method extract (_xpath varchar, _nsmap varchar) returns any,\n"
"method query (_xquery varchar) returns any,\n"
"method isFragment () returns integer,\n"
"method getClobVal () returns nvarchar,\n"
"method getNumVal () returns numeric,\n"
"method getStringVal () returns nvarchar,\n"
"method transform (_xsl any) returns XMLType,\n"
"method transform (_xsl any, _param_map any) returns XMLType,\n"
"method isSchemaBased () returns integer,\n"
"method getSchemaURL () returns varchar,\n"
"method getRootElement () returns any,\n"
"method createSchemaBasedXML () returns any,\n"
"method createSchemaBasedXML (_url varchar) returns any,\n"
"method createNonSchemaBasedXML () returns any,\n"
"method getNamespace () returns nvarchar,\n"
"method schemaValidate () returns any,\n"
"method isSchemaValidated () returns integer,\n"
"method setSchemaValidated () returns integer,\n"
"method setSchemaValidated (_flag integer) returns integer,\n"
"method isSchemaValid () returns integer,\n"
"method isSchemaValid (_url varchar) returns integer,\n"
"method isSchemaValid (_url varchar, _elemname varchar) returns integer,\n"
"constructor method XMLType (_src any),\n"
"constructor method XMLType (_src any, _schema varchar),\n"
"constructor method XMLType (_src any, _schema varchar, _validated integer),\n"
"constructor method XMLType (_src any, _schema varchar, _validated integer, _wellformed integer)\n";

static const char *other53 = 
"call exec_quiet (\'alter type XMLType add method transform (_xsl any) returns XMLType\')\n";
static const char *other54 = 
"call exec_quiet (\'alter type XMLType add method transform (_xsl any, _param_map any) returns XMLType\')\n";
static const char *other55 = 
"call exec_quiet (\'alter type XMLType drop method getStringVal () returns varchar\')\n";
static const char *other56 = 
"call exec_quiet (\'alter type XMLType drop method getNamespace () returns any\')\n";
static const char *other57 = 
"call exec_quiet (\'alter type XMLType add method query (_xquery varchar) returns any\')\n";
static const char *other58 = 
"call exec_quiet (\'alter type XMLType add method getStringVal () returns nvarchar\')\n";
static const char *other59 = 
"call exec_quiet (\'alter type XMLType add method getNamespace () returns nvarchar\')\n";
static const char *other60 = 
"call exec_quiet (\'alter type XMLType add method setSchemaValidated () returns integer\')\n";
static const char *other61 = 
"call exec_quiet (\'alter type XMLType add method setSchemaValidated (_flag integer) returns integer\')\n";
static const char *other62 = 
"create method existsNode (in _xpath varchar) returns integer for XMLType\n"
"{\n"
"declare _hit any;\n"
"_hit := xpath_eval (_xpath, self.xt_ent, 1);\n"
"if (__tag (_hit) = 230)\n"
"return 1;\n"
"return 0;\n"
"}\n";

static const char *other63 = 
"create method existsNode (in _xpath varchar, in _nsmap varchar) returns integer for XMLType\n"
"{\n"
"declare _hit any;\n"
"if (_nsmap is not null)\n"
"if (_xpath <> \'\' and aref (_xpath, 0) = \'[\')\n"
"_xpath := concat (\'[\', _nsmap, \' \', subseq (_xpath, 1));\n"
"else\n"
"_xpath := concat (\'[\', _nsmap, \']\', _xpath);\n"
"_hit := xpath_eval (_xpath, self.xt_ent, 1);\n"
"if (__tag (_hit) = 230)\n"
"return 1;\n"
"return 0;\n"
"}\n";

static const char *other64 = 
"create method extract (in _xpath varchar) returns any for XMLType\n"
"{\n"
"declare _hit any;\n"
"_hit := xpath_eval (_xpath, self.xt_ent, 1);\n"
"if (__tag (_hit) = 230)\n"
"return XMLType (_hit);\n"
"return _hit;\n"
"}\n";

static const char *other65 = 
"create method query (in _xquery varchar) returns any for XMLType\n"
"{\n"
"declare _hit any;\n"
"_hit := xquery_eval (_xquery, self.xt_ent, 1);\n"
"if (__tag (_hit) = 230)\n"
"return XMLType (_hit);\n"
"return _hit;\n"
"}\n";

static const char *other66 = 
"create method extract (in _xpath varchar, in _nsmap varchar) returns any for XMLType\n"
"{\n"
"declare _hit any;\n"
"if (_nsmap is not null)\n"
"if (_xpath <> \'\' and aref (_xpath, 0) = \'[\')\n"
"_xpath := concat (\'[\', _nsmap, \' \', subseq (_xpath, 1));\n"
"else\n"
"_xpath := concat (\'[\', _nsmap, \']\', _xpath);\n"
"_hit := xpath_eval (_xpath, self.xt_ent, 1);\n"
"if (__tag(_hit) = 230)\n"
"return XMLType (_hit);\n"
"return _hit;\n"
"}\n";

static const char *other67 = 
"create method isFragment () returns integer for XMLType\n"
"{\n"
"if (xpath_eval (\'count(/*)\', self.xt_ent) = 1)\n"
"return 0;\n"
"return 1;\n"
"}\n";

static const char *other68 = 
"create method getClobVal () returns nvarchar for XMLType\n"
"{\n"
"return xpath_eval (\'serialize(.)\', self.xt_ent, 1);\n"
"}\n";

static const char *other69 = 
"create method getNumVal () returns numeric for XMLType\n"
"{\n"
"return xpath_eval (\'number(.)\', self.xt_ent, 1);\n"
"}\n";

static const char *other70 = 
"create method getStringVal () returns nvarchar for XMLType\n"
"{\n"
"return xpath_eval (\'string(.)\', self.xt_ent, 1);\n"
"}\n";

static const char *other71 = 
"create method transform (inout _xsl any) returns XMLType for XMLType\n"
"{\n"
"signal (\'42000\', \'Virtuoso does not support method XMLType.transform(); use xslt built-in function instead\');\n"
"}\n";

static const char *other72 = 
"create method transform (inout _xsl any, in _param_map any) returns XMLType for XMLType\n"
"{\n"
"signal (\'42000\', \'Virtuoso does not support method XMLType.transform(); use xslt built-in function instead\');\n"
"}\n";

static const char *other73 = 
"create method isSchemaBased () returns integer for XMLType\n"
"{\n"
"if (self.xt_schema is null)\n"
"return 0;\n"
"return 1;\n"
"}\n";

static const char *other74 = 
"create method getSchemaURL () returns varchar for XMLType\n"
"{\n"
"return self.xt_schema;\n"
"}\n";

static const char *other75 = 
"create method getRootElement () returns any for XMLType\n"
"{\n"
"declare _roots any;\n"
"_roots := xpath_eval (\'/*\', self.xt_ent, 0);\n"
"if (length (_roots) <> 1)\n"
"return null;\n"
"return XMLType (aref (_roots, 0), self.xt_schema);\n"
"}\n";

static const char *other76 = 
"create method createSchemaBasedXML () returns any for XMLType\n"
"{\n"
"return XMLType (self.xt_ent);\n"
"}\n";

static const char *other77 = 
"create method createSchemaBasedXML (in _url varchar) returns any for XMLType\n"
"{\n"
"if (_url = self.xt_schema)\n"
"return self;\n"
"return XMLType (self.xt_ent, _url);\n"
"}\n";

static const char *other78 = 
"create method createNonSchemaBasedXML () returns any for XMLType\n"
"{\n"
"return XMLType (self.xt_ent);\n"
"}\n";

static const char *other79 = 
"create method getNamespace () returns nvarchar for XMLType\n"
"{\n"
"declare _res nvarchar;\n"
"if (self.xt_schema is null)\n"
"return null;\n"
"if (xpath_eval (\'count(/*)\', self.xt_ent) <> 1)\n"
"return null;\n"
"_res := xpath_eval (\'namespace-uri(/*)\', self.xt_ent);\n"
"\n"
"\n"
"\n"
"return _res;\n"
"}\n";

static const char *other80 = 
"create method schemaValidate () returns any for XMLType\n"
"{\n"
"if (self.xt_validated <> 0)\n"
"return null;\n"
"if (self.xt_schema is null)\n"
"signal (\'42000\', \'Document is not schema-based\');\n"
"xml_validate_schema (self.xt_ent,\n"
"0,\n"
"coalesce (xml_doc_get_base_uri (self.xt_ent), \'\'),\n"
"\'UTF-8\',\n"
"\'x-any\',\n"
"\'Validation=SGML FsaBadWs=IGNORE SignalOnError=ENABLE\',\n"
"\'xs:\', \':xs\', self.xt_schema );\n"
"self.xt_validated := 1;\n"
"}\n";

static const char *other81 = 
"create method isSchemaValidated () returns integer for XMLType\n"
"{\n"
"return self.xt_validated;\n"
"}\n";

static const char *other82 = 
"create method setSchemaValidated () returns integer for XMLType\n"
"{\n"
"if (self.xt_schema is null)\n"
"signal (\'42000\', \'Document is not schema-based\');\n"
"self.xt_validated := 1;\n"
"return 1;\n"
"}\n";

static const char *other83 = 
"create method setSchemaValidated (in _flag integer) returns integer for XMLType\n"
"{\n"
"if (self.xt_schema is null)\n"
"signal (\'42000\', \'Document is not schema-based\');\n"
"self.xt_validated := _flag;\n"
"return _flag;\n"
"}\n";

static const char *other84 = 
"create method isSchemaValid () returns integer for XMLType\n"
"{\n"
"if (self.xt_schema is null)\n"
"signal (\'42000\', \'Document is not schema-based and no schema URL is provided for XMLType.isSchemaValid().\');\n"
"whenever sqlstate \'42000\' goto err;\n"
"xml_validate_schema (self.xt_ent,\n"
"0,\n"
"coalesce (xml_doc_get_base_uri (self.xt_ent), \'\'),\n"
"\'UTF-8\',\n"
"\'x-any\',\n"
"\'Validation=SGML FsaBadWs=IGNORE SignalOnError=ENABLE\',\n"
"\'xs:\', \':xs\', self.xt_schema );\n"
"return 1;\n"
"\n"
"err:\n"
"return 0;\n"
"}\n";

static const char *other85 = 
"create method isSchemaValid (in _url varchar) returns integer for XMLType\n"
"{\n"
"whenever sqlstate \'42000\' goto err;\n"
"xml_validate_schema (self.xt_ent,\n"
"0,\n"
"coalesce (xml_doc_get_base_uri (self.xt_ent), \'\'),\n"
"\'UTF-8\',\n"
"\'x-any\',\n"
"\'Validation=SGML FsaBadWs=IGNORE SignalOnError=ENABLE\',\n"
"\'xs:\', \':xs\', _url );\n"
"return 1;\n"
"\n"
"err:\n"
"return 0;\n"
"}\n";

static const char *other86 = 
"create method isSchemaValid (in _url varchar, in _elemname varchar) returns integer for XMLType\n"
"{\n"
"whenever sqlstate \'42000\' goto err;\n"
"xml_validate_schema (self.xt_ent,\n"
"0,\n"
"coalesce (xml_doc_get_base_uri (self.xt_ent), \'\'),\n"
"\'UTF-8\',\n"
"\'x-any\',\n"
"\'Validation=SGML FsaBadWs=IGNORE SignalOnError=ENABLE\',\n"
"\'xs:\', \':xs\', _url );\n"
"return 1;\n"
"\n"
"err:\n"
"return 0;\n"
"}\n";

static const char *other87 = 
"create constructor method XMLType (in _src any) for XMLType\n"
"{\n"
"if (__tag (_src) = 230)\n"
"self.xt_ent := _src;\n"
"else if (__tag (_src) = 193)\n"
"self.xt_ent := xml_tree_doc(_src);\n"
"else\n"
"self.xt_ent := xtree_doc (_src);\n"
"self.xt_schema := null;\n"
"self.xt_validated := 0;\n"
"}\n";

static const char *other88 = 
"create constructor method XMLType (in _src any, in _schema varchar) for XMLType\n"
"{\n"
"if (__tag (_src) = 230)\n"
"self.xt_ent := _src;\n"
"else if (__tag (_src) = 193)\n"
"self.xt_ent := xml_tree_doc(_src);\n"
"else\n"
"self.xt_ent := xtree_doc (_src);\n"
"self.xt_schema := _schema;\n"
"self.xt_validated := 0;\n"
"}\n";

static const char *other89 = 
"create constructor method XMLType (in _src any, in _schema varchar, in _validated integer) for XMLType\n"
"{\n"
"if (__tag (_src) = 230)\n"
"self.xt_ent := _src;\n"
"else if (__tag (_src) = 193)\n"
"self.xt_ent := xml_tree_doc(_src);\n"
"else\n"
"self.xt_ent := xtree_doc (_src);\n"
"self.xt_schema := _schema;\n"
"self.xt_validated := _validated;\n"
"}\n";

static const char *other90 = 
"create constructor method XMLType (in _src any, in _schema varchar, in _validated integer, in _wellformed integer) for XMLType\n"
"{\n"
"if (__tag (_src) = 230)\n"
"self.xt_ent := _src;\n"
"else if (__tag (_src) = 193)\n"
"self.xt_ent := xml_tree_doc(_src);\n"
"else\n"
"self.xt_ent := xtree_doc (_src);\n"
"self.xt_schema := _schema;\n"
"self.xt_validated := _validated;\n"
"}\n";

static const char *other91 = 
"create constructor method XMLType (in _src any, in _schema varchar := null, in _validated integer := 0, in _wellformed integer := 0) for XMLType\n"
"{\n"
"if (__tag (_src) = 230)\n"
"self.xt_ent := _src;\n"
"else\n"
"self.xt_ent := xtree_doc (_src);\n"
"self.xt_schema := _schema;\n"
"self.xt_validated := _validated;\n"
"}\n";

static const char *proc119 = 
"create function createXML (in _src any, in _schema varchar := null, in _validated integer := 0, in _wellformed integer := 0) returns XMLType\n"
"{\n"
"declare _res XMLType;\n"
"_res := XMLType (_src, _schema, _validated, _wellformed);\n"
"return _res;\n"
"}\n"
"--src system.sql:5290\n";

static const char *other92 = 
"grant execute on XMLType to public\n";
static const char *proc120 = 
" create procedure DB.DBA.SYS_CREATE_XML_SCHEMA (in _txt varchar)\n"
"{\n"
"declare _log varchar;\n"
"declare _parsed any;\n"
"declare _xsd_top any;\n"
"declare _target_ns any;\n"
"declare _cres_uri any;\n"
"_parsed := xtree_doc (_txt, 0, \'(argument of CREATE XML SCHEMA statement)\', \'UTF-8\', \'x-any\', \'Validation=RIGOROUS BuildStandalone=ENABLE\');\n"
"_xsd_top := xpath_eval (\'[xmlns:xs=\"http://www.w3.org/2001/XMLSchema\"] /xs:schema\', _parsed, 0);\n"
"if (0 = length(_xsd_top))\n"
"signal (\'XSD01\', \'No XMLSchema top element found in the provided XML document\');\n"
"if (1 < length(_xsd_top))\n"
"signal (\'XSD01\', \'The provided XML document is not a valida schema\');\n"
"_target_ns := xpath_eval (\'@targetNamespace\', _xsd_top[0]);\n"
"if (_target_ns is NULL)\n"
"signal (\'XSD01\', \'No \"targetNamespace\" attribute in top-level \"xs:schema\" element in the provided XML document\');\n"
"if (_target_ns = \'\')\n"
"signal (\'XSD01\', \'The value of the \"targetNamespace\" attribute in top-level \"xs:schema\" element is not a well-formed URI\');\n"
"_cres_uri := \'x-virt-cache-xsd--\' || _target_ns;\n"
"if (exists (select top 1 1 from SYS_CACHED_RESOURCES where CRES_URI=_cres_uri))\n"
"signal (\'XSD01\', sprintf (\'The XMLSchema for target namespace \"%s\" is already declared\', _target_ns));\n"
"insert into SYS_CACHED_RESOURCES (CRES_URI, CRES_CONTENT)\n"
"values (_cres_uri, _txt);\n"
"}\n"
"--src system.sql:5302\n";

static const char *proc121 = 
" create procedure DB.DBA.XML_COLUMN_SCHEMA_VALIDATE (\n"
"in _table varchar, in _column varchar, in _xml any,\n"
"in _xsd_uri varchar, in _top_name varchar, in _dtd_cfg varchar)\n"
"{\n"
"declare _log varchar;\n"
"\n"
"if (_xml is null)\n"
"return null;\n"
"\n"
"xml_validate_schema (\n"
"_xml, 0, sprintf(\'(value to be placed in column %s of %s)\', _table, _column),\n"
"\'UTF-8\', \'x-any\',\n"
"case when (_dtd_cfg is null) then \'Validation=RIGOROUS AttrMisformat=ERROR AttrMissing=ERROR FSA=ERROR IdDuplicates=ERROR IdrefIntegrity=ERROR SignalOnError=ENABLE\' else concat (_dtd_cfg, \' SignalOnError=ENABLE\') end,\n"
"\'xs:\', \':xs\', \'x-virt-cache-xsd--\' || _xsd_uri );\n"
"\n"
"\n"
"return null;\n"
"}\n"
"--src system.sql:5329\n";

static const char *proc122 = 
" create function SYS_TREE_OF_ARRAYS_CONTAINS (in _haystack any, in _needle any)\n"
"{\n"
"declare _ctr integer;\n"
"if (__tag (_haystack) = __tag (_needle))\n"
"return equ (_haystack, _needle);\n"
"if (isstring (_haystack) or not (isarray (_haystack)))\n"
"return 0;\n"
"_ctr := length (_haystack);\n"
"while (_ctr > 0)\n"
"{\n"
"_ctr := _ctr - 1;\n"
"if (SYS_TREE_OF_ARRAYS_CONTAINS (aref (_haystack, _ctr), _needle))\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src system.sql:5350\n";

static const char *proc123 = 
" create procedure DB.DBA.SYS_DROP_XML_SCHEMA (in _target_ns varchar)\n"
"{\n"
"declare _log varchar;\n"
"declare _parsed any;\n"
"declare _xsd_top any;\n"
"declare _cres_uri any;\n"
"_cres_uri := \'x-virt-cache-xsd--\' || _target_ns;\n"
"if (not exists (select top 1 1 from SYS_CACHED_RESOURCES where CRES_URI=_cres_uri))\n"
"signal (\'XSD01\', sprintf (\'Undefined XMLSchema name in DROP XML SCHEMA \"%s\"\', _target_ns));\n"
"for\n"
"select C_TABLE from SYS_CONSTRAINTS where\n"
"SYS_TREE_OF_ARRAYS_CONTAINS (deserialize(C_MODE), cast (_target_ns as varchar)) do\n"
"signal (\'XSD01\', sprintf (\'Can not DROP XML SCHEMA \"%s\" because the schema is in use in constraint of table %s\', _target_ns, C_TABLE));\n"
"delete from SYS_CACHED_RESOURCES where CRES_URI =_cres_uri;\n"
"}\n"
"--src system.sql:5369\n";

static const char *proc124 = 
" create procedure REGEXP_LIKE (in source_string any, in pattern any, in match_parameter integer := null)\n"
"returns integer\n"
"{\n"
"if (match_parameter is not null)\n"
"signal (\'22023\', \'match_parameter not supported yet\', \'SR371\');\n"
"if (source_string is null or pattern is null)\n"
"return 0;\n"
"else\n"
"{\n"
"if ((not isstring (source_string)) and (not iswidestring (source_string)))\n"
"source_string := cast (source_string as varchar);\n"
"if ((not isstring (pattern)) and (not iswidestring (pattern)))\n"
"pattern := cast (pattern as varchar);\n"
"}\n"
"return either (isnull (regexp_match (pattern, source_string)), 0, 1);\n"
"}\n"
"--src system.sql:5387\n";

static const char *proc125 = 
" create procedure REGEXP_REPLACE (in source_string any, in pattern any,\n"
"in replace_string varchar := \'\', in position integer := 1,\n"
"in occurrence any := 1, in match_parameter integer := null)\n"
"{\n"
"if (source_string is null or pattern is null or replace_string is null)\n"
"return source_string;\n"
"else\n"
"{\n"
"if ((not isstring (source_string)) and (not iswidestring (source_string)))\n"
"source_string := cast (source_string as varchar);\n"
"if ((not isstring (pattern)) and (not iswidestring (pattern)))\n"
"pattern := cast (pattern as varchar);\n"
"if ((not isstring (replace_string)) and (not iswidestring (replace_string)))\n"
"replace_string := cast (replace_string as varchar);\n"
"}\n"
"\n"
"if (match_parameter is not null)\n"
"signal (\'22023\', \'match_parameter not supported yet\', \'SR372\');\n"
"declare cur_pos, copied_up_to, nth integer;\n"
"declare ret any;\n"
"\n"
"ret := either (iswidestring (source_string), N\'\', \'\');\n"
"cur_pos := position - 1;\n"
"copied_up_to := position - 1;\n"
"nth := 1;\n"
"\n"
"while (cur_pos < length (source_string))\n"
"{\n"
"declare exprs any;\n"
"\n"
"exprs := regexp_parse (pattern, source_string, cur_pos);\n"
"\n"
"if (not isarray (exprs))\n"
"goto done;\n"
"\n"
"declare start_inx, end_inx integer;\n"
"start_inx := exprs[0];\n"
"end_inx := exprs[1];\n"
"\n"
"if (occurrence is null or occurrence = nth)\n"
"{\n"
"if (start_inx > copied_up_to)\n"
"ret := concat (ret, subseq (source_string, copied_up_to, start_inx));\n"
"\n"
"if (length (exprs) > 2)\n"
"{\n"
"declare expr_inx integer;\n"
"declare replace_str any;\n"
"declare replace_string_tmp any;\n"
"replace_string_tmp := replace_string;\n"
"expr_inx := 1;\n"
"\n"
"while (expr_inx * 2 < length (exprs))\n"
"{\n"
"declare replace_str_found varchar;\n"
"\n"
"if (exprs[expr_inx * 2] >= 0 and exprs[expr_inx * 2 + 1] >= 0)\n"
"replace_str_found := subseq (source_string, exprs[expr_inx * 2], exprs [expr_inx * 2 + 1]);\n"
"else\n"
"replace_str_found := either (iswidestring (source_string), N\'\', \'\');\n"
"\n"
"replace_str := sprintf (\'\\\\%d\', expr_inx);\n"
"if (iswidestring (source_string))\n"
"replace_str := cast (replace_str as nvarchar);\n"
"replace_string_tmp := replace (replace_string_tmp, replace_str,\n"
"replace_str_found);\n"
"expr_inx := expr_inx + 1;\n"
"}\n"
"while (expr_inx < 10)\n"
"{\n"
"replace_str := sprintf (\'\\\\%d\', expr_inx);\n"
"if (iswidestring (source_string))\n"
"replace_str := cast (replace_str as nvarchar);\n"
"replace_string_tmp := replace (replace_string_tmp, replace_str,\n"
"either (iswidestring (source_string), N\'\', \'\'));\n"
"expr_inx := expr_inx + 1;\n"
"}\n"
"ret := concat (ret, replace_string_tmp);\n"
"}\n"
"else\n"
"ret := concat (ret, replace_string);\n"
"copied_up_to := end_inx;\n"
"if (occurrence is not null)\n"
"goto done;\n"
"}\n"
"\n"
"nth := nth + 1;\n"
"cur_pos := end_inx;\n"
"}\n"
"done:\n"
"if (copied_up_to < length (source_string))\n"
"ret := concat (ret, subseq (source_string, copied_up_to, length (source_string)));\n"
"\n"
"return ret;\n"
"}\n"
"--src system.sql:5407\n";

static const char *proc126 = 
" create procedure REGEXP_INSTR (in source_string varchar, in pattern varchar,\n"
"in start_position integer := 1, in occurrence integer := 1, in return_option integer := 0,\n"
"in match_parameter integer := null)\n"
"returns integer\n"
"{\n"
"\n"
"if (source_string is null or pattern is null)\n"
"return null;\n"
"else\n"
"{\n"
"if ((not isstring (source_string)) and (not iswidestring (source_string)))\n"
"source_string := cast (source_string as varchar);\n"
"if ((not isstring (pattern)) and (not iswidestring (pattern)))\n"
"pattern := cast (pattern as varchar);\n"
"}\n"
"\n"
"if (match_parameter is not null)\n"
"signal (\'22023\', \'match_parameter not supported yet\', \'SR373\');\n"
"\n"
"declare cur_pos, nth integer;\n"
"\n"
"cur_pos := start_position - 1;\n"
"nth := 1;\n"
"\n"
"while (cur_pos < length (source_string) and nth <= occurrence)\n"
"{\n"
"declare exprs any;\n"
"\n"
"exprs := regexp_parse (pattern, source_string, cur_pos);\n"
"\n"
"if (not isarray (exprs))\n"
"return null;\n"
"\n"
"declare start_inx, end_inx integer;\n"
"start_inx := exprs[0];\n"
"end_inx := exprs[1];\n"
"\n"
"if (occurrence = nth)\n"
"{\n"
"if (return_option = 0)\n"
"return start_inx + 1;\n"
"else if (return_option = 1)\n"
"return end_inx + 1;\n"
"else\n"
"signal (\'22023\', \'return_option should be 0 or 1\', \'SR374\');\n"
"}\n"
"\n"
"cur_pos := end_inx;\n"
"nth := nth + 1;\n"
"}\n"
"\n"
"return null;\n"
"}\n"
"--src system.sql:5506\n";

static const char *proc127 = 
" create procedure HTTP_REQUESTED_URL ()\n"
"{\n"
"declare hf, pat, proto, meth, so, eo, lines any;\n"
"if (not is_http_ctx())\n"
"signal (\'22023\', \'http_requested_url function outside of http context\', \'HT069\');\n"
"lines := http_request_header ();\n"
"pat := lines[0];\n"
"proto := http_request_get (\'SERVER_PROTOCOL\');\n"
"meth := http_request_get (\'REQUEST_METHOD\');\n"
"so := strstr (pat, meth || \' \');\n"
"eo := strstr (pat, \' \' || proto);\n"
"pat := trim(subseq (pat, so + length (meth) + 1, eo), \' \\r\\n\');\n"
"hf := WS.WS.PARSE_URI (pat);\n"
"return WS.WS.EXPAND_URL(soap_current_url (), hf[2]);\n"
"}\n"
"--src system.sql:5562\n";

static const char *proc128 = 
" create procedure HTTP_URL_HANDLER ()\n"
"{\n"
"if (not is_http_ctx())\n"
"signal (\'22023\', \'http_url_handler function outside of http context\', \'HT068\');\n"
"return WS.WS.EXPAND_URL(soap_current_url (), http_path());\n"
"}\n"
"--src system.sql:5580\n";

static const char *proc129 = 
"create procedure DB.DBA.SERVICES_WSIL (in path any, in params any, in lines any)\n"
"{\n"
"declare host, intf, requrl, proto, rhost varchar;\n"
"declare arr any;\n"
"host := http_map_get (\'vhost\');\n"
"intf := http_map_get (\'lhost\');\n"
"requrl := http_requested_url ();\n"
"arr := WS.WS.PARSE_URI (requrl);\n"
"proto := arr[0];\n"
"rhost := arr[1];\n"
"\n"
"if (host = server_http_port () and intf = server_http_port ())\n"
"{\n"
"host := \'*ini*\';\n"
"intf := \'*ini*\';\n"
"}\n"
"\n"
"http_header (\'Content-Type: text/xml\\r\\n\');\n"
"http(\'<?xml version=\"1.0\" ?>\');\n"
"http(\'<inspection xmlns=\"http://schemas.xmlsoap.org/ws/2001/10/inspection\">\');\n"
"for select HP_LPATH, deserialize (HP_SOAP_OPTIONS) as opts from DB.DBA.HTTP_PATH where HP_HOST = host and HP_LISTEN_HOST = intf and HP_PPATH = \'/SOAP/\' do\n"
"{\n"
"declare nam any;\n"
"nam := trim (HP_LPATH, \'/ \');\n"
"if (isarray (opts))\n"
"nam := get_keyword (\'ServiceName\', opts, nam);\n"
"http (\'<service>\');\n"
"http (sprintf (\'<name>%V</name>\', nam));\n"
"http (sprintf (\'<description referencedNamespace=\"http://schemas.xmlsoap.org/wsdl/\" location=\"%s://%s%s/services.wsdl\"/>\', proto, rhost, HP_LPATH));\n"
"http (\'</service>\');\n"
"}\n"
"http(\'</inspection>\');\n"
"}\n"
"--src system.sql:5588\n";

static const char *proc130 = 
"create procedure DB.DBA.SCHEDULER_NOTIFY ()\n"
"{\n"
"declare arr, err_text, current_rec, mime_parts, hdrs, hostname any;\n"
"\n"
"arr := vector ();\n"
"\n"
"current_rec := null;\n"
"err_text := \'\';\n"
"hostname := sys_stat (\'st_host_name\');\n"
"\n"
"if (not isstring (hostname))\n"
"return;\n"
"\n"
"hdrs := sprintf (\'Subject: [Scheduled Event Errors] %s\\r\\n\', hostname);\n"
"\n"
"for select SE_NAME, SE_SQL, SE_LAST_ERROR, SE_NOTIFY from SYS_SCHEDULED_EVENT where\n"
"SE_LAST_ERROR is not null and SE_ENABLE_NOTIFY = 1 and SE_NOTIFICATION_SENT = 0 order by SE_NOTIFY do\n"
"{\n"
"arr := vector_concat (arr, vector (vector (SE_NAME, SE_SQL, SE_LAST_ERROR, SE_NOTIFY)));\n"
"}\n"
"\n"
"commit work;\n"
"foreach (any elm in arr) do\n"
"{\n"
"declare _SE_NAME, _SE_SQL, _SE_LAST_ERROR, _SE_NOTIFY any;\n"
"_SE_NAME := elm[0];\n"
"_SE_SQL := elm[1];\n"
"_SE_LAST_ERROR := elm[2];\n"
"_SE_NOTIFY := elm[3];\n"
"\n"
"\n"
"if (current_rec is null)\n"
"{\n"
"current_rec := _SE_NOTIFY;\n"
"err_text := \'\';\n"
"}\n"
"else if (current_rec <> _SE_NOTIFY)\n"
"{\n"
"mime_parts := vector (DB.DBA.MIME_PART (\'text/html\', null, null, err_text));\n"
"update SYS_SCHEDULED_EVENT set SE_NOTIFICATION_SENT = 1 where SE_NOTIFY = current_rec and SE_NOTIFICATION_SENT = 0;\n"
"commit work;\n"
"{\n"
"declare exit handler for sqlstate \'*\'\n"
"{\n"
"rollback work;\n"
"goto next;\n"
"};\n"
"smtp_send (null, current_rec, current_rec, concat (hdrs, DB.DBA.MIME_BODY (mime_parts)));\n"
"next:;\n"
"}\n"
"current_rec := _SE_NOTIFY;\n"
"err_text := \'\';\n"
"}\n"
"err_text := err_text || \'<pre>\' || _SE_NAME || \' \' || _SE_SQL || \'\\r\\n\' || blob_to_string (_SE_LAST_ERROR) || \'</pre>\\r\\n\' ;\n"
"}\n"
"if (length (err_text) and current_rec is not null)\n"
"{\n"
"mime_parts := vector (DB.DBA.MIME_PART (\'text/html\', null, null, err_text));\n"
"update SYS_SCHEDULED_EVENT set SE_NOTIFICATION_SENT = 1 where SE_NOTIFY = current_rec and SE_NOTIFICATION_SENT = 0;\n"
"commit work;\n"
"smtp_send (null, current_rec, current_rec, concat (hdrs, DB.DBA.MIME_BODY (mime_parts)));\n"
"}\n"
"}\n"
"--src system.sql:5625\n";

static const char *proc131 = 
"create procedure\n"
"SYS_CHECK_OLD_BLOG ()\n"
"{\n"
"if (registry_get (\'__weblog2_tables_is_upgrated\') = \'OK\')\n"
"return;\n"
"if(exists(select 1 from DB.DBA.SYS_KEYS where KEY_TABLE = \'DB.DBA.SYS_BLOGS\'))\n"
"{\n"
"declare mtd, dta, state, msg any;\n"
"state := \'00000\';\n"
"exec (\'select count (*) from DB.DBA.SYS_BLOGS\', state, msg, vector (), 1, mtd, dta);\n"
"if (\'00000\' <> state)\n"
"return;\n"
"if (dta[0][0] > 1)\n"
"log_message (\'Detected old blog instance. Please update it with latest blog.vad\');\n"
"}\n"
"}\n"
"--src system.sql:5691\n";

static const char *other93 = 
"SYS_CHECK_OLD_BLOG ()\n";
static const char *proc132 = 
" create procedure\n"
"HTTP_GET_HOST ()\n"
"{\n"
"declare ret varchar;\n"
"if (is_http_ctx ())\n"
"{\n"
"ret := http_request_header (http_request_header (), \'Host\', null, sys_connected_server_address ());\n"
"if (isstring (ret) and strchr (ret, \':\') is null)\n"
"{\n"
"declare hp varchar;\n"
"declare hpa any;\n"
"hp := sys_connected_server_address ();\n"
"hpa := split_and_decode (hp, 0, \'\\0\\0:\');\n"
"ret := ret || \':\' || hpa[1];\n"
"}\n"
"}\n"
"else\n"
"{\n"
"ret := sys_connected_server_address ();\n"
"if (ret is null)\n"
"ret := sys_stat (\'st_host_name\')||\':\'||server_http_port ();\n"
"}\n"
"\n"
"return ret;\n"
"}\n"
"--src system.sql:5714\n";

static const char *proc133 = 
" create procedure\n"
"date_rfc1123 (in dt datetime)\n"
"{\n"
"return soap_print_box (dt, \'\', 1);\n"
"}\n"
"--src system.sql:5742\n";

static const char *proc134 = 
" create procedure\n"
"date_iso8601 (in dt datetime)\n"
"{\n"
"return soap_print_box (dt, \'\', 0);\n"
"}\n"
"--src system.sql:5750\n";

static const char *proc135 = 
"create procedure DB.DBA.INSTALLER_VAD (in _pak_name varchar)\n"
"{\n"
"declare state, msg, m_dta, res any;\n"
"declare out_message varchar;\n"
"declare idx, len integer;\n"
"\n"
"state := \'00000\';\n"
"msg := \'none\';\n"
"out_message := \'\';\n"
"\n"
"exec (\'VAD_INSTALL(?, 0, 1)\',\n"
"state, msg, vector (_pak_name), 100, m_dta, res);\n"
"\n"
"if (\'00000\' <> state)\n"
"{\n"
"out_message := msg;\n"
"goto finish;\n"
"}\n"
"\n"
"idx := 0;\n"
"len := length (res);\n"
"\n"
"while (idx < len)\n"
"{\n"
"if (res[idx][0] <> \'00000\')\n"
"out_message := out_message || res[idx][1] || \' \';\n"
"idx := idx + 1;\n"
"}\n"
"\n"
"finish:;\n"
"\n"
"string_to_file (\'../vad/install.res\', out_message, -2);\n"
"return;\n"
"}\n"
"--src system.sql:5757\n";

static const char *proc136 = 
"create procedure DB.DBA.VACUUM (in table_name varchar := \'%\', in index_name varchar := \'%\')\n"
"{\n"
"declare stmt, stat, msg varchar;\n"
"set isolation=\'uncommitted\';\n"
"for select distinct KEY_TABLE as _table_name, KEY_NAME as _index_name from SYS_KEYS where\n"
"KEY_TABLE like table_name and KEY_NAME like index_name and KEY_MIGRATE_TO is null do\n"
"{\n"
"if (not exists (select 1 from SYS_VIEWS where V_NAME = _table_name) and\n"
"not exists (select 1 from SYS_REMOTE_TABLE where RT_NAME = _table_name))\n"
"{\n"
"stmt := sprintf (\'select count(*) from \"%I\".\"%I\".\"%I\" table option (index %I, vacuum 0)\',\n"
"name_part (_table_name,0),\n"
"name_part (_table_name,1),\n"
"name_part (_table_name,2),\n"
"name_part (_index_name,2)\n"
");\n"
"stat := \'00000\';\n"
"exec (stmt, stat, msg, vector (), 0);\n"
"dbg_printf (\'%s %s\', stat, stmt);\n"
"}\n"
"}\n"
"}\n"
"--src system.sql:5793\n";

static const char *proc137 = 
"create procedure tc_result (in n varchar)\n"
"{\n"
"declare exit handler for sqlstate \'*\' {\n"
"result (-1, n);\n"
"};\n"
"if (sys_stat (n) = 0)\n"
"return;\n"
"result (sys_stat (n), n);\n"
"}\n"
"--src system.sql:5819\n";

static const char *proc138 = 
"create procedure tc_stat ()\n"
"{\n"
"declare cond varchar (60);\n"
"declare n int;\n"
"result_names (n, cond);\n"
"tc_result (\'tc_initial_while_closing\');\n"
"tc_result (\'tc_initial_while_closing_died\');\n"
"tc_result (\'tc_client_dropped_connection\');\n"
"tc_result (\'tc_no_client_in_tp_data\');\n"
"tc_result (\'tc_bp_get_buffer\');\n"
"tc_result (\'tc_bp_get_buffer_loop\');\n"
"tc_result (\'tc_first_free_replace\');\n"
"tc_result (\'tc_hi_lock_new_lock\');\n"
"tc_result (\'tc_hi_lock_old_dp_no_lock\');\n"
"tc_result (\'tc_hi_lock_old_dp_no_lock_deadlock\');\n"
"tc_result (\'tc_hi_lock_old_dp_no_lock_put_lock\');\n"
"tc_result (\'tc_hi_lock_lock\');\n"
"tc_result (\'tc_hi_lock_lock_deadlock\');\n"
"tc_result (\'tc_pg_write_compact\');\n"
"tc_result (\'tc_write_cancel\');\n"
"tc_result (\'tc_write_scrapped_buf\');\n"
"tc_result (\'tc_serializable_land_reset\');\n"
"tc_result (\'tc_dive_cache_compares\');\n"
"tc_result (\'tc_desc_serial_reset\');\n"
"tc_result (\'tc_try_land_write\');\n"
"tc_result (\'tc_try_land_reset\');\n"
"tc_result (\'tc_up_transit_parent_change\');\n"
"tc_result (\'tc_dp_set_parent_being_read\');\n"
"tc_result (\'tc_dp_changed_while_waiting_mtx\');\n"
"tc_result (\'tc_dive_split\');\n"
"tc_result (\'tc_dtrans_split\');\n"
"tc_result (\'tc_up_transit_wait\');\n"
"tc_result (\'tc_double_deletes\');\n"
"tc_result (\'tc_delete_parent_waits\');\n"
"tc_result (\'tc_wait_trx_self_kill\');\n"
"tc_result (\'tc_split_while_committing\');\n"
"tc_result (\'tc_rb_code_non_unique\');\n"
"tc_result (\'tc_set_by_pl_wait\');\n"
"tc_result (\'tc_split_2nd_read\');\n"
"tc_result (\'tc_read_wait\');\n"
"tc_result (\'tc_write_wait\');\n"
"tc_result (\'tc_reentry_split\');\n"
"tc_result (\'tc_pl_moved_in_reentry\');\n"
"tc_result (\'tc_release_pl_on_deleted_dp\');\n"
"tc_result (\'tc_release_pl_on_absent_dp\');\n"
"tc_result (\'tc_cpt_lt_start_wait\');\n"
"tc_result (\'tc_cpt_rollback\');\n"
"tc_result (\'tc_wait_for_closing_lt\');\n"
"tc_result (\'tc_pl_non_owner_wait_ref_deld\');\n"
"tc_result (\'tc_pl_split\');\n"
"tc_result (\'tc_pl_split_multi_owner_page\');\n"
"tc_result (\'tc_pl_split_while_wait\');\n"
"tc_result (\'tc_insert_follow_wait\');\n"
"tc_result (\'tc_history_itc_delta_wait\');\n"
"tc_result (\'tc_page_wait_reset\');\n"
"tc_result (\'tc_key_sample_reset\');\n"
"tc_result (\'tc_posthumous_lock\');\n"
"tc_result (\'tc_finalize_while_being_read\');\n"
"tc_result (\'tc_rollback_cpt_page\');\n"
"tc_result (\'tc_kill_closing\');\n"
"tc_result (\'tc_dive_cache_hits\');\n"
"tc_result (\'tc_deadlock_win_get_lock\');\n"
"tc_result (\'tc_double_deadlock\');\n"
"tc_result (\'tc_update_wait_move\');\n"
"tc_result (\'tc_root_cache_miss\');\n"
"tc_result (\'tc_dive_would_deadlock\');\n"
"tc_result (\'tc_bm_split_left_separate_but_no_split;\');\n"
"tc_result (\'tc_enter_transiting_bm_inx\');\n"
"tc_result (\'tc_root_image_miss\');\n"
"tc_result (\'tc_root_image_ref_deleted\');\n"
"tc_result (\'tc_root_write\');\n"
"tc_result (\'tc_cpt_rollback_retry\');\n"
"tc_result (\'tc_uncommit_cpt_page\');\n"
"tc_result (\'tc_repl_cycle\');\n"
"tc_result (\'tc_repl_connect_quick_reuse\');\n"
"tc_result (\'tc_no_thread_kill_idle\');\n"
"tc_result (\'tc_no_thread_kill_vdb\');\n"
"tc_result (\'tc_no_thread_kill_running\');\n"
"tc_result (\'tc_deld_row_rl_rb\');\n"
"tc_result (\'tc_blob_read\');\n"
"tc_result (\'tc_blob_write\');\n"
"tc_result (\'tc_blob_ra\');\n"
"tc_result (\'tc_blob_ra_size\');\n"
"tc_result (\'tc_get_buf_failed\');\n"
"tc_result (\'tc_read_wait_decoy\');\n"
"tc_result (\'tc_read_absent_while_finalize\');\n"
"tc_result (\'tc_read_wait_while_ra_finding_buf\');\n"
"tc_result (\'tc_unregister_enter\');\n"
"\n"
"}\n"
"--src system.sql:5830\n";

/* system2.sql */

static const char *proc139 = 
"create procedure DB.DBA.SYS_INDEX_SPACE_STATS_PROC ()\n"
"{\n"
"declare ISS_KEY_ID, ISS_NROWS, ISS_ROW_BYTES, ISS_BLOB_PAGES, ISS_ROW_PAGES integer;\n"
"\n"
"result_names (ISS_KEY_ID, ISS_NROWS, ISS_ROW_BYTES, ISS_BLOB_PAGES, ISS_ROW_PAGES);\n"
"\n"
"declare _res any;\n"
"_res := sys_index_space_usage ();\n"
"\n"
"if (isarray (_res))\n"
"{\n"
"declare _inx, _len integer;\n"
"_inx := 0;\n"
"_len := length (_res);\n"
"\n"
"while (_inx < _len)\n"
"{\n"
"declare _row any;\n"
"_row := _res[_inx];\n"
"\n"
"result (_row[0], _row[1], _row[2], _row[3], _row[4]);\n"
"_inx := _inx + 1;\n"
"}\n"
"}\n"
"}\n"
"--src system2.sql:22\n";

static const char *view0 = 
"create view DB.DBA.SYS_INDEX_SPACE_STATS as\n"
"select\n"
"KEY_TABLE as ISS_KEY_TABLE,\n"
"KEY_NAME as ISS_KEY_NAME,\n"
"ISS_KEY_ID,\n"
"ISS_NROWS,\n"
"ISS_ROW_BYTES,\n"
"ISS_BLOB_PAGES,\n"
"ISS_ROW_PAGES,\n"
"ISS_ROW_PAGES + ISS_BLOB_PAGES as ISS_PAGES\n"
"from\n"
"DB.DBA.SYS_INDEX_SPACE_STATS_PROC () (\n"
"ISS_KEY_ID integer,\n"
"ISS_NROWS integer,\n"
"ISS_ROW_BYTES integer,\n"
"ISS_BLOB_PAGES integer,\n"
"ISS_ROW_PAGES integer) _tmp,\n"
"DB.DBA.SYS_KEYS table option (order)\n"
"where\n"
"ISS_KEY_ID = KEY_ID\n";

static const char *proc140 = 
" create procedure DB.DBA.__VD_GET_SQLSTATS_COUNT (in _ds_dsn varchar, in _remote_name varchar)\n"
"{\n"
"declare exit handler for sqlstate \'*\' { return NULL; };\n"
"declare stats any;\n"
"stats := sql_statistics (_ds_dsn,\n"
"name_part (_remote_name, 0, NULL),\n"
"name_part (_remote_name, 1, NULL),\n"
"name_part (_remote_name, 2, NULL),\n"
"1,\n"
"0);\n"
"\n"
"if (isarray (stats))\n"
"{\n"
"declare inx, len integer;\n"
"len := length (stats);\n"
"inx := 0;\n"
"while (inx < len)\n"
"{\n"
"declare stat any;\n"
"declare stat_type, stat_cardinality integer;\n"
"stat := stats[inx];\n"
"\n"
"stat_type := stat[6];\n"
"stat_cardinality := stat[10];\n"
"if (stat_type = 0 and stat_cardinality is not null)\n"
"return stat_cardinality;\n"
"inx := inx + 1;\n"
"}\n"
"}\n"
"return NULL;\n"
"}\n"
"--src system2.sql:72\n";

static const char *proc141 = 
" create procedure DB.DBA.VD_STATISTICS (in _dsn varchar := \'%\', in vd_table_mask varchar := \'%\')\n"
"{\n"
"declare _ds_dsn, _ds_conn_str any;\n"
"declare changed_tables any;\n"
"declare cr cursor for\n"
"SELECT DS_DSN, deserialize (DS_CONN_STR) from DB.DBA.SYS_DATA_SOURCE where DS_DSN like _dsn;\n"
"\n"
"whenever NOT FOUND goto done;\n"
"\n"
"changed_tables := vector ();\n"
"\n"
"open cr (exclusive, prefetch 1);\n"
"while (1 = 1)\n"
"{\n"
"declare _pos integer;\n"
"declare _rpc_time float;\n"
"\n"
"fetch cr into _ds_dsn, _ds_conn_str;\n"
"\n"
"_rpc_time := vdd_measure_rpc_time (_ds_dsn);\n"
"\n"
"_pos := position (-200, _ds_conn_str, 0, 2);\n"
"if (_pos > 0)\n"
"aset (_ds_conn_str, _pos, _rpc_time);\n"
"else\n"
"_ds_conn_str := vector_concat (_ds_conn_str, vector (-200, _rpc_time));\n"
"\n"
"update DB.DBA.SYS_DATA_SOURCE set DS_CONN_STR = serialize (_ds_conn_str)\n"
"where current of cr;\n"
"\n"
"for select RT_REMOTE_NAME, RT_NAME from SYS_REMOTE_TABLE\n"
"where RT_DSN = _ds_dsn and RT_NAME like vd_table_mask do\n"
"{\n"
"declare exit handler for sqlstate \'*\' { ; };\n"
"declare stats_updated integer;\n"
"declare stat_cardinality integer;\n"
"\n"
"stats_updated := 0;\n"
"\n"
"stat_cardinality := DB.DBA.__VD_GET_SQLSTATS_COUNT (_ds_dsn, RT_REMOTE_NAME);\n"
"if (stat_cardinality is not null)\n"
"{\n"
"insert replacing SYS_COL_STAT\n"
"(CS_TABLE, CS_COL, CS_N_DISTINCT, CS_MIN, CS_MAX,\n"
"CS_AVG_LEN,\n"
"CS_N_VALUES, CS_N_ROWS)\n"
"select\n"
"KEY_TABLE, \"COLUMN\", stat_cardinality, NULL, NULL,\n"
"(case when COL_PREC = 0 then 30\n"
"when dv_type_title (COL_DTP) like \'LONG %\' then 30 else COL_PREC end),\n"
"stat_cardinality, stat_cardinality\n"
"from\n"
"SYS_COLS, SYS_KEYS, SYS_KEY_PARTS\n"
"where\n"
"KEY_IS_MAIN = 1 and\n"
"KEY_MIGRATE_TO is NULL and\n"
"KEY_SUPER_ID = KEY_ID and\n"
"KP_KEY_ID = KEY_ID and\n"
"KP_COL = COL_ID and\n"
"KEY_TABLE = RT_NAME;\n"
"\n"
"if (row_count () > 0)\n"
"stats_updated := 1;\n"
"}\n"
"if (stats_updated)\n"
"changed_tables := vector_concat (changed_tables, vector (RT_NAME));\n"
"}\n"
"}\n"
"done:\n"
"close cr;\n"
"declare inx, len integer;\n"
"inx := 0;\n"
"len := length (changed_tables);\n"
"while (inx < len)\n"
"{\n"
"__ddl_changed (changed_tables[inx]);\n"
"inx := inx + 1;\n"
"}\n"
"}\n"
"--src system2.sql:106\n";

static const char *proc142 = 
" create procedure DB.DBA.TABLE_SET_POLICY (in _tb varchar, in _proc varchar, in _type varchar := \'IDUS\')\n"
"{\n"
"declare tb_name, proc_name varchar;\n"
"declare is_view integer;\n"
"\n"
"tb_name := complete_table_name (_tb, 1);\n"
"if (1 <> (select count(*) from DB.DBA.SYS_KEYS\n"
"where\n"
"KEY_TABLE = tb_name and\n"
"KEY_IS_MAIN = 1 and\n"
"KEY_MIGRATE_TO is null))\n"
"signal (\'22023\', sprintf (\'No table or duplicate table %s in TABLE_SET_POLICY\', _tb), \'SR382\');\n"
"\n"
"if (name_part (tb_name, 1) <> user and user <> \'dba\')\n"
"signal (\'42S02\', sprintf (\'Access denied for table %s in TABLE_SET_POLICY\', _tb), \'SR383\');\n"
"\n"
"proc_name := complete_proc_name (_proc, 1);\n"
"if (not isstring (__proc_exists (proc_name)))\n"
"signal (\'22023\', sprintf (\'The procedure %s does not exist in TABLE_SET_POLICY\', _proc), \'SR384\');\n"
"\n"
"is_view := case when exists (select 1 from SYS_VIEWS where V_NAME = tb_name) then 1 else 0 end;\n"
"\n"
"declare _stat, _msg varchar;\n"
"if (exec (\'call (?) (?, ?)\', _stat, _msg, vector (proc_name, tb_name, \'S\')))\n"
"{\n"
"signal (\'42000\', sprintf (\'Trying in TABLE_SET_POLICY the procedure %s yielded an error : [%s]%s\', proc_name, _stat, _msg), \'SR385\');\n"
"}\n"
"declare inx, len integer;\n"
"\n"
"len := length (_type);\n"
"inx := 0;\n"
"while (inx < len)\n"
"{\n"
"declare opt varchar;\n"
"opt := upper (chr (_type[inx]));\n"
"\n"
"if (opt not in (\'I\', \'D\', \'U\', \'S\'))\n"
"signal (\'22023\', sprintf (\'Invalid option %s specified in TABLE_SET_POLICY\', opt), \'SR386\');\n"
"\n"
"if (is_view and opt <> \'S\')\n"
"signal (\'22023\', sprintf (\n"
"\'insert/delete/update policies must be declared for an actual table, \' ||\n"
"\'not a view %s in TABLE_SET_POLICY\', tb_name), \'SR391\');\n"
"\n"
"if (exists (select 1 from DB.DBA.SYS_RLS_POLICY where RLSP_TABLE = tb_name and RLSP_OP = proc_name))\n"
"signal (\'22023\',\n"
"sprintf (\'Procedure for option %s for table %s already defined in TABLE_SET_POLICY. Drop it first\',\n"
"opt, _tb), \'SR387\');\n"
"\n"
"insert into DB.DBA.SYS_RLS_POLICY (RLSP_TABLE, RLSP_FUNC, RLSP_OP)\n"
"values (tb_name, proc_name, opt);\n"
"\n"
"inx := inx + 1;\n"
"}\n"
"\n"
"__ddl_changed (tb_name);\n"
"}\n"
"--src system2.sql:189\n";

static const char *proc143 = 
" create procedure DB.DBA.TABLE_DROP_POLICY (in _tb varchar, in _type varchar := \'IUDS\')\n"
"{\n"
"declare tb_name varchar;\n"
"\n"
"tb_name := complete_table_name (_tb, 1);\n"
"if (1 <> (select count(*) from DB.DBA.SYS_KEYS\n"
"where\n"
"KEY_TABLE = tb_name and\n"
"KEY_IS_MAIN = 1 and\n"
"KEY_MIGRATE_TO is null))\n"
"signal (\'22023\', sprintf (\'No table or duplicate table %s in TABLE_DROP_POLICY\', _tb), \'SR388\');\n"
"\n"
"if (name_part (tb_name, 1) <> user and user <> \'dba\')\n"
"signal (\'42S02\', sprintf (\'Access denied for table %s in TABLE_DROP_POLICY\', _tb), \'SR389\');\n"
"\n"
"delete from DB.DBA.SYS_RLS_POLICY where RLSP_TABLE = tb_name and strchr (upper (_type), RLSP_OP) is not NULL;\n"
"\n"
"if (row_count () > 0)\n"
"__ddl_changed (tb_name);\n"
"}\n"
"--src system2.sql:249\n";

static const char *view1 = 
"create view ALL_COL_STAT as\n"
"select * from DB.DBA.SYS_COL_STAT where __any_grants (CS_TABLE)\n";

static const char *other94 = 
"grant select on ALL_COL_STAT to public\n";
static const char *view2 = 
"create view USER_COL_STAT as\n"
"select * from DB.DBA.SYS_COL_STAT where name_part (CS_TABLE, 1, NULL) = case user when \'dba\' then \'DBA\' else user end\n";

static const char *other95 = 
"grant select on USER_COL_STAT to public\n";
static const char *view3 = 
"create view ALL_COL_HIST as\n"
"select * from DB.DBA.SYS_COL_HIST where __any_grants (CH_TABLE)\n";

static const char *other96 = 
"grant select on ALL_COL_HIST to public\n";
static const char *view4 = 
"create view USER_COL_HIST as\n"
"select * from DB.DBA.SYS_COL_HIST where name_part (CH_TABLE, 1, NULL) = case user when \'dba\' then \'DBA\' else user end\n";

static const char *other97 = 
"grant select on USER_COL_HIST to public\n";
static const char *proc144 = 
"create procedure SINV_CREATE_INVERSE (in _SINVM_NAME_IN varchar, in _SINV_INVERSE any, in _SINVM_FLAGS integer)\n"
"{\n"
"declare _SINVM_NAME varchar;\n"
"if (isstring (_SINV_INVERSE))\n"
"{\n"
"_SINV_INVERSE := vector (_SINV_INVERSE);\n"
"}\n"
"else if (length (_SINV_INVERSE) > 1)\n"
"_SINVM_FLAGS := 0;\n"
"\n"
"declare inx integer;\n"
"inx := 0;\n"
"\n"
"_SINVM_NAME := fix_identifier_case (_SINVM_NAME_IN);\n"
"_SINVM_NAME := __proc_exists (_SINVM_NAME, 2);\n"
"if (not isstring (_SINVM_NAME))\n"
"{\n"
"_SINVM_NAME := __proc_exists (_SINVM_NAME_IN, 1);\n"
"if (not isstring (_SINVM_NAME))\n"
"signal (\'22023\', sprintf (\n"
"\'Non-existent function %s passed as argument 1 to SINV_CREATE_INVERSE\', _SINVM_NAME_IN),\n"
"\'SR456\');\n"
"}\n"
"\n"
"declare _inverse varchar;\n"
"foreach (varchar _inverse_in in _SINV_INVERSE) do\n"
"{\n"
"_inverse := fix_identifier_case (_inverse_in);\n"
"_inverse := __proc_exists (_inverse, 2);\n"
"if (not isstring (_inverse))\n"
"{\n"
"_inverse := fix_identifier_case (_inverse_in);\n"
"_inverse := __proc_exists (_inverse, 1);\n"
"if (not isstring (_inverse))\n"
"signal (\'22023\', sprintf (\n"
"\'Non-existent function %s passed as %dth value in argument 2 to SINV_CREATE_INVERSE\',\n"
"_SINVM_NAME_IN, inx + 1),\n"
"\'SR457\');\n"
"}\n"
"\n"
"insert into SYS_SQL_INVERSE (SINV_FUNCTION, SINV_ARGUMENT, SINV_INVERSE, SINV_FLAGS)\n"
"values (_SINVM_NAME, inx, _inverse, _SINVM_FLAGS);\n"
"inx := inx + 1;\n"
"}\n"
"sinv_read_invers_sys (_SINVM_NAME);\n"
"if (inx = 1)\n"
"{\n"
"insert into SYS_SQL_INVERSE (SINV_FUNCTION, SINV_ARGUMENT, SINV_INVERSE, SINV_FLAGS)\n"
"values (_inverse, 0, _SINVM_NAME, _SINVM_FLAGS);\n"
"sinv_read_invers_sys (_inverse);\n"
"}\n"
"}\n"
"--src system2.sql:299\n";

static const char *proc145 = 
"create procedure SINV_DROP_INVERSE (in _SINVM_NAME_IN varchar)\n"
"{\n"
"declare _SINVM_NAME varchar;\n"
"_SINVM_NAME := fix_identifier_case (_SINVM_NAME_IN);\n"
"_SINVM_NAME := __proc_exists (_SINVM_NAME, 2);\n"
"if (not isstring (_SINVM_NAME))\n"
"{\n"
"_SINVM_NAME := __proc_exists (_SINVM_NAME_IN, 1);\n"
"if (not isstring (_SINVM_NAME))\n"
"signal (\'22023\', sprintf (\n"
"\'Non-existent function %s passed as argument 1 to SINV_DROP_INVERSE\', _SINVM_NAME_IN),\n"
"\'SR458\');\n"
"}\n"
"delete from SYS_SQL_INVERSE where SINV_FUNCTION = _SINVM_NAME;\n"
"sinv_read_invers_sys (_SINVM_NAME);\n"
"}\n"
"--src system2.sql:353\n";

static const char *proc146 = 
"create procedure SINV_CREATE_KEY_MAPPING (in map_name varchar,  in part_defs any, in do_drops integer := 1)\n"
"{\n"
"declare inx, len_of_part_defs integer;\n"
"\n"
"declare col_def_list, col_list, ocol_list, where_cond, gen_col_list, proc_parm_list, inv_vector varchar;\n"
"\n"
"if (isstring (map_name))\n"
"map_name := fix_identifier_case (map_name);\n"
"col_def_list := \'\';\n"
"col_list := \'\';\n"
"ocol_list := \'\';\n"
"where_cond := \'\';\n"
"gen_col_list := \'\';\n"
"proc_parm_list := \'\';\n"
"inv_vector := \'\';\n"
"\n"
"for (inx := 0, len_of_part_defs := length (part_defs); inx < len_of_part_defs; inx := inx + 2)\n"
"{\n"
"declare var_name, var_type varchar;\n"
"\n"
"var_name := fix_identifier_case (part_defs[inx]);\n"
"var_type := part_defs[inx + 1];\n"
"\n"
"col_def_list := concat (col_def_list, sprintf (\'K%d %I\', (inx/2) + 1, var_type));\n"
"col_list := concat (col_list, sprintf (\'K%d\', (inx/2) + 1));\n"
"ocol_list := concat (ocol_list, var_name);\n"
"proc_parm_list := concat (proc_parm_list, sprintf (\'in \"%I\" %s\', var_name, var_type));\n"
"where_cond := concat (where_cond, sprintf (\'K%d = \"%I\"\', (inx/2) + 1, var_name));\n"
"inv_vector := concat (inv_vector, sprintf (\'\'\'%s_%s\'\'\', map_name, var_name));\n"
"if (inx < len_of_part_defs - 2)\n"
"{\n"
"col_def_list := concat (col_def_list, \',\\n \');\n"
"col_list := concat (col_list, \', \');\n"
"ocol_list := concat (ocol_list, \', \');\n"
"proc_parm_list := concat (proc_parm_list, \', \');\n"
"where_cond := concat (where_cond, \' and \');\n"
"inv_vector := concat (inv_vector, \',\');\n"
"}\n"
"}\n"
"if (do_drops > 0)\n"
"{\n"
"declare stat, msg any;\n"
"stat := NULL;\n"
"exec (sprintf (\'\\nDB.DBA.SINV_DROP_INVERSE (\'\'%s\'\')\\n\', map_name), stat, msg);\n"
"if (stat is not null)\n"
"{\n"
"sql_warning (stat, \'IN005\', msg);\n"
"stat := NULL;\n"
"}\n"
"exec (sprintf (\'\\nsequence_remove (\'\'%s\'\')\\n\', map_name), stat, msg);\n"
"if (stat is not null)\n"
"{\n"
"sql_warning (stat, \'INV01\', msg);\n"
"stat := NULL;\n"
"}\n"
"exec (sprintf (\'\\ndrop function \"%I\"\\n\', map_name), stat, msg);\n"
"if (stat is not null)\n"
"{\n"
"sql_warning (stat, \'INV02\', msg);\n"
"stat := NULL;\n"
"}\n"
"for (inx := 0, len_of_part_defs := length (part_defs); inx < len_of_part_defs; inx := inx + 2)\n"
"{\n"
"declare var_name varchar;\n"
"\n"
"var_name := fix_identifier_case (part_defs[inx]);\n"
"exec (sprintf (\'\\ndrop function \"%I_%I\"\\n\', map_name, var_name), stat, msg);\n"
"if (stat is not null)\n"
"{\n"
"sql_warning (stat, \'INV03\', msg);\n"
"stat := NULL;\n"
"}\n"
"}\n"
"exec (sprintf (\'\\ndrop table \"MAP_%I\"\\n\', map_name), stat, msg);\n"
"if (stat is not null)\n"
"{\n"
"sql_warning (stat, \'INV04\', msg);\n"
"stat := NULL;\n"
"}\n"
"}\n"
"\n"
"if (do_drops = 2)\n"
"return;\n"
"\n"
"exec (sprintf (concat (\n"
"\'\\ncreate table \"MAP_%I\" (\\n\',\n"
"\' ID integer,\\n\',\n"
"\' %s,\\n\',\n"
"\' primary key (%s))\\n\'),\n"
"map_name,\n"
"col_def_list, col_list\n"
"));\n"
"\n"
"exec (sprintf (concat (\n"
"\'create index \"MAP_%I_ID\" on \"MAP_%I\" (ID)\\n\'),\n"
"map_name, map_name));\n"
"\n"
"exec (sprintf (concat (\n"
"\'\\ncreate function \"%I\" (%s) returns integer\\n\',\n"
"\'{\\n\',\n"
"\'  declare _ID integer;\\n\',\n"
"\'  set isolation = \'\'committed\'\';\\n\',\n"
"\'  whenever not found  goto none1;\\n\',\n"
"\'  select ID into _ID from \"MAP_%I\" where\\n\',\n"
"\'    %s;\\n\',\n"
"\'  return _ID;\\n\',\n"
"\'none1:\\n\',\n"
"\'  set isolation = \'\'serializable\'\';\\n\',\n"
"\'  whenever not found  goto none2;\\n\',\n"
"\'  select ID into _ID from \"MAP_%I\" where\\n\',\n"
"\'    %s;\\n\',\n"
"\'  return _ID;\\n\',\n"
"\'none2:\\n\',\n"
"\'  _ID := sequence_next (\'\'%s\'\');\\n\',\n"
"\'  insert into \"MAP_%I\" (ID, %s) values (_ID, %s);\\n\',\n"
"\'  return _ID;\\n\',\n"
"\'}\\n\'),\n"
"map_name, proc_parm_list,\n"
"map_name, where_cond,\n"
"map_name, where_cond,\n"
"map_name,\n"
"map_name, col_list, ocol_list));\n"
"\n"
"for (inx := 0, len_of_part_defs := length (part_defs); inx < len_of_part_defs; inx := inx + 2)\n"
"{\n"
"declare var_name, var_type varchar;\n"
"\n"
"var_name := fix_identifier_case (part_defs[inx]);\n"
"var_type := part_defs[inx + 1];\n"
"\n"
"exec (sprintf (concat (\n"
"\'\\ncreate function \"%I_%I\" (in _ID integer) returns %s\\n\',\n"
"\'{\\n\',\n"
"\'  return (select K%d from \"MAP_%I\" where ID = _ID);\\n\',\n"
"\'}\\n\'),\n"
"map_name, var_name, var_type,\n"
"(inx/2) + 1, map_name));\n"
"}\n"
"\n"
"\n"
"exec (sprintf (\n"
"\'\\nDB.DBA.SINV_CREATE_INVERSE (\'\'%s\'\', vector (%s), 0)\\n\',\n"
"map_name, inv_vector));\n"
"}\n"
"--src system2.sql:371\n";

static const char *proc147 = 
"create procedure SYS_CREATE_TABLE_AS (\n"
"in tb_name varchar, in _parse_tree any, in with_data integer,\n"
"in exec_it integer := 1)\n"
"{\n"
"declare _desc, _rows any;\n"
"declare _cols any;\n"
"declare _n_cols, _inx integer;\n"
"declare _stmt varchar;\n"
"declare log_is_on integer;\n"
"log_is_on := client_attr (\'transaction_log\');\n"
"\n"
"exec (_parse_tree, NULL, NULL, NULL, 1, _desc, _rows);\n"
"\n"
"_cols := _desc[0];\n"
"_n_cols := length (_cols);\n"
"\n"
"_stmt := sprintf (\'create table %s (\', REPL_FQNAME (tb_name));\n"
"for (_inx := 0; _inx < _n_cols; _inx := _inx + 1)\n"
"{\n"
"declare _col any;\n"
"declare _col_name varchar;\n"
"\n"
"_col := aref(_cols, _inx);\n"
"_col_name := repl_undot_name (aref(_col, 0));\n"
"\n"
"_stmt := concat(_stmt,\n"
"sprintf(\'\"%I\" \', _col_name), REPL_COLTYPE (_col));\n"
"\n"
"if (_inx + 1 < _n_cols)\n"
"_stmt:= concat(_stmt, \', \');\n"
"}\n"
"_stmt := concat(_stmt, \')\');\n"
"\n"
"if (exec_it <> 0)\n"
"{\n"
"if (log_is_on)\n"
"log_enable (0);\n"
"{\n"
"declare exit handler for sqlstate \'*\'\n"
"{\n"
"rollback work;\n"
"if (log_is_on)\n"
"log_enable (1);\n"
"resignal;\n"
"};\n"
"exec (_stmt);\n"
"if (with_data <> 0)\n"
"{\n"
"\n"
"declare _insert_stmt, _tb_dotted any;\n"
"_tb_dotted :=\n"
"vector (\n"
"200,\n"
"tb_name,\n"
"NULL,\n"
"0,\n"
"0,\n"
"0\n"
");\n"
"\n"
"aref_set_0 (_tb_dotted, 3);\n"
"aref_set_0 (_tb_dotted, 4);\n"
"aref_set_0 (_tb_dotted, 5);\n"
"\n"
"_insert_stmt := vector (\n"
"110,\n"
"_tb_dotted,\n"
"0,\n"
"_parse_tree,\n"
"0\n"
");\n"
"aref_set_0 (_insert_stmt, 2);\n"
"aref_set_0 (_insert_stmt, 4);\n"
"exec (_insert_stmt);\n"
"\n"
"}\n"
"}\n"
"if (log_is_on)\n"
"log_enable (1);\n"
"log_text (\'DB.DBA.SYS_CREATE_TABLE_AS (?, ?, ?)\', tb_name, _parse_tree, with_data);\n"
"}\n"
"else\n"
"return _stmt;\n"
"}\n"
"--src system2.sql:517\n";

/* soap.sql */

static const char *proc148 = 
" create procedure\n"
"SOAP_CLIENT (\n"
"in url varchar,\n"
"in operation varchar,\n"
"in target_namespace varchar := null,\n"
"in parameters any := null,\n"
"in headers any := null,\n"
"in soap_action varchar := \'\',\n"
"in attachments any := null,\n"
"in ticket any := null,\n"
"in passwd varchar := null,\n"
"in user_name varchar := null,\n"
"in user_password varchar := null,\n"
"in auth_type varchar := \'none\',\n"
"in security_type varchar := \'sign\',\n"
"in debug integer := 0,\n"
"in template varchar := null,\n"
"in style integer := 0,\n"
"in version integer := 11,\n"
"in direction integer := 0,\n"
"in http_header any := null,\n"
"in security_schema any := null,\n"
"in time_out int := 100)\n"
"{\n"
"declare conn, ret any;\n"
"conn := null;\n"
"ret := SOAP_ASYNC_CLIENT (\n"
"url,\n"
"operation,\n"
"target_namespace,\n"
"parameters,\n"
"headers,\n"
"soap_action,\n"
"attachments,\n"
"ticket,\n"
"passwd,\n"
"user_name,\n"
"user_password,\n"
"auth_type,\n"
"security_type,\n"
"debug,\n"
"template,\n"
"style,\n"
"version,\n"
"direction,\n"
"http_header,\n"
"security_schema,\n"
"time_out,\n"
"conn\n"
");\n"
"return ret;\n"
"}\n"
"--src soap.sql:23\n";

static const char *proc149 = 
" create procedure\n"
"SOAP_ASYNC_CLIENT\n"
"(\n"
"in url varchar,\n"
"in operation varchar,\n"
"in target_namespace varchar := null,\n"
"in parameters any := null,\n"
"in headers any := null,\n"
"in soap_action varchar := \'\',\n"
"in attachments any := null,\n"
"in ticket any := null,\n"
"in passwd varchar := null,\n"
"in user_name varchar := null,\n"
"in user_password varchar := null,\n"
"in auth_type varchar := \'none\',\n"
"in security_type varchar := \'sign\',\n"
"in debug integer := 0,\n"
"in template varchar := null,\n"
"in style integer := 0,\n"
"in version integer := 11,\n"
"in direction integer := 0,\n"
"in http_header any := null,\n"
"in security_schema any := null,\n"
"in time_out int := 100,\n"
"inout conn any\n"
")\n"
"{\n"
"declare host, path varchar;\n"
"declare hinfo, resp, ver, skeys any;\n"
"declare security_tp int;\n"
"\n"
"hinfo := WS.WS.PARSE_URI (url);\n"
"host := hinfo [1];\n"
"if (lower (hinfo[0]) = \'https\' and ticket is null)\n"
"ticket := \'1\';\n"
"path := vspx_uri_compose (vector (\'\',\'\', hinfo [2], hinfo[3], hinfo[4], hinfo[5]));\n"
"if (parameters is null)\n"
"parameters := vector ();\n"
"\n"
"if (auth_type = \'x509\' or auth_type = \'kerberos\' or auth_type = \'key\')\n"
"security_tp := case security_type when \'sign\' then 1 else 2 end;\n"
"else\n"
"{\n"
"security_tp := 0;\n"
"if (lower (hinfo[0]) <> \'https\')\n"
"ticket := null;\n"
"}\n"
"\n"
"if (debug)\n"
"ver := -1 * version;\n"
"else\n"
"ver := version;\n"
"\n"
"soap_action := \'\"\' || trim (soap_action, \'\"\') || \'\"\';\n"
"\n"
"if (lower (hinfo[0]) = \'https\' and strchr (host, \':\') is null)\n"
"host := host || \':443\';\n"
"\n"
"skeys := null;\n"
"\n"
"if (connection_get (\'wssc-keys\') is not null)\n"
"connection_set (\'wssc-keys\', null);\n"
"\n"
"resp := soap_call_new (host, path, target_namespace, operation, parameters,\n"
"ver, ticket, passwd, soap_action, style,\n"
"user_name, user_password, security_tp, ticket, template, headers, http_header,\n"
"direction, security_schema, conn, time_out, skeys);\n"
"\n"
"if (skeys is not null)\n"
"connection_set (\'wssc-keys\', skeys);\n"
"\n"
"return resp;\n"
"}\n"
"--src soap.sql:78\n";

static const char *proc150 = 
"create procedure WSSE_GET_NS_INFO (inout doc any, inout ns any)\n"
"{\n"
"declare wsse any;\n"
"wsse := vector (\n"
"\'http://schemas.xmlsoap.org/ws/2002/12/secext\',\n"
"\'http://schemas.xmlsoap.org/ws/2002/04/secext\',\n"
"\'http://schemas.xmlsoap.org/ws/2002/07/secext\',\n"
"\'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\'\n"
");\n"
"foreach (varchar uri in wsse) do\n"
"{\n"
"if (xpath_eval (sprintf (\'[ xmlns:wsse=\"%s\" ] //wsse:Security\', uri), doc) is not null)\n"
"{\n"
"if (uri like \'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-%\')\n"
"ns := vector (\'wsse\', uri,\n"
"\'wsu\', \'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\');\n"
"else\n"
"ns := vector (\'wsse\', uri);\n"
"}\n"
"}\n"
"}\n"
"--src soap.sql:153\n";

static const char *proc151 = 
" create procedure WSSE_OASIS_URI () returns varchar\n"
"{\n"
"return \'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\';\n"
"}\n"
"--src soap.sql:177\n";

static const char *proc152 = 
" create procedure WSSU_OASIS_URI () returns varchar\n"
"{\n"
"return \'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\';\n"
"}\n"
"--src soap.sql:184\n";

static const char *proc153 = 
"create procedure\n"
"SOAP_DEFAULT_XENC_TEMPLATE (in body varchar, in key_name varchar, in ns any)\n"
"{\n"
"declare tmpl, algo varchar;\n"
"algo := xenc_get_key_algo (key_name);\n"
"if (algo is null)\n"
"return NULL;\n"
"\n"
"tmpl := sprintf (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
"<Signature xmlns=\"http://www.w3.org/2000/09/xmldsig#\" >\n"
"<SignedInfo>\n"
"<CanonicalizationMethod Algorithm=\"http://www.w3.org/2001/10/xml-exc-c14n#\" />\n"
"<SignatureMethod Algorithm=\"%s\" />\n"
"</SignedInfo>\n"
"<SignatureValue></SignatureValue>\n"
"<KeyInfo>\n"
"<KeyName>%s</KeyName>\n"
"</KeyInfo>\n"
"</Signature>\', algo, key_name);\n"
"\n"
"return dsig_template_ext (xtree_doc (body), tmpl, ns,\n"
"\'http://schemas.xmlsoap.org/soap/envelope/\', \'Body\',\n"
"\n"
"\'http://schemas.xmlsoap.org/ws/2004/03/addressing\', \'Action\',\n"
"\'http://schemas.xmlsoap.org/ws/2004/03/addressing\', \'From\',\n"
"\'http://schemas.xmlsoap.org/ws/2004/03/addressing\', \'To\',\n"
"\'http://schemas.xmlsoap.org/ws/2004/03/addressing\', \'MessageID\',\n"
"\'http://schemas.xmlsoap.org/ws/2004/03/addressing\', \'ReplyTo\',\n"
"\'http://schemas.xmlsoap.org/ws/2004/03/addressing\', \'FaultTo\',\n"
"\'http://schemas.xmlsoap.org/ws/2004/03/addressing\', \'RelatesTo\',\n"
"\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'Action\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'From\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'To\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'MessageID\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'ReplyTo\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'FaultTo\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'RelatesTo\',\n"
"\n"
"\'http://schemas.xmlsoap.org/rp\', \'action\',\n"
"\'http://schemas.xmlsoap.org/rp\', \'to\',\n"
"\'http://schemas.xmlsoap.org/rp\', \'id\',\n"
"\n"
"\'http://schemas.xmlsoap.org/ws/2002/07/utility\', \'Created\',\n"
"\'http://schemas.xmlsoap.org/ws/2002/07/utility\', \'Expires\'\n"
");\n"
"\n"
"}\n"
"--src soap.sql:190\n";

static const char *proc154 = 
"create procedure\n"
"SOAP_CLIENT_WSS (INOUT BODY ANY, INOUT KEYI ANY, INOUT TEMPLATE VARCHAR, INOUT SIGN INT, INOUT NS ANY)\n"
"{\n"
"declare resp varchar;\n"
"declare request varchar;\n"
"declare _template varchar;\n"
"declare _ns any;\n"
"\n"
"if (not sign)\n"
"return;\n"
"\n"
"request := string_output_string (BODY);\n"
"_template := TEMPLATE;\n"
"\n"
"if (isarray (NS) and not isstring (NS))\n"
"_ns := NS;\n"
"else\n"
"_ns := vector ();\n"
"\n"
"\n"
"if (_template like \'^[%^]\' escape \'^\')\n"
"{\n"
"_template := trim (_template, \'[]\');\n"
"if (\"LEFT\" (_template, 5) = \'func:\')\n"
"{\n"
"declare mdata any;\n"
"_template := subseq (_template, 5);\n"
"_template := call (_template)(request);\n"
"}\n"
"else\n"
"_template := SOAP_DEFAULT_XENC_TEMPLATE (request, _template, _ns);\n"
"}\n"
"\n"
"if (sign = 1 or keyi is null)\n"
"{\n"
"resp := xenc_encrypt (request, 11, _template, _ns);\n"
"}\n"
"else if (sign = 2)\n"
"resp := xenc_encrypt (request, 11, _template, _ns, \'//Envelope/Body\', keyi, \'Content\');\n"
"string_output_flush (BODY);\n"
"http (resp, BODY);\n"
"}\n"
"--src soap.sql:240\n";

static const char *proc155 = 
" create procedure\n"
"wsrp_error (in code integer, in reason varchar, in endpoint varchar, inout soap_xml any)\n"
"{\n"
"declare errm any;\n"
"http_rewrite ();\n"
"errm := xslt (\'http://local.virt/wsrp_error\', soap_xml, vector (\'code\', cast (code as varchar), \'reason\', reason, \'endpoint\', endpoint, \'id\', lower(uuid())));\n"
"http_value (errm);\n"
"http_request_status (\'HTTP/1.1 500 Server Error\');\n"
"signal (\'SOAP\', sprintf (\'%d %s\', code, reason));\n"
"}\n"
"--src soap.sql:285\n";

static const char *proc156 = 
"create procedure\n"
"WS_SOAP_GET_KEYINFO (inout soap_xml any, inout lines any)\n"
"{\n"
"declare tkt any;\n"
"declare tp, enc varchar;\n"
"declare ser, own, issuer, stard, endd, usr any;\n"
"declare sec, pos1, pos2 any;\n"
"\n"
"sec := xpath_eval\n"
"(\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\"] /S:Envelope/S:Header/*:Security\',\n"
"soap_xml, 1);\n"
"\n"
"\n"
"if (sec is null)\n"
"return ;\n"
"\n"
"\n"
"\n"
"tkt := xpath_eval (\'BinarySecurityToken/text()\', sec, 1);\n"
"tp := xpath_eval  (\'BinarySecurityToken/@ValueType\', sec, 1);\n"
"enc := xpath_eval (\'BinarySecurityToken/@EncodingType\', sec, 1);\n"
"usr := xpath_eval (\'UsernameToken/Username/text()\', sec, 1);\n"
"\n"
"if (usr is not null)\n"
"{\n"
"connection_set (\'wss-user\', cast (usr as varchar));\n"
"}\n"
"\n"
"if (tkt is null)\n"
"return;\n"
"\n"
"tp := cast (tp as varchar);\n"
"enc := cast (enc as varchar);\n"
"tkt := cast (tkt as varchar);\n"
"\n"
"pos1 := strrchr (tp,  \'#\');\n"
"pos2 := strrchr (enc, \'#\');\n"
"if (pos1 is null)\n"
"{\n"
"pos1 := strrchr (tp, \':\');\n"
"pos2 := strrchr (enc, \':\');\n"
"}\n"
"\n"
"if (pos1 is not null)\n"
"tp := subseq (tp, pos1 + 1, length (tp));\n"
"if (pos2 is not null)\n"
"enc := subseq (enc, pos2 + 1, length (enc));\n"
"\n"
"ser := own := issuer := stard := endd := NULL;\n"
"if (tp = \'X509v3\')\n"
"{\n"
"if (enc = \'Base64Binary\')\n"
"{\n"
"declare cert any;\n"
"cert := decode_base64 (tkt);\n"
"ser := get_certificate_info (1, cert, 1);\n"
"own := get_certificate_info (2, cert, 1);\n"
"issuer := get_certificate_info (3, cert, 1);\n"
"stard := get_certificate_info (4, cert, 1);\n"
"endd := get_certificate_info (5, cert, 1);\n"
"}\n"
"}\n"
"else if (tp = \'Kerberosv5ST\')\n"
"{\n"
"if (enc = \'Base64Binary\')\n"
"{\n"
"declare cert, ctx, cip, cnt any;\n"
"cert := decode_base64 (tkt);\n"
"declare exit handler for sqlstate \'*\'\n"
"{\n"
"dbg_obj_print (__SQL_MESSAGE);\n"
"resignal;\n"
"};\n"
"ctx := krb_init_srv_ctx (\'host\', cert);\n"
"ser := krb_inquire_ctx (ctx, 1);\n"
"own := krb_inquire_ctx (ctx, 2);\n"
"issuer := krb_inquire_ctx (ctx, 3);\n"
"stard := krb_inquire_ctx (ctx, 4);\n"
"endd := krb_inquire_ctx (ctx, 5);\n"
"\n"
"cip := cast (xpath_eval (\'//CipherValue/text()\', soap_xml, 1) as varchar);\n"
"cnt := kerberos_unseal (ctx, cip);\n"
"dbg_obj_print (cnt);\n"
"}\n"
"}\n"
"connection_set (\'wss-token-owner\', own);\n"
"connection_set (\'wss-token-issuer\', issuer);\n"
"connection_set (\'wss-token-serial\', ser);\n"
"connection_set (\'wss-token-start\', stard);\n"
"connection_set (\'wss-token-end\', endd);\n"
"}\n"
"--src soap.sql:297\n";

static const char *proc157 = 
"create procedure\n"
"WS_SECURITY_CHECK (inout body varchar, inout soap_xml any, inout lines any, inout ns any)\n"
"{\n"
"declare decoded varchar;\n"
"declare body_str varchar;\n"
"declare validate_sign int;\n"
"declare opts, uhook, ekeys any;\n"
"\n"
"body_str := string_output_string (body);\n"
"\n"
"if (0)\n"
"log_message (\'Calling security pre-processing\');\n"
"\n"
"opts := http_map_get (\'soap_opts\');\n"
"validate_sign := get_keyword (\'WSS-Validate-Signature\', opts, 2);\n"
"\n"
"if (isstring (validate_sign))\n"
"validate_sign := cast (validate_sign as integer);\n"
"\n"
"\n"
"{\n"
"declare exit handler for sqlstate \'*\' {\n"
"if (1)\n"
"log_message (sprintf (\'WSS: %s\', __SQL_MESSAGE));\n"
"resignal;\n"
"\n"
"\n"
"};\n"
"\n"
"decoded := xenc_decrypt_soap (body_str, 11, validate_sign, \'UTF-8\', \'x-any\', opts, ekeys);\n"
"connection_set (\'wss-keys\', ekeys);\n"
"if (isstring (decoded))\n"
"soap_xml := xml_tree_doc (decoded);\n"
"}\n"
"\n"
"WSSE_GET_NS_INFO (soap_xml, ns);\n"
"\n"
"\n"
"{\n"
"declare created, expires, timenow datetime;\n"
"declare _created, _expires any;\n"
"timenow := now ();\n"
"_created := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:u=\"http://schemas.xmlsoap.org/ws/2002/07/utility\"] /S:Envelope/S:Header/u:Timestamp/u:Created\', soap_xml);\n"
"_expires := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:u=\"http://schemas.xmlsoap.org/ws/2002/07/utility\"] /S:Envelope/S:Header/u:Timestamp/u:Expires\', soap_xml);\n"
"\n"
"if (_expires is not null and _created is not null)\n"
"{\n"
"created := soap_box_xml_entity (_created, timenow, 11);\n"
"expires := soap_box_xml_entity (_expires, timenow, 11);\n"
"\n"
"\n"
"if (not (created < timenow and timenow < expires))\n"
"signal (\'SOAP\', sprintf (\'%d %s\', 300, \'Message Expired\'));\n"
"}\n"
"}\n"
"\n"
"\n"
"nxt:\n"
"WS_SOAP_GET_KEYINFO (soap_xml, lines);\n"
"\n"
"uhook := get_keyword (\'WSS-SecurityCheck\', opts, NULL);\n"
"\n"
"\n"
"if (length (uhook) > 0 and __proc_exists (uhook))\n"
"{\n"
"call (uhook) (soap_xml);\n"
"}\n"
"\n"
"if (__proc_exists (\'DB.DBA.WS_SOAP_ACCOUNTING\'))\n"
"{\n"
"declare rc int;\n"
"rc := call (\'DB.DBA.WS_SOAP_ACCOUNTING\') ();\n"
"if (not rc)\n"
"{\n"
"http_rewrite ();\n"
"http (soap_make_error (\'300\', \'42000\', \'Accounting failed\'));\n"
"http_request_status (\'HTTP/1.1 500 Server Error\');\n"
"signal (\'SOAP\', sprintf (\'%d %s\', 300, \'Accounting failed\'));\n"
"}\n"
"}\n"
"\n"
"}\n"
"--src soap.sql:390\n";

static const char *proc158 = 
"create procedure\n"
"WS_SECURITY_ADD (inout body any, inout ns any)\n"
"{\n"
"declare _body any;\n"
"declare _ns any;\n"
"\n"
"if (0)\n"
"log_message (\'Calling security post-processing\');\n"
"declare templ, tempf, kname, ktype, tp varchar;\n"
"declare keyinst, ses, opts any;\n"
"\n"
"opts := http_map_get (\'soap_opts\');\n"
"templ := get_keyword (\'WSS-Template\', opts, NULL);\n"
"tempf := get_keyword (\'WSS-Func-Template\', opts, NULL);\n"
"kname := get_keyword (\'WSS-KEY\', opts, NULL);\n"
"\n"
"if (isarray (ns) and not isstring (ns))\n"
"_ns := ns;\n"
"else\n"
"_ns := vector ();\n"
"\n"
"\n"
"if (isstring (kname) and __proc_exists (kname))\n"
"keyinst := call (kname) ();\n"
"else\n"
"keyinst := NULL;\n"
"\n"
"\n"
"ses := string_output ();\n"
"http_value (body, null, ses);\n"
"_body := string_output_string (ses);\n"
"\n"
"\n"
"if (tempf is not null)\n"
"{\n"
"templ := call (tempf)(body);\n"
"}\n"
"else if (templ is not null)\n"
"{\n"
"if (templ like \'^[%^]\' escape \'^\')\n"
"{\n"
"templ := trim (templ, \'[]\');\n"
"if (\"LEFT\" (templ, 5) = \'func:\')\n"
"{\n"
"templ := subseq (templ, 5);\n"
"templ := call (templ)(_body);\n"
"}\n"
"else\n"
"templ := SOAP_DEFAULT_XENC_TEMPLATE (_body, templ, _ns);\n"
"}\n"
"else\n"
"templ := file_to_string (templ);\n"
"}\n"
"else\n"
"templ := null;\n"
"\n"
"if (keyinst is not null)\n"
"body := xenc_encrypt (_body, 11, templ, _ns,\n"
"\'//Envelope/Body[*]\', keyinst, \'Content\');\n"
"else if (templ is not null)\n"
"body := xenc_encrypt (_body, 11, templ, _ns);\n"
"else\n"
"return 0;\n"
"return 1;\n"
"}\n"
"--src soap.sql:474\n";

static const char *proc159 = 
" create procedure\n"
"WS_SOAP (in path any, in params any, in lines any)\n"
"{\n"
"declare content_type, soap_method, soap_xml varchar;\n"
"declare res any;\n"
"declare rp, soap_header any;\n"
"declare rp_act, wssec, wsrpe integer;\n"
"declare req_body varchar;\n"
"declare wss, attachments, ns any;\n"
"declare soap_ver int;\n"
"\n"
"soap_ver := 11;\n"
"ns := vector ();\n"
"\n"
"if (length (params) < 1) params := __http_stream_params ();\n"
"\n"
"if (isstring({?\'content\'}) and lower(trim({?\'content\'})) = \'wsdl\')\n"
"{\n"
"http (soap_wsdl ());\n"
"return;\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"rp_act := 0; wssec := 0; wsrpe := 0;\n"
"content_type := http_request_header (lines, \'Content-Type\');\n"
"soap_method := trim (http_request_header (lines, \'SOAPAction\', null, \'\'), \'\"\');\n"
"soap_xml := NULL; attachments := NULL;\n"
"if (isstring (content_type))\n"
"content_type := lower (content_type);\n"
"\n"
"if (content_type = \'text/xml\')\n"
"{\n"
"req_body := http_body_read ();\n"
"soap_xml := xml_tree_doc (xml_tree (req_body));\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"}\n"
"else if (content_type = \'application/dime\')\n"
"{\n"
"declare dime_arr any;\n"
"req_body := http_body_read ();\n"
"req_body := string_output_string (req_body);\n"
"dime_arr := dime_tree (req_body);\n"
"\n"
"req_body := dime_arr [0][2];\n"
"attachments := dime_arr;\n"
"aset (attachments, 0, NULL);\n"
"soap_xml := xml_tree_doc (xml_tree (req_body));\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"else\n"
"{\n"
"http_request_status (\'HTTP/1.1 400 Bad request\');\n"
"signal (\'42000\', \'Unsupported media type\');\n"
"}\n"
"\n"
"http_header (\'Content-Type: text/xml; charset=\"utf-8\"\\r\\n\');\n"
"\n"
"\n"
"rp := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:rp=\"http://schemas.xmlsoap.org/rp\"] /S:Envelope/S:Header/rp:path\', soap_xml, 1);\n"
"soap_header := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\"] /S:Envelope/S:Header\', soap_xml, 1);\n"
"\n"
"wss := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:wss=\"http://schemas.xmlsoap.org/ws/2002/07/secext\"] /S:Envelope/S:Header/wss:Security\', soap_xml, 1);\n"
"if (wss is null)\n"
"wss := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:wss=\"http://schemas.xmlsoap.org/ws/2002/04/secext\"] /S:Envelope/S:Header/wss:Security\', soap_xml, 1);\n"
"\n"
"if (http_map_get (\'soap_opts\'))\n"
"{\n"
"if (lower (get_keyword (\'WS-SEC\', http_map_get (\'soap_opts\'), \'no\')) like \'y%\')\n"
"{\n"
"\n"
"wssec := 1;\n"
"}\n"
"\n"
"if (lower (get_keyword (\'WS-RP\', http_map_get (\'soap_opts\'), \'no\')) like \'y%\')\n"
"wsrpe := 1;\n"
"}\n"
"\n"
"declare this_point, send_to, _action, _id, _to, newfwd varchar;\n"
"declare _rev any;\n"
"declare errm any;\n"
"if (rp is not null and wsrpe)\n"
"{\n"
"declare _actor, _mustund nvarchar;\n"
"\n"
"declare _fwd any;\n"
"\n"
"_action := xpath_eval (\'string(action)\', rp, 1);\n"
"_id := xpath_eval (\'string(id)\', rp, 1);\n"
"_actor := xpath_eval (\'@actor\', rp, 1);\n"
"_mustund := xpath_eval (\'@mustUnderstand\', rp, 1);\n"
"if (_actor <> N\'http://schemas.xmlsoap.org/soap/actor/next\' or _mustund <> N\'1\')\n"
"db..wsrp_error (701, \'WS-Routing Header Required\', \'\', soap_xml);\n"
"\n"
"_to := xpath_eval (\'string(to)\', rp, 1);\n"
"_fwd := xpath_eval (\'fwd\', rp, 1);\n"
"_rev := xpath_eval (\'rev\', rp, 1);\n"
"\n"
"\n"
"\n"
"\n"
"this_point := soap_current_url ();\n"
"if (this_point not like \'%/\' and http_path() like \'%/\')\n"
"this_point := concat (this_point, \'/\');\n"
"send_to := NULL;\n"
"_to := cast (_to as varchar);\n"
"if (_fwd is null or xpath_eval(\'via[1]\', _fwd, 1) is null)\n"
"{\n"
"\n"
"if (_to <> this_point)\n"
"{\n"
"db..wsrp_error (800, \'WS-Routing receiver fault\', _to, soap_xml);\n"
"}\n"
"\n"
"rp_act := 2;\n"
"}\n"
"else\n"
"{\n"
"declare _to1 varchar;\n"
"send_to := xpath_eval(\'via[2]\', _fwd, 1);\n"
"if (send_to is not null)\n"
"send_to := xpath_eval(\'string()\', send_to, 1);\n"
"_to1 := xpath_eval(\'string(via[1])\', _fwd, 1);\n"
"_to1 := cast (_to1 as varchar);\n"
"\n"
"\n"
"if (_to1 <> this_point)\n"
"{\n"
"db..wsrp_error (800, \'WS-Routing receiver fault\', _to, soap_xml);\n"
"}\n"
"\n"
"if (send_to is null)\n"
"{\n"
"if (xpath_eval (\'to\', rp, 1) is null)\n"
"{\n"
"\n"
"_to := _to1;\n"
"rp_act := 2;\n"
"}\n"
"else\n"
"{\n"
"\n"
"send_to := _to;\n"
"rp_act := 1;\n"
"}\n"
"}\n"
"else\n"
"{\n"
"\n"
"rp_act := 1;\n"
"}\n"
"}\n"
"\n"
"}\n"
"else if (wsrpe)\n"
"db..wsrp_error (701, \'WS-Routing Header Required\', \'\', soap_xml);\n"
"\n"
"newfwd := \'\';\n"
"if (__proc_exists (\'DB.DBA.WS_SOAP_RF_HEADER\'))\n"
"{\n"
"newfwd := call (\'DB.DBA.WS_SOAP_RF_HEADER\') (soap_header, lines, this_point, send_to);\n"
"if (newfwd <> \'\')\n"
"{\n"
"send_to := newfwd;\n"
"rp_act := 1;\n"
"}\n"
"}\n"
"\n"
"if (rp_act = 1)\n"
"{\n"
"declare hdr, body, hl, ses, hinfo varchar;\n"
"declare hst varchar;\n"
"send_to := cast (send_to as varchar);\n"
"hinfo := WS.WS.PARSE_URI (send_to);\n"
"if (hinfo [0] = \'\' or hinfo [1] = \'\' or hinfo [2] = \'\' or hinfo [5] <> \'\')\n"
"{\n"
"db..wsrp_error (713, \'Endpoint Invalid\', send_to, soap_xml);\n"
"}\n"
"if (hinfo [0] <> \'http\')\n"
"{\n"
"db..wsrp_error (712, \'Endpoint Not Supported\', send_to, soap_xml);\n"
"}\n"
"body := xslt (\'http://local.virt/wsrp_interm\', soap_xml, vector (\'newrev\', \'\', \'newfwd\', newfwd));\n"
"ses := string_output ();\n"
"http_value (body, NULL, ses);\n"
"body := string_output_string (ses);\n"
"hdr := sprintf (\'SOAPAction: \"%s\"\\r\\nContent-Type: text/xml; charset=\"utf-8\"\', _action);\n"
"{\n"
"declare exit handler for sqlstate \'*\' {\n"
"db..wsrp_error (820, \'Endpoint Not Reachable\', send_to, soap_xml);\n"
"};\n"
"declare exit handler for sqlstate \'22023\' {\n"
"db..wsrp_error (730, \'Endpoint Too Long\', send_to, soap_xml);\n"
"};\n"
"declare exit handler for sqlstate \'08006\' {\n"
"db..wsrp_error (740, \'Message Timeout\', send_to, soap_xml);\n"
"};\n"
"if (registry_get (\'__SOAP_WSRP_LOG\') = \'1\')\n"
"log_message (\'Forwarding request to: \' || send_to);\n"
"res := http_get (send_to, hl, \'POST\', hdr, body);\n"
"}\n"
"\n"
"\n"
"hst := trim(hl[0], \'\\r\\n \');\n"
"\n"
"if (hst like \'HTTP/1.1 4%\')\n"
"db..wsrp_error (820, \'Endpoint Not Reachable\', send_to, soap_xml);\n"
"\n"
"http_request_status (hst);\n"
"\n"
"rp_act := 0;\n"
"if ((\'text/xml\' = http_request_header (hl, \'Content-Type\')) and atoi (http_request_header (hl, \'Content-Length\', null, \'0\')))\n"
"{\n"
"soap_xml := xml_tree_doc (xml_tree (res));\n"
"\n"
"res := xslt (\'http://local.virt/wsrp_interm\', soap_xml, vector (\'newrev\', this_point, \'newfwd\', \'\'));\n"
"}\n"
"\n"
"}\n"
"else\n"
"{\n"
"declare soap_res any;\n"
"declare new_xml any;\n"
"\n"
"declare exit handler for SQLSTATE \'*\' {\n"
"declare err_msg varchar;\n"
"err_msg := soap_make_error (\'300\', __SQL_STATE, __SQL_MESSAGE);\n"
"http (err_msg);\n"
"if (wssec and length (http_pending_req ()) = 1)\n"
"xenc_delete_temp_keys ();\n"
"resignal \'VSPRT\';\n"
"};\n"
"\n"
"if (wssec)\n"
"{\n"
"WS_SECURITY_CHECK (req_body, soap_xml, lines, ns);\n"
"}\n"
"\n"
"new_xml := xslt (\'http://local.virt/wsrp_ultim\', soap_xml);\n"
"\n"
"if (__proc_exists (\'DB.DBA.WS_SOAP_RF_MESSAGE\'))\n"
"res := call (\'DB.DBA.WS_SOAP_RF_MESSAGE\') (new_xml, lines, _action, this_point);\n"
"if (res is null)\n"
"res := soap_server (new_xml, soap_method, lines, soap_ver, null, null, attachments);\n"
"\n"
"if (wsrpe)\n"
"{\n"
"declare _from_mail varchar;\n"
"_from_mail := get_keyword (\'wsrp-from\',http_map_get (\'soap_opts\'), \'\');\n"
"soap_res := xml_tree_doc (res);\n"
"\n"
"res := xslt (\'http://local.virt/wsrp_resp\', soap_res, vector (\'id\', lower(uuid()), \'relatesTo\', _id, \'action\', _action, \'fwd\', _rev, \'to\', _to, \'from\', _from_mail));\n"
"}\n"
"else\n"
"{\n"
"soap_res := xml_tree_doc (res);\n"
"res := xslt (\'http://local.virt/wsrp_resp\', soap_res, vector (\'routing\', 0, \'b_id\', lower(uuid())));\n"
"}\n"
"\n"
"if (wssec)\n"
"{\n"
"WS_SECURITY_ADD (res, ns);\n"
"if (length (http_pending_req ()) = 1)\n"
"xenc_delete_temp_keys ();\n"
"}\n"
"}\n"
"\n"
"if (registry_get (\'__SOAP_WSRP_LOG\') = \'1\')\n"
"log_message (\'Sending response to: \' || http_client_ip ());\n"
"\n"
"if (isstring (res))\n"
"http (res);\n"
"else\n"
"http_value (res);\n"
"}\n"
"--src soap.sql:542\n";

static const char *tbl12 = 
"create table DB.DBA.WS_REFERRALS (\n"
"R_ID  	varchar,\n"
"R_FOR 	varchar,\n"
"R_GO  	long varchar,\n"
"R_EXPIRY 	datetime,\n"
"R_URL	varchar,\n"
"R_STATIC	varchar default NULL,\n"
"primary key (R_ID, R_FOR)\n"
")\n";

static const char *alter6 = 
"alter table DB.DBA.WS_REFERRALS add R_STATIC varchar default NULL\n";

static const char *proc160 = 
"create procedure\n"
"DB.DBA.WS_SOAP_RF_HEADER (in soap_xml any, in lines any, in this_point varchar, in next_hop varchar)\n"
"{\n"
"declare referrals any;\n"
"declare matches any;\n"
"\n"
"if (soap_xml is null)\n"
"return \'\';\n"
"\n"
"referrals := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\"] /S:Envelope/S:Header/r:referrals\', soap_xml, 1);\n"
"\n"
"matches := vector ();\n"
"if (referrals is null)\n"
"{\n"
"for select R_ID, R_FOR, R_GO, R_EXPIRY from DB.DBA.WS_REFERRALS where R_URL = this_point and\n"
"(this_point like R_FOR or next_hop like R_FOR)\n"
"and datediff (\'second\', now(), R_EXPIRY) > 0 do\n"
"{\n"
"matches := vector_concat (matches, vector (vector (R_FOR, R_GO, R_ID, R_EXPIRY)));\n"
"}\n"
"goto choose;\n"
"}\n"
"\n"
"\n"
"declare _refs, _ref, _for_pref, _for_exact, _go, _if_ttl, go_via any;\n"
"declare _refid, _if_inv varchar;\n"
"declare len, inx, i, l integer;\n"
"\n"
"_refs := xpath_eval (\'ref[*]\', referrals, 0);\n"
"inx := 0; len := length(_refs);\n"
"\n"
"if (not len)\n"
"return \'\';\n"
"while (inx < len)\n"
"{\n"
"_ref := _refs[inx];\n"
"inx := inx + 1;\n"
"_refid := cast (xpath_eval (\'string(refId)\', _ref, 1) as varchar);\n"
"_if_ttl := cast (xpath_eval (\'string(if/ttl)\', _ref, 1) as integer);\n"
"_if_inv := xpath_eval (\'if/invalidates/rid/text()\', _ref, 0);\n"
"_go := xpath_eval (\'go/via/text()\', _ref, 0);\n"
"_for_pref := xpath_eval (\'for/prefix/text()\', _ref, 0);\n"
"_for_exact := xpath_eval (\'for/exact/text()\', _ref, 0);\n"
"i := 0; l := length (_if_inv);\n"
"while (i < l)\n"
"{\n"
"declare elm varchar;\n"
"elm := cast (_if_inv[i] as varchar);\n"
"delete from WS_REFERRALS where R_ID = elm;\n"
"i := i + 1;\n"
"}\n"
"i := 0; l := length (_go);\n"
"go_via := vector ();\n"
"while (i < l)\n"
"{\n"
"go_via := vector_concat (go_via, vector (cast (_go[i] as varchar)));\n"
"i := i + 1;\n"
"}\n"
"if (i)\n"
"go_via := serialize (go_via);\n"
"else\n"
"go_via := NULL;\n"
"declare expiry datetime;\n"
"_if_ttl := _if_ttl / 1000;\n"
"if (_if_ttl <= 0)\n"
"_if_ttl := 3600*24;\n"
"expiry := dateadd (\'second\', _if_ttl, now());\n"
"declare exit handler for sqlstate \'23000\' {\n"
"rollback work;\n"
"return \'\';\n"
"};\n"
"i := 0; l := length (_for_pref);\n"
"while (go_via is not null and (i < l))\n"
"{\n"
"declare elm varchar;\n"
"elm := cast (_for_pref[i] as varchar);\n"
"elm := concat (elm, \'%\');\n"
"if (this_point like elm)\n"
"{\n"
"matches := vector_concat (matches, vector (vector (elm, go_via, _refid, expiry)));\n"
"\n"
"}\n"
"i := i + 1;\n"
"}\n"
"i := 0; l := length (_for_exact);\n"
"while (go_via is not null and (i < l))\n"
"{\n"
"declare elm varchar;\n"
"elm := cast (_for_exact[i] as varchar);\n"
"if (this_point = elm)\n"
"{\n"
"matches := vector_concat (matches, vector (vector (elm, go_via, _refid, expiry)));\n"
"\n"
"}\n"
"i := i + 1;\n"
"}\n"
"}\n"
"choose:\n"
"commit work;\n"
"i := 0; l := length (matches);\n"
"declare choice any;\n"
"choice := vector (\'\', vector (\'\'));\n"
"while (i < l)\n"
"{\n"
"declare elm any;\n"
"declare via, host varchar;\n"
"elm := matches[i];\n"
"host := elm[0];\n"
"via := deserialize(elm[1]);\n"
"if (length (via) and length (host) > length (choice[0]))\n"
"choice := vector (host, via);\n"
"i := i + 1;\n"
"}\n"
"\n"
"if (choice[0] <> \'\')\n"
"return choice[1][0];\n"
"return \'\';\n"
"}\n"
"--src soap.sql:857\n";

static const char *proc161 = 
"create procedure\n"
"DB.DBA.WS_SOAP_RF_MESSAGE (in soap_xml any, in lines any, inout action varchar, inout this_url varchar)\n"
"{\n"
"declare query, queryresp, register, register_resp, refresp, referrals, _for_pref, _for_exact any;\n"
"declare _go, _if, _refid any;\n"
"declare i, l integer;\n"
"query := NULL; queryresp := NULL; register := NULL; register_resp := NULL; refresp := NULL;\n"
"referrals := NULL;\n"
"if (action = \'http://schemas.xmlsoap.org/ws/2001/10/referral#query\')\n"
"query := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\"] /S:Envelope/S:Body/r:query\', soap_xml, 1);\n"
"else if (action = \'http://schemas.xmlsoap.org/ws/2001/10/referral#queryResponse\')\n"
"queryresp := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\"] /S:Envelope/S:Body/r:queryResponse\', soap_xml, 1);\n"
"else if (action = \'http://schemas.xmlsoap.org/ws/2001/10/referral#register\')\n"
"register := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\"] /S:Envelope/S:Body/r:register\', soap_xml, 1);\n"
"else if (action = \'http://schemas.xmlsoap.org/ws/2001/10/referral#registrationResponse\')\n"
"register_resp := xpath_eval (\'[xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\"] /S:Envelope/S:Body/r:registrationResponse\', soap_xml, 1);\n"
"\n"
"if (query is not null or queryresp is not null or register is not null or register_resp is not null)\n"
"{\n"
"delete from WS_REFERRALS where datediff (\'second\', now(), R_EXPIRY) <= 0;\n"
"commit work;\n"
"}\n"
"\n"
"if (query is not null)\n"
"{\n"
"declare ses, _for any;\n"
"declare pt varchar;\n"
"ses := string_output ();\n"
"_for_pref := xpath_eval (\'for/prefix/text()\', query, 0);\n"
"_for_exact := xpath_eval (\'for/exact/text()\', query, 0);\n"
"http (\'<S:Envelope xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">\', ses);\n"
"http (\'<S:Body xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\">\', ses);\n"
"http (\'<r:queryResponse>\', ses);\n"
"\n"
"pt := \'exact\';\n"
"_for := _for_exact;\n"
"again:\n"
"i := 0; l := length (_for);\n"
"while (i < l)\n"
"{\n"
"declare elm, velm varchar;\n"
"declare j, k, ttl integer;\n"
"declare via any;\n"
"elm := cast (_for[i] as varchar);\n"
"for select R_ID, R_FOR, R_GO, R_EXPIRY from WS_REFERRALS where elm like R_FOR and R_URL = this_url do\n"
"{\n"
"ttl := datediff (\'second\', now(), R_EXPIRY);\n"
"ttl := ttl * 1000;\n"
"R_FOR := trim (R_FOR, \'%\');\n"
"http (\'<r:ref>\', ses);\n"
"http (\'<r:for>\', ses);\n"
"http (sprintf (\'<r:%s>%s</r:%s>\', pt, R_FOR, pt), ses);\n"
"http (\'</r:for>\', ses);\n"
"http (\'<r:if>\', ses);\n"
"http (sprintf (\'<r:ttl>%d</r:ttl>\', ttl), ses);\n"
"http (\'</r:if>\', ses);\n"
"via := deserialize (R_GO);\n"
"j := 0; k := length (via);\n"
"http (\'<r:go>\', ses);\n"
"\n"
"while (j < k)\n"
"{\n"
"velm := sprintf (\'<r:via>%s</r:via>\', via[j]);\n"
"http (velm, ses);\n"
"j := j + 1;\n"
"}\n"
"http (\'</r:go>\', ses);\n"
"http (sprintf (\'<r:refId>%s</r:refId>\', R_ID), ses);\n"
"http (\'</r:ref>\', ses);\n"
"}\n"
"i := i + 1;\n"
"}\n"
"if (pt = \'exact\')\n"
"{\n"
"pt := \'prefix\';\n"
"_for := _for_pref;\n"
"goto again;\n"
"}\n"
"http (\'</r:queryResponse>\', ses);\n"
"http (\'</S:Body>\', ses);\n"
"http (\'</S:Envelope>\', ses);\n"
"action := \'http://schemas.xmlsoap.org/ws/2001/10/referral#queryResponse\';\n"
"return string_output_string (ses);\n"
"}\n"
"else if (register is not null or queryresp is not null)\n"
"{\n"
"declare _ref, _refs, go_via, _if_ttl, _if_inv any;\n"
"declare is_reg integer;\n"
"declare inx, len integer;\n"
"is_reg := 1;\n"
"if (register is null)\n"
"{\n"
"is_reg := 0;\n"
"register := queryresp;\n"
"}\n"
"_refs := xpath_eval (\'ref[*]\', register, 0);\n"
"inx := 0; len := length(_refs);\n"
"\n"
"if (not len)\n"
"return NULL;\n"
"\n"
"while (inx < len)\n"
"{\n"
"_ref := _refs[inx];\n"
"inx := inx + 1;\n"
"_refid := cast (xpath_eval (\'string(refId)\', _ref, 1) as varchar);\n"
"_if_ttl := cast (xpath_eval (\'string(if/ttl)\', _ref, 1) as integer);\n"
"_if_inv := xpath_eval (\'if/invalidates/rid/text()\', _ref, 0);\n"
"_go := xpath_eval (\'go/via/text()\', _ref, 0);\n"
"_for_pref := xpath_eval (\'for/prefix/text()\', _ref, 0);\n"
"_for_exact := xpath_eval (\'for/exact/text()\', _ref, 0);\n"
"i := 0; l := length (_if_inv);\n"
"while (i < l)\n"
"{\n"
"declare elm varchar;\n"
"elm := cast (_if_inv[i] as varchar);\n"
"delete from WS_REFERRALS where R_ID = elm;\n"
"i := i + 1;\n"
"}\n"
"i := 0; l := length (_go);\n"
"go_via := vector ();\n"
"while (i < l)\n"
"{\n"
"go_via := vector_concat (go_via, vector (cast (_go[i] as varchar)));\n"
"i := i + 1;\n"
"}\n"
"if (i)\n"
"go_via := serialize (go_via);\n"
"else\n"
"go_via := NULL;\n"
"i := 0; l := length (_for_pref);\n"
"declare expiry datetime;\n"
"_if_ttl := _if_ttl / 1000;\n"
"if (_if_ttl <= 0)\n"
"_if_ttl := 3600*24;\n"
"expiry := dateadd (\'second\', _if_ttl, now());\n"
"declare exit handler for sqlstate \'23000\' {\n"
"rollback work;\n"
"if (is_reg)\n"
"{\n"
"action := \'http://schemas.xmlsoap.org/ws/2001/10/referral#registrationResponse\';\n"
"return (\n"
"\'<S:Envelope xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">\n"
"<S:Body>\n"
"<S:Fault xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\">\n"
"<faultcode>r:registrationFault</faultcode>\n"
"<faultstring>Registration Fault</faultstring>\n"
"<detail>\n"
"<r:duplicate />\n"
"</detail>\n"
"</S:Fault>\n"
"</S:Body>\n"
"</S:Envelope>\');\n"
"}\n"
"return NULL;\n"
"};\n"
"while (go_via is not null and (i < l))\n"
"{\n"
"declare elm varchar;\n"
"elm := cast (_for_pref[i] as varchar);\n"
"elm := concat (elm, \'%\');\n"
"insert into WS_REFERRALS (R_ID, R_FOR, R_GO, R_EXPIRY, R_URL)\n"
"values (_refid, elm, go_via, expiry, this_url);\n"
"i := i + 1;\n"
"}\n"
"i := 0; l := length (_for_exact);\n"
"while (go_via is not null and (i < l))\n"
"{\n"
"declare elm varchar;\n"
"elm := cast (_for_exact[i] as varchar);\n"
"insert into WS_REFERRALS (R_ID, R_FOR, R_GO, R_EXPIRY, R_URL)\n"
"values (_refid, elm, go_via, expiry, this_url);\n"
"i := i + 1;\n"
"}\n"
"}\n"
"\n"
"if (is_reg)\n"
"{\n"
"action := \'http://schemas.xmlsoap.org/ws/2001/10/referral#registrationResponse\';\n"
"return (\'<S:Envelope xmlns:S=\"http://schemas.xmlsoap.org/soap/envelope/\">\n"
"<S:Body>\n"
"<r:registrationResponse xmlns:r=\"http://schemas.xmlsoap.org/ws/2001/10/referral\"/>\n"
"</S:Body>\n"
"</S:Envelope>\');\n"
"}\n"
"\n"
"}\n"
"\n"
"return NULL;\n"
"}\n"
"--src soap.sql:977\n";

static const char *proc162 = 
"create procedure\n"
"SOAP_LOAD_SCH (in sch varchar, in udts any := null, in \"array\" int := 0, in do_result int := 1)\n"
"{\n"
"declare ents, xte, xt, arr, xarr any;\n"
"declare i, l int;\n"
"declare name, udt, name1, tns1 varchar;\n"
"if (isentity (sch))\n"
"xte := sch;\n"
"else\n"
"xte := xml_tree_doc (sch);\n"
"xt := xslt (\'http://local.virt/soap_import_sch\', xte);\n"
"arr := xpath_eval (\'/complexType|/element|/simpleType|/attribute\', xt, 0);\n"
"l := length (arr);\n"
"if (not \"array\")\n"
"{\n"
"if (do_result)\n"
"result_names (name, udt);\n"
"}\n"
"else\n"
"xarr := make_array (l, \'any\');\n"
"if (isnull (udts))\n"
"udts := vector ();\n"
"while (i < l)\n"
"{\n"
"declare frag, udtn any;\n"
"frag := xml_cut (arr[i]);\n"
"frag := xslt (\'http://local.virt/xslt_copy\', frag);\n"
"name1 := cast(xpath_eval (\'string(/@name)\', frag, 1) as varchar);\n"
"tns1 := cast(xpath_eval (\'string(/@targetNamespace)\', frag, 1) as varchar);\n"
"if (tns1 is not null and tns1 <> \'\')\n"
"name1 := sprintf (\'%s:%s\', tns1, name1);\n"
"udt := null;\n"
"if (not \"array\")\n"
"{\n"
"if (get_keyword (name1, udts, \'\') <> \'\')\n"
"{\n"
"udtn := get_keyword (name1, udts, \'\');\n"
"udt := udtn;\n"
"name := soap_dt_define (\'\', frag, udtn);\n"
"}\n"
"else\n"
"name := soap_dt_define (\'\', frag);\n"
"if (do_result)\n"
"result (name, udt);\n"
"}\n"
"else if (\"array\" < 0)\n"
"{\n"
"aset (xarr, i, frag);\n"
"}\n"
"else\n"
"{\n"
"declare xte1 any;\n"
"\n"
"xte1 := xslt (\'http://local.virt/soap_sch\', frag, vector (\'udt_struct\', 0, \'any_type\', 1));\n"
"aset (xarr, i, xte1);\n"
"}\n"
"i := i + 1;\n"
"}\n"
"return xarr;\n"
"}\n"
"--src soap.sql:1169\n";

static const char *proc163 = 
" create procedure\n"
"DB.DBA.WSDL_SPLIT_NAME (in url varchar, in part int)\n"
"{\n"
"declare pos int;\n"
"declare ret varchar;\n"
"if (not isstring (url))\n"
"return \'\';\n"
"pos := strrchr (url, \':\');\n"
"if (pos is not null)\n"
"{\n"
"if (part)\n"
"{\n"
"ret := substring (url, pos + 2, length (url));\n"
"}\n"
"else\n"
"{\n"
"ret := substring (url, 1, pos);\n"
"}\n"
"}\n"
"else\n"
"return url;\n"
"return ret;\n"
"}\n"
"--src soap.sql:1232\n";

static const char *other98 = 
"insert soft DB.DBA.SYS_XPF_EXTENSIONS (XPE_NAME, XPE_PNAME) VALUES (\'http://www.openlinksw.com/wsdl/:split-name\',\n"
"\'DB.DBA.WSDL_SPLIT_NAME\')\n";
static const char *other99 = 
"xpf_extension (\'http://www.openlinksw.com/wsdl/:split-name\', \'DB.DBA.WSDL_SPLIT_NAME\', 0)\n";
static const char *proc164 = 
"create procedure\n"
"WSDL_IMPORT_TYPES (inout mid any)\n"
"{\n"
"declare xp, tp any;\n"
"declare i, l, inx, len int;\n"
"xp := xpath_eval (\'[ xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" ] //xsd:schema\', mid, 0);\n"
"i := 0; l := length (xp);\n"
"while (i < l)\n"
"{\n"
"declare ent any;\n"
"ent := xml_cut (xp[i]);\n"
"tp := SOAP_LOAD_SCH (ent, null, -1);\n"
"inx := 0; len := length (tp);\n"
"while (inx < len)\n"
"{\n"
"declare elm any;\n"
"declare name1, tns1, name2, is_elem varchar;\n"
"elm := tp[inx];\n"
"name1 := cast(xpath_eval (\'string(/@name)\', elm, 1) as varchar);\n"
"tns1 := cast(xpath_eval (\'string(/@targetNamespace)\', elm, 1) as varchar);\n"
"is_elem := xpath_eval (\'boolean (element)\', elm, 1);\n"
"if (tns1 is not null and tns1 <> \'\')\n"
"name1 := sprintf (\'%s:%s\', tns1, name1);\n"
"if (not exists (select 1 from SYS_SOAP_DATATYPES where SDT_NAME = name1 and SDT_TYPE = is_elem))\n"
"{\n"
"name2 := soap_dt_define (\'\', elm);\n"
"\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"i := i + 1;\n"
"}\n"
"}\n"
"--src soap.sql:1264\n";

static const char *proc165 = 
"create procedure\n"
"EXECUTE_SCRIPT (inout ses any)\n"
"{\n"
"declare cmd, dbg any;\n"
"declare line varchar;\n"
"declare i, is_drop, ctr, offs int;\n"
"commit work;\n"
"cmd := null;\n"
"ctr := 0;\n"
"while (1)\n"
"{\n"
"line := ses_read_line (ses, 0);\n"
"ctr := ctr + 1;\n"
"if (not isstring (line))\n"
"return;\n"
"if (cmd is null and (line like \'create %\' or line like \'drop %\'))\n"
"{\n"
"cmd := string_output ();\n"
"dbg := string_output ();\n"
"is_drop := 0;\n"
"if (line like \'drop %\')\n"
"is_drop := 1;\n"
"i := 1;\n"
"offs := ctr;\n"
"}\n"
"if (rtrim(line) = \';\')\n"
"{\n"
"declare stmt, stat, msg varchar;\n"
"stmt := string_output_string (cmd);\n"
"stat := \'00000\'; msg := \'\';\n"
"exec (stmt, stat, msg);\n"
"if (stat = \'00000\')\n"
"{\n"
"commit work;\n"
"}\n"
"else\n"
"{\n"
"rollback work;\n"
"if (not is_drop)\n"
"{\n"
"log_message (sprintf (\'VSPX: %s %s\',stat, msg));\n"
"dbg_obj_print (string_output_string (dbg));\n"
"}\n"
"if (not (stmt like \'drop %\'))\n"
"signal (stat, concat (msg, sprintf (\'; at offset: %d\', offs), \'\\nwhile executing the following statement:\\n\', stmt));\n"
"}\n"
"cmd := null;\n"
"dbg := null;\n"
"}\n"
"if (cmd is not null)\n"
"{\n"
"http (line, cmd);\n"
"http (\'\\n\', cmd);\n"
"http (sprintf (\'%03d \', i), dbg);\n"
"http (line, dbg);\n"
"http (\'\\n\', dbg);\n"
"i := i + 1;\n"
"}\n"
"}\n"
"return NULL;\n"
"}\n"
"--src soap.sql:1299\n";

static const char *proc166 = 
"create procedure\n"
"WSDL_IMPORT_UDT (in url varchar, in f varchar := null, in exec int := 0)\n"
"{\n"
"declare res, ses, xe, mid any;\n"
"declare resource_text, src varchar;\n"
"\n"
"resource_text := XML_URI_GET (\'\', url);\n"
"xe := xtree_doc (resource_text, 0, url);\n"
"res := xslt (\'http://local.virt/wsdl_expand\', xe);\n"
"\n"
"mid := xslt (\'http://local.virt/wsdl_parts\', res);\n"
"\n"
"\n"
"res := xslt (\'http://local.virt/wsdl_import\', mid, vector (\'wsdlURI\', url));\n"
"ses := string_output ();\n"
"http_value (res, null, ses);\n"
"src := string_output_string (ses);\n"
"\n"
"if (f is not null)\n"
"string_to_file (f, src, -2);\n"
"\n"
"\n"
"WSDL_IMPORT_TYPES (mid);\n"
"\n"
"if (exec)\n"
"EXECUTE_SCRIPT (ses);\n"
"\n"
"return src;\n"
"}\n"
"--src soap.sql:1362\n";

static const char *proc167 = 
" create procedure\n"
"DB.DBA.XML_RPC_GET_PARAM_NAME (in proc varchar, in ordinal int)\n"
"{\n"
"declare pars, proc1 any;\n"
"declare elm any;\n"
"proc1 := __proc_exists (proc);\n"
"if (proc1 is not null)\n"
"pars := procedure_cols (proc1);\n"
"else\n"
"pars := procedure_cols (complete_proc_name (proc,1));\n"
"if (not isarray(pars) or length (pars) < ordinal)\n"
"return \'param\';\n"
"if (pars[0][3] = \'\')\n"
"ordinal := ordinal + 1;\n"
"elm := pars[ordinal - 1];\n"
"return elm[3];\n"
"}\n"
"--src soap.sql:1396\n";

static const char *other100 = 
"insert soft DB.DBA.SYS_XPF_EXTENSIONS (XPE_NAME, XPE_PNAME)\n"
"VALUES (\'http://www.openlinksw.com/xmlrpc/:getParamName\', \'DB.DBA.XML_RPC_GET_PARAM_NAME\')\n";
static const char *other101 = 
"xpf_extension (\'http://www.openlinksw.com/xmlrpc/:getParamName\', \'DB.DBA.XML_RPC_GET_PARAM_NAME\', 0)\n";
static const char *proc168 = 
" create procedure DB.DBA.XML_RPC_DATE_CVT (in dt varchar)\n"
"{\n"
"declare ts any;\n"
"if (dt not like \'____-__-__T__:__:__.%\')\n"
"return dt;\n"
"ts := stringdate (dt);\n"
"ts := dt_set_tz (ts, 0);\n"
"return soap_print_box (ts, \'\', 0);\n"
"}\n"
"--src soap.sql:1426\n";

static const char *other102 = 
"insert soft DB.DBA.SYS_XPF_EXTENSIONS (XPE_NAME, XPE_PNAME)\n"
"VALUES (\'http://www.openlinksw.com/xmlrpc/:getGMTtime\', \'DB.DBA.XML_RPC_DATE_CVT\')\n";
static const char *other103 = 
"xpf_extension (\'http://www.openlinksw.com/xmlrpc/:getGMTtime\', \'DB.DBA.XML_RPC_DATE_CVT\', 0)\n";
static const char *proc169 = 
"create procedure\n"
"XMLRPC_MAKE_ERROR (in code varchar, in state varchar, in message varchar)\n"
"{\n"
"return\n"
"\'<?xml version=\"1.0\"?>\\n\' ||\n"
"\'  <methodResponse>\\n\' ||\n"
"\'   <fault>\\n\' ||\n"
"\'    <value>\\n\' ||\n"
"\'      <struct>\\n\' ||\n"
"\'         <member>\\n\' ||\n"
"\'            <name>faultCode</name>\\n\' ||\n"
"\'            <value><int>\' || code || \'</int></value>\\n\' ||\n"
"\'         </member>\\n\' ||\n"
"\'      <member>\\n\' ||\n"
"\'        <name>faultString</name>\\n\' ||\n"
"\'        <value>\\n\' ||\n"
"\'          <string>\' || sprintf (\'%V\', message) ||\'</string>\\n\' ||\n"
"\'        </value>\\n\' ||\n"
"\'      </member>\\n\' ||\n"
"\'    </struct>\\n\' ||\n"
"\'  </value>\\n\' ||\n"
"\'</fault>\\n\' ||\n"
"\'</methodResponse>\' ;\n"
"}\n"
"--src soap.sql:1445\n";

static const char *proc170 = 
" create procedure\n"
"XMLRPC_SERVER (in path any, in params any, in lines any)\n"
"{\n"
"declare content_type, soap_xml varchar;\n"
"declare req_body, resp_body varchar;\n"
"declare soap_req any;\n"
"declare soap_resp any;\n"
"declare result any;\n"
"\n"
"if (length (params) < 1) params := __http_stream_params ();\n"
"\n"
"content_type := http_request_header (lines, \'Content-Type\');\n"
"\n"
"\n"
"if (content_type = \'text/xml\')\n"
"{\n"
"req_body := http_body_read ();\n"
"soap_xml := xml_tree_doc (xml_tree (req_body));\n"
"}\n"
"else\n"
"{\n"
"http_request_status (\'HTTP/1.1 400 Bad request\');\n"
"signal (\'42000\', \'Unsupported media type\');\n"
"}\n"
"\n"
"http_header (\'Content-Type: text/xml; charset=\"utf-8\"\\r\\n\');\n"
"\n"
"set http_charset=\'UTF-8\';\n"
"\n"
"declare exit handler for SQLSTATE \'*\' {\n"
"declare err_msg varchar;\n"
"http_rewrite ();\n"
"rollback work;\n"
"err_msg := xmlrpc_make_error (\'300\', __SQL_STATE, __SQL_MESSAGE);\n"
"if (registry_get (\'__debug_xmlrpc\') = \'1\')\n"
"dbg_obj_print (err_msg);\n"
"http (err_msg);\n"
"resignal \'VSPRT\';\n"
"};\n"
"\n"
"set_user_id (http_map_get (\'soap_uid\'), 0);\n"
"if (registry_get (\'__debug_xmlrpc\') = \'1\')\n"
"dbg_obj_print (\'XML-RPC request:\', soap_xml);\n"
"soap_req := xslt (\'http://local.virt/xmlrpc_soap\', soap_xml);\n"
"\n"
"resp_body := soap_server (soap_req, \'\', lines, 11);\n"
"\n"
"soap_resp := xml_tree_doc (resp_body);\n"
"result := xslt (\'http://local.virt/soap_xmlrpc\', soap_resp);\n"
"if (registry_get (\'__debug_xmlrpc\') = \'1\')\n"
"dbg_obj_print (\'XML-RPC response:\', result);\n"
"http_value (result);\n"
"}\n"
"--src soap.sql:1474\n";

static const char *proc171 = 
"create procedure\n"
"XMLRPC2SOAP (INOUT BODY VARCHAR)\n"
"{\n"
"declare tmp, ret, ses any;\n"
"{\n"
"declare exit handler for sqlstate \'*\'\n"
"{\n"
"signal (\'42000\', \'Not well formed XMLRPC response.\', \'SP036\');\n"
"};\n"
"tmp := xml_tree_doc (BODY);\n"
"}\n"
"ret := xslt (\'http://local.virt/xmlrpc_soap\', tmp, vector (\'call\', \'1\'));\n"
"ses := string_output ();\n"
"http_value (ret, null, ses);\n"
"BODY := string_output_string (ses);\n"
"}\n"
"--src soap.sql:1531\n";

static const char *proc172 = 
"create procedure\n"
"SOAP2XMLRPC (INOUT BODY VARCHAR)\n"
"{\n"
"declare tmp, ret any;\n"
"tmp := xml_tree_doc (string_output_string (BODY));\n"
"ret := xslt (\'http://local.virt/soap_xmlrpc\', tmp, vector (\'call\', \'1\'));\n"
"if (registry_get (\'__debug_xmlrpc\') = \'1\')\n"
"dbg_obj_print (tmp, ret);\n"
"string_output_flush (BODY);\n"
"http_value (ret, null, BODY);\n"
"}\n"
"--src soap.sql:1549\n";

static const char *proc173 = 
" create procedure\n"
"XMLRPC_CALL (in uri varchar, in meth varchar, in params any, in id any := null)\n"
"{\n"
"declare i, l int;\n"
"declare pars, ret, hinfo, res any;\n"
"\n"
"l := length (params);\n"
"i := 0;\n"
"pars := vector ();\n"
"\n"
"while (i < l)\n"
"{\n"
"pars := vector_concat (pars, vector (sprintf (\'param%d\', i), params[i]));\n"
"i := i + 1;\n"
"}\n"
"hinfo := WS.WS.PARSE_URI (uri);\n"
"res := soap_call_new (hinfo[1], hinfo[2], null, meth, pars, 11, null, null, null, 32, null, null, 0, null, null, null, id);\n"
"return res;\n"
"}\n"
"--src soap.sql:1565\n";

static const char *proc174 = 
" create procedure\n"
"SOAP12_ROUTER (in uri varchar, in this_url varchar, in header any, in body any)\n"
"{\n"
"declare req varchar;\n"
"declare resp varchar;\n"
"declare hd, head any;\n"
"declare host varchar;\n"
"declare ss any;\n"
"ss := string_output ();\n"
"\n"
"req := xml_tree_doc (xmlconcat (xml_tree_doc (header), xml_tree_doc (body)));\n"
"req := xslt (\'http://local.virt/soap12_router\', req, vector (\'this\', this_url));\n"
"req := serialize_to_UTF8_xml (req);\n"
"http (req, ss);\n"
"\n"
"hd := WS.WS.PARSE_URI (uri);\n"
"\n"
"host := hd[1];\n"
"\n"
"head := vector (\n"
"sprintf (\'POST %s HTTP/1.1\\r\\n\', hd[2]),\n"
"\'Content-Type: application/soap+xml; charset=\"utf-8\"\\r\\n\',\n"
"sprintf (\'Content-Length: %d\\r\\n\', length (req))\n"
");\n"
"\n"
"http_proxy (host, head, ss);\n"
"}\n"
"--src soap.sql:1587\n";

static const char *proc175 = 
"create procedure\n"
"DB.DBA.SOAP_WS_TRUST_XENC_TEMPLATE (in body varchar)\n"
"{\n"
"declare tmpl, _user, _pass varchar;\n"
"_user := cast (connection_get (\'__soap_ws_trust_user\') as varchar);\n"
"_pass := cast (connection_get (\'__soap_ws_trust_pass\') as varchar);\n"
"tmpl := sprintf (\'<?xml version=\"1.0\" encoding=\"utf-8\"?><Signature xmlns=\"http://www.w3.org/2000/09/xmldsig#\" xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" xmlns:wsse=\"http://schemas.xmlsoap.org/ws/2002/12/secext\"> <SignedInfo><CanonicalizationMethod Algorithm=\"http://www.w3.org/2001/10/xml-exc-c14n#\"/><SignatureMethod Algorithm=\"http://www.w3.org/2000/09/xmldsig#hmac-sha1\"/></SignedInfo><SignatureValue /><KeyInfo><KeyValue><wsse:UsernameToken><wsse:Username>%s</wsse:Username><wsse:Password Type=\"wsse:PasswordText\">%s</wsse:Password></wsse:UsernameToken></KeyValue></KeyInfo></Signature>\', _user, _pass);\n"
"return dsig_template_ext (xtree_doc (body), tmpl,\n"
"\'http://schemas.xmlsoap.org/soap/envelope/\', \'Body\',\n"
"\'http://schemas.xmlsoap.org/ws/2002/07/utility\', \'Expires\',\n"
"\'http://schemas.xmlsoap.org/ws/2002/07/utility\', \'Created\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'To\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'MessageID\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'From\',\n"
"\'http://schemas.xmlsoap.org/ws/2003/03/addressing\', \'Action\');\n"
"}\n"
"--src soap.sql:1616\n";

static const char *tbl13 = 
"create table SYS_SOAP_UDT_PUB (SUP_CLASS varchar,\n"
"SUP_LHOST varchar,\n"
"SUP_HOST varchar,\n"
"SUP_END_POINT varchar,\n"
"primary key (SUP_LHOST, SUP_HOST, SUP_END_POINT, SUP_CLASS))\n";

static const char *trig1 = 
"create trigger HTTP_PATH_D_UDT_PUB after delete on DB.DBA.HTTP_PATH\n"
"{\n"
"delete from SYS_SOAP_UDT_PUB where SUP_LHOST = HP_LISTEN_HOST and\n"
"SUP_HOST = HP_HOST and SUP_END_POINT = HP_LPATH;\n"
"}\n"
"--src soap.sql:1641\n";

static const char *trig2 = 
"create trigger SOAP_UDT_PUB_I before insert on SYS_SOAP_UDT_PUB\n"
"{\n"
"if (not exists\n"
"(select 1 from DB.DBA.HTTP_PATH\n"
"where SUP_LHOST = HP_LISTEN_HOST and SUP_HOST = HP_HOST and SUP_END_POINT = HP_LPATH\n"
"))\n"
"signal (\'22023\', \'No such virtual directory defined\');\n"
"__soap_udt_publish (SUP_HOST, SUP_LHOST, SUP_END_POINT, SUP_CLASS);\n"
"}\n"
"--src soap.sql:1648\n";

static const char *trig3 = 
"create trigger SOAP_UDT_PUB_U before update on SYS_SOAP_UDT_PUB referencing old as O, new as N\n"
"{\n"
"__soap_udt_unpublish (O.SUP_HOST, O.SUP_LHOST, O.SUP_END_POINT, O.SUP_CLASS);\n"
"__soap_udt_publish (O.SUP_HOST, O.SUP_LHOST, N.SUP_END_POINT, N.SUP_CLASS);\n"
"}\n"
"--src soap.sql:1660\n";

static const char *trig4 = 
"create trigger SOAP_UDT_PUB_D before delete on SYS_SOAP_UDT_PUB\n"
"{\n"
"__soap_udt_unpublish (SUP_HOST, SUP_LHOST, SUP_END_POINT, SUP_CLASS);\n"
"}\n"
"--src soap.sql:1668\n";

static const char *proc176 = 
" create procedure GET_XSD_EXTENSION (in nam varchar)\n"
"{\n"
"declare ext any;\n"
"ext := (select xslt(\'http://local.virt/soap_sch\', xml_tree_doc (sdt_sch)) from sys_soap_datatypes where sdt_name = nam and sdt_type = 0);\n"
"if (ext is null)\n"
"return xml_tree_doc (\'<fake/>\');\n"
"return ext;\n"
"}\n"
"--src soap.sql:1675\n";

static const char *other104 = 
"insert soft DB.DBA.SYS_XPF_EXTENSIONS (XPE_NAME, XPE_PNAME) VALUES\n"
"(\'http://www.openlinksw.com/virtuoso/soap:getExtension\', \'DB.DBA.GET_XSD_EXTENSION\')\n";
static const char *other105 = 
"xpf_extension (\'http://www.openlinksw.com/virtuoso/soap:getExtension\', \'DB.DBA.GET_XSD_EXTENSION\', 0)\n";
static const char *proc177 = 
"create procedure DB.DBA.WS_MIME_ENV (in _all any, in call_mode integer)\n"
"{\n"
"declare _inx, _len integer;\n"
"declare _res, _bnd, _c_type varchar;\n"
"declare _part, temp, hdr any;\n"
"\n"
"_bnd := concat (\'-\',\'-\',\'-\',\'-\', md5 (cast (now () as varchar)));\n"
"\n"
"temp := \'<uuid:\' || uuid () || \'>\';\n"
"temp := \'<\' || uuid () || \'>\';\n"
"\n"
"_c_type := sprintf (\'multipart/related; boundary=\"%s\"; type=\"text/xml\"; start=\"%s\"\', _bnd, temp);\n"
"\n"
"if (call_mode)\n"
"{\n"
"hdr := (concat (\'Content-Type: \', _c_type, \'\\r\\n\'));\n"
"_res := \'\\r\\n\\r\\n\';\n"
"}\n"
"else\n"
"{\n"
"hdr := _c_type;\n"
"_res := \'\';\n"
"}\n"
"\n"
"_inx := 0;\n"
"_len := length (_all);\n"
"\n"
"while (_inx < _len)\n"
"{\n"
"declare c_id, c_type any;\n"
"\n"
"_part := aref (_all, _inx);\n"
"\n"
"if (_inx = 0)\n"
"{\n"
"c_id := temp;\n"
"c_type := \'text/xml\';\n"
"}\n"
"else\n"
"{\n"
"c_id := \'<\' || replace (_part[0], \'cid:\', \'\', 1) || \'>\';\n"
"c_type := _part[1];\n"
"}\n"
"\n"
"_res := concat (_res, \'-\',\'-\', _bnd, \'\\r\\n\');\n"
"_res := concat (_res, \'Content-Type: \', c_type, \'\\r\\n\');\n"
"_res := concat (_res, \'Content-Transfer-Encoding: binary\\r\\n\');\n"
"_res := concat (_res, \'Content-ID: \', c_id, \'\\r\\n\\r\\n\');\n"
"_res := concat (_res, aref (_part, 2), \'\\r\\n\');\n"
"_inx := _inx + 1;\n"
"}\n"
"_res := concat (_res, \'-\',\'-\', _bnd, \'-\',\'-\\r\\n\');\n"
"\n"
"return vector (_res, hdr);\n"
"}\n"
"--src soap.sql:1694\n";

static const char *proc178 = 
"create procedure DB.DBA.WS_MIME_RESP_C (in _all any)\n"
"{\n"
"return DB.DBA.WS_MIME_ENV (_all, 0);\n"
"}\n"
"--src soap.sql:1752\n";

static const char *proc179 = 
"create procedure DB.DBA.WS_MIME_RESP (in _all any)\n"
"{\n"
"return DB.DBA.WS_MIME_ENV (_all, 1);\n"
"}\n"
"--src soap.sql:1758\n";

static const char *other106 = 
"grant execute on DB.DBA.WS_MIME_RESP to public\n";
static const char *other107 = 
"grant execute on DB.DBA.WS_MIME_RESP_C to public\n";
/* wsrp_ultim.xsl */

static const char *xsl6[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: wsrp_ultim.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"    xmlns:SOAP=\"http://schemas.xmlsoap.org/soap/envelope/\"\n"
"    xmlns:rp=\"http://schemas.xmlsoap.org/rp\"\n"
"    xmlns:wss04=\"http://schemas.xmlsoap.org/ws/2002/04/secext\"\n"
"    xmlns:wss07=\"http://schemas.xmlsoap.org/ws/2002/07/secext\"\n"
"    xmlns:wss=\"http://schemas.xmlsoap.org/ws/2002/12/secext\"\n"
"    xmlns:wsso=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\"\n"
"    xmlns:util=\"http://schemas.xmlsoap.org/ws/2002/07/utility\">\n"
"<xsl:output method=\"xml\" indent=\"yes\" omit-xml-declaration=\"yes\"/>\n"
"\n"
"  <xsl:template match=\"rp:path|wss04:Security|wss07:Security|wss:Security|wsso:Security|util:Timestamp\" />\n"
"\n"
"  <xsl:template match=\"*\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:apply-templates />\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
"\n"
,
 NULL };

/* wsrp_resp.xsl */

static const char *xsl7[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: wsrp_resp.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"    xmlns:SOAP=\"http://schemas.xmlsoap.org/soap/envelope/\"\n"
"    xmlns:rp=\"http://schemas.xmlsoap.org/rp\"\n"
"    xmlns:wss=\"http://schemas.xmlsoap.org/ws/2002/12/secext\"\n"
"    xmlns:wsse=\"http://schemas.xmlsoap.org/ws/2002/12/secext\"\n"
"    xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2003/03/addressing\"\n"
"    xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\"\n"
"    xmlns:wsuoasis=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\"\n"
"    >\n"
"<xsl:output method=\"xml\" indent=\"yes\" omit-xml-declaration=\"yes\"/>\n"
"\n"
"  <xsl:param name=\"action\" />\n"
"  <xsl:param name=\"fwd\" />\n"
"  <xsl:param name=\"id\" />\n"
"  <xsl:param name=\"to\" />\n"
"  <xsl:param name=\"from\" />\n"
"  <xsl:param name=\"relatesTo\" />\n"
"  <xsl:param name=\"routing\" select=\"1\" />\n"
"  <xsl:param name=\"b_id\" />\n"
"  <xsl:param name=\"wsu\" select=\"'http://schemas.xmlsoap.org/ws/2002/07/utility'\"/>\n"
"\n"
"  <xsl:template match=\"/\">\n"
"    <xsl:apply-templates select=\"*\" />\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Envelope\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"        <xsl:choose>\n"
"	<xsl:when test=\"not SOAP:Header and boolean($routing)\">\n"
"	  <SOAP:Header>\n"
"	    <rp:path  SOAP:actor=\"http://schemas.xmlsoap.org/soap/actor/next\" SOAP:mustUnderstand=\"1\">\n"
"	      <rp:action><xsl:value-of select=\"$action\" /></rp:action>\n"
"	      <rp:id>uuid:<xsl:value-of select=\"$id\" /></rp:id>\n"
"	      <rp:relatesTo><xsl:value-of select=\"$relatesTo\" /></rp:relatesTo>\n"
"	      <rp:fwd>\n"
"	      <xsl:if test=\"$fwd\">\n"
"		<xsl:copy-of select=\"$fwd/via\" />\n"
"	      </xsl:if>\n"
"	      </rp:fwd>\n"
"	      <rp:rev>\n"
"		<rp:via><xsl:value-of select=\"$to\" /></rp:via>\n"
"	      </rp:rev>\n"
"	      <rp:from><xsl:value-of select=\"$from\" /></rp:from>\n"
"	    </rp:path>\n"
"	  </SOAP:Header>\n"
"	</xsl:when>\n"
"	<xsl:when test=\"not boolean($routing) and not SOAP:Header\">\n"
"	  <SOAP:Header />\n"
"	</xsl:when>\n"
"	</xsl:choose>\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Header\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"	<xsl:if test=\"boolean($routing)\" >\n"
"        <rp:path  SOAP:actor=\"http://schemas.xmlsoap.org/soap/actor/next\" SOAP:mustUnderstand=\"1\">\n"
"	  <rp:action><xsl:value-of select=\"$action\" /></rp:action>\n"
"	  <rp:id>uuid:<xsl:value-of select=\"$id\" /></rp:id>\n"
"	  <rp:relatesTo><xsl:value-of select=\"$relatesTo\" /></rp:relatesTo>\n"
"	  <rp:fwd>\n"
"	    <xsl:if test=\"$fwd\">\n"
"	    <xsl:copy-of select=\"$fwd/via\" />\n"
"	    </xsl:if>\n"
"	  </rp:fwd>\n"
"	  <rp:rev>\n"
"	    <rp:via><xsl:value-of select=\"$to\" /></rp:via>\n"
"	  </rp:rev>\n"
"	  <rp:from><xsl:value-of select=\"$from\" /></rp:from>\n"
"	</rp:path>\n"
"	</xsl:if>\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"rp:path\"></xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Body[not @wsu:Id and not @wsuoasis:Id]\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:attribute name=\"Id\" namespace=\"{$wsu}\">Id-<xsl:value-of select=\"$b_id\" /></xsl:attribute>\n"
"     <xsl:apply-templates select=\"*\"/>\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"*\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:copy-of select=\"*\" />\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* wsrp_interm.xsl */

static const char *xsl8[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: wsrp_interm.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"    xmlns:SOAP=\"http://schemas.xmlsoap.org/soap/envelope/\"\n"
"    xmlns:rp=\"http://schemas.xmlsoap.org/rp\">\n"
"<xsl:output method=\"xml\" indent=\"yes\" omit-xml-declaration=\"yes\"/>\n"
"<xsl:param name=\"newrev\" />\n"
"<xsl:param name=\"newfwd\" />\n"
"  <xsl:template match=\"/\">\n"
"    <xsl:apply-templates select=\"*\" />\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Envelope\">\n"
"   <SOAP:Envelope>\n"
"    <xsl:copy-of select=\"@*\" />\n"
"    <xsl:apply-templates select=\"*\" />\n"
"   </SOAP:Envelope>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Body\">\n"
"   <SOAP:Body>\n"
"    <xsl:copy-of select=\"@*\" />\n"
"    <xsl:copy-of select=\"*\" />\n"
"   </SOAP:Body>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Header\">\n"
"   <SOAP:Header>\n"
"   <xsl:copy-of select=\"@*\" />\n"
"   <xsl:for-each select=\"*\">\n"
"     <xsl:choose>\n"
"       <xsl:when test=\"name(.) = 'http://schemas.xmlsoap.org/rp:path'\">\n"
"         <rp:path>\n"
"	   <xsl:apply-templates select=\".\" />\n"
"         </rp:path>\n"
"       </xsl:when>\n"
"       <xsl:otherwise>\n"
"         <xsl:copy-of select=\".\" />\n"
"       </xsl:otherwise>\n"
"     </xsl:choose>\n"
"   </xsl:for-each>\n"
"   </SOAP:Header>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"rp:path\">\n"
"   <xsl:copy-of select=\"@*\" />\n"
"   <xsl:for-each select=\"*\">\n"
"     <xsl:choose>\n"
"       <xsl:when test=\"name(.) = 'http://schemas.xmlsoap.org/rp:fwd'\">\n"
"         <rp:fwd>\n"
"	   <xsl:if test=\"$newfwd != ''\">\n"
"	     <rp:via><xsl:value-of select=\"$newfwd\" /></rp:via>\n"
"	   </xsl:if>\n"
"	   <xsl:for-each select=\"via\">\n"
" 	     <xsl:if test=\"position(.) > 1\">\n"
"	       <xsl:copy-of select=\".\" />\n"
"	      </xsl:if>\n"
"	   </xsl:for-each>\n"
"         </rp:fwd>\n"
"       </xsl:when>\n"
"       <xsl:when test=\"name(.) = 'http://schemas.xmlsoap.org/rp:rev'\">\n"
"         <rp:rev>\n"
"	   <rp:via><xsl:value-of select=\"$newrev\" /></rp:via>\n"
"	   <xsl:copy-of select=\"via\" />\n"
"         </rp:rev>\n"
"       </xsl:when>\n"
"       <xsl:otherwise>\n"
"         <xsl:copy-of select=\".\" />\n"
"       </xsl:otherwise>\n"
"     </xsl:choose>\n"
"   </xsl:for-each>\n"
"  </xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* wsrp_error.xsl */

static const char *xsl9[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: wsrp_error.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"    xmlns:SOAP=\"http://schemas.xmlsoap.org/soap/envelope/\"\n"
"    xmlns:n0=\"http://schemas.xmlsoap.org/soap/envelope/\"\n"
"    xmlns:rp=\"http://schemas.xmlsoap.org/rp\">\n"
"<xsl:output method=\"xml\" indent=\"yes\" omit-xml-declaration=\"yes\"/>\n"
"<xsl:param name=\"newrev\" />\n"
"  <xsl:template match=\"/\">\n"
"    <xsl:apply-templates select=\"*\" />\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Envelope\">\n"
"   <SOAP:Envelope>\n"
"    <xsl:apply-templates select=\"*\" />\n"
"   </SOAP:Envelope>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Body\">\n"
"   <SOAP:Body>\n"
"     <SOAP:Fault>\n"
"       <SOAP:faultcode>n0:Client</SOAP:faultcode>\n"
"       <SOAP:faultstring>Client Error</SOAP:faultstring>\n"
"       <SOAP:faultactor></SOAP:faultactor>\n"
"     </SOAP:Fault>\n"
"   </SOAP:Body>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"SOAP:Header\">\n"
"   <SOAP:Header>\n"
"   <xsl:choose>\n"
"   <xsl:when test=\"rp:path\">\n"
"   <xsl:for-each select=\"*\">\n"
"       <xsl:if test=\"name(.) = 'http://schemas.xmlsoap.org/rp:path'\">\n"
"         <rp:path>\n"
"	   <xsl:apply-templates select=\".\" />\n"
"	   <rp:fault>\n"
"	     <rp:code><xsl:value-of select=\"$code\" /></rp:code>\n"
"	     <rp:reason><xsl:value-of select=\"$reason\" /></rp:reason>\n"
"	     <rp:endpoint><xsl:value-of select=\"$endpoint\" /></rp:endpoint>\n"
"           </rp:fault>\n"
"         </rp:path>\n"
"       </xsl:if>\n"
"   </xsl:for-each>\n"
"   </xsl:when>\n"
"   <xsl:otherwise>\n"
"         <rp:path>\n"
"           <rp:fwd>\n"
"  	     <rp:via />\n"
"           </rp:fwd>\n"
"	   <rp:rev>\n"
"	   </rp:rev>\n"
"	   <rp:fault>\n"
"	     <rp:code><xsl:value-of select=\"$code\" /></rp:code>\n"
"	     <rp:reason><xsl:value-of select=\"$reason\" /></rp:reason>\n"
"	     <rp:endpoint><xsl:value-of select=\"$endpoint\" /></rp:endpoint>\n"
"           </rp:fault>\n"
"         </rp:path>\n"
"   </xsl:otherwise>\n"
"   </xsl:choose>\n"
"   </SOAP:Header>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"rp:path\">\n"
"   <xsl:copy-of select=\"@*\" />\n"
"   <xsl:for-each select=\"*\">\n"
"     <xsl:choose>\n"
"       <xsl:when test=\"name(.) = 'http://schemas.xmlsoap.org/rp:fwd'\">\n"
"         <rp:fwd>\n"
"	   <rp:via />\n"
"         </rp:fwd>\n"
"       </xsl:when>\n"
"       <xsl:when test=\"name(.) = 'http://schemas.xmlsoap.org/rp:rev'\">\n"
"         <rp:rev>\n"
"         </rp:rev>\n"
"       </xsl:when>\n"
"       <xsl:when test=\"name(.) = 'http://schemas.xmlsoap.org/rp:id'\">\n"
"         <rp:relatesTo><xsl:value-of select=\".\" /></rp:relatesTo>\n"
"         <rp:id>uuid:<xsl:value-of select=\"$id\" /></rp:id>\n"
"       </xsl:when>\n"
"     </xsl:choose>\n"
"   </xsl:for-each>\n"
"  </xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* soap_sch.xsl */

static const char *xsl10[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: soap_sch.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"    xmlns:enc=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
"    xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"\n"
"    xmlns=\"http://www.w3.org/2001/XMLSchema\"\n"
"    xmlns:xs=\"http://www.w3.org/2001/XMLSchema\"\n"
"    xmlns:vi=\"http://www.openlinksw.com/wsdl/\"\n"
"    xmlns:vs=\"http://www.openlinksw.com/virtuoso/soap\"\n"
"    >\n"
"  <xsl:output method=\"xml\" omit-xml-declaration=\"yes\" indent=\"yes\" encoding=\"UTF-8\"/>\n"
"  <xsl:param name=\"type_name\" select=\"''\"/>\n"
"  <xsl:param name=\"udt_struct\" select=\"0\"/>\n"
"  <xsl:param name=\"target_Namespace\" select=\"''\"/>\n"
"  <xsl:param name=\"any_type\" select=\"0\"/>\n"
"  <xsl:template match=\"/\">\n"
"    <xsl:apply-templates select=\"*\"/>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"schema\">\n"
"    <xsl:apply-templates select=\"*\"/>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"complexType\">\n"
"    <complexType>\n"
"      <xsl:choose>\n"
"        <xsl:when test=\"@name != ''\">\n"
"          <xsl:attribute name=\"name\"><xsl:value-of select=\"@name\"/></xsl:attribute>\n"
"        </xsl:when>\n"
"        <xsl:otherwise>\n"
"          <xsl:attribute name=\"name\"><xsl:value-of select=\"$type_name\"/></xsl:attribute>\n"
"        </xsl:otherwise>\n"
"      </xsl:choose>\n"
"      <!-- keep the targetNamespace -->\n"
"      <xsl:attribute name=\"targetNamespace\"><xsl:value-of select=\"@targetNamespace\"/></xsl:attribute>\n"
"      <xsl:choose>\n"
"        <xsl:when test=\"not boolean ($udt_struct) and (count (child::*/child::*/sequence/element) &lt;= 1 or starts-with(@name,'ArrayOf') or count (child::*/element) &lt;= 1)\">\n"
"          <xsl:apply-templates select=\"complexContent|simpleContent\">\n"
"            <xsl:with-param name=\"min\">0</xsl:with-param>\n"
"          </xsl:apply-templates>\n"
"        </xsl:when>\n"
"        <xsl:otherwise>\n"
"          <xsl:apply-templates select=\"complexContent|simpleContent\">\n"
"            <xsl:with-param name=\"min\">1</xsl:with-param>\n"
"          </xsl:apply-templates>\n"
"        </xsl:otherwise>\n"
"      </xsl:choose>\n"
"      <xsl:apply-templates select=\"group\">\n"
"        <xsl:with-param name=\"min\">1</xsl:with-param>\n"
"      </xsl:apply-templates>\n"
"      <xsl:choose>\n"
"        <xsl:when test=\"count (sequence/element) &lt;= 1 and not boolean ($udt_struct)\">\n"
"          <xsl:apply-templates select=\"sequence\">\n"
"            <xsl:with-param name=\"min\">0</xsl:with-param>\n"
"            <xsl:with-param name=\"cmpc\">1</xsl:with-param>\n"
"            <xsl:with-param name=\"attr\">\n"
"              <xsl:copy-of select=\"attribute\"/>\n"
"            </xsl:with-param>\n"
"            <xsl:with-param name=\"ext\">\n"
"              <xsl:value-of select=\"count(attribute)\"/>\n"
"            </xsl:with-param>\n"
"          </xsl:apply-templates>\n"
"        </xsl:when>\n"
"        <xsl:otherwise>\n"
"          <xsl:apply-templates select=\"sequence\">\n"
"            <xsl:with-param name=\"min\">1</xsl:with-param>\n"
"            <xsl:with-param name=\"cmpc\">1</xsl:with-param>\n"
"            <xsl:with-param name=\"attr\">\n"
"              <xsl:copy-of select=\"attribute|anyAttribute\"/>\n"
"            </xsl:with-param>\n"
"            <xsl:with-param name=\"ext\">\n"
"              <xsl:value-of select=\"count(attribute|anyAttribute)\"/>\n"
"            </xsl:with-param>\n"
"          </xsl:apply-templates>\n"
"        </xsl:otherwise>\n"
"      </xsl:choose>\n"
"      <xsl:if test=\"choice\">\n"
"        <complexContent>\n"
"	  <restriction base=\"enc:Struct\">\n"
"	    <xsl:attribute name=\"choice\">1</xsl:attribute>\n"
"            <xsl:apply-templates select=\"choice\">\n"
"              <xsl:with-param name=\"min\">1</xsl:with-param>\n"
"            </xsl:apply-templates>\n"
"	  </restriction>\n"
"	</complexContent>\n"
"      </xsl:if>\n"
"      <xsl:apply-templates select=\"all\">\n"
"        <xsl:with-param name=\"min\">1</xsl:with-param>\n"
"      </xsl:apply-templates>\n"
"      <xsl:if test=\"attribute and not local-name(*) != 'attribute'\">\n"
"	  <simpleContent>\n"
"	      <extension base=\"string\">\n"
"		  <xsl:apply-templates select=\"attribute\" />\n"
"	      </extension>\n"
"	  </simpleContent>\n"
"      </xsl:if>\n"
"    </complexType>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"complexContent\">\n"
"    <complexContent>\n"
"      <xsl:apply-templates select=\"restriction\">\n"
"        <xsl:with-param name=\"min\">\n"
"          <xsl:value-of select=\"$min\"/>\n"
"        </xsl:with-param>\n"
"      </xsl:apply-templates>\n"
"      <xsl:apply-templates select=\"extension\">\n"
"        <xsl:with-param name=\"min\">\n"
"          <xsl:value-of select=\"$min\"/>\n"
"        </xsl:with-param>\n"
"      </xsl:apply-templates>\n"
"      <xsl:if test=\"count(sequence)>0\">\n"
"        <sequence error=\"The 'sequence' element is not supported as child of complexContent\"/>\n"
"      </xsl:if>\n"
"    </complexContent>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"any\">\n"
"    <element type=\"__XML__\" name=\"\" minOccurs=\"0\" maxOccurs=\"unbounded\" />\n"
"    <!--any error=\"The 'any' element is not supported\"/-->\n"
"  </xsl:template>\n"
"  <xsl:template match=\"simpleContent\">\n"
"    <xsl:copy-of select=\".\"/>\n"
"    <!--complexContent>\n"
"  <xsl:apply-templates select=\"restriction\">\n"
"     <xsl:with-param name=\"min\"><xsl:value-of select=\"$min\" /></xsl:with-param>\n"
"  </xsl:apply-templates>\n"
"  <xsl:apply-templates select=\"extension\">\n"
"     <xsl:with-param name=\"min\"><xsl:value-of select=\"$min\" /></xsl:with-param>\n"
"  </xsl:apply-templates>\n"
"</complexContent-->\n"
"  </xsl:template>\n"
"  <xsl:template match=\"extension|restriction\" mode=\"simple\">\n"
"  <xsl:copy>\n"
"    <xsl:copy-of select=\"@*\" />\n"
"    <xsl:attribute name=\"enumeration\"><xsl:value-of select=\"boolean(enumeration)\" /></xsl:attribute>\n"
"    <xsl:copy-of select=\"*\" />\n"
"  </xsl:copy>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"*\" mode=\"simple\">\n"
"  </xsl:template>\n"
"  <xsl:template match=\"simpleType\">\n"
"    <complexType>\n"
"      <xsl:attribute name=\"name\"><xsl:value-of select=\"@name\"/></xsl:attribute>\n"
"      <simpleContent>\n"
"        <xsl:apply-templates select=\"extension|restriction\" mode=\"simple\" />\n"
"      </simpleContent>\n"
"    </complexType>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"group\">\n"
"    <group error=\"The 'group' element is not supported\"/>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"choice\">\n"
"    <xsl:choose>\n"
"      <xsl:when test=\"parent::sequence\">\n"
"        <xsl:apply-templates select=\"element|any\" />\n"
"      </xsl:when>\n"
"      <xsl:otherwise>\n"
"        <sequence>\n"
"	  <xsl:apply-templates select=\"element|any\" />\n"
"        <!--choice error=\"The 'choice' element is not supported\"/-->\n"
"	</sequence>\n"
"      </xsl:otherwise>\n"
"    </xsl:choose>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"restriction\">\n"
"    <xsl:choose>\n"
"      <xsl:when test=\"count(sequence/element|attribute)>0\">\n"
"        <restriction base=\"enc:Struct\">\n"
"          <xsl:if test=\"$min!=1\">\n"
"            <xsl:attribute name=\"base\"><xsl:value-of select=\"@base\"/></xsl:attribute>\n"
"          </xsl:if>\n"
"          <xsl:choose>\n"
"            <xsl:when test=\"sequence/element\">\n"
"              <xsl:apply-templates select=\"sequence\">\n"
"                <xsl:with-param name=\"min\">\n"
"                  <xsl:value-of select=\"$min\"/>\n"
"                </xsl:with-param>\n"
"              </xsl:apply-templates>\n"
"            </xsl:when>\n"
"            <xsl:when test=\"attribute/@arrayType\">\n"
"              <sequence>\n"
"                <element name=\"item\" type=\"\" minOccurs=\"0\" maxOccurs=\"unbounded\">\n"
"                  <xsl:attribute name=\"type\"><xsl:value-of select=\"normalize-space(translate(attribute/@arrayType,'[]','  '))\"/></xsl:attribute>\n"
"                </element>\n"
"              </sequence>\n"
"            </xsl:when>\n"
"          </xsl:choose>\n"
"          <xsl:if test=\"attribute/@arrayType\">\n"
"	      <attribute ref=\"enc:arrayType\" wsdl:arrayType=\"\">\n"
"		  <xsl:attribute name=\"wsdl:arrayType\"><xsl:value-of select=\"attribute/@arrayType\"/></xsl:attribute>\n"
"	      </attribute>\n"
"          </xsl:if>\n"
"          <xsl:if test=\"not(attribute/@arrayType) and $min=0 and @base\">\n"
"            <attribute ref=\"enc:arrayType\">\n"
"              <xsl:attribute name=\"wsdl:arrayType\"><xsl:value-of select=\"sequence/element[1]/@type\"/><xsl:text>[]</xsl:text></xsl:attribute>\n"
"            </attribute>\n"
"          </xsl:if>\n"
"        </restriction>\n"
"      </xsl:when>\n"
"      <xsl:otherwise>\n"
"        <xsl:if test=\"@base\">\n"
"          <restriction base=\"enc:Struct\">\n"
"            <sequence>\n"
"              <element name=\"item\" type=\"\">\n"
"                <xsl:attribute name=\"type\"><xsl:value-of select=\"@base\"/></xsl:attribute>\n"
"              </element>\n"
"            </sequence>\n"
"          </restriction>\n"
"        </xsl:if>\n"
"        <xsl:if test=\"not (@base)\">\n"
"          <sequence>\n"
"            <element error=\"No sequence/element defined or base attribute supplied\"/>\n"
"          </sequence>\n"
"        </xsl:if>\n"
"      </xsl:otherwise>\n"
"    </xsl:choose>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"extension\">\n"
"    <xsl:choose>\n"
"	<xsl:when test=\"not boolean ($udt_struct)\">\n"
"	  <xsl:variable name=\"ext\" select=\"vs:getExtension (@base)\"/>\n"
"	  <xsl:if test=\"not $ext//xs:element or not xs:sequence/xs:element\">\n"
"             <extension error=\"The 'extension' element is not supported\"/>\n"
"	 </xsl:if>\n"
"	  <restriction base=\"enc:Struct\">\n"
"	      <sequence>\n"
"		  <xsl:apply-templates select=\"$ext//xs:element\">\n"
"		      <xsl:with-param name=\"namespace\" select=\"concat($ext/*/@targetNamespace,':',$ext/*/@name)\"/>\n"
"		  </xsl:apply-templates>\n"
"		  <xsl:apply-templates select=\"xs:sequence/*\"/>\n"
"	      </sequence>\n"
"	  </restriction>\n"
"      </xsl:when>\n"
"      <xsl:otherwise>\n"
"        <xsl:copy>\n"
"          <xsl:copy-of select=\"@*\"/>\n"
"          <xsl:apply-templates select=\"node()\">\n"
"            <xsl:with-param name=\"min\">1</xsl:with-param>\n"
"          </xsl:apply-templates>\n"
"        </xsl:copy>\n"
"      </xsl:otherwise>\n"
"    </xsl:choose>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"attribute\">\n"
"      <xsl:choose>\n"
"	  <xsl:when test=\"@arrayType\">\n"
"	      <attribute ref=\"enc:arrayType\" wsdl:arrayType=\"\">\n"
"		  <xsl:attribute name=\"wsdl:arrayType\"><xsl:value-of select=\"@arrayType\"/></xsl:attribute>\n"
"	      </attribute>\n"
"	  </xsl:when>\n"
"	  <xsl:when test=\"@ref\">\n"
"	      <xsl:copy>\n"
"		  <xsl:attribute name=\"name\"><xsl:value-of select=\"vi:split-name(@ref, 1)\"/></xsl:attribute>\n"
"		  <xsl:attribute name=\"type\">string</xsl:attribute>\n"
"	      </xsl:copy>\n"
"	  </xsl:when>\n"
"	  <xsl:when test=\"@type and @name\">\n"
"	      <xsl:copy-of select=\".|@*\"/>\n"
"	  </xsl:when>\n"
"      </xsl:choose>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"sequence\">\n"
"    <xsl:param name=\"min\" select=\"0\"/>\n"
"    <xsl:param name=\"cmpc\" select=\"''\"/>\n"
"    <xsl:param name=\"ext\" select=\"0\"/>\n"
"    <xsl:param name=\"attr\" select=\"''\"/>\n"
"    <xsl:if test=\"$cmpc!=''\">\n"
"      <xsl:if test=\"$ext='0'\">\n"
"        <complexContent>\n"
"          <restriction base=\"enc:Struct\">\n"
"            <xsl:attribute name=\"base\"><xsl:choose><xsl:when test=\"count(element) > 1 or boolean($udt_struct) or choice\">http://schemas.xmlsoap.org/soap/encoding/:Struct</xsl:when><xsl:otherwise>http://schemas.xmlsoap.org/soap/encoding/:Array</xsl:otherwise></xsl:choose></xsl:attribute>\n"
"	    <xsl:if test=\"choice\">\n"
"	      <xsl:attribute name=\"choice\">1</xsl:attribute>\n"
"	    </xsl:if>\n"
"            <sequence>\n"
"              <xsl:apply-templates select=\"element|any|choice\">\n"
"                <xsl:with-param name=\"min\">\n"
"                  <xsl:value-of select=\"$min\"/>\n"
"                </xsl:with-param>\n"
"              </xsl:apply-templates>\n"
"            </sequence>\n"
"          </restriction>\n"
"        </complexContent>\n"
"      </xsl:if>\n"
"      <xsl:if test=\"$ext!='0'\">\n"
"        <complexContent>\n"
"          <extension base=\"enc:Struct\">\n"
"            <sequence>\n"
"              <xsl:apply-templates select=\"element|any|choice\">\n"
"                <xsl:with-param name=\"min\">\n"
"                  <xsl:value-of select=\"$min\"/>\n"
"                </xsl:with-param>\n"
"              </xsl:apply-templates>\n"
"            </sequence>\n"
"            <xsl:copy-of select=\"$attr\"/>\n"
"          </extension>\n"
"        </complexContent>\n"
"      </xsl:if>\n"
"    </xsl:if>\n"
"    <xsl:if test=\"$cmpc=''\">\n"
"      <sequence>\n"
"        <xsl:apply-templates select=\"element|any|choice\">\n"
"          <xsl:with-param name=\"min\">\n"
"            <xsl:value-of select=\"$min\"/>\n"
"          </xsl:with-param>\n"
"        </xsl:apply-templates>\n"
"      </sequence>\n"
"    </xsl:if>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"element\">\n"
"    <xsl:param name=\"min\" select=\"0\"/>\n"
"    <xsl:param name=\"namespace\" select=\"''\"/>\n"
"    <xsl:choose>\n"
"      <xsl:when test=\"complexType\">\n"
"        <element>\n"
"          <xsl:copy-of select=\"@*\"/>\n"
"	  <xsl:choose>\n"
"	  <xsl:when test=\"$any_type and complexType/sequence/any\" >\n"
"	  <xsl:attribute name=\"type\">__ANY__</xsl:attribute>\n"
"	  </xsl:when>\n"
"          <xsl:when test=\"complexType\">\n"
"            <xsl:choose>\n"
"              <xsl:when test=\"@targetNamespace != ''\">\n"
"                <xsl:attribute name=\"type\"><xsl:value-of select=\"@targetNamespace\"/>:elementType__<xsl:value-of select=\"@name\"/></xsl:attribute>\n"
"              </xsl:when>\n"
"              <xsl:otherwise>\n"
"                <xsl:attribute name=\"targetNamespace\"><xsl:value-of select=\"$target_Namespace\"/></xsl:attribute>\n"
"                <xsl:attribute name=\"type\"><xsl:value-of select=\"$target_Namespace\"/>:elementType__<xsl:value-of select=\"@name\"/></xsl:attribute>\n"
"              </xsl:otherwise>\n"
"            </xsl:choose>\n"
"          </xsl:when>\n"
"	  </xsl:choose>\n"
"        </element>\n"
"      </xsl:when>\n"
"      <xsl:when test=\"simpleType/restriction[@base]\">\n"
"        <element>\n"
"	    <xsl:copy-of select=\"@*\"/>\n"
"	    <xsl:attribute name=\"type\"><xsl:value-of select=\"simpleType/restriction/@base\"/></xsl:attribute>\n"
"        </element>\n"
"      </xsl:when>\n"
"      <xsl:otherwise>\n"
"        <element>\n"
"	  <xsl:choose>\n"
"	    <xsl:when test=\"boolean (@ref)\">\n"
"	      <xsl:attribute name=\"ref\"><xsl:value-of select=\"@ref\"/></xsl:attribute>\n"
"	    </xsl:when>\n"
"	    <xsl:otherwise>\n"
"              <xsl:attribute name=\"name\"><xsl:value-of select=\"@name\"/></xsl:attribute>\n"
"	      <xsl:choose>\n"
"	        <xsl:when test=\"boolean(@type)\">\n"
"                  <xsl:attribute name=\"type\"><xsl:value-of select=\"@type\"/></xsl:attribute>\n"
"		</xsl:when>\n"
"		<xsl:otherwise>\n"
"                  <xsl:attribute name=\"type\">__ANY__</xsl:attribute>\n"
"		</xsl:otherwise>\n"
"	      </xsl:choose>\n"
"	    </xsl:otherwise>\n"
"	  </xsl:choose>\n"
"          <xsl:if test=\"@form\">\n"
"            <xsl:attribute name=\"form\"><xsl:value-of select=\"@form\"/></xsl:attribute>\n"
"	  </xsl:if>\n"
"	  <xsl:attribute name=\"nillable\"><xsl:value-of select=\"boolean(@nillable = 1 or @nillable = 'true')\"/></xsl:attribute>\n"
"	  <xsl:copy-of select=\"@minOccurs\"/>\n"
"	  <xsl:copy-of select=\"@maxOccurs\"/>\n"
"	  <xsl:if test=\"not @minOccurs\">\n"
"	      <xsl:choose>\n"
"		  <xsl:when test=\"parent::*[@minOccurs]\">\n"
"		      <xsl:copy-of select=\"parent::*/@minOccurs\"/>\n"
"		  </xsl:when>\n"
"		  <xsl:when test=\"ancestor::*[@base='http://schemas.xmlsoap.org/soap/encoding/:Array']\">\n"
"		      <xsl:attribute name=\"minOccurs\">0</xsl:attribute>\n"
"		  </xsl:when>\n"
"		  <xsl:otherwise>\n"
"		      <xsl:attribute name=\"minOccurs\">1</xsl:attribute>\n"
"		  </xsl:otherwise>\n"
"	      </xsl:choose>\n"
"	  </xsl:if>\n"
"	  <xsl:if test=\"not @maxOccurs\">\n"
"	      <xsl:choose>\n"
"		  <xsl:when test=\"parent::*[@maxOccurs]\">\n"
"		      <xsl:copy-of select=\"parent::*/@maxOccurs\"/>\n"
"		  </xsl:when>\n"
"		  <xsl:when test=\"ancestor::*[@base='http://schemas.xmlsoap.org/soap/encoding/:Array']\">\n"
"		      <xsl:attribute name=\"maxOccurs\">unbounded</xsl:attribute>\n"
"		  </xsl:when>\n"
"		  <xsl:otherwise>\n"
"		      <xsl:attribute name=\"maxOccurs\">1</xsl:attribute>\n"
"		  </xsl:otherwise>\n"
"	      </xsl:choose>\n"
"	  </xsl:if>\n"
"          <xsl:if test=\"./child::*\">\n"
"	      <xsl:attribute name=\"error\">The definitions cannot be implied</xsl:attribute>\n"
"	  </xsl:if>\n"
"	  <xsl:if test=\"$namespace != ''\">\n"
"	      <xsl:attribute name=\"namespace\"><xsl:value-of select=\"$namespace\"/></xsl:attribute>\n"
"	  </xsl:if>\n"
"        </element>\n"
"      </xsl:otherwise>\n"
"    </xsl:choose>\n"
"  </xsl:template>\n"
"  <xsl:template match=\"all\">\n"
"    <complexContent>\n"
"      <restriction base=\"enc:Struct\">\n"
"        <sequence>\n"
"          <xsl:apply-templates select=\"element|any\">\n"
"            <xsl:with-param name=\"min\">\n"
"              <xsl:value-of select=\"$min\"/>\n"
"            </xsl:with-param>\n"
"          </xsl:apply-templates>\n"
"        </sequence>\n"
"      </restriction>\n"
"    </complexContent>\n"
"  </xsl:template>\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* soap_import_sch.xsl */

static const char *xsl11[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: soap_import_sch.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"	xmlns:types=\"http://soapinterop.org/attachments/xsd\"\n"
"	xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n"
"	xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"\n"
"	xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"\n"
"	xmlns:dime=\"http://schemas.xmlsoap.org/ws/2002/04/dime/wsdl/\"\n"
"	xmlns:content=\"http://schemas.xmlsoap.org/ws/2002/04/content-type/\"\n"
"	xmlns:ref=\"http://schemas.xmlsoap.org/ws/2002/04/reference/\">\n"
"  <xsl:output method=\"xml\" indent=\"yes\" omit-xml-declaration=\"yes\"/>\n"
"\n"
"  <xsl:param name=\"tns\" select=\"//xsd:schema/@targetNamespace\"/>\n"
"\n"
"  <xsl:template match=\"/\">\n"
"    <xsl:apply-templates select=\"*\" />\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"xsd:schema\">\n"
"      <xsl:apply-templates select=\"xsd:complexType[not xsd:complexContent/xsd:extension]|xsd:simpleType|xsd:element|xsd:attribute\" />\n"
"      <xsl:apply-templates select=\"xsd:complexType[xsd:complexContent/xsd:extension]\" />\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"xsd:complexType|xsd:simpleType|xsd:element|xsd:attribute\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\"/>\n"
"      <xsl:attribute name=\"targetNamespace\"><xsl:value-of select=\"$tns\"/></xsl:attribute>\n"
"      <xsl:apply-templates select=\"*\" mode=\"inside_type\" />\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"xsd:annotation[not xsd:appinfo]|xsd:documentation\" mode=\"inside_type\"/>\n"
"\n"
"  <xsl:template match=\"*\" mode=\"inside_type\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:apply-templates select=\"*\" mode=\"inside_type\" />\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"\n"
"  <xsl:template match=\"*\"/>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* odbccat.sql */

static const char *proc180 = 
"create procedure\n"
"sql_normalize_qon (in dsn varchar, inout infos any, inout qual varchar, inout owner varchar, inout name varchar)\n"
"{\n"
"\n"
"\n"
"if (sql_normalize_qon_oracle_oracle (dsn, infos, qual, owner, name)) return;\n"
"if (sql_normalize_qon_oracle_msora (dsn, infos, qual, owner, name)) return;\n"
"if (sql_normalize_qon_infohub_dcsyb30 (dsn, infos, qual, owner, name)) return;\n"
"if (sql_normalize_qon_viaserv_opl (dsn, infos, qual, owner, name)) return;\n"
"\n"
"return;\n"
"}\n"
"--src odbccat.sql:22\n";

static const char *proc181 = 
"create procedure\n"
"sql_filter_qon (inout infos any, inout result any, in qual varchar, in owner varchar, in name varchar)\n"
"{\n"
"\n"
"declare filter any;\n"
"if (not isarray(result))\n"
"return;\n"
"\n"
"filter := NULL;\n"
"\n"
"if (sql_filter_qon_oracle_oracle (infos, filter, qual, owner, name)) goto foun;\n"
"\n"
"return;\n"
"foun:\n"
"\n"
"if (isarray(filter))\n"
"{\n"
"if (length (filter) > 0 and isstring (aref(filter, 0)))\n"
"aset (filter, 0, replace (replace (replace (aref(filter, 0), \'\\\\\', \'\\\\\\\\\'), \'%\', \'\\\\%\'), \'_\', \'\\\\_\'));\n"
"if (length (filter) > 1 and isstring (aref(filter, 1)))\n"
"aset (filter, 1, replace (replace (replace (aref(filter, 1), \'\\\\\', \'\\\\\\\\\'), \'%\', \'\\\\%\'), \'_\', \'\\\\_\'));\n"
"if (length (filter) > 2 and isstring (aref(filter, 2)))\n"
"aset (filter, 2, replace (replace (replace (aref(filter, 2), \'\\\\\', \'\\\\\\\\\'), \'%\', \'\\\\%\'), \'_\', \'\\\\_\'));\n"
"}\n"
"\n"
"if (isarray (filter))\n"
"{\n"
"declare inx integer;\n"
"declare result_out, res_row any;\n"
"inx := 0;\n"
"result_out := NULL;\n"
"while (inx < length (result))\n"
"{\n"
"res_row := aref_set_0 (result, inx);\n"
"\n"
"if (not ((length (filter) > 0 and isstring (aref (filter, 0)) and (aref (res_row, 0) not like aref (filter, 0))) or\n"
"(length (filter) > 1 and isstring (aref (filter, 1)) and (aref (res_row, 1) not like aref (filter, 1))) or\n"
"(length (filter) > 2 and isstring (aref (filter, 2)) and (aref (res_row, 2) not like aref (filter, 2)))))\n"
"{\n"
"\n"
"if (result_out is null)\n"
"result_out := vector (res_row);\n"
"else\n"
"result_out := vector_concat (result_out, vector (res_row));\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"result := result_out;\n"
"}\n"
"}\n"
"--src odbccat.sql:36\n";

static const char *proc182 = 
"create procedure\n"
"sql_columns (in dsn varchar, in qual varchar, in owner varchar, in name varchar, in col varchar)\n"
"{\n"
"declare result, infos any;\n"
"declare _qual, _owner, _name, _col varchar;\n"
"_qual := qual;\n"
"_owner := owner;\n"
"_name := name;\n"
"_col := col;\n"
"\n"
"infos := null;\n"
"whenever not found goto nf;\n"
"select deserialize (DS_CONN_STR) into infos from DB.DBA.SYS_DATA_SOURCE where DS_DSN = dsn;\n"
"\n"
"sql_normalize_qon (dsn, infos, qual, owner, name);\n"
"\n"
"\n"
"result := _sql_columns (dsn, qual,\n"
"sql_escape_meta_identifier (dsn, owner),\n"
"sql_escape_meta_identifier (dsn, name),\n"
"sql_escape_meta_identifier (dsn, col));\n"
"\n"
"sql_filter_qon (infos, result, _qual, _owner, _name);\n"
"\n"
"sql_columns_post_oracle_openlink (infos, result);\n"
"\n"
"return result;\n"
"nf:\n"
"signal (\'HZ000\', \'Bad DSN in sql_columns\', \'VD073\');\n"
"}\n"
"--src odbccat.sql:88\n";

static const char *proc183 = 
"create procedure\n"
"sql_tables (in dsn varchar, in qual varchar, in owner varchar, in name varchar, in typ varchar)\n"
"{\n"
"declare result, infos any;\n"
"declare _qual, _owner, _name, _typ varchar;\n"
"_qual := qual;\n"
"_owner := owner;\n"
"_name := name;\n"
"_typ := typ;\n"
"\n"
"infos := null;\n"
"whenever not found goto nf;\n"
"select deserialize (DS_CONN_STR) into infos from DB.DBA.SYS_DATA_SOURCE where DS_DSN = dsn;\n"
"\n"
"sql_normalize_qon (dsn, infos, qual, owner, name);\n"
"\n"
"if (1 = sql_tables_pre_infohub_dcsyb30 (infos, typ));\n"
"if (1 = sql_tables_pre_excel_drv (infos, typ));\n"
"\n"
"result := _sql_tables (dsn,\n"
"sql_escape_meta_identifier (dsn, qual),\n"
"sql_escape_meta_identifier (dsn, owner),\n"
"sql_escape_meta_identifier (dsn, name),\n"
"typ);\n"
"\n"
"sql_filter_qon (infos, result, _qual, _owner, _name);\n"
"\n"
"if (1 = sql_tables_post_infohub_dcsyb30 (infos, result, _typ));\n"
"if (1 = sql_tables_post_excel_drv (dsn, infos, result, _typ));\n"
"if (1 = sql_tables_post_progress_win_openlink (infos, result, _typ));\n"
"\n"
"return result;\n"
"nf:\n"
"signal (\'HZ000\', \'Bad DSN in sql_tables\', \'VD074\');\n"
"}\n"
"--src odbccat.sql:121\n";

static const char *proc184 = 
"create procedure\n"
"sql_primary_keys (in dsn varchar, in qual varchar, in owner varchar, in name varchar)\n"
"{\n"
"declare result, infos any;\n"
"declare _qual, _owner, _name varchar;\n"
"_qual := qual;\n"
"_owner := owner;\n"
"_name := name;\n"
"\n"
"infos := null;\n"
"whenever not found goto nf;\n"
"select deserialize (DS_CONN_STR) into infos from DB.DBA.SYS_DATA_SOURCE where DS_DSN = dsn;\n"
"\n"
"sql_normalize_qon (dsn, infos, qual, owner, name);\n"
"\n"
"\n"
"result := _sql_primary_keys (dsn, qual, owner, name);\n"
"\n"
"sql_filter_qon (infos, result, _qual, _owner, _name);\n"
"\n"
"\n"
"return result;\n"
"nf:\n"
"signal (\'HZ000\', \'Bad DSN in sql_primary_keys\', \'VD075\');\n"
"}\n"
"--src odbccat.sql:159\n";

static const char *proc185 = 
"create procedure\n"
"sql_statistics (in dsn varchar, in qual varchar, in owner varchar, in name varchar, in uniqu integer, in acc integer)\n"
"{\n"
"declare result, infos any;\n"
"declare _qual, _owner, _name varchar;\n"
"declare _uniqu, _acc integer;\n"
"_qual := qual;\n"
"_owner := owner;\n"
"_name := name;\n"
"_uniqu := uniqu;\n"
"_acc := acc;\n"
"\n"
"infos := null;\n"
"whenever not found goto nf;\n"
"select deserialize (DS_CONN_STR) into infos from DB.DBA.SYS_DATA_SOURCE where DS_DSN = dsn;\n"
"\n"
"sql_normalize_qon (dsn, infos, qual, owner, name);\n"
"\n"
"\n"
"result := _sql_statistics (dsn, qual, owner, name, uniqu, acc);\n"
"\n"
"sql_filter_qon (infos, result, _qual, _owner, _name);\n"
"\n"
"\n"
"return result;\n"
"nf:\n"
"signal (\'HZ000\', \'Bad DSN in sql_statistics\', \'VD076\');\n"
"}\n"
"--src odbccat.sql:187\n";

static const char *proc186 = 
"create procedure\n"
"sql_procedures (in dsn varchar, in qual varchar, in owner varchar, in name varchar)\n"
"{\n"
"declare result, infos any;\n"
"declare _qual, _owner, _name varchar;\n"
"_qual := qual;\n"
"_owner := owner;\n"
"_name := name;\n"
"\n"
"infos := null;\n"
"whenever not found goto nf;\n"
"select deserialize (DS_CONN_STR) into infos from DB.DBA.SYS_DATA_SOURCE where DS_DSN = dsn;\n"
"\n"
"sql_normalize_qon (dsn, infos, qual, owner, name);\n"
"\n"
"\n"
"result := _sql_procedures (dsn, qual,\n"
"sql_escape_meta_identifier (dsn, owner),\n"
"sql_escape_meta_identifier (dsn, name));\n"
"\n"
"sql_filter_qon (infos, result, _qual, _owner, _name);\n"
"\n"
"\n"
"return result;\n"
"nf:\n"
"signal (\'HZ000\', \'Bad DSN in sql_procedures\', \'VD077\');\n"
"}\n"
"--src odbccat.sql:218\n";

static const char *proc187 = 
"create procedure\n"
"sql_procedure_cols (in dsn varchar, in qual any, in owner any, in name varchar, in col varchar)\n"
"{\n"
"declare result, infos any;\n"
"declare _qual, _owner, _name, _col varchar;\n"
"_qual := qual;\n"
"_owner := owner;\n"
"_name := name;\n"
"_col := col;\n"
"\n"
"if (qual = 0) qual := \'\';\n"
"if (owner = 0) owner := \'\';\n"
"infos := null;\n"
"whenever not found goto nf;\n"
"select deserialize (DS_CONN_STR) into infos from DB.DBA.SYS_DATA_SOURCE where DS_DSN = dsn;\n"
"\n"
"sql_normalize_qon (dsn, infos, qual, owner, name);\n"
"\n"
"\n"
"result := _sql_procedure_columns (dsn, qual, owner, name, col);\n"
"\n"
"sql_filter_qon (infos, result, _qual, _owner, _name);\n"
"\n"
"\n"
"return result;\n"
"nf:\n"
"signal (\'HZ000\', \'Bad DSN in sql_procedures\', \'VD077\');\n"
"}\n"
"--src odbccat.sql:248\n";

static const char *proc188 = 
"create procedure __virt_sql_qon_is_oracle_oracle (inout infos any,\n"
"inout qual varchar, inout owner varchar, inout name varchar)\n"
"{\n"
"declare dbms_name, driver_name, driver_ver varchar;\n"
"declare ver_arr any;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"driver_ver := upper (get_keyword (7, infos, \'\'));\n"
"\n"
"if (upper (dbms_name) like \'%ORACLE%\' and (driver_name like \'SQOCI%.DLL\' or driver_name like \'SQORA32%.DLL\'))\n"
"{\n"
"if (isstring (driver_ver))\n"
"{\n"
"ver_arr := split_and_decode (driver_ver,0,\'\\0\\0.\');\n"
"if (isarray (ver_arr) and length (ver_arr) >= 3)\n"
"{\n"
"declare v1, v2, v3 integer;\n"
"v1 := atoi (ver_arr [0]);\n"
"v2 := atoi (ver_arr [1]);\n"
"v3 := atoi (ver_arr [2]);\n"
"if (v1 > 8)\n"
"goto check_special_chars;\n"
"if (v1 = 8)\n"
"{\n"
"if (v2 > 1)\n"
"goto check_special_chars;\n"
"if (v2 = 1)\n"
"{\n"
"if (v3 >= 705)\n"
"goto check_special_chars;\n"
"}\n"
"}\n"
"}\n"
"}\n"
"return 1;\n"
"}\n"
"else\n"
"return 0;\n"
"\n"
"check_special_chars:\n"
"if (isstring (qual) and (strstr (qual, \'\\\\_\') or strstr (qual, \'\\\\%\')))\n"
"return 1;\n"
"if (isstring (owner) and (strstr (owner, \'\\\\_\') or strstr (owner, \'\\\\%\')))\n"
"return 1;\n"
"if (isstring (name) and (strstr (name, \'\\\\_\') or strstr (name, \'\\\\%\')))\n"
"return 1;\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:284\n";

static const char *proc189 = 
"create procedure\n"
"sql_normalize_qon_oracle_oracle (in dsn varchar, inout infos any, inout qual varchar, inout owner varchar, inout name varchar)\n"
"{\n"
"if (__virt_sql_qon_is_oracle_oracle (infos, qual, owner, name) > 0)\n"
"{\n"
"qual := NULL;\n"
"\n"
"if (name is not null)\n"
"name := NULL;\n"
"else if (owner is not null)\n"
"owner := NULL;\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:334\n";

static const char *proc190 = 
"create procedure\n"
"sql_filter_qon_oracle_oracle (inout infos any, inout filter any, in qual varchar, in owner varchar, in name varchar)\n"
"{\n"
"filter := NULL;\n"
"if (__virt_sql_qon_is_oracle_oracle (infos, qual, owner, name) > 0)\n"
"{\n"
"filter := vector (qual, owner, name);\n"
"\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:351\n";

static const char *proc191 = 
"create procedure\n"
"sql_normalize_qon_oracle_msora (in dsn varchar, inout infos any, inout qual varchar, inout owner varchar, inout name varchar)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (upper (dbms_name) like \'%ORACLE%\' and upper (driver_name) like \'MSORCL32.DLL\')\n"
"{\n"
"qual := NULL;\n"
"if (isstring (owner) and length (owner) > 0) owner := concat (\'\"\', owner, \'\"\');\n"
"if (isstring (name) and length (name) > 0) name := concat (\'\"\', name, \'\"\');\n"
"\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:368\n";

static const char *proc192 = 
"create procedure\n"
"sql_normalize_qon_infohub_dcsyb30 (in dsn varchar, inout infos any, inout qual varchar, inout owner varchar, inout name varchar)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (dbms_name like \'%INFOHUB%\' and driver_name like \'DCSYB30.DLL\')\n"
"{\n"
"\n"
"vd_autocommit (dsn, 1);\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:394\n";

static const char *proc193 = 
"create procedure\n"
"sql_tables_pre_infohub_dcsyb30 (inout infos any, inout typ varchar)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (dbms_name like \'%INFOHUB%\' and driver_name like \'DCSYB30.DLL\')\n"
"{\n"
"\n"
"typ := NULL;\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:411\n";

static const char *proc194 = 
"create procedure\n"
"sql_tables_post_infohub_dcsyb30 (inout infos any, inout result any, inout typ varchar)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (dbms_name like \'%INFOHUB%\' and driver_name like \'DCSYB30.DLL\')\n"
"{\n"
"\n"
"declare broken_typ any;\n"
"declare inx, inx1, is_in integer;\n"
"declare result_out, res_row any;\n"
"\n"
"if (0 = isstring (typ) or length (typ) < 1)\n"
"return 1;\n"
"broken_typ := split_and_decode (typ, 1, \'\\0\'\',\');\n"
"\n"
"inx := 0;\n"
"result_out := NULL;\n"
"\n"
"while (inx < length (result))\n"
"{\n"
"res_row := aref_set_0 (result, inx);\n"
"inx1 := 0;\n"
"is_in := 0;\n"
"\n"
"\n"
"while (inx1 < length (broken_typ))\n"
"{\n"
"\n"
"if (upper (aref (res_row, 3)) like trim (aref (broken_typ, inx1)))\n"
"{\n"
"is_in := 1;\n"
"inx1 := length (broken_typ);\n"
"}\n"
"inx1 := inx1 + 1;\n"
"}\n"
"if (is_in)\n"
"{\n"
"\n"
"if (result_out is null)\n"
"result_out := vector (res_row);\n"
"else\n"
"result_out := vector_concat (result_out, vector (res_row));\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"result := result_out;\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:429\n";

static const char *proc195 = 
"create procedure sql_columns_post_oracle_openlink (inout infos any, inout result any)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (upper (dbms_name) like \'%ORACLE%\' and (driver_name like \'OLOD3032.DLL\' or driver_name like \'OPLODBC.SO%\'))\n"
"{\n"
"\n"
"declare row_inx integer;\n"
"row_inx := 0;\n"
"while (row_inx < length (result))\n"
"{\n"
"declare row_data any;\n"
"declare data_type integer;\n"
"declare type_name varchar;\n"
"\n"
"row_data := aref (result, row_inx);\n"
"data_type := cast (aref (row_data, 4) as integer);\n"
"type_name := cast (aref (row_data, 5) as varchar);\n"
"if (data_type = 12 and type_name = \'FLOAT\')\n"
"{\n"
"\n"
"aset (row_data, 4, 8);\n"
"aset (result, row_inx, row_data);\n"
"}\n"
"row_inx := row_inx + 1;\n"
"}\n"
"\n"
"}\n"
"}\n"
"--src odbccat.sql:489\n";

static const char *proc196 = 
"create procedure\n"
"sql_tables_post_progress_win_openlink (inout infos any, inout result any, inout typ varchar)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (dbms_name like \'%PROGRESS%\' and driver_name like \'OLOD4032.DLL\')\n"
"{\n"
"\n"
"declare broken_typ any;\n"
"declare inx, inx1, is_in integer;\n"
"declare result_out, res_row any;\n"
"\n"
"if (0 = isstring (typ) or length (typ) < 1)\n"
"return 1;\n"
"broken_typ := split_and_decode (typ, 1, \'\\0\'\',\');\n"
"\n"
"inx := 0;\n"
"result_out := NULL;\n"
"\n"
"while (inx < length (result))\n"
"{\n"
"res_row := aref_set_0 (result, inx);\n"
"inx1 := 0;\n"
"is_in := 0;\n"
"\n"
"\n"
"while (inx1 < length (broken_typ))\n"
"{\n"
"\n"
"if (upper (aref (res_row, 3)) like trim (aref (broken_typ, inx1)))\n"
"{\n"
"is_in := 1;\n"
"inx1 := length (broken_typ);\n"
"}\n"
"inx1 := inx1 + 1;\n"
"}\n"
"if (is_in)\n"
"{\n"
"\n"
"if (result_out is null)\n"
"result_out := vector (res_row);\n"
"else\n"
"result_out := vector_concat (result_out, vector (res_row));\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"result := result_out;\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:526\n";

static const char *proc197 = 
"create procedure\n"
"sql_tables_post_excel_drv (in dsn varchar, inout infos any, inout result any, inout typ varchar)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (dbms_name like \'%EXCEL%\' and driver_name like \'ODBCJT32.DLL\')\n"
"{\n"
"\n"
"declare broken_typ any;\n"
"declare inx, inx1, is_in integer;\n"
"declare result_out, res_row any;\n"
"\n"
"if (0 = isstring (typ) or length (typ) < 1)\n"
"return 1;\n"
"broken_typ := split_and_decode (typ, 1, \'\\0\'\',\');\n"
"\n"
"inx := 0;\n"
"result_out := NULL;\n"
"\n"
"while (inx < length (result))\n"
"{\n"
"res_row := aref_set_0 (result, inx);\n"
"inx1 := 0;\n"
"is_in := 0;\n"
"\n"
"\n"
"while (inx1 < length (broken_typ))\n"
"{\n"
"\n"
"if (upper (aref (res_row, 3)) like trim (aref (broken_typ, inx1)))\n"
"{\n"
"is_in := 1;\n"
"inx1 := length (broken_typ);\n"
"}\n"
"inx1 := inx1 + 1;\n"
"}\n"
"if (is_in)\n"
"{\n"
"\n"
"declare cols any;\n"
"cols := sql_columns (dsn, null, null, aref (res_row, 2), null);\n"
"if (cols is not null and length (cols) > 0)\n"
"{\n"
"if (result_out is null)\n"
"result_out := vector (res_row);\n"
"else\n"
"result_out := vector_concat (result_out, vector (res_row));\n"
"}\n"
"}\n"
"inx := inx + 1;\n"
"}\n"
"result := result_out;\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:586\n";

static const char *proc198 = 
"create procedure\n"
"sql_tables_pre_excel_drv (inout infos any, inout typ varchar)\n"
"{\n"
"declare dbms_name, driver_name varchar;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"\n"
"if (dbms_name like \'%EXCEL%\' and driver_name like \'ODBCJT32.DLL\')\n"
"{\n"
"typ := NULL;\n"
"return 1;\n"
"}\n"
"\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:647\n";

static const char *proc199 = 
"create procedure\n"
"sql_normalize_qon_viaserv_opl (in dsn varchar, inout infos any, inout qual varchar, inout owner varchar, inout name varchar)\n"
"{\n"
"declare dbms_name, driver_name, driver_ver varchar;\n"
"declare ver_arr any;\n"
"dbms_name := upper (get_keyword (17, infos, \'\'));\n"
"driver_name := upper (get_keyword (6, infos, \'\'));\n"
"driver_ver := upper (get_keyword (7, infos, \'\'));\n"
"\n"
"if (upper (dbms_name) like \'%VIASQL%\' and (driver_name like \'OLOD40%.DLL\' or driver_name like \'OPL%.so\'))\n"
"{\n"
"\n"
"if (isstring (qual))\n"
"{\n"
"qual := replace (qual, \'\\\\%\', \'%\');\n"
"qual := replace (qual, \'\\\\_\', \'_\');\n"
"}\n"
"if (isstring (owner))\n"
"{\n"
"owner := replace (owner, \'\\\\%\', \'%\');\n"
"owner := replace (owner, \'\\\\_\', \'_\');\n"
"}\n"
"if (isstring (name))\n"
"{\n"
"name := replace (name, \'\\\\%\', \'%\');\n"
"name := replace (name, \'\\\\_\', \'_\');\n"
"}\n"
"return 1;\n"
"}\n"
"return 0;\n"
"}\n"
"--src odbccat.sql:669\n";

/* useraggr.sql */

static const char *proc200 = 
" create procedure STD_COUNT (in _env varchar)\n"
"{\n"
"return aref (deserialize(_env), 0);\n"
"}\n"
"--src useraggr.sql:23\n";

static const char *proc201 = 
" create procedure STD11_INIT (inout _env varchar)\n"
"{\n"
"_env := serialize (vector (0, 0.0));\n"
"}\n"
"--src useraggr.sql:30\n";

static const char *proc202 = 
" create procedure STD12_INIT (inout _env varchar)\n"
"{\n"
"_env := serialize (vector (0, 0.0,0.0));\n"
"}\n"
"--src useraggr.sql:37\n";

static const char *proc203 = 
" create procedure STD13_INIT (inout _env varchar)\n"
"{\n"
"_env := serialize (vector (0, 0.0,0.0, 0.0));\n"
"}\n"
"--src useraggr.sql:44\n";

static const char *proc204 = 
" create procedure VAR_ACC (inout _env varchar, in val numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if (val is null)\n"
"return;\n"
"declare ctx any;\n"
"ctx := deserialize (_env);\n"
"\n"
"aset( ctx, 1, aref (ctx, 1) + val);\n"
"aset( ctx, 2, aref (ctx, 2) + val*val);\n"
"aset( ctx, 0, aref (ctx, 0) + 1);\n"
"_env := serialize (ctx);\n"
"}\n"
"--src useraggr.sql:51\n";

static const char *proc205 = 
" create procedure VAR_POP_FIN (inout _ctx varchar)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"declare _env any;\n"
"_env := deserialize (_ctx);\n"
"declare c integer;\n"
"c := aref (_env, 0);\n"
"if (c = 0)\n"
"return null;\n"
"return  (aref (_env, 2) - aref (_env, 1) * aref (_env, 1) / c) / c; 	\n"
"}\n"
"--src useraggr.sql:68\n";

static const char *proc206 = 
" create procedure VAR_SAMP_FIN (inout _ctx varchar)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"declare _env any;\n"
"_env := deserialize (_ctx);\n"
"declare c integer;\n"
"c := aref (_env, 0);\n"
"if (c = 0)\n"
"return null;\n"
"if (c = 1)\n"
"return 0.0;\n"
"return  (aref (_env, 2) - aref (_env, 1) * aref (_env, 1) / c) / (c - 1);\n"
"}\n"
"--src useraggr.sql:83\n";

static const char *proc207 = 
" create procedure VAR_FIN (inout _ctx varchar)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"if (STD_COUNT (_ctx) = 1)\n"
"return null;\n"
"return VAR_SAMP_FIN (_ctx);\n"
"}\n"
"--src useraggr.sql:100\n";

static const char *proc208 = 
" create procedure STDDEV_POP_FIN (inout _ctx varchar)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"declare c integer;\n"
"declare _env any;\n"
"_env := deserialize (_ctx);\n"
"c := aref (_env, 0);\n"
"if (c = 0)\n"
"return null;\n"
"\n"
"return  sqrt ((aref (_env, 2) - aref (_env, 1) * aref (_env, 1) / c) / c) ; 	\n"
"}\n"
"--src useraggr.sql:111\n";

static const char *proc209 = 
" create procedure STDDEV_SAMP_FIN (inout _ctx varchar)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"declare c integer;\n"
"declare _env any;\n"
"_env := deserialize (_ctx);\n"
"c := aref (_env, 0);\n"
"if (c = 0)\n"
"return null;\n"
"if (c = 1)\n"
"return 0.0;\n"
"return  sqrt ((aref (_env, 2) - aref (_env, 1) * aref (_env, 1) / c) / ( c - 1));\n"
"}\n"
"--src useraggr.sql:127\n";

static const char *proc210 = 
" create procedure STDDEV_FIN (inout _ctx varchar)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"if (STD_COUNT (_ctx) = 1)\n"
"return null;\n"
"return STDDEV_SAMP_FIN (_ctx);\n"
"}\n"
"--src useraggr.sql:144\n";

static const char *proc211 = 
" create procedure COVAR_ACC (inout _ctx any,\n"
"in expr1 numeric,\n"
"in expr2 numeric)\n"
"{\n"
"if (_ctx is null)\n"
"return;\n"
"if (expr1 is null or expr2 is null)\n"
"return;\n"
"\n"
"declare _env any;\n"
"\n"
"_env := deserialize (_ctx);\n"
"\n"
"aset (_env, 1, aref (_env,1)+expr1);\n"
"aset (_env, 2, aref (_env,2)+expr2);\n"
"aset (_env, 3, aref (_env,3)+expr2*expr1);\n"
"aset (_env, 0, aref (_env,0)+1);\n"
"\n"
"_ctx := serialize (_env);\n"
"}\n"
"--src useraggr.sql:155\n";

static const char *proc212 = 
" create procedure COVAR_SAMP_FIN (inout _ctx any)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"declare _env any;\n"
"_env := deserialize (_ctx);\n"
"if (aref (_env, 0) = 0)\n"
"return null;\n"
"if (aref (_env, 0) = 1)\n"
"return 0.0;\n"
"\n"
"return (aref (_env, 3) - aref(_env,2) * aref (_env,1) / aref (_env, 0)) / ( aref (_env, 0) - 1);\n"
"}\n"
"--src useraggr.sql:178\n";

static const char *proc213 = 
" create procedure COVAR_POP_FIN (inout _ctx any)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"declare _env any;\n"
"_env := deserialize (_ctx);\n"
"if (aref (_env, 0) = 0)\n"
"return null;\n"
"if (aref (_env, 0) = 1)\n"
"return 0.0;\n"
"\n"
"return (aref (_env, 3) - aref(_env,2) * aref (_env,1) / aref (_env, 0))/ aref (_env,0);\n"
"}\n"
"--src useraggr.sql:194\n";

static const char *proc214 = 
" create procedure COVAR_FIN (inout _ctx varchar)\n"
"{\n"
"if (_ctx is null)\n"
"return null;\n"
"if (STD_COUNT (_ctx) = 1)\n"
"return null;\n"
"return COVAR_SAMP_FIN (_ctx);\n"
"}\n"
"--src useraggr.sql:210\n";

static const char *other108 = 
"create aggregate VAR_POP (in val numeric) returns numeric from\n"
"STD12_INIT, VAR_ACC, VAR_POP_FIN\n";

static const char *other109 = 
"create aggregate VAR_SAMP (in val numeric) returns numeric from\n"
"STD12_INIT, VAR_ACC, VAR_SAMP_FIN\n";

static const char *other110 = 
"create aggregate VAR (in val numeric) returns numeric from\n"
"STD12_INIT, VAR_ACC, VAR_FIN\n";

static const char *other111 = 
"create aggregate STDDEV_POP (in val numeric) returns numeric from\n"
"STD12_INIT, VAR_ACC, STDDEV_POP_FIN\n";

static const char *other112 = 
"create aggregate STDDEV_SAMP (in val numeric) returns numeric from\n"
"STD12_INIT, VAR_ACC, STDDEV_SAMP_FIN\n";

static const char *other113 = 
"create aggregate STDDEV (in val numeric) returns numeric from\n"
"STD12_INIT, VAR_ACC, STDDEV_FIN\n";

static const char *other114 = 
"create aggregate COVAR_SAMP (in expr1 numeric, in expr2 numeric) returns numeric from\n"
"STD13_INIT, COVAR_ACC, COVAR_SAMP_FIN\n";

static const char *other115 = 
"create aggregate COVAR_POP (in expr1 numeric, in expr2 numeric) returns numeric from\n"
"STD13_INIT, COVAR_ACC, COVAR_POP_FIN\n";

static const char *other116 = 
"create aggregate COVAR (in expr1 numeric, in expr2 numeric) returns numeric from\n"
"STD13_INIT, COVAR_ACC, COVAR_FIN\n";

static const char *proc215 = 
" create procedure REGR_SLOPE_INIT (inout _env varchar)\n"
"{\n"
"declare _ctx1 varchar;\n"
"declare _ctx2 varchar;\n"
"\n"
"STD13_INIT (_ctx1);\n"
"STD12_INIT (_ctx2);\n"
"\n"
"_env := serialize (vector (0, _ctx1, _ctx2));\n"
"}\n"
"--src useraggr.sql:249\n";

static const char *proc216 = 
" create procedure REGR_SLOPE_ACC (inout _env varchar, in expr1 numeric, in expr2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if ( (expr1 is null) or (expr2 is null))\n"
"return;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"\n"
"declare _ctx1 varchar;\n"
"declare _ctx2 varchar;\n"
"\n"
"_ctx1 := aref (_ctx, 1);\n"
"_ctx2 := aref (_ctx, 2);\n"
"\n"
"aset (_ctx, 0, aref (_ctx,0) + 1);\n"
"COVAR_ACC (_ctx1, expr1, expr2);\n"
"VAR_ACC (_ctx2, expr2);\n"
"\n"
"aset (_ctx, 1, _ctx1);\n"
"aset (_ctx, 2, _ctx2);\n"
"\n"
"_env := serialize (_ctx);\n"
"}\n"
"--src useraggr.sql:262\n";

static const char *proc217 = 
" create procedure REGR_SLOPE_FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"declare c integer;\n"
"\n"
"_ctx := deserialize (_env);\n"
"\n"
"c := aref (_ctx, 0);\n"
"if (c = 0)\n"
"return 0;\n"
"if (c = 1)\n"
"return null;\n"
"\n"
"declare _ctx1 varchar;\n"
"declare _ctx2 varchar;\n"
"declare covar_pop_val numeric;\n"
"declare var_pop_val numeric;\n"
"\n"
"_ctx1 := aref (_ctx, 1);\n"
"_ctx2 := aref (_ctx, 2);\n"
"\n"
"\n"
"covar_pop_val := COVAR_POP_FIN (_ctx1);\n"
"var_pop_val := VAR_POP_FIN (_ctx2);\n"
"\n"
"if (var_pop_val = 0)\n"
"return null;\n"
"return covar_pop_val / var_pop_val;\n"
"}\n"
"--src useraggr.sql:289\n";

static const char *other117 = 
"create aggregate REGR_SLOPE (in expr1 numeric, in expr2 numeric) returns numeric from REGR_SLOPE_INIT, REGR_SLOPE_ACC, REGR_SLOPE_FIN\n";

static const char *proc218 = 
" create procedure REGR_INTERCEPT_INIT (inout _env varchar)\n"
"{\n"
"declare _ctx_regr_slope varchar;\n"
"\n"
"REGR_SLOPE_INIT (_ctx_regr_slope);\n"
"_env := serialize (vector (0, 0.0, 0.0, _ctx_regr_slope));\n"
"}\n"
"--src useraggr.sql:326\n";

static const char *proc219 = 
" create procedure REGR_INTERCEPT_ACC (inout _env varchar, in expr1 numeric, in expr2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if ((expr1 is null) or (expr2 is null))\n"
"return;\n"
"\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"\n"
"aset (_ctx, 0, aref (_ctx, 0) + 1);\n"
"aset (_ctx, 1, aref (_ctx, 1) + expr1);\n"
"aset (_ctx, 2, aref (_ctx, 2) + expr2);\n"
"\n"
"declare _ctx_r varchar;\n"
"_ctx_r := aref (_ctx, 3);\n"
"REGR_SLOPE_ACC (_ctx_r, expr1, expr2);\n"
"aset (_ctx, 3, _ctx_r);\n"
"\n"
"_env := serialize (_ctx);\n"
"}\n"
"--src useraggr.sql:336\n";

static const char *proc220 = 
" create procedure REGR_INTERCEPT_FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"declare c integer;\n"
"c := aref (_ctx, 0);\n"
"if ((c = 0) or (c = 1))\n"
"return null;\n"
"\n"
"return aref (_ctx, 1) / c - REGR_SLOPE_FIN (aref (_ctx, 3)) * aref (_ctx, 2) / c;\n"
"}\n"
"--src useraggr.sql:360\n";

static const char *other118 = 
"create aggregate REGR_INTERCEPT (in expr1 numeric, in expr2 numeric) returns numeric from REGR_INTERCEPT_INIT, REGR_INTERCEPT_ACC, REGR_INTERCEPT_FIN\n";

static const char *proc221 = 
" create procedure REGR_COUNT_INIT (inout _env integer)\n"
"{\n"
"_env := 0;\n"
"}\n"
"--src useraggr.sql:379\n";

static const char *proc222 = 
" create procedure REGR_COUNT_ACC (inout _env integer, in expr numeric, in expr2 numeric)\n"
"{\n"
"if ((_env is null) or (expr is null) or (expr2 is null))\n"
"return;\n"
"_env := _env + 1;\n"
"}\n"
"--src useraggr.sql:386\n";

static const char *proc223 = 
" create procedure REGR_COUNT_FIN (inout _env integer)\n"
"{\n"
"return _env;\n"
"}\n"
"--src useraggr.sql:395\n";

static const char *proc224 = 
" create procedure REGR_COUNT_MERGE (inout _e1 integer, inout _e2 integer)\n"
"{\n"
"_e1 := _e1 + _e2;\n"
"}\n"
"--src useraggr.sql:402\n";

static const char *other119 = 
"create aggregate REGR_COUNT (in expr1 numeric, in expr2 numeric) returns numeric from REGR_COUNT_INIT, REGR_COUNT_ACC, REGR_COUNT_FIN, REGR_COUNT_MERGE\n";

static const char *proc225 = 
" create procedure REGR_AVG_ACC (inout _env varchar, in expr1 numeric, in expr2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"\n"
"if ( (expr1 is null) or (expr2 is null))\n"
"return;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"\n"
"aset (_ctx, 0, aref (_ctx, 0) + 1);\n"
"aset (_ctx, 1, aref (_ctx, 1) + expr1);\n"
"aset (_ctx, 2, aref (_ctx, 2) + expr2);\n"
"\n"
"_env := serialize (_ctx);\n"
"}\n"
"--src useraggr.sql:412\n";

static const char *proc226 = 
" create procedure REGR_AVGX_FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"if (aref (_ctx, 0) = 0)\n"
"return null;\n"
"return aref (_ctx, 1) / aref (_ctx,0);\n"
"}\n"
"--src useraggr.sql:431\n";

static const char *proc227 = 
" create procedure REGR_AVGY_FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"if (aref (_ctx, 0) = 0)\n"
"return null;\n"
"return aref (_ctx, 2) / aref (_ctx,0);\n"
"}\n"
"--src useraggr.sql:444\n";

static const char *other120 = 
"create aggregate REGR_AVGX (in x numeric, in y numeric) returns numeric from\n"
"STD12_INIT, REGR_AVG_ACC, REGR_AVGX_FIN\n";

static const char *other121 = 
"create aggregate REGR_AVGY (in x numeric, in y numeric) returns numeric from\n"
"STD12_INIT, REGR_AVG_ACC, REGR_AVGY_FIN\n";

static const char *proc228 = 
" create procedure CORR_INIT (inout _env varchar)\n"
"{\n"
"declare _ctx_cov varchar;\n"
"declare _ctx_stdev1 varchar;\n"
"declare _ctx_stdev2 varchar;\n"
"\n"
"STD13_INIT (_ctx_cov);\n"
"STD12_INIT (_ctx_stdev1);\n"
"STD12_INIT (_ctx_stdev2);\n"
"\n"
"_env := serialize (vector (0, _ctx_cov, _ctx_stdev1, _ctx_stdev2));\n"
"}\n"
"--src useraggr.sql:465\n";

static const char *proc229 = 
" create procedure CORR_ACC (inout _env varchar, in e1 numeric, in e2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if ((e1 is null) or (e2 is null))\n"
"return;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"\n"
"declare _ctx_cov varchar;\n"
"declare _ctx_stdev1 varchar;\n"
"declare _ctx_stdev2 varchar;\n"
"\n"
"_ctx_cov := aref (_ctx, 1);\n"
"_ctx_stdev1 := aref (_ctx, 2);\n"
"_ctx_stdev2 := aref (_ctx, 3);\n"
"\n"
"COVAR_ACC (_ctx_cov, e1, e2);\n"
"VAR_ACC (_ctx_stdev1, e1);\n"
"VAR_ACC (_ctx_stdev2, e2);\n"
"\n"
"aset (_ctx, 0, aref (_ctx, 0) + 1);\n"
"aset (_ctx, 1, _ctx_cov);\n"
"aset (_ctx, 2, _ctx_stdev1);\n"
"aset (_ctx, 3, _ctx_stdev2);\n"
"\n"
"_env := serialize (_ctx);\n"
"}\n"
"--src useraggr.sql:480\n";

static const char *proc230 = 
" create procedure CORR_FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"\n"
"declare _ctx_cov_val numeric;\n"
"declare _ctx_stdev1_val numeric;\n"
"declare _ctx_stdev2_val numeric;\n"
"\n"
"_ctx_cov_val := COVAR_POP_FIN (aref (_ctx, 1));\n"
"_ctx_stdev1_val := STDDEV_POP_FIN (aref (_ctx, 2));\n"
"_ctx_stdev2_val := STDDEV_POP_FIN (aref (_ctx, 3));\n"
"\n"
"if (_ctx_cov_val is null)\n"
"return null;\n"
"if (_ctx_stdev1_val is null or _ctx_stdev1_val = 0)\n"
"return null;\n"
"if (_ctx_stdev2_val is null or _ctx_stdev2_val = 0)\n"
"return null;\n"
"\n"
"return _ctx_cov_val / _ctx_stdev1_val / _ctx_stdev2_val;\n"
"}\n"
"--src useraggr.sql:511\n";

static const char *other122 = 
"create aggregate CORR (in x numeric, in y numeric) returns numeric from\n"
"CORR_INIT, CORR_ACC, CORR_FIN\n";

static const char *proc231 = 
" create procedure REGR_R2_INIT (inout _env varchar)\n"
"{\n"
"declare _ctx_vp1 varchar;\n"
"declare _ctx_vp2 varchar;\n"
"declare _ctx_corr varchar;\n"
"\n"
"STD12_INIT (_ctx_vp1);\n"
"STD12_INIT (_ctx_vp2);\n"
"CORR_INIT (_ctx_corr);\n"
"\n"
"_env := serialize (vector (_ctx_vp1, _ctx_vp2, _ctx_corr));\n"
"}\n"
"--src useraggr.sql:542\n";

static const char *proc232 = 
" create procedure REGR_R2_ACC (inout _env varchar, in e1 numeric, in e2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if (e1 is null or e2 is null)\n"
"return;\n"
"declare _ctx  any;\n"
"\n"
"_ctx := deserialize (_env);\n"
"\n"
"declare _ctx_vp1 varchar;\n"
"declare _ctx_vp2 varchar;\n"
"declare _ctx_corr varchar;\n"
"\n"
"_ctx_vp1 := aref (_ctx, 0);\n"
"_ctx_vp2 := aref (_ctx, 1);\n"
"_ctx_corr := aref (_ctx, 2);\n"
"\n"
"VAR_ACC (_ctx_vp1, e1);\n"
"VAR_ACC (_ctx_vp2, e2);\n"
"CORR_ACC (_ctx_corr, e1, e2);\n"
"\n"
"aset (_ctx, 0, _ctx_vp1);	\n"
"aset (_ctx, 1, _ctx_vp2);	\n"
"aset (_ctx, 2, _ctx_corr);	\n"
"\n"
"_env := serialize (_ctx);\n"
"}\n"
"--src useraggr.sql:557\n";

static const char *proc233 = 
" create procedure REGR_R2_FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"\n"
"_ctx := deserialize (_env);\n"
"\n"
"declare _vp1 numeric;\n"
"declare _vp2 numeric;\n"
"declare _corr numeric;\n"
"\n"
"_vp2 := VAR_POP_FIN (aref(_ctx, 1));\n"
"if (_vp2 is null or _vp2 = 0)\n"
"return null;\n"
"_vp1 := VAR_POP_FIN (aref(_ctx, 0));\n"
"if (_vp1 is null or _vp1 = 0)\n"
"return 1;\n"
"_corr := CORR_FIN (aref (_ctx, 2));\n"
"return _corr * _corr;\n"
"}\n"
"--src useraggr.sql:588\n";

static const char *other123 = 
"create aggregate REGR_R2 (in e1 numeric, in e2 numeric) returns numeric from\n"
"REGR_R2_INIT, REGR_R2_ACC, REGR_R2_FIN\n";

static const char *proc234 = 
" create procedure REGR_SXX_ACC (inout _env varchar, in e1 numeric, in e2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if (e1 is null or e2 is null)\n"
"return;\n"
"\n"
"VAR_ACC (_env, e2);\n"
"}\n"
"--src useraggr.sql:616\n";

static const char *proc235 = 
" create procedure REGR_SYY_ACC (inout _env varchar, in e1 numeric, in e2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if (e1 is null or e2 is null)\n"
"return;\n"
"\n"
"VAR_ACC (_env, e1);\n"
"}\n"
"--src useraggr.sql:628\n";

static const char *proc236 = 
" create procedure REGR_SXY_ACC (inout _env varchar, in e1 numeric, in e2 numeric)\n"
"{\n"
"if (_env is null)\n"
"return;\n"
"if (e1 is null or e2 is null)\n"
"return;\n"
"\n"
"COVAR_ACC (_env, e1, e2);\n"
"}\n"
"--src useraggr.sql:640\n";

static const char *proc237 = 
" create procedure REGR_S___FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"\n"
"declare _var numeric;\n"
"\n"
"_var := VAR_POP_FIN (_env);\n"
"if (_var is null)\n"
"return null;\n"
"return aref (_ctx,0) * _var;\n"
"}\n"
"--src useraggr.sql:652\n";

static const char *proc238 = 
" create procedure REGR_SXY_FIN (inout _env varchar)\n"
"{\n"
"if (_env is null)\n"
"return null;\n"
"declare _ctx any;\n"
"_ctx := deserialize (_env);\n"
"\n"
"declare _var numeric;\n"
"\n"
"_var := COVAR_POP_FIN (_env);\n"
"if (_var is null)\n"
"return null;\n"
"return aref (_ctx,0) * _var;\n"
"}\n"
"--src useraggr.sql:669\n";

static const char *other124 = 
"create aggregate REGR_SXX (in e1 numeric, in e2 numeric) returns numeric from\n"
"STD12_INIT, REGR_SXX_ACC, REGR_S___FIN\n";

static const char *other125 = 
"create aggregate REGR_SYY (in e1 numeric, in e2 numeric) returns numeric from\n"
"STD12_INIT, REGR_SYY_ACC, REGR_S___FIN\n";

static const char *other126 = 
"create aggregate REGR_SXY (in e1 numeric, in e2 numeric) returns numeric from\n"
"STD13_INIT, REGR_SXY_ACC, REGR_SXY_FIN\n";

static const char *proc239 = 
" create procedure xte_nodebld_final_root (in acc any) returns any\n"
"{\n"
"return xte_nodebld_xmlagg_final (acc, xte_head (UNAME\' root\'));\n"
"}\n"
"--src useraggr.sql:698\n";

static const char *other127 = 
"create aggregate XMLAGG (in _child any) returns any\n"
"from xte_nodebld_init, xte_nodebld_xmlagg_acc, xte_nodebld_final_root\n";

static const char *other128 = 
"create aggregate VECTOR_AGG (in _child any) returns any\n"
"from vectorbld_init, vectorbld_agg_acc, vectorbld_agg_final\n";

static const char *other129 = 
"create aggregate VECTOR_CONCAT_AGG (in _child any) returns any\n"
"from vectorbld_init, vectorbld_concat_agg_acc, vectorbld_agg_final\n";

static const char *other130 = 
"create aggregate XQ_SEQUENCE_AGG (in _child any) returns any\n"
"from xq_sequencebld_init, xq_sequencebld_agg_acc, xq_sequencebld_agg_final\n";

/* wsdl_expand.xsl */

static const char *xsl14[]= {
"<?xml version='1.0'?>\n"
"<!--\n"
" -\n"
" -  $Id: wsdl_expand.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n"
"     version=\"1.0\"\n"
"     xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"\n"
"     xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n"
"     xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"\n"
"     xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
"     xmlns:pl=\"http://schemas.xmlsoap.org/ws/2003/05/partner-link/\"\n"
"     >\n"
"\n"
"<xsl:output method=\"xml\" omit-xml-declaration=\"no\" indent=\"yes\" />\n"
"\n"
"<xsl:template match=\"/\">\n"
"<wsdl:definitions>\n"
"    <xsl:attribute name=\"targetNamespace\"><xsl:value-of select=\"descendant-or-self::wsdl:definitions/@targetNamespace\" /></xsl:attribute>\n"
"    <wsdl:types>\n"
"	<xsl:apply-templates select=\"//xsd:schema\" mode=\"xsd\"/>\n"
"	<xsl:apply-templates select=\"//wsdl:import\" mode=\"xsd\"/>\n"
"    </wsdl:types>\n"
"    <xsl:apply-templates select=\"node()\" />\n"
"</wsdl:definitions>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:import\">\n"
"    <xsl:param name=\"topns\" />\n"
"    <xsl:choose>\n"
"	<xsl:when test=\"$topns != ''\">\n"
"	    <xsl:variable name=\"ns\" select=\"$topns\"/>\n"
"	</xsl:when>\n"
"	<xsl:when test=\"@namespace\">\n"
"	    <xsl:variable name=\"ns\" select=\"@namespace\"/>\n"
"	</xsl:when>\n"
"	<xsl:otherwise>\n"
"	    <xsl:variable name=\"ns\" select=\"ancestor::wsdl:definitions/@targetNamespace\"/>\n"
"	</xsl:otherwise>\n"
"    </xsl:choose>\n"
"    <xsl:choose>\n"
"	<xsl:when test=\"@namespace\">\n"
"	    <xsl:variable name=\"ns1\" select=\"@namespace\"/>\n"
"	</xsl:when>\n"
"	<xsl:otherwise>\n"
"	    <xsl:variable name=\"ns1\" select=\"ancestor::wsdl:definitions/@targetNamespace\"/>\n"
"	</xsl:otherwise>\n"
"    </xsl:choose>\n"
"    <xsl:variable name=\"doc\" select=\"document (@location)\"/>\n"
"    <xsl:apply-templates select=\"$doc/*[@targetNamespace = $ns]\" >\n"
"	<xsl:with-param name=\"topns\" select=\"$ns\" />\n"
"    </xsl:apply-templates>\n"
"    <xsl:apply-templates select=\"$doc//wsdl:import\" >\n"
"	<xsl:with-param name=\"topns\" select=\"$ns1\" />\n"
"    </xsl:apply-templates>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:definitions\">\n"
"<xsl:param name=\"topns\" />\n"
"    <xsl:apply-templates select=\"node()\" >\n"
"      <xsl:with-param name=\"topns\" select=\"$topns\" />\n"
"    </xsl:apply-templates>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:portType|wsdl:binding|wsdl:message\">\n"
"    <xsl:variable name=\"tns\" select=\"ancestor::wsdl:definitions/@targetNamespace\"/>\n"
"    <xsl:variable name=\"localname\" select=\"@name\"/>\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:attribute name=\"name\"><xsl:value-of select=\"concat ($tns,':',$localname)\" /></xsl:attribute>\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </xsl:copy>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"pl:*\">\n"
"    <xsl:copy>\n"
"	<xsl:for-each select=\"@*\">\n"
"	    <xsl:attribute name=\"{local-name()}\"><xsl:value-of select=\"expand-qname (0, .)\"/></xsl:attribute>\n"
"	</xsl:for-each>\n"
"      <xsl:apply-templates select=\"*\" />\n"
"    </xsl:copy>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </xsl:copy>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:types\" />\n"
"<xsl:template match=\"xsd:schema\" />\n"
"<xsl:template match=\"xsd:import[@schemaLocation]\" />\n"
"\n"
"<xsl:template match=\"xsd:schema\" mode=\"xsd\">\n"
"    <xsl:for-each select=\"xsd:import\">\n"
"	<xsl:choose>\n"
"	    <xsl:when test=\"@schemaLocation\">\n"
"		<xsl:variable name=\"sch\" select=\"document(@schemaLocation)\"/>\n"
"		<xsl:apply-templates select=\"$sch/*\" mode=\"xsd\"/>\n"
"	    </xsl:when>\n"
"	    <xsl:otherwise>\n"
"		<xsl:variable name=\"lns\" select=\"@namespace\"/>\n"
"		<xsl:apply-templates select=\"//xsd:schema[@targetNamespace = $lns]\" mode=\"xsd\"/>\n"
"	    </xsl:otherwise>\n"
"	</xsl:choose>\n"
"    </xsl:for-each>\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:apply-templates select=\"*\" />\n"
"    </xsl:copy>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:import\" mode=\"xsd\">\n"
"    <xsl:choose>\n"
"	<xsl:when test=\"@namespace\">\n"
"	    <xsl:variable name=\"ns\" select=\"@namespace\"/>\n"
"	</xsl:when>\n"
"	<xsl:otherwise>\n"
"	    <xsl:variable name=\"ns\" select=\"ancestor::wsdl:definitions/@targetNamespace\"/>\n"
"	</xsl:otherwise>\n"
"    </xsl:choose>\n"
"\n"
"    <xsl:variable name=\"doc\" select=\"document (@location)\"/>\n"
"    <xsl:apply-templates select=\"$doc//xsd:schema[@targetNamespace = $ns]\" mode=\"xsd\"/>\n"
"    <xsl:apply-templates select=\"$doc//wsdl:definitions[@targetNamespace = $ns]/wsdl:import\" mode=\"xsd\"/>\n"
"    <xsl:apply-templates select=\"$doc//wsdl:import[@namespace=$ns]\" mode=\"xsd\"/>\n"
"</xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* wsdl_parts.xsl */

static const char *xsl15[]= {
"<?xml version='1.0'?>\n"
"<!--\n"
" -\n"
" -  $Id: wsdl_parts.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n"
"     version=\"1.0\"\n"
"     xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"\n"
"     xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n"
"     xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"\n"
"     xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
"     xmlns:vi=\"http://www.openlinksw.com/wsdl/\"\n"
"     >\n"
"\n"
"<xsl:output method=\"xml\" omit-xml-declaration=\"no\" indent=\"yes\" />\n"
"\n"
"<xsl:param name=\"tns\" select=\"/wsdl:definitions/@targetNamespace\" />\n"
"\n"
"<xsl:template match=\"/\">\n"
"  <xsl:apply-templates select=\"node()\" />\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:part\">\n"
"<xsl:choose>\n"
"<xsl:when test=\"@type\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </xsl:copy>\n"
"</xsl:when>\n"
"<xsl:when test=\"@element and @name != 'parameters'\">\n"
"  <xsl:copy>\n"
"    <xsl:copy-of select=\"@*\" />\n"
"    <xsl:apply-templates select=\"node()\" />\n"
"  </xsl:copy>\n"
"  <!--wsdl:part>\n"
"  <xsl:variable name=\"ename\" select=\"vi:split-name (@element, 1)\" />\n"
"  <xsl:variable name=\"exsd\" select=\"vi:split-name (@element, 0)\" />\n"
"  <xsl:attribute name=\"name\"><xsl:value-of select=\"//xsd:schema[@targetNamespace = $exsd]/xsd:element[@name = $ename]/@name\" /></xsl:attribute>\n"
"  <xsl:choose>\n"
"  <xsl:when test=\"//xsd:schema[@targetNamespace = $exsd]/xsd:element[@name = $ename]/@type\">\n"
"  <xsl:attribute name=\"type\"><xsl:value-of select=\"//xsd:schema[@targetNamespace = $exsd]/xsd:element[@name = $ename]/@type\" /></xsl:attribute>\n"
"  </xsl:when>\n"
"  <xsl:otherwise>\n"
"  <xsl:attribute name=\"type\"><xsl:value-of select=\"$exsd\"/>:elementType__<xsl:value-of select=\"//xsd:schema[@targetNamespace = $exsd]/xsd:element[@name = $ename]/@name\" /></xsl:attribute>\n"
"  </xsl:otherwise>\n"
"  </xsl:choose>\n"
"  </wsdl:part-->\n"
"</xsl:when>\n"
"<xsl:when test=\"@element and @name = 'parameters'\">\n"
"  <xsl:variable name=\"ename\" select=\"vi:split-name (@element, 1)\" />\n"
"  <xsl:variable name=\"exsd\" select=\"vi:split-name (@element, 0)\" />\n"
"  <xsl:for-each select=\"//xsd:schema[@targetNamespace = $exsd]/xsd:element[@name = $ename]\">\n"
"    <xsl:choose>\n"
"     <xsl:when test=\"xsd:complexType//xsd:element\">\n"
"       <xsl:for-each select=\"xsd:complexType//xsd:element\">\n"
"	   <wsdl:part>\n"
"	       <xsl:choose>\n"
"		   <xsl:when test=\"@name\">\n"
"		       <xsl:attribute name=\"name\">\n"
"			   <xsl:value-of select=\"@name\"/>\n"
"		       </xsl:attribute>\n"
"		       <xsl:attribute name=\"type\">\n"
"			   <xsl:value-of select=\"@type\"/>\n"
"		       </xsl:attribute>\n"
"		   </xsl:when>\n"
"		   <xsl:when test=\"@ref\">\n"
"		       <xsl:variable name=\"rnam\" select=\"vi:split-name (@ref, 1)\" />\n"
"		       <xsl:variable name=\"rns\" select=\"vi:split-name (@ref, 0)\" />\n"
"		       <xsl:attribute name=\"name\">\n"
"			   <xsl:value-of select=\"$rnam\"/>\n"
"		       </xsl:attribute>\n"
"		       <xsl:attribute name=\"type\">\n"
"			   <xsl:value-of select=\"//xsd:schema[@targetNamespace = $rns]/xsd:element[@name=$rnam]/@type\"/>\n"
"		       </xsl:attribute>\n"
"		   </xsl:when>\n"
"	       </xsl:choose>\n"
"         </wsdl:part>\n"
"       </xsl:for-each>\n"
"     </xsl:when>\n"
"     <xsl:otherwise>\n"
"   	<xsl:variable name=\"tname\" select=\"vi:split-name (@type, 1)\" />\n"
"  	<xsl:variable name=\"txsd\" select=\"vi:split-name (@type, 0)\" />\n"
"        <xsl:for-each select=\"//xsd:schema[@targetNamespace = $txsd]/xsd:complexType[@name = $tname]//xsd:element\">\n"
"         <wsdl:part>\n"
"	  <xsl:attribute name=\"name\">\n"
"            <xsl:value-of select=\"@name\"/>\n"
"	  </xsl:attribute>\n"
"	  <xsl:attribute name=\"type\">\n"
"            <xsl:value-of select=\"@type\"/>\n"
"	  </xsl:attribute>\n"
"         </wsdl:part>\n"
"       </xsl:for-each>\n"
"     </xsl:otherwise>\n"
"    </xsl:choose>\n"
"  </xsl:for-each>\n"
"</xsl:when>\n"
"<xsl:otherwise>\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"</xsl:otherwise>\n"
"</xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:operation[wsdl:input/soap:body]\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"\n"
"      <xsl:if test=\"not (wsdl:input/soap:body/@encodingStyle)\">\n"
"      <xsl:variable name=\"opname\" select=\"@name\" />\n"
"      <xsl:variable name=\"pname\" select=\"ancestor::wsdl:binding/@type\" />\n"
"       <xsl:attribute name=\"enc\">\n"
"        <xsl:for-each select=\"/wsdl:definitions/wsdl:portType[@name = $pname]/wsdl:operation[@name = $opname]\">\n"
"          <xsl:variable name=\"msg\" select=\"wsdl:input/@message\"/>\n"
"          <xsl:value-of select=\"boolean (/wsdl:definitions/wsdl:message[@name = $msg]/part[1]/@name = 'parameters')\" />\n"
"        </xsl:for-each>\n"
"       </xsl:attribute>\n"
"       <xsl:if test=\"/wsdl:definitions/wsdl:message[@name = $msg]/part[1]/@name = 'parameters'\">\n"
"         <xsl:attribute name=\"elnamespace\">\n"
"           <xsl:value-of select=\"vi:split-name (/wsdl:definitions/wsdl:message[@name = $msg]/part[1]/@element, 0)\" />\n"
"         </xsl:attribute>\n"
"         <xsl:attribute name=\"form\">\n"
"	   <xsl:variable name=\"elname\" select=\"/wsdl:definitions/wsdl:message[@name = $msg]/part[1]/@element\" />\n"
" 	   <xsl:variable name=\"elname0\" select=\"vi:split-name ($elname, 0)\" />\n"
" 	   <xsl:variable name=\"elname1\" select=\"vi:split-name ($elname, 1)\" />\n"
"           <xsl:value-of select=\"/wsdl:definitions/wsdl:types/xsd:schema[ @targetNamespace = $elname0 and xsd:element[ @name = $elname1 ] ]/@elementFormDefault\"/>\n"
"         </xsl:attribute>\n"
"\n"
"       </xsl:if>\n"
"      </xsl:if>\n"
"\n"
"      <xsl:if test=\"not (wsdl:input/soap:body/@namespace)\">\n"
"      <xsl:variable name=\"opname\" select=\"@name\" />\n"
"      <xsl:variable name=\"pname\" select=\"ancestor::wsdl:binding/@type\" />\n"
"       <xsl:attribute name=\"namespace\">\n"
"        <xsl:for-each select=\"/wsdl:definitions/wsdl:portType[@name = $pname]/wsdl:operation[@name = $opname]\">\n"
"          <xsl:variable name=\"msg\" select=\"wsdl:input/@message\"/>\n"
"          <xsl:value-of select=\"vi:split-name (/wsdl:definitions/wsdl:message[@name = $msg]/part[1]/@element, 0)\" />\n"
"        </xsl:for-each>\n"
"       </xsl:attribute>\n"
"      </xsl:if>\n"
"\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </xsl:copy>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </xsl:copy>\n"
"</xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* wsdl_import.xsl */

static const char *xsl16[]= {
"<?xml version='1.0'?>\n"
"<!--\n"
" -\n"
" -  $Id: wsdl_import.xsl,v 1.4 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n"
"     version=\"1.0\"\n"
"     xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"\n"
"     xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n"
"     xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"\n"
"     xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
"     xmlns:vi=\"http://www.openlinksw.com/wsdl/\"\n"
"     >\n"
"<xsl:output method=\"text\" omit-xml-declaration=\"yes\" indent=\"yes\" />\n"
"\n"
"<xsl:param name=\"tns\" select=\"/wsdl:definitions/@targetNamespace\" />\n"
"<xsl:param name=\"wsdlURI\" />\n"
"<xsl:template match=\"/\">\n"
"-- Automatically generated code\n"
"-- imported from WSDL URI: \"<xsl:value-of select=\"$wsdlURI\" />\"\n"
" <xsl:apply-templates select=\"*\" />\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:definitions\">\n"
" <xsl:apply-templates select=\"*\" />\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:service\">\n"
"<xsl:variable name=\"classname\" select=\"@name\" />\n"
"<xsl:for-each select=\"wsdl:port[soap:address]\">\n"
"<xsl:variable name=\"binded\" select=\"@binding\" />\n"
"<xsl:choose>\n"
"<xsl:when test=\"position() = 1\">\n"
"<xsl:variable name=\"sname\" select=\"$classname\" />\n"
"</xsl:when>\n"
"<xsl:otherwise>\n"
"<xsl:variable name=\"sname\" select=\"concat ($classname,position())\" />\n"
"</xsl:otherwise>\n"
"</xsl:choose>\n"
"-- UDT class\n"
"drop type \"<xsl:value-of select=\"$sname\"/>\"\n"
";\n", 
"\n"
"create type \"<xsl:value-of select=\"$sname\"/>\"\n"
"  as\n"
"    (\n"
"      debug int default 0,\n"
"      url varchar default '<xsl:value-of select=\"soap:address/@location\" />',\n"
"      ticket varchar default null,\n"
"      request varchar,\n"
"      response varchar\n"
"    )\n"
"-- Binding: \"<xsl:value-of select=\"$binded\" />\"\n"
"<xsl:apply-templates select=\"/wsdl:definitions/wsdl:binding[@name=$binded]\" mode=\"declare\" />\n"
"method style () returns any\n"
";\n", 
"\n"
"-- Methods\n"
"<xsl:apply-templates select=\"/wsdl:definitions/wsdl:binding[@name=$binded]\" mode=\"define\" ><xsl:with-param name=\"class\" select=\"$sname\"/></xsl:apply-templates>\n"
"</xsl:for-each>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:binding\" mode=\"declare\" >\n"
"    <xsl:apply-templates select=\"wsdl:*\" mode=\"declare\">\n"
"	<xsl:with-param name=\"portname\" select=\"@type\" />\n"
"	<xsl:with-param name=\"bindname\" select=\"@name\" />\n"
"    </xsl:apply-templates>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:binding\" mode=\"define\" >\n"
"    <xsl:apply-templates select=\"wsdl:*\" mode=\"define\">\n"
"	<xsl:with-param name=\"portname\" select=\"@type\" />\n"
"	<xsl:with-param name=\"bindname\" select=\"@name\" />\n"
"	<xsl:with-param name=\"class\" select=\"$class\" />\n"
"    </xsl:apply-templates>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:operation\" mode=\"declare\" >\n"
"<xsl:variable name=\"opname\" select=\"@name\" />\n"
"<xsl:variable name=\"oper\" select=\".\" />\n"
"method \"<xsl:value-of select=\"@name\" />\"\n"
"       (\n"
"<xsl:apply-templates select=\"/wsdl:definitions/wsdl:portType[@name = $portname]/wsdl:operation[@name = $opname]\" mode=\"params\" >\n"
"	<xsl:with-param name=\"bindname\" select=\"$bindname\" />\n"
"	<xsl:with-param name=\"oper\" select=\"$oper\" />\n"
"       </xsl:apply-templates>\n"
"       ) returns any,\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:operation\" mode=\"define\" >\n"
"<xsl:variable name=\"opname\" select=\"@name\" />\n"
"<xsl:variable name=\"oper\" select=\".\" />\n"
"create method \"<xsl:value-of select=\"@name\" />\"\n"
"       (\n"
"<xsl:apply-templates select=\"/wsdl:definitions/wsdl:portType[@name = $portname]/wsdl:operation[@name = $opname]\" mode=\"def_params\" >\n"
"	<xsl:with-param name=\"bindname\" select=\"$bindname\" />\n"
"	<xsl:with-param name=\"oper\" select=\"$oper\" />\n"
"       </xsl:apply-templates>\n"
"       )\n"
"       <xsl:text>__soap_type '__VOID__' </xsl:text>\n"
"for \"<xsl:value-of select=\"$class\" />\"\n"
"{\n"
"  declare action, namespace, enc varchar;\n"
"  declare style, form int;\n"
"  declare _result, _body, xe any;\n"
"  action := '<xsl:value-of select=\"soap:operation/@soapAction\" />';\n"
"  <xsl:choose>\n"
"  <xsl:when test=\"@elnamespace and @enc = 1\">\n"
"  namespace := '<xsl:value-of select=\"@elnamespace\" />';\n"
"  form := <xsl:value-of select=\"boolean (@form = 'qualified')\" />;\n"
"  </xsl:when>\n"
"  <xsl:when test=\"wsdl:input/soap:body/@namespace\">\n"
"  namespace := '<xsl:value-of select=\"wsdl:input/soap:body/@namespace\" />';\n"
"  form := 0;\n"
"  </xsl:when>\n"
"  <xsl:otherwise>\n"
"  namespace := '<xsl:value-of select=\"@namespace\" />';\n"
"  form := 0;\n"
"  </xsl:otherwise>\n"
"  </xsl:choose>\n"
"  <xsl:choose>\n"
"  <xsl:when test=\"wsdl:input/soap:body/@encodingStyle\" >\n"
"  style := 0;\n"
"  </xsl:when>\n"
"  <xsl:when test=\"@enc = 1\" >\n"
"  style := 5;\n"
"  </xsl:when>\n"
"  <xsl:otherwise>\n"
"  style := 1;\n"
"  </xsl:otherwise>\n"
"  </xsl:choose>\n"
"  if (self.debug)\n"
"    style := style + 2;\n"
"  style := style + (form * 16);\n"
"  _result := DB.DBA.SOAP_CLIENT (\n"
"	        url=>self.url,\n"
"		operation=>'<xsl:value-of select=\"@name\" />',\n"
" 		soap_action=>action,\n"
"	        target_namespace=>namespace,\n"
" 		parameters=>vector\n"
"                        (\n"
"<xsl:apply-templates select=\"/wsdl:definitions/wsdl:portType[@name=$portname]/wsdl:operation[@name = $opname]\" mode=\"val_params\" />\n"
"			),\n"
" 		headers=>vector\n"
"                        (\n"
"<xsl:call-template name=\"header_params\" />\n"
"			),\n"
"		style=>style,\n"
"		ticket=>self.ticket\n"
"	       );\n"
"  if (self.debug)\n"
"    {\n"
"      _body := _result[0];\n"
"      self.request := _result[1];\n"
"      self.response := _result[2];\n"
"    }\n"
"  else\n"
"    _body := _result;\n"
"  xe := xml_cut (xml_tree_doc (_body));\n"
"  if (xpath_eval ('[ xmlns:SOAP=\"http://schemas.xmlsoap.org/soap/envelope/\" ] //SOAP:Fault', xe, 1) is null)\n"
"    {\n"
"<xsl:apply-templates select=\"/wsdl:definitions/wsdl:portType[@name=$portname]/wsdl:operation[@name = $opname]\" mode=\"ret_params\" /><xsl:text>      </xsl:text>;\n"
"    }\n"
"  return _result;\n"
"}\n"
";\n", 
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:operation\" mode=\"params\" >\n"
"<xsl:variable name=\"inmsg\" select=\"wsdl:input/@message\"/>\n"
"<xsl:variable name=\"outmsg\" select=\"wsdl:output/@message\"/>\n"
"<xsl:variable name=\"inhdr\" select=\"$oper/input/header/@message\"/>\n"
"<xsl:variable name=\"outhdr\" select=\"$oper/output/header/@message\"/>\n"
"<xsl:for-each select=\"/wsdl:definitions/wsdl:message[@name = $inmsg or @name = $outmsg or @name = $inhdr or @name = $outhdr]/part\" >\n"
"<xsl:choose>\n"
"<xsl:when test=\"parent::wsdl:message[@name = $inmsg or @name = $inhdr]\">\n"
"<xsl:variable name=\"partname\" select=\"''\"/>\n"
"</xsl:when>\n"
"<xsl:otherwise>\n"
"<xsl:variable name=\"partname\" select=\"@name\"/>\n"
"</xsl:otherwise>\n"
"</xsl:choose>\n"
"<xsl:if test=\"not(/wsdl:definitions/wsdl:message[@name = $inmsg or @name = $inhdr]/part[@name=$partname])\">\n"
"<xsl:text>        </xsl:text>\"<xsl:value-of select=\"@name\" />\" any<xsl:if test=\"position() < last()\">,\n"
"</xsl:if>\n"
"</xsl:if>\n"
"</xsl:for-each>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:operation\" mode=\"def_params\" >\n"
"<xsl:variable name=\"inmsg\" select=\"wsdl:input/@message\"/>\n"
"<xsl:variable name=\"outmsg\" select=\"wsdl:output/@message\"/>\n"
"<xsl:variable name=\"inhdr\" select=\"$oper/input/header/@message\"/>\n"
"<xsl:variable name=\"outhdr\" select=\"$oper/output/header/@message\"/>\n"
"<xsl:for-each select=\"/wsdl:definitions/wsdl:message[@name = $inmsg or @name = $outmsg or @name = $inhdr or @name = $outhdr]/part\" >\n"
"<xsl:choose>\n"
"<xsl:when test=\"parent::wsdl:message[@name = $inmsg or @name = $inhdr]\">\n"
"    <xsl:variable name=\"partname\" select=\"''\"/>\n"
"    <xsl:variable name=\"myname\" select=\"@name\"/>\n"
"    <xsl:choose>\n"
"	<xsl:when test=\"/wsdl:definitions/wsdl:message[@name = $outmsg or @name = $outhdr]/part[@name=$myname]\">\n"
"    <xsl:variable name=\"partty\" select=\"'inout'\"/>\n"
"    </xsl:when>\n"
"    <xsl:otherwise>\n"
"    <xsl:variable name=\"partty\" select=\"'in'\"/>\n"
"    </xsl:otherwise>\n"
"    </xsl:choose>\n"
"</xsl:when>\n"
"<xsl:otherwise>\n"
"<xsl:variable name=\"partname\" select=\"@name\"/>\n"
"    <xsl:variable name=\"partty\" select=\"'out'\"/>\n"
"</xsl:otherwise>\n"
"</xsl:choose>\n"
"<xsl:if test=\"not(/wsdl:definitions/wsdl:message[@name = $inmsg]/part[@name=$partname])\">\n"
"    <xsl:text>        </xsl:text><xsl:value-of select=\"$partty\"/><xsl:text> \"</xsl:text>\n"
"    <xsl:value-of select=\"@name\" /><xsl:text>\" any </xsl:text>\n"
"    <xsl:choose>\n"
"	<xsl:when test=\"/wsdl:definitions/wsdl:message[@name = $inhdr or @name = $outhdr]/part[@name=$myname]\">\n"
"	    <xsl:variable name=\"ishdr\" select=\"true()\"/>\n"
"	</xsl:when>\n"
"	<xsl:otherwise>\n"
"	    <xsl:variable name=\"ishdr\" select=\"false()\"/>\n"
"	</xsl:otherwise>\n"
"    </xsl:choose>\n"
"    <xsl:call-template name=\"soap_dt\">\n"
"	<xsl:with-param name=\"ishdr\" select=\"$ishdr\"/>\n"
"    </xsl:call-template>\n"
"    <xsl:if test=\"position() < last()\">,\n"
"</xsl:if>\n"
"</xsl:if>\n"
"</xsl:for-each>\n"
"</xsl:template>\n"
"\n"
"<xsl:template name=\"soap_dt\">\n"
"    <xsl:if test=\"@type != '' or @element != ''\">\n"
"	<xsl:text> </xsl:text>\n"
"	 <xsl:choose>\n"
"	     <xsl:when test=\"$ishdr\">__soap_header</xsl:when>\n"
"	     <xsl:otherwise>__soap_type</xsl:otherwise>\n"
"	 </xsl:choose>\n"
"	<xsl:text> '</xsl:text><xsl:call-template name=\"par_type\"/><xsl:text>'</xsl:text>\n"
"    </xsl:if>\n"
"</xsl:template>\n"
"\n"
"<xsl:template name=\"header_params\">\n"
"    <xsl:for-each select=\"wsdl:input/header\">\n"
"	<xsl:variable name=\"part\" select=\"@part\"/>\n"
"	<xsl:variable name=\"message\" select=\"@message\"/>\n"
"	<xsl:for-each select=\"/wsdl:definitions/wsdl:message[@name = $message]/part[@name=$part]\">\n"
"	    <xsl:text>        		</xsl:text>vector('<xsl:value-of select=\"@name\" />', '<xsl:call-template name=\"par_type\"/>'), \"<xsl:value-of select=\"@name\" /><xsl:text>\"</xsl:text>\n"
"	</xsl:for-each><xsl:if test=\"position() < last()\">,\n"
"</xsl:if>\n"
"    </xsl:for-each>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:operation\" mode=\"val_params\" >\n"
"<xsl:variable name=\"inmsg\" select=\"wsdl:input/@message\"/>\n"
"<xsl:for-each select=\"/wsdl:definitions/wsdl:message[@name = $inmsg]/part\" >\n"
"<xsl:text>        		</xsl:text>vector('<xsl:value-of select=\"@name\" />', '<xsl:call-template name=\"par_type\"/>'), \"<xsl:value-of select=\"@name\" />\" <xsl:if test=\"position() < last()\">,\n"
"</xsl:if>\n"
"</xsl:for-each>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"wsdl:operation\" mode=\"ret_params\" >\n"
"<xsl:variable name=\"msg\" select=\"wsdl:output/@message\"/>\n"
"<xsl:for-each select=\"/wsdl:definitions/wsdl:message[@name = $msg]/part\" >\n"
"    <xsl:text> declare temp any;     </xsl:text>\n"
"    <xsl:text> temp:= </xsl:text> xpath_eval ('//<xsl:call-template name=\"xpf_elm\"/>', xe, 1); if (temp is NULL) return NULL;\n"
"    <xsl:text>      </xsl:text>\"<xsl:value-of select=\"@name\" />\" := xml_cut (temp);\n"
"    <xsl:if test=\"@type != '' or @element != ''\">\n"
"	<xsl:text>      </xsl:text>\"<xsl:value-of select=\"@name\" />\" := soap_box_xml_entity_validating (\"<xsl:value-of select=\"@name\" />\", '<xsl:call-template name=\"par_type\"/>', <xsl:call-template name=\"type_mode\"/>);\n"
"    </xsl:if>\n"
"</xsl:for-each>\n"
"</xsl:template>\n"
"\n"
"<xsl:template name=\"par_type\">\n"
"<xsl:choose>\n"
"<xsl:when test=\"@type\">\n"
"<xsl:value-of select=\"@type\" />\n"
"</xsl:when>\n"
"<xsl:when test=\"@element\">\n"
"<xsl:value-of select=\"@element\" />\n"
"</xsl:when>\n"
"</xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<xsl:template name=\"xpf_elm\">\n"
"<xsl:choose>\n"
"<xsl:when test=\"@type\"><xsl:value-of select=\"@name\" /></xsl:when>\n"
"<xsl:when test=\"@element\"><xsl:value-of select=\"vi:split-name(@element,1)\" /></xsl:when>\n"
"</xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<xsl:template name=\"type_mode\">\n"
"<xsl:choose>\n"
"<xsl:when test=\"@type\">0</xsl:when>\n"
"<xsl:when test=\"@element\">1</xsl:when>\n"
"</xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*\"/>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* xmlrpc_soap.xsl */

static const char *xsl17[]= {
"<?xml version='1.0'?>\n"
"<!--\n"
" -\n"
" -  $Id: xmlrpc_soap.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n"
"     version=\"1.0\"\n"
"     xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"\n"
"     xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n"
"     xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"\n"
"     xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
"     xmlns:SOAP=\"http://schemas.xmlsoap.org/soap/envelope/\"\n"
"     xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
"     xmlns:vi=\"http://www.openlinksw.com/xmlrpc/\"\n"
"     >\n"
"\n"
"<xsl:output method=\"xml\" omit-xml-declaration=\"no\" indent=\"yes\" />\n"
"\n"
"<xsl:param name=\"call\" select=\"''\" />\n"
"\n"
"<xsl:template match=\"/\">\n"
"  <SOAP:Envelope SOAP:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">\n"
"    <SOAP:Body>\n"
"      <xsl:apply-templates select=\"node()\" />\n"
"    </SOAP:Body>\n"
"  </SOAP:Envelope>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"methodCall\">\n"
"<xsl:element name=\"{methodName}\" namespace=\"\">\n"
"  <xsl:apply-templates select=\"*\"><xsl:with-param name=\"method\" select=\"methodName\"/></xsl:apply-templates>\n"
"</xsl:element>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"methodResponse\">\n"
"  <xsl:choose>\n"
"  <xsl:when test=\"fault\">\n"
"    <xsl:apply-templates select=\"*\"><xsl:with-param name=\"method\" select=\"''\"/></xsl:apply-templates>\n"
"  </xsl:when>\n"
"  <xsl:otherwise>\n"
"  <xsl:copy>\n"
"    <xsl:apply-templates select=\"*\"><xsl:with-param name=\"method\" select=\"''\"/></xsl:apply-templates>\n"
"  </xsl:copy>\n"
"  </xsl:otherwise>\n"
"  </xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"fault\">\n"
"   <SOAP:Fault>\n"
"     <faultcode><xsl:apply-templates select=\".//member[name='faultCode']/value\" mode=\"value\"/></faultcode>\n"
"     <faultstring><xsl:apply-templates select=\".//member[name='faultString']/value\" mode=\"value\"/></faultstring>\n"
"     <detail/>\n"
"   </SOAP:Fault>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"params\">\n"
"  <xsl:for-each select=\"param\">\n"
"  <xsl:choose>\n"
"  <xsl:when test=\"$method != ''\">\n"
"  <xsl:variable name=\"elname\" select=\"vi:getParamName ($method, position ())\" />\n"
"  </xsl:when>\n"
"  <xsl:otherwise>\n"
"  <xsl:variable name=\"elname\" select=\"concat ('Param', position ())\" />\n"
"  </xsl:otherwise>\n"
"  </xsl:choose>\n"
"  <xsl:element name=\"{$elname}\">\n"
"  <xsl:attribute name=\"type\" namespace=\"http://www.w3.org/2001/XMLSchema-instance\">\n"
"      <xsl:apply-templates select=\"value\" mode=\"type\" />\n"
"  </xsl:attribute>\n"
"  <xsl:if test=\"value/array\">\n"
"  <xsl:attribute name=\"arrayType\" namespace=\"http://schemas.xmlsoap.org/soap/encoding/\">\n"
"    <xsl:apply-templates select=\"value/array/data/*[1]\" mode=\"type\" /><xsl:value-of select=\"concat('[',count(value/array/data/*),']')\" />\n"
"  </xsl:attribute>\n"
"  </xsl:if>\n"
"  <xsl:apply-templates select=\"value\" mode=\"value\" />\n"
"  </xsl:element>\n"
"  </xsl:for-each>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"value\" mode=\"type\">\n"
"<xsl:choose>\n"
"<xsl:when test=\"i4|int\">http://www.w3.org/2001/XMLSchema:int</xsl:when>\n"
"<xsl:when test=\"string\">http://www.w3.org/2001/XMLSchema:string</xsl:when>\n"
"<xsl:when test=\"double\">http://www.w3.org/2001/XMLSchema:double</xsl:when>\n"
"<xsl:when test=\"boolean\">http://www.w3.org/2001/XMLSchema:boolean</xsl:when>\n"
"<xsl:when test=\"local-name(*[1]) = 'dateTime.iso8601'\">http://www.w3.org/2001/XMLSchema:dateTime</xsl:when>\n"
"<xsl:when test=\"base64\">http://www.w3.org/2001/XMLSchema:base64Binary</xsl:when>\n"
"<xsl:when test=\"struct\">http://schemas.xmlsoap.org/soap/encoding/:Struct</xsl:when>\n"
"<xsl:when test=\"array\">http://schemas.xmlsoap.org/soap/encoding/:Array</xsl:when>\n"
"<xsl:otherwise>http://www.w3.org/2001/XMLSchema:string</xsl:otherwise>\n"
"</xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<!--xsl:comment><xsl:value-of select=\"value/i4\" /></xsl:comment-->\n"
"<xsl:template match=\"value\" mode=\"value\">\n"
"  <xsl:choose>\n"
"    <xsl:when test=\"struct\">\n"
"	<xsl:for-each select=\"struct/member\">\n"
"	    <xsl:choose>\n"
"		<xsl:when test=\"name like '[0-9]%'\">\n"
"		    <xsl:variable name=\"mname\" select=\"concat('_',name)\"/>\n"
"		</xsl:when>\n"
"		<xsl:otherwise>\n"
"		    <xsl:variable name=\"mname\" select=\"name\"/>\n"
"		</xsl:otherwise>\n"
"	    </xsl:choose>\n"
"          <xsl:element name=\"{$mname}\">\n"
"	      <xsl:attribute name=\"type\" namespace=\"http://www.w3.org/2001/XMLSchema-instance\">\n"
"		  <xsl:apply-templates select=\"value\" mode=\"type\" />\n"
"	      </xsl:attribute>\n"
"	      <xsl:if test=\"value/array\">\n"
"	        <xsl:attribute name=\"arrayType\" namespace=\"http://schemas.xmlsoap.org/soap/encoding/\">\n"
"	          <xsl:apply-templates select=\"value/array/data/*[1]\" mode=\"type\" /><xsl:value-of select=\"concat('[',count(value/array/data/*),']')\" />\n"
"	        </xsl:attribute>\n"
"              </xsl:if>\n"
"             <xsl:apply-templates select=\"value\" mode=\"value\" />\n"
"          </xsl:element>\n"
"        </xsl:for-each>\n"
"    </xsl:when>\n"
"    <xsl:when test=\"array\">\n"
"        <xsl:for-each select=\"array/data/value\">\n"
"          <item>\n"
"	      <xsl:attribute name=\"type\" namespace=\"http://www.w3.org/2001/XMLSchema-instance\">\n"
"		  <xsl:apply-templates select=\".\" mode=\"type\" />\n"
"	      </xsl:attribute>\n"
"             <xsl:apply-templates select=\".\" mode=\"value\" />\n"
"          </item>\n"
"        </xsl:for-each>\n"
"    </xsl:when>\n"
"    <xsl:when test=\"*\">\n"
"      <xsl:apply-templates select=\"*\" mode=\"value\" />\n"
"    </xsl:when>\n"
"    <xsl:otherwise>\n"
"      <xsl:value-of select=\"text()\" />\n"
"    </xsl:otherwise>\n"
"  </xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*\">\n"
"</xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
"\n"
,
 NULL };

/* soap_xmlrpc.xsl */

static const char *xsl18[]= {
"<?xml version='1.0'?>\n"
"<!--\n"
" -\n"
" -  $Id: soap_xmlrpc.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\"\n"
"     version=\"1.0\"\n"
"     xmlns:wsdl=\"http://schemas.xmlsoap.org/wsdl/\"\n"
"     xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n"
"     xmlns:soap=\"http://schemas.xmlsoap.org/wsdl/soap/\"\n"
"     xmlns:soapenc=\"http://schemas.xmlsoap.org/soap/encoding/\"\n"
"     xmlns:SOAP=\"http://schemas.xmlsoap.org/soap/envelope/\"\n"
"     xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
"     xmlns:vi=\"http://www.openlinksw.com/xmlrpc/\"\n"
"     >\n"
"\n"
"<xsl:output method=\"xml\" omit-xml-declaration=\"no\" indent=\"yes\" />\n"
"\n"
"<xsl:param name=\"call\" select=\"''\" />\n"
"\n"
"<xsl:template match=\"/\">\n"
"   <xsl:apply-templates select=\"*\" />\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"SOAP:Envelope\">\n"
"   <xsl:apply-templates select=\"*\" />\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"SOAP:Body\">\n"
"<xsl:choose>\n"
"<xsl:when test=\"$call != ''\">\n"
"   <methodCall>\n"
"     <methodName><xsl:value-of select=\"name(*[1])\" /></methodName>\n"
"     <params>\n"
"       <xsl:for-each select=\"*[1]/*\">\n"
"         <param>\n"
"           <value>\n"
"             <xsl:apply-templates select=\".\" mode=\"value\" />\n"
"           </value>\n"
"         </param>\n"
"       </xsl:for-each>\n"
"     </params>\n"
"   </methodCall>\n"
"</xsl:when>\n"
"<xsl:otherwise>\n"
"   <methodResponse>\n"
"     <params>\n"
"       <xsl:for-each select=\"*[1]/*\">\n"
"         <param>\n"
"           <value>\n"
"             <xsl:apply-templates select=\".\" mode=\"value\" />\n"
"           </value>\n"
"         </param>\n"
"       </xsl:for-each>\n"
"     </params>\n"
"   </methodResponse>\n"
"</xsl:otherwise>\n"
"</xsl:choose>\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*\" mode=\"value\">\n"
"\n"
" <!--xsl:comment><xsl:value-of select=\"count(*)\" /></xsl:comment-->\n"
" <xsl:choose>\n"
" <xsl:when test=\"@xsi:type\">\n"
"   <xsl:variable name=\"xsitype\" select=\"@xsi:type\"/>\n"
" </xsl:when>\n"
" <xsl:when test=\"parent::*[@soapenc:arrayType]/@xsi:type\">\n"
"   <xsl:variable name=\"xsitype\" select=\"substring-before (parent::*[@soapenc:arrayType]/@xsi:type, '[')\"/>\n"
" </xsl:when>\n"
" <xsl:otherwise>\n"
"   <xsl:variable name=\"xsitype\" select=\"''\"/>\n"
" </xsl:otherwise>\n"
" </xsl:choose>\n"
"\n"
" <xsl:choose>\n"
" <xsl:when test=\"@soapenc:arrayType\">\n"
"   <xsl:variable name=\"elname\" select=\"'array'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:string'\">\n"
" <xsl:variable name=\"elname\" select=\"'string'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:int'\">\n"
" <xsl:variable name=\"elname\" select=\"'i4'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:double'\">\n"
" <xsl:variable name=\"elname\" select=\"'double'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:decimal'\">\n"
" <xsl:variable name=\"elname\" select=\"'double'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:float'\">\n"
" <xsl:variable name=\"elname\" select=\"'double'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:boolean'\">\n"
" <xsl:variable name=\"elname\" select=\"'boolean'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:dateTime'\">\n"
" <xsl:variable name=\"elname\" select=\"'dateTime.iso8601'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"$xsitype = 'http://www.w3.org/2001/XMLSchema:base64Binary'\">\n"
" <xsl:variable name=\"elname\" select=\"'base64'\" />\n"
" </xsl:when>\n"
" <xsl:when test=\"*\">\n"
"   <xsl:variable name=\"elname\" select=\"'struct'\" />\n"
" </xsl:when>\n"
" <xsl:otherwise>\n"
" <xsl:variable name=\"elname\" select=\"'string'\" />\n"
" </xsl:otherwise>\n"
" </xsl:choose>\n"
"\n"
" <xsl:element name=\"{$elname}\">\n"
" <xsl:choose>\n"
" <xsl:when test=\"$elname = 'struct'\">\n"
"   <xsl:for-each select=\"*\">\n"
"     <xsl:if test=\"not boolean(number(@xsi:nil))\">\n"
"     <member>\n"
"       <name><xsl:value-of select=\"name()\" /></name>\n"
"       <value><xsl:apply-templates select=\".\" mode=\"value\" /></value>\n"
"     </member>\n"
"     </xsl:if>\n"
"   </xsl:for-each>\n"
" </xsl:when>\n"
" <xsl:when test=\"$elname = 'array'\">\n"
"    <data>\n"
"      <xsl:for-each select=\"*\">\n"
"         <value><xsl:apply-templates select=\".\" mode=\"value\" /></value>\n"
"      </xsl:for-each>\n"
"    </data>\n"
" </xsl:when>\n"
" <xsl:when test=\"$elname = 'dateTime.iso8601'\">\n"
"     <xsl:variable name=\"dt\" select=\"vi:getGMTtime(.)\" />\n"
"  <xsl:value-of select=\"concat (translate (substring-before($dt, 'T'), '-', ''), 'T', substring-after ($dt, 'T'))\" />\n"
" </xsl:when>\n"
" <xsl:otherwise>\n"
" <xsl:value-of select=\".\" />\n"
" </xsl:otherwise>\n"
" </xsl:choose>\n"
" </xsl:element>\n"
"\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"*\">\n"
"</xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
"\n"
"\n"
,
 NULL };

/* soap12_router.xsl */

static const char *xsl19[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: soap12_router.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"    xmlns:env=\"http://www.w3.org/2003/05/soap-envelope\"\n"
"    xmlns:enc=\"http://www.w3.org/2003/05/soap-encoding\"\n"
"    xmlns:rpc=\"http://www.w3.org/2003/05/soap-rpc\">\n"
"    <xsl:output method=\"xml\" indent=\"yes\" />\n"
"    <xsl:param name=\"this\" />\n"
"    <xsl:param name=\"next\" select=\"'http://www.w3.org/2003/05/soap-encoding/role/next'\"/>\n"
"    <xsl:template match=\"/\">\n"
"	<env:Envelope>\n"
"	    <xsl:apply-templates />\n"
"	</env:Envelope>\n"
"    </xsl:template>\n"
"    <xsl:template match=\"env:Envelope\">\n"
"	<xsl:apply-templates />\n"
"    </xsl:template>\n"
"    <xsl:template match=\"*[@env:role = $this or @env:role = $next]\"/>\n"
"    <xsl:template match=\"*\">\n"
"	<xsl:copy>\n"
"	    <xsl:copy-of select=\"@*\" />\n"
"	    <xsl:apply-templates />\n"
"	</xsl:copy>\n"
"    </xsl:template>\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* wsrm_ddl.sql */

static const char *udt1 = 
"CREATE TYPE SOAP_CLIENT_REQ AS\n"
"(\n"
"url varchar,\n"
"operation varchar,\n"
"target_namespace varchar default null,\n"
"parameters any default null,\n"
"headers any default null,\n"
"soap_action varchar default \'\',\n"
"attachments any default null,\n"
"ticket any default null,\n"
"passwd varchar default null,\n"
"user_name varchar default null,\n"
"user_password varchar default null,\n"
"auth_type varchar default \'none\',\n"
"security_type varchar default \'sign\',\n"
"debug integer default 0,\n"
"template varchar default null,\n"
"style integer default 1,\n"
"version integer default 11,\n"
"direction integer default 0,\n"
"security_schema any default null\n"
")\n";


static const char *alter7 = 
" alter type SOAP_CLIENT_REQ add attribute security_schema any\n";

static const char *udt2 = 
"create type WSA_CLI as\n"
"(\n"
"mid varchar default null,\n"
"\"to\" varchar default null,\n"
"\"from\" varchar default null,\n"
"action varchar default null,\n"
"fault_to varchar default null,\n"
"reply_to varchar default null\n"
")\n"
"constructor method WSA_CLI ()\n";

static const char *other131 = 
"create constructor method WSA_CLI () for WSA_CLI\n"
"{\n"
"self.mid := lower (\'uuid:\' || uuid ());\n"
"}\n";

static const char *tbl14 = 
"CREATE TABLE SYS_WSRM_IN_MESSAGE_LOG (\n"
"IML_INDENTIFIER 	varchar,\n"
"IML_MESSAGE_ID 		int NOT NULL,\n"
"IML_EXPIRE_DATE 	datetime,\n"
"IML_RECEIVE_DATE 	timestamp NOT NULL ,\n"
"IML_MESSAGE 		long varchar NOT NULL,\n"
"IML_EXECUTE_RESP	long varchar,\n"
"IML_ADDRES		long DB.DBA.WSA_CLI NOT NULL,\n"
"IML_STATE		int default 0,\n"
"primary key (IML_INDENTIFIER, IML_MESSAGE_ID)\n"
")\n";

static const char *tbl15 = 
"CREATE TABLE SYS_WSRM_IN_SEQUENCES\n"
"(\n"
"WIS_IDENTIFIER 			varchar,\n"
"WIS_VERSION 			varchar,\n"
"WIS_DELIVERY_ASSURANCE 		varchar,\n"
"WIS_SEQUENCE_EXPIRATION 	datetime,\n"
"WIS_INACTIVITY_TIMEOUT 		integer,\n"
"WIS_RETRANSMISSION_INTERVAL 	integer,\n"
"WIS_ACKNOWLEDGEMENT_INTERVAL 	integer,\n"
"WIS_ACK_SENT			int default 0,\n"
"primary key (WIS_IDENTIFIER)\n"
")\n";

static const char *trig5 = 
"create trigger SYS_WSRM_IN_SEQUENCES_D after delete on SYS_WSRM_IN_SEQUENCES\n"
"{\n"
"delete from SYS_WSRM_IN_MESSAGE_LOG where IML_INDENTIFIER = WIS_IDENTIFIER;\n"
"}\n"
"--src wsrm_ddl.sql:97\n";

static const char *tbl16 = 
"CREATE TABLE SYS_WSRM_OUT_MESSAGE_LOG (\n"
"OML_INDENTIFIER 	varchar,\n"
"OML_MESSAGE_ID 		int NOT NULL,\n"
"OML_EXPIRE_DATE 	datetime,\n"
"OML_SEND_DATE 		timestamp NOT NULL,\n"
"OML_MESSAGE 		long DB.DBA.SOAP_CLIENT_REQ NOT NULL,\n"
"OML_ADDRESS 		long DB.DBA.WSA_CLI NOT NULL,\n"
"OML_STATE		int,\n"
"OML_RESPONSE		long xml,\n"
"primary key (OML_INDENTIFIER, OML_MESSAGE_ID)\n"
")\n";


static const char *alter8 = 
" alter table SYS_WSRM_OUT_MESSAGE_LOG add OML_RESPONSE long xml\n";

static const char *tbl17 = 
"CREATE TABLE SYS_WSRM_OUT_SEQUENCES\n"
"(\n"
"WOS_IDENTIFIER 			varchar,\n"
"WOS_VERSION 			varchar,\n"
"WOS_DELIVERY_ASSURANCE 		varchar,\n"
"WOS_SEQUENCE_EXPIRATION 	datetime,\n"
"WOS_INACTIVITY_TIMEOUT 		integer,\n"
"WOS_RETRANSMISSION_INTERVAL 	integer,\n"
"WOS_ACKNOWLEDGEMENT_INTERVAL 	integer,\n"
"WOS_LAST_SENT			integer,\n"
"primary key (WOS_IDENTIFIER)\n"
")\n";

static const char *trig6 = 
"create trigger SYS_WSRM_OUT_SEQUENCES_D after delete on SYS_WSRM_OUT_SEQUENCES\n"
"{\n"
"delete from SYS_WSRM_OUT_MESSAGE_LOG where OML_INDENTIFIER = WOS_IDENTIFIER;\n"
"}\n"
"--src wsrm_ddl.sql:136\n";


static const char *alter9 = 
" alter table SYS_WSRM_OUT_SEQUENCES add WOS_LAST_SENT integer\n";

static const char *udt3 = 
"create type soap_parameter as\n"
"(\n"
"s any default null,\n"
"param_type int default 1,\n"
"param_xsd varchar default null,\n"
"ver int default 11\n"
")\n"
"temporary self as ref\n"
"constructor method soap_complex_parameter (),\n"
"constructor method soap_simple_parameter (val any),\n"
"constructor method soap_array_parameter (n int),\n"
"constructor method soap_single_parameter (elm soap_parameter),\n"
"method get_length () returns any,\n"
"method add_member (name varchar, val any) returns any,\n"
"method set_member (name varchar, val any) returns any,\n"
"method set_member (pos int, val any) returns any,\n"
"method get_member (name varchar) returns any,\n"
"method get_member (pos int) returns any,\n"
"method get_value () returns any,\n"
"method set_value (val any) returns any,\n"
"method set_attribute (name varchar, val any) returns any,\n"
"method get_attribute (name varchar) returns any,\n"
"method get_call_param (name varchar) returns any,\n"
"method set_xsd (xsd varchar) returns any,\n"
"method deserialize (xs any, elem varchar) returns any,\n"
"method serialize (tag varchar) returns any,\n"
"method check_struct () returns any,\n"
"method check_simple () returns any,\n"
"method set_struct (s any) returns any\n";

static const char *other132 = 
"create method check_struct () for soap_parameter\n"
"{\n"
"if (self.s is not null and self.param_type <> 1)\n"
"signal (\'22023\', \'Not structure\');\n"
"}\n";

static const char *other133 = 
"create method check_simple () for soap_parameter\n"
"{\n"
"if (self.s is not null and self.param_type <> 0)\n"
"signal (\'22023\', \'Not simple type\');\n"
"}\n";

static const char *other134 = 
"create method set_struct (in s any) for soap_parameter\n"
"{\n"
"self.s := s;\n"
"if (isarray (s) and length (s))\n"
"{\n"
"if (__tag (s[0]) = 255 and length (s) = 3)\n"
"self.param_type := 0;\n"
"else if (__tag (s[0]) = 255 and mod (length (s), 2) = 0)\n"
"self.param_type := 1;\n"
"else\n"
"self.param_type := 2;\n"
"}\n"
"}\n";

static const char *other135 = 
"create constructor method soap_complex_parameter () for soap_parameter\n"
"{\n"
"self.s := vector (composite (), \'\');\n"
"}\n";

static const char *other136 = 
"create constructor method soap_simple_parameter (in val any) for soap_parameter\n"
"{\n"
"self.s := vector (composite (), \'\', val);\n"
"self.param_type := 0;\n"
"}\n";

static const char *other137 = 
"create constructor method soap_array_parameter (in n int) for soap_parameter\n"
"{\n"
"self.s := make_array (n, \'any\');\n"
"self.param_type := 2;\n"
"}\n";

static const char *other138 = 
"create constructor method soap_single_parameter (in elm soap_parameter) for soap_parameter\n"
"{\n"
"self.s := vector (elm.s);\n"
"self.param_type := 2;\n"
"}\n";

static const char *other139 = 
"create method get_length () for soap_parameter\n"
"{\n"
"if (self.s is null)\n"
"return 0;\n"
"\n"
"if (self.param_type)\n"
"return ((length (self.s) - 2) / 2);\n"
"\n"
"return length (self.s[2]);\n"
"}\n";

static const char *other140 = 
"create method add_member (in name varchar, in val any) for soap_parameter\n"
"{\n"
"self.check_struct ();\n"
"if (__tag (val) = 206 and udt_instance_of (val, fix_identifier_case (\'DB.DBA.soap_parameter\')))\n"
"val := (val as soap_parameter).s;\n"
"self.s := vector_concat (self.s, vector (name, val));\n"
"}\n";

static const char *other141 = 
"create method set_member (in name varchar, in val any) for soap_parameter\n"
"{\n"
"declare pos int;\n"
"self.check_struct ();\n"
"if (__tag (val) = 206 and udt_instance_of (val, fix_identifier_case (\'DB.DBA.soap_parameter\')))\n"
"val := (val as soap_parameter).s;\n"
"pos := position (name, self.s);\n"
"if (pos)\n"
"{\n"
"declare tmp any;\n"
"tmp := self.s;\n"
"tmp[pos] := val;\n"
"self.s := tmp;\n"
"}\n"
"else\n"
"self.add_member (name, val);\n"
"}\n";

static const char *other142 = 
"create method set_member (in pos int, in val any) for soap_parameter\n"
"{\n"
"self.check_struct ();\n"
"if (pos >= self.get_length () or pos < 0)\n"
"signal (\'22023\', \'Bad range\');\n"
"\n"
"if (__tag (val) = 206 and udt_instance_of (val, fix_identifier_case (\'DB.DBA.soap_parameter\')))\n"
"val := (val as soap_parameter).s;\n"
"declare tmp any;\n"
"tmp := self.s;\n"
"tmp[((pos+1)*2)+1] := val;\n"
"self.s := tmp;\n"
"}\n";

static const char *other143 = 
"create method get_member (in name varchar) for soap_parameter\n"
"{\n"
"self.check_struct ();\n"
"return get_keyword (name, self.s);\n"
"}\n";

static const char *other144 = 
"create method get_member (in pos int) for soap_parameter\n"
"{\n"
"self.check_struct ();\n"
"return self.s[((pos+1)*2)+1];\n"
"}\n";

static const char *other145 = 
"create method get_value () for soap_parameter\n"
"{\n"
"self.check_simple ();\n"
"return self.s[2];\n"
"}\n";

static const char *other146 = 
"create method set_value (in val any) for soap_parameter\n"
"{\n"
"self.check_simple ();\n"
"declare tmp any;\n"
"tmp := self.s;\n"
"tmp[2] := val;\n"
"self.s := tmp;\n"
"}\n";

static const char *other147 = 
"create method set_attribute (in name varchar, in val any) for soap_parameter\n"
"{\n"
"declare tmp, attr any;\n"
"declare pos int;\n"
"\n"
"tmp := self.s;\n"
"attr := tmp[1];\n"
"\n"
"if (not isarray (attr) or isstring (attr))\n"
"attr := vector ();\n"
"\n"
"pos := position (name, attr);\n"
"if (pos)\n"
"attr[pos] := val;\n"
"else\n"
"attr := vector_concat (attr, vector (name, val));\n"
"\n"
"tmp[1] := attr;\n"
"self.s := tmp;\n"
"}\n";

static const char *other148 = 
"create method get_attribute (in name varchar) for soap_parameter\n"
"{\n"
"declare tmp, attr any;\n"
"tmp := self.s;\n"
"attr := tmp[1];\n"
"\n"
"if (not isarray (attr) or isstring (attr))\n"
"attr := vector ();\n"
"return get_keyword (name, attr);\n"
"}\n";

static const char *other149 = 
"create method set_xsd (in xsd varchar) for soap_parameter\n"
"{\n"
"self.param_xsd := xsd;\n"
"}\n";

static const char *other150 = 
"create method deserialize (in xs any, in elem varchar) for soap_parameter\n"
"{\n"
"declare xt, xp, val any;\n"
"xt := xml_tree_doc (xs);\n"
"xp := xpath_eval (\'//\'||elem, xt, 1);\n"
"if (xp is null)\n"
"{\n"
"self.s := vector ();\n"
"return;\n"
"}\n"
"\n"
"if (self.param_xsd is not null)\n"
"val := soap_box_xml_entity_validating (xml_cut(xp), self.param_xsd);\n"
"else\n"
"val := soap_box_xml_entity (xml_cut(xp), self.s, self.ver);\n"
"self.s := val;\n"
"}\n";

static const char *other151 = 
"create method serialize (in tag varchar) for soap_parameter\n"
"{\n"
"if (self.param_xsd is not null)\n"
"return soap_print_box_validating (self.s, tag, self.param_xsd, 0, 0);\n"
"else\n"
"return soap_print_box (self.s, tag, self.ver);\n"
"}\n";

static const char *other152 = 
"create method get_call_param (in name varchar) for soap_parameter\n"
"{\n"
"if (self.param_xsd is not null)\n"
"return vector (vector (name, self.param_xsd), self.s);\n"
"else\n"
"return vector (name, self.s);\n"
"}\n";

static const char *proc240 = 
"create procedure WSRM_ENSURE_SCH ()\n"
"{\n"
"if (registry_get (\'__wsrm_version__\') = \'0.8\')\n"
"return;\n"
"\n"
"SOAP_LOAD_SCH (WSRM_WSRM_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_WSP_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_WSA_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_UTILITY_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_UTILITY200306_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_WSS_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_WSA200403_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_OASIS200401WSSUTILITY_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_ORABPEL_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_WSRM_2005_02_XSD (), null, 0, 0);\n"
"SOAP_LOAD_SCH (WSRM_WSA200408_XSD (), null, 0, 0);\n"
"\n"
"registry_set (\'__wsrm_version__\', \'0.8\');\n"
"}\n"
"--src wsrm_ddl.sql:397\n";


static const char *other153 = 
" WSRM_ENSURE_SCH ()\n";
/* wsrm_xsd.sql */

static const char *proc241 = 
"CREATE PROCEDURE WSRM_WSRM_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xsd:schema\\n\', ses);\n"
"http (\'    	targetNamespace=\"http://schemas.xmlsoap.org/ws/2004/03/rm\"\\n\', ses);\n"
"http (\'	xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\"\\n\', ses);\n"
"http (\'	xmlns:wsrm=\"http://schemas.xmlsoap.org/ws/2004/03/rm\"\\n\', ses);\n"
"http (\'	xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\\n\', ses);\n"
"http (\'	xmlns:wssu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\"\\n\', ses);\n"
"http (\'	elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\">\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<!-- *** BASE ***\\n\', ses);\n"
"http (\'	-->\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"SequenceType\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Identifier\"/>\\n\', ses);\n"
"http (\'	    <xsd:element name=\"MessageNumber\" type=\"xsd:unsignedLong\"/>\\n\', ses);\n"
"http (\'	    <xsd:element name=\"LastMessage\" type=\"xsd:ENTITY\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:attribute ref=\"wssu:Id\" />\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"SequenceTerminate_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Identifier\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:attribute ref=\"wssu:Id\" />\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"AcknowledgmentRange_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Upper\" type=\"xsd:unsignedLong\" use=\"required\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Lower\" type=\"xsd:unsignedLong\" use=\"required\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"SequenceAcknowledgment_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Identifier\"/>\\n\', ses);\n"
"http (\'	    <xsd:element name=\"AcknowledgmentRange\" type=\"wsrm:AcknowledgmentRange_t\" maxOccurs=\"unbounded\">\\n\', ses);\n"
"http (\'	    </xsd:element>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:attribute ref=\"wssu:Id\" />\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"SequenceAcknowledgement_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Identifier\"/>\\n\', ses);\n"
"http (\'	    <xsd:element name=\"AcknowledgementRange\" type=\"wsrm:AcknowledgmentRange_t\" maxOccurs=\"unbounded\">\\n\', ses);\n"
"http (\'	    </xsd:element>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:attribute ref=\"wssu:Id\" />\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"AckRequestedType\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Identifier\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:element name=\"Sequence\" type=\"wsrm:SequenceType\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"SequenceTerminate\" type=\"wsrm:SequenceTerminate_t\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"SequenceAcknowledgment\" type=\"wsrm:SequenceAcknowledgment_t\" />\\n\', ses);\n"
"http (\'    <xsd:element name=\"SequenceAcknowledgement\" type=\"wsrm:SequenceAcknowledgement_t\" />\\n\', ses);\n"
"http (\'    <xsd:element name=\"AckRequested\" type=\"wsrm:AckRequestedType\"/>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <!-- *** FAULTS ***\\n\', ses);\n"
"http (\'    -->\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:simpleType name=\"FaultCodes\">\\n\', ses);\n"
"http (\'	<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:UnknownSequence\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:SequenceTerminated\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:InvalidAcknowledgement\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:MessageNumberRollover\"/>\\n\', ses);\n"
"http (\'	</xsd:restriction>\\n\', ses);\n"
"http (\'    </xsd:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"SequenceFaultType\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Identifier\"/>\\n\', ses);\n"
"http (\'	    <xsd:element name=\"FaultCode\" type=\"wsrm:FaultCodes\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:element name=\"SequenceFault\" type=\"wsrm:SequenceFaultType\"/>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <!-- *** ASSERTATIONS ***\\n\', ses);\n"
"http (\'    -->\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"InactivityTimeout_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Milliseconds\" type=\"xsd:unsignedLong\" use=\"required\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"BaseRetransmissionInterval_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Milliseconds\" type=\"xsd:unsignedLong\" use=\"required\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"AcknowledgementInterval_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Milliseconds\" type=\"xsd:unsignedLong\" use=\"required\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"PolicyAssertionType\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:any namespace=\"##other\" processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:anyAttribute namespace=\"##other\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:simpleType name=\"DeliveryAssuranceEnum\">\\n\', ses);\n"
"http (\'	<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:AtMostOnce\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:AtLeastOnce\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:ExactlyOnce\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:InOrder\"/>\\n\', ses);\n"
"http (\'	</xsd:restriction>\\n\', ses);\n"
"http (\'    </xsd:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"DeliveryAssurance_t\">\\n\', ses);\n"
"http (\'	<xsd:sequence/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Value\" type=\"xsd:QName\" use=\"required\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:element name=\"InactivityTimeout\" type=\"wsrm:InactivityTimeout_t\" />\\n\', ses);\n"
"http (\'    <xsd:element name=\"BaseRetransmissionInterval\" type=\"wsrm:BaseRetransmissionInterval_t\" />\\n\', ses);\n"
"http (\'    <xsd:element name=\"ExponentialBackoff\" type=\"wsrm:PolicyAssertionType\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"AcknowledgementInterval\" type=\"wsrm:AcknowledgementInterval_t\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"DeliveryAssurance\" type=\"wsrm:DeliveryAssurance_t\"/>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <!-- *** Sequence Reference ***\\n\', ses);\n"
"http (\'    -->\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"SequenceRefType\">\\n\', ses);\n"
"http (\'	<xsd:sequence />\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Identifier\" type=\"xsd:anyURI\" use=\"required\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Match\" type=\"wsrm:MatchChoiceType\" use=\"optional\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:simpleType name=\"MatchChoiceType\">\\n\', ses);\n"
"http (\'	<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:Exact\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsrm:Prefix\"/>\\n\', ses);\n"
"http (\'	</xsd:restriction>\\n\', ses);\n"
"http (\'    </xsd:simpleType>\\n\', ses);\n"
"http (\'    <xsd:element name=\"SequenceRef\" type=\"wsrm:SequenceRefType\"/>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xsd:element name=\"CreateSequence\" type=\"wsrm:CreateSequenceType\"/>\\n\', ses);\n"
"http (\'  <xsd:complexType name=\"CreateSequenceType\">\\n\', ses);\n"
"http (\'     <xsd:sequence />\\n\', ses);\n"
"http (\'	<xsd:attribute ref=\"wssu:Id\" />\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'  <xsd:element name=\"CreateSequenceResponse\" type=\"wsrm:HandshakeType\"/>\\n\', ses);\n"
"http (\'  <xsd:element name=\"TerminateSequence\" type=\"wsrm:HandshakeType\"/>\\n\', ses);\n"
"http (\'  <xsd:complexType name=\"HandshakeType\">\\n\', ses);\n"
"http (\'    <xsd:sequence>\\n\', ses);\n"
"http (\'      <xsd:element ref=\"wsu:Identifier\"/>\\n\', ses);\n"
"http (\'    </xsd:sequence>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:7\n";

static const char *proc242 = 
"CREATE PROCEDURE WSRM_WSP_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xsd:schema\\n\', ses);\n"
"http (\'    targetNamespace=\"http://schemas.xmlsoap.org/ws/2002/12/policy\"\\n\', ses);\n"
"http (\'    xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\\n\', ses);\n"
"http (\'    xmlns:wsp=\"http://schemas.xmlsoap.org/ws/2002/12/policy\"\\n\', ses);\n"
"http (\'    xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\"\\n\', ses);\n"
"http (\'    xmlns:wsrm=\"http://schemas.xmlsoap.org/ws/2004/03/rm\"\\n\', ses);\n"
"http (\'    xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2003/03/addressing\"\\n\', ses);\n"
"http (\'    elementFormDefault=\"qualified\" blockDefault=\"#all\">\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:simpleType name=\"UsageType\">\\n\', ses);\n"
"http (\'	<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsp:Required\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsp:Optional\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsp:Rejected\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsp:Ignored\"/>\\n\', ses);\n"
"http (\'	    <xsd:enumeration value=\"wsp:Observed\"/>\\n\', ses);\n"
"http (\'	</xsd:restriction>\\n\', ses);\n"
"http (\'    </xsd:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"SpecVersionAssertion\">\\n\', ses);\n"
"http (\'	<xsd:sequence />\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"URI\" type=\"xsd:anyURI\" use=\"required\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name =\"Usage\" type=\"xsd:string\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Preference\" type=\"xsd:int\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Id\" type=\"xsd:ID\" use=\"optional\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"PolicyExpression\">\\n\', ses);\n"
"http (\'	<xsd:sequence minOccurs=\"0\" maxOccurs=\"unbounded\">\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsp:SpecVersion\" />\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsrm:DeliveryAssurance\" />\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Expires\" minOccurs=\"0\" maxOccurs=\"1\"/>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsrm:InactivityTimeout\" />\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsrm:BaseRetransmissionInterval\" />\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsrm:AcknowledgementInterval\" />\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Name\" type=\"xsd:NCName\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"TargetNamespace\" type=\"xsd:anyURI\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Id\" type=\"xsd:ID\" use=\"optional\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"PolicyAttachmentType\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsp:AppliesTo\"/>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsp:Policy\" minOccurs=\"0\" />\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsp:PolicyReference\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"AppliesTo\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsrm:SequenceRef\" minOccurs=\"0\" maxOccurs=\"1\"/>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsa:EndpointReference\" minOccurs=\"0\" maxOccurs=\"1\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"PolicyReferenceType\">\\n\', ses);\n"
"http (\'	<xsd:sequence />\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"URI\" type=\"xsd:anyURI\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Ref\" type=\"xsd:QName\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"Digest\" type=\"xsd:base64Binary\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"DigestAlgorithm\" type=\"xsd:QName\" use=\"optional\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:element name=\"AppliesTo\" type=\"wsp:AppliesTo\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"SpecVersion\" type=\"wsp:SpecVersionAssertion\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"Policy\" type=\"wsp:PolicyExpression\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"PolicyAttachment\" type=\"wsp:PolicyAttachmentType\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"PolicyReference\" type=\"wsp:PolicyReferenceType\"/>\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:179\n";

static const char *proc243 = 
"CREATE PROCEDURE WSRM_WSA_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\"?>\\n\', ses);\n"
"http (\'<xs:schema targetNamespace=\"http://schemas.xmlsoap.org/ws/2003/03/addressing\" xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2003/03/addressing\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" xmlns:ora=\"http://schemas.oracle.com/bpel\" elementFormDefault=\"qualified\" blockDefault=\"#all\">\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<xs:element name=\"EndpointReference\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'	<xs:complexType name=\"EndpointReferenceType\">\\n\', ses);\n"
"http (\'		<xs:sequence>\\n\', ses);\n"
"http (\'			<xs:element name=\"Address\" type=\"xs:anyURI\"/>\\n\', ses);\n"
"http (\'			<xs:element name=\"ReferenceProperties\" type=\"wsa:ReferencePropertiesType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'			<xs:element name=\"PortType\" type=\"wsa:AttributedQName\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'			<xs:element name=\"ServiceName\" type=\"wsa:ServiceNameType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'		</xs:sequence>\\n\', ses);\n"
"http (\'	<xs:attribute ref=\"wsu:Id\" />\\n\', ses);\n"
"http (\'	</xs:complexType>\\n\', ses);\n"
"http (\'	<xs:complexType name=\"ReferencePropertiesType\">\\n\', ses);\n"
"http (\'		<xs:sequence>\\n\', ses);\n"
"http (\'			<xs:any processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'		</xs:sequence>\\n\', ses);\n"
"http (\'	</xs:complexType>\\n\', ses);\n"
"http (\'	<xs:complexType name=\"ServiceNameType\">\\n\', ses);\n"
"http (\'		<xs:simpleContent>\\n\', ses);\n"
"http (\'			<xs:extension base=\"xs:QName\">\\n\', ses);\n"
"http (\'				<xs:attribute name=\"PortName\" type=\"xs:NCName\"/>\\n\', ses);\n"
"http (\'			</xs:extension>\\n\', ses);\n"
"http (\'		</xs:simpleContent>\\n\', ses);\n"
"http (\'	</xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    	<xs:complexType name=\"AttributedURI\">\\n\', ses);\n"
"http (\'		<xs:simpleContent>\\n\', ses);\n"
"http (\'	    		<xs:extension base=\"xs:anyURI\">\\n\', ses);\n"
"http (\'				<xs:attribute ref=\"wsu:Id\" use=\"optional\"/>\\n\', ses);\n"
"http (\'				<xs:attribute ref=\"ora:rootId\" use=\"optional\"/>\\n\', ses);\n"
"http (\'				<xs:attribute ref=\"ora:parentId\" use=\"optional\"/>\\n\', ses);\n"
"http (\'				<xs:attribute ref=\"ora:priority\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	    		</xs:extension>\\n\', ses);\n"
"http (\'		</xs:simpleContent>\\n\', ses);\n"
"http (\'    	</xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<xs:element name=\"MessageID\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'	<xs:element name=\"RelatesTo\" type=\"wsa:Relationship\"/>\\n\', ses);\n"
"http (\'	<xs:element name=\"To\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'	<xs:element name=\"Action\" type=\"wsa:AttributedURI\" nillable=\"false\" />\\n\', ses);\n"
"http (\'	<xs:element name=\"From\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'	<xs:element name=\"ReplyTo\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'	<xs:element name=\"FaultTo\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'	<xs:element name=\"Recipient\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'	<xs:complexType name=\"Relationship\">\\n\', ses);\n"
"http (\'		<xs:simpleContent>\\n\', ses);\n"
"http (\'			<xs:extension base=\"xs:anyURI\">\\n\', ses);\n"
"http (\'				<xs:attribute name=\"RelationshipType\" type=\"xs:QName\" use=\"optional\"/>\\n\', ses);\n"
"http (\'				<xs:attribute ref=\"wsu:Id\" />\\n\', ses);\n"
"http (\'			</xs:extension>\\n\', ses);\n"
"http (\'		</xs:simpleContent>\\n\', ses);\n"
"http (\'	</xs:complexType>\\n\', ses);\n"
"http (\'	<xs:simpleType name=\"RelationshipTypeValues\">\\n\', ses);\n"
"http (\'		<xs:restriction base=\"xs:QName\">\\n\', ses);\n"
"http (\'			<xs:enumeration value=\"wsa:Response\"/>\\n\', ses);\n"
"http (\'		</xs:restriction>\\n\', ses);\n"
"http (\'	</xs:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<xs:complexType name=\"AttributedQName\">\\n\', ses);\n"
"http (\'		<xs:simpleContent>\\n\', ses);\n"
"http (\'			<xs:extension base=\"xs:QName\">\\n\', ses);\n"
"http (\'			</xs:extension>\\n\', ses);\n"
"http (\'		</xs:simpleContent>\\n\', ses);\n"
"http (\'	</xs:complexType>\\n\', ses);\n"
"http (\'</xs:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:261\n";

static const char *proc244 = 
"CREATE PROCEDURE WSRM_UTILITY_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xsd:schema targetNamespace=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" xmlns=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\" version=\"0.1\">\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"AttributedURI\">\\n\', ses);\n"
"http (\'	<xsd:simpleContent>\\n\', ses);\n"
"http (\'	    <xsd:extension base=\"xsd:anyURI\">\\n\', ses);\n"
"http (\'		<xsd:attribute ref=\"wsu:Id\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	    </xsd:extension>\\n\', ses);\n"
"http (\'	</xsd:simpleContent>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"TimestampType\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element name=\"Created\" type=\"wsu:TimestampType_t\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'	    <xsd:element name=\"Expires\" type=\"wsu:TimestampType_t\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"TimestampType_t\">\\n\', ses);\n"
"http (\'	<xsd:simpleContent>\\n\', ses);\n"
"http (\'	    <xsd:extension base=\"xsd:dateTime\">\\n\', ses);\n"
"http (\'		<xsd:attribute ref=\"wsu:Id\" use=\"optional\"/>\\n\', ses);\n"
"http (\'	    </xsd:extension>\\n\', ses);\n"
"http (\'	</xsd:simpleContent>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:element name=\"Timestamp\" type=\"wsu:TimestampType\" />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:attribute name=\"Id\" type=\"xsd:ID\"/>\\n\', ses);\n"
"http (\'    <xsd:element name=\"Identifier\" type=\"wsu:AttributedURI\" />\\n\', ses);\n"
"http (\'    <xsd:element name=\"Expires\" type=\"wsu:TimestampType_t\" />\\n\', ses);\n"
"http (\'    <xsd:element name=\"Created\" type=\"wsu:TimestampType_t\" />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:339\n";

static const char *proc245 = 
"CREATE PROCEDURE WSRM_UTILITY200306_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xsd:schema targetNamespace=\"http://schemas.xmlsoap.org/ws/2003/06/utility\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2003/06/utility\" xmlns=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\" version=\"0.1\">\\n\', ses);\n"
"http (\'    <xsd:complexType name=\"TimestampType\">\\n\', ses);\n"
"http (\'	<xsd:sequence>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Created\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'	    <xsd:element ref=\"wsu:Expires\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'	</xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:attribute type=\"xsd:ID\" use=\"optional\"/>\\n\', ses);\n"
"http (\'    </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:element name=\"Timestamp\" type=\"wsu:TimestampType\" />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xsd:element name=\"Expires\" type=\"xsd:dateTime\" />\\n\', ses);\n"
"http (\'    <xsd:element name=\"Created\" type=\"xsd:dateTime\" />\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:382\n";

static const char *proc246 = 
"CREATE PROCEDURE WSRM_WSS_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xsd:schema \\n\', ses);\n"
"http (\'    targetNamespace=\"http://schemas.xmlsoap.org/ws/2003/06/secext\" \\n\', ses);\n"
"http (\'    xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" \\n\', ses);\n"
"http (\'    xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2003/06/utility\" \\n\', ses);\n"
"http (\'    xmlns:wsse=\"http://schemas.xmlsoap.org/ws/2003/06/secext\" \\n\', ses);\n"
"http (\'    xmlns=\"http://schemas.xmlsoap.org/ws/2003/06/secext\" \\n\', ses);\n"
"http (\'    xmlns:env=\"http://schemas.xmlsoap.org/soap/envelope/\" \\n\', ses);\n"
"http (\'    elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\">\\n\', ses);\n"
"http (\'	<xsd:element name=\"Security\" type=\"wsse:SecurityHeaderType\" />\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"SecurityHeaderType\">\\n\', ses);\n"
"http (\'	        <xsd:sequence>\\n\', ses);\n"
"http (\'		  <xsd:element ref=\"wsu:Timestamp\" minOccurs=\"0\" maxOccurs=\"1\" />\\n\', ses);\n"
"http (\'		</xsd:sequence>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:408\n";

static const char *proc247 = 
"CREATE PROCEDURE WSRM_WSS0212_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xsd:schema targetNamespace=\"http://schemas.xmlsoap.org/ws/2002/12/secext\" \\n\', ses);\n"
"http (\'            xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" \\n\', ses);\n"
"http (\'            xmlns=\"http://schemas.xmlsoap.org/ws/2002/12/secext\" \\n\', ses);\n"
"http (\'            xmlns:wsse=\"http://schemas.xmlsoap.org/ws/2002/12/secext\" \\n\', ses);\n"
"http (\'            xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" \\n\', ses);\n"
"http (\'	    xmlns:wsp=\"http://schemas.xmlsoap.org/ws/2002/12/policy\"\\n\', ses);\n"
"http (\'            xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" \\n\', ses);\n"
"http (\'            xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2003/03/addressing\"\\n\', ses);\n"
"http (\'            xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" \\n\', ses);\n"
"http (\'            xmlns:ds=\"http://www.w3.org/2000/09/xmldsig#\" \\n\', ses);\n"
"http (\'            elementFormDefault=\"qualified\" \\n\', ses);\n"
"http (\'            attributeFormDefault=\"unqualified\" \\n\', ses);\n"
"http (\'            blockDefault=\"#all\" \\n\', ses);\n"
"http (\'            version=\"0.3\">\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<xsd:import namespace=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" schemaLocation=\"http://schemas.xmlsoap.org/ws/2002/07/utility\"/>\\n\', ses);\n"
"http (\'    <xsd:import namespace=\"http://schemas.xmlsoap.org/ws/2002/12/policy\" schemaLocation=\"http://schemas.xmlsoap.org/ws/2002/12/policy\" />\\n\', ses);\n"
"http (\'	<xsd:import namespace=\"http://www.w3.org/XML/1998/namespace\" schemaLocation=\"http://www.w3.org/2001/xml.xsd\"/>\\n\', ses);\n"
"http (\'	<xsd:import namespace=\"http://www.w3.org/2000/09/xmldsig#\" schemaLocation=\"http://www.w3.org/TR/2002/REC-xmldsig-core-20020212/xmldsig-core-schema.xsd\"/>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"AttributedString\">\\n\', ses);\n"
"http (\'		<xsd:simpleContent>\\n\', ses);\n"
"http (\'				<xsd:attribute ref=\"wsu:Id\"/>\\n\', ses);\n"
"http (\'				<xsd:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'		</xsd:simpleContent>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"PasswordString\">\\n\', ses);\n"
"http (\'		<xsd:simpleContent>\\n\', ses);\n"
"http (\'				<xsd:attribute name=\"Type\" type=\"xsd:QName\"/>\\n\', ses);\n"
"http (\'		</xsd:simpleContent>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"EncodedString\">\\n\', ses);\n"
"http (\'		<xsd:simpleContent>\\n\', ses);\n"
"http (\'				<xsd:attribute name=\"EncodingType\" type=\"xsd:QName\"/>\\n\', ses);\n"
"http (\'		</xsd:simpleContent>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"UsernameTokenType\">\\n\', ses);\n"
"http (\'		<xsd:sequence>\\n\', ses);\n"
"http (\'			<xsd:element name=\"Username\" type=\"wsse:AttributedString\"/>\\n\', ses);\n"
"http (\'			<xsd:any processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'		</xsd:sequence>\\n\', ses);\n"
"http (\'		<xsd:attribute ref=\"wsu:Id\"/>\\n\', ses);\n"
"http (\'		<xsd:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"BinarySecurityTokenType\">\\n\', ses);\n"
"http (\'		<xsd:attribute name=\"ValueType\" type=\"xsd:QName\"/>\\n\', ses);\n"
"http (\'		<xsd:attribute name=\"EncodingType\" type=\"xsd:QName\"/>\\n\', ses);\n"
"http (\'		<xsd:attribute ref=\"wsu:Id\"/>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"KeyIdentifierType\">\\n\', ses);\n"
"http (\'		<xsd:simpleContent>\\n\', ses);\n"
"http (\'				<xsd:attribute name=\"ValueType\" type=\"xsd:QName\"/>\\n\', ses);\n"
"http (\'		</xsd:simpleContent>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'RefType\\\' type=\\\'xs:QName\\\' />\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"ReferenceType\">\\n\', ses);\n"
"http (\'		<xsd:attribute name=\"URI\" type=\"xsd:anyURI\"/>\\n\', ses);\n"
"http (\'		<xsd:attribute ref=\"wsse:RefType\" use=\"optional\" />\\n\', ses);\n"
"http (\'		<xsd:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"SecurityTokenReferenceType\">\\n\', ses);\n"
"http (\'		<xsd:choice minOccurs=\"0\" maxOccurs=\"unbounded\">\\n\', ses);\n"
"http (\'			<xsd:any processContents=\"lax\"/>\\n\', ses);\n"
"http (\'		</xsd:choice>\\n\', ses);\n"
"http (\'		<xsd:attribute ref=\"wsu:Id\"/>\\n\', ses);\n"
"http (\'		<xsd:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'	<xsd:complexType name=\"SecurityHeaderType\">\\n\', ses);\n"
"http (\'		<xsd:sequence>\\n\', ses);\n"
"http (\'			<xsd:any processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\">\\n\', ses);\n"
"http (\'			</xsd:any>\\n\', ses);\n"
"http (\'		</xsd:sequence>\\n\', ses);\n"
"http (\'		<xsd:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'	</xsd:complexType>\\n\', ses);\n"
"http (\'	<xsd:element name=\"UsernameToken\" type=\"wsse:UsernameTokenType\">\\n\', ses);\n"
"http (\'	</xsd:element>\\n\', ses);\n"
"http (\'	<xsd:element name=\"BinarySecurityToken\" type=\"wsse:BinarySecurityTokenType\">\\n\', ses);\n"
"http (\'	</xsd:element>\\n\', ses);\n"
"http (\'	<xsd:element name=\"Reference\" type=\"wsse:ReferenceType\">\\n\', ses);\n"
"http (\'	</xsd:element>\\n\', ses);\n"
"http (\'	<xsd:element name=\"KeyIdentifier\" type=\"wsse:KeyIdentifierType\">\\n\', ses);\n"
"http (\'	</xsd:element>\\n\', ses);\n"
"http (\'	<xsd:element name=\"SecurityTokenReference\" type=\"wsse:SecurityTokenReferenceType\">\\n\', ses);\n"
"http (\'	</xsd:element>\\n\', ses);\n"
"http (\'	<xsd:element name=\"Security\" type=\"wsse:SecurityHeaderType\">\\n\', ses);\n"
"http (\'	</xsd:element>\\n\', ses);\n"
"http (\'	<xsd:element name=\"Password\" type=\"wsse:PasswordString\"/>\\n\', ses);\n"
"http (\'	<xsd:element name=\"Nonce\" type=\"wsse:EncodedString\"/>\\n\', ses);\n"
"http (\'	<xsd:simpleType name=\"PasswordTypeEnum\">\\n\', ses);\n"
"http (\'		<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:PasswordText\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:PasswordDigest\"/>\\n\', ses);\n"
"http (\'		</xsd:restriction>\\n\', ses);\n"
"http (\'	</xsd:simpleType>\\n\', ses);\n"
"http (\'	<xsd:simpleType name=\"ValueTypeEnum\">\\n\', ses);\n"
"http (\'		<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:X509v3\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:Kerberosv5TGT\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:Kerberosv5ST\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:PKCS7\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:PKIPath\"/>\\n\', ses);\n"
"http (\'		</xsd:restriction>\\n\', ses);\n"
"http (\'	</xsd:simpleType>\\n\', ses);\n"
"http (\'	<xsd:simpleType name=\"EncodingTypeEnum\">\\n\', ses);\n"
"http (\'		<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:Base64Binary\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:HexBinary\"/>\\n\', ses);\n"
"http (\'		</xsd:restriction>\\n\', ses);\n"
"http (\'	</xsd:simpleType>\\n\', ses);\n"
"http (\'	<xsd:simpleType name=\"FaultcodeEnum\">\\n\', ses);\n"
"http (\'		<xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:UnsupportedSecurityToken\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:UnsupportedAlgorithm\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:InvalidSecurity\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:InvalidSecurityToken\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:FailedAuthentication\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:FailedCheck\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:SecurityTokenUnavailable\"/>\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:InvalidRequest\" />\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:RequestFailed\" />\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:AuthenticationBadElements\" />\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:BadRequest\" />\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:ExpiredData\" />\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:InvalidTimeRange\" />\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:BadContextToken\" />\\n\', ses);\n"
"http (\'			<xsd:enumeration value=\"wsse:UnknownDerivationSource\" />\\n\', ses);\n"
"http (\'		</xsd:restriction>\\n\', ses);\n"
"http (\'	</xsd:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xsd:complexType name=\\\'RequestSecurityTokenType\\\' >\\n\', ses);\n"
"http (\'    <xsd:sequence>\\n\', ses);\n"
"http (\'       <xsd:element name=\\\'TokenType\\\' type=\\\'xsd:string\\\' minOccurs=\"0\" maxOccurs=\"1\" />\\n\', ses);\n"
"http (\'       <xsd:element name=\\\'RequestType\\\' type=\\\'xsd:string\\\' minOccurs=\"0\" maxOccurs=\"1\" />\\n\', ses);\n"
"http (\'       <xsd:element ref=\\\'wsp:AppliesTo\\\' minOccurs=\"0\" maxOccurs=\"1\" />\\n\', ses);\n"
"http (\'    </xsd:sequence>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xsd:element name=\\\'RequestSecurityToken\\\' type=\\\'wsse:RequestSecurityTokenType\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xsd:complexType name=\\\'RequestedSecurityTokenType\\\' >\\n\', ses);\n"
"http (\'    <xsd:sequence>\\n\', ses);\n"
"http (\'       <xsd:element name=\"BinarySecurityToken\" type=\"wsse:BinarySecurityTokenType\"/>\\n\', ses);\n"
"http (\'    </xsd:sequence>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xsd:complexType name=\\\'RequestSecurityTokenResponseType\\\' >\\n\', ses);\n"
"http (\'    <xsd:sequence>\\n\', ses);\n"
"http (\'       <xsd:element name=\\\'TokenType\\\' type=\\\'xsd:string\\\' minOccurs=\"0\" maxOccurs=\"1\" />\\n\', ses);\n"
"http (\'       <xsd:element name=\\\'RequestedSecurityToken\\\' type=\\\'wsse:RequestedSecurityTokenType\\\' minOccurs=\"0\" maxOccurs=\"1\" />\\n\', ses);\n"
"http (\'    </xsd:sequence>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xsd:element name=\\\'RequestSecurityTokenResponse\\\' type=\\\'wsse:RequestSecurityTokenResponseType\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Challenge\\\' type=\\\'wsse:ChallengeOrIntegrity\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'BinaryNegotiation\\\' type=\\\'wsse:BinarySecurityTokenType\\\' /> \\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestedProofToken\\\' type=\\\'wsse:RequestedSecurityTokenType\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xsd:complexType name=\\\'RequestedSecurityTokenType_h\\\' >\\n\', ses);\n"
"http (\'    <xsd:sequence>\\n\', ses);\n"
"http (\'	<xsd:element name=\"wsa:MessageID\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'	<xsd:element name=\"wsa:From\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'    </xsd:sequence>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestedProofToken_h\\\' type=\\\'wsse:RequestedSecurityTokenType_h\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'SecurityHeader\\\' type=\\\'wsse:SecurityHeaderPolType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'SecurityHeaderPolType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Usage\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'	<xs:attribute name=\\\'MustPrepend\\\' type=\\\'xs:boolean\\\' />\\n\', ses);\n"
"http (\'	<xs:attribute name=\\\'MustManifestEncryption\\\' type=\\\'xs:boolean\\\' />\\n\', ses);\n"
"http (\'	<xs:anyAttribute namespace=\\\'##any\\\' processContents=\\\'lax\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'MessageAge\\\' type=\\\'wsse:MessageAgeType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'MessageAgeType\\\' >\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Usage\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'	<xs:attribute ref=\\\'wsp:Preference\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'	<xs:attribute name=\\\'Age\\\' type=\\\'xs:unsignedInt\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'	<xs:anyAttribute namespace=\\\'##any\\\' processContents=\\\'lax\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  \\n\', ses);\n"
"http (\'  <xs:element name=\\\'MessageParts\\\' type=\\\'wsse:XPathSoap\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'TokenIssuer\\\' type=\\\'xs:string\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Confidentiality\\\' type=\\\'wsse:Confidentiality\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'Confidentiality\\\' >\\n\', ses);\n"
"http (\'	<xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'Actor\\\' type=\\\'xs:anyURI\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Preference\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Usage\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Integrity\\\' type=\\\'wsse:ChallengeOrIntegrity\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'ChallengeOrIntegrity\\\' >\\n\', ses);\n"
"http (\'	<xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Preference\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Usage\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Algorithm\\\' type=\\\'wsse:AlgorithmType\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'AlgorithmType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'Type\\\' type=\\\'wsse:AlgorithmTypeOpenEnum\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'URI\\\' type=\\\'xs:anyURI\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Preference\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'AlgorithmTypeEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:restriction base=\\\'xs:QName\\\' >\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:AlgCanonicalization\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:AlgSignature\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:AlgTransform\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:AlgDigest\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:AlgEncryption\\\' />\\n\', ses);\n"
"http (\'    </xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'AlgorithmTypeOpenEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:union memberTypes=\\\'wsse:AlgorithmTypeEnum xs:QName\\\' />\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'KeyInfo\\\' type=\\\'wsse:KeyInfoType\\\' />  \\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'KeyInfoType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:element ref=\\\'wsse:SecurityToken\\\' minOccurs=\\\'0\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'SecurityToken\\\' type=\\\'wsse:SecurityTokenType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'SecurityTokenType\\\' >\\n\', ses);\n"
"http (\'	<xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />	 \\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'	<xs:attribute ref=\\\'wsp:Preference\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsp:Usage\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'	<xs:anyAttribute namespace=\\\'##other\\\' processContents=\\\'lax\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'TokenTypeEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:restriction base=\\\'xs:QName\\\' >\\n\', ses);\n"
"http (\'      <xs:enumeration value=\\\'wsse:X509v3\\\' />\\n\', ses);\n"
"http (\'      <xs:enumeration value=\\\'wsse:Kerberosv5TGT\\\' />\\n\', ses);\n"
"http (\'      <xs:enumeration value=\\\'wsse:Kerberosv5ST\\\' />\\n\', ses);\n"
"http (\'      <xs:enumeration value=\\\'wsse:UserNameToken\\\' />\\n\', ses);\n"
"http (\'      <xs:enumeration value=\\\'wsse:SAMLAssertion\\\' />\\n\', ses);\n"
"http (\'      <xs:enumeration value=\\\'wsse:XrMLLicense\\\' />\\n\', ses);\n"
"http (\'    </xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'TokenTypeOpenEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:union memberTypes=\\\'wsse:TokenTypeEnum xs:QName\\\' />\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Visibility\\\' type=\\\'wsse:VisibilityType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'VisibilityType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'	<xs:attribute ref=\\\'wsp:Usage\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'	<xs:anyAttribute namespace=\\\'##any\\\' processContents=\\\'lax\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'SignerType\\\'>\\n\', ses);\n"
"http (\'    <xs:list itemType=\\\'xs:anyURI\\\' />\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'SubjectName\\\' type=\\\'wsse:SubjectNameType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'SubjectNameType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'	<xs:attribute name=\\\'MatchType\\\' type=\\\'wsse:MatchTypeEnum\\\' use=\\\'optional\\\' /> \\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\\\'X509Extension\\\' type=\\\'wsse:X509ExtensionType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'X509ExtensionType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'	<xs:attribute name=\\\'MatchType\\\' type=\\\'wsse:MatchTypeEnum\\\' use=\\\'optional\\\' /> \\n\', ses);\n"
"http (\'	<xs:attribute name=\\\'OID\\\' type=\\\'xs:string\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'	<xs:attribute name=\\\'Critical\\\' type=\\\'xs:boolean\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\\\'UsePassword\\\' type=\\\'wsse:UsePasswordType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'UsePasswordType\\\' >\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'Type\\\' type=\\\'wsse:PasswordTypeEnum\\\' use=\\\'optional\\\' /> \\n\', ses);\n"
"http (\'	<xs:attribute ref=\\\'wsp:Usage\\\' use=\\\'required\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'MatchTypeEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:restriction base=\\\'xs:QName\\\' >\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:Exact\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:Prefix\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:Regexp\\\' />\\n\', ses);\n"
"http (\'	</xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'ServiceName\\\' type=\\\'xs:string\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'RequestTypeEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:restriction base=\\\'xs:QName\\\' >\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:ReqIssue\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:ReqValidate\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:ReqExchange\\\' />\\n\', ses);\n"
"http (\'	</xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'RequestTypeOpenEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:union memberTypes=\\\'wsse:RequestTypeEnum xs:QName\\\' />\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestType\\\' type=\\\'wsse:RequestTypeOpenEnum\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Base\\\' type=\\\'wsse:SecurityTokenReferenceType\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Supporting\\\' type=\\\'wsse:SecurityTokenReferenceType\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Claims\\\' />\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'KeyEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:restriction base=\\\'xs:QName\\\' >\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:PublicKey\\\' />\\n\', ses);\n"
"http (\'	  <xs:enumeration value=\\\'wsse:SymmetricKey\\\' />\\n\', ses);\n"
"http (\'	</xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\\\'KeyOpenEnum\\\' >\\n\', ses);\n"
"http (\'    <xs:union memberTypes=\\\'wsse:KeyEnum xs:QName\\\' />\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:element name=\\\'KeyType\\\' type=\\\'wsse:KeyOpenEnum\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestKeyType\\\' type=\\\'wsse:KeyOpenEnum\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'KeySize\\\' type=\\\'xs:unsignedInt\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestKeySize\\\' type=\\\'xs:unsignedInt\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestSignatureAlgorithm\\\' type=\\\'xs:anyURI\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestEncryption\\\' type=\\\'wsse:SecurityTokenReferenceType\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'RequestProofEncryption\\\' type=\\\'wsse:SecurityTokenReferenceType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'SecurityTokenReferences\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\\\'wsse:SecurityTokenReference\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'UseBase\\\' >\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'UsePublicKey\\\' type=\\\'wsse:UsePublicKeyType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'UsePublicKeyType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\\\'ds:KeyInfo\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'Sig\\\' type=\\\'xs:anyURI\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'OnBehalfOf\\\' type=\\\'wsse:TokenOrRef\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'DelegateTo\\\' type=\\\'wsse:TokenOrRef\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'TokenOrRef\\\' >\\n\', ses);\n"
"http (\'	<xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Forwardable\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Delegatable\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Proxiable\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'AllowPostdating\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Renewing\\\' type=\\\'wsse:RenewingType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'RenewingType\\\' >\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'Allow\\\' type=\\\'xs:boolean\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'OK\\\' type=\\\'xs:boolean\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'LifeTime\\\' type=\\\'wsse:LifeTimeType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'LifeTimeType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\\\'wsu:Created\\\' minOccurs=\\\'0\\\' /> \\n\', ses);\n"
"http (\'      <xs:element ref=\\\'wsu:Expires\\\' minOccurs=\\\'0\\\' />\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'SignChallenge\\\' type=\\\'wsse:SignChallengeType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'SignChallengeType\\\' >\\n\', ses);\n"
"http (\'	<xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'	<xs:anyAttribute namespace=\\\'##any\\\' processContents=\\\'lax\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\\\'SignChallengeResponse\\\' type=\\\'wsse:SignChallengeResponseType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'SignChallengeResponseType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'	  <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'SecurityContextToken\\\' type=\\\'wsse:SecurityContextTokenType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'SecurityContextTokenType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'	   <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'	<xs:attribute ref=\\\'wsu:Id\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'	<xs:anyAttribute namespace=\\\'##other\\\' processContents=\\\'lax\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Keys\\\' type=\\\'wsse:KeysType\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'KeysType\\\' >\\n\', ses);\n"
"http (\'	<xs:sequence>\\n\', ses);\n"
"http (\'		<xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'	</xs:sequence>  \\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'DerivedKeyToken\\\' type=\\\'wsse:Key\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'Key\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\\\'wsse:SecurityTokenReference\\\' minOccurs=\\\'0\\\' />\\n\', ses);\n"
"http (\'	  <xs:element name=\\\'Properties\\\' type=\\\'wsse:PropertiesType\\\' minOccurs=\\\'0\\\' />\\n\', ses);\n"
"http (\'	  <xs:choice minOccurs=\\\'0\\\' >\\n\', ses);\n"
"http (\'        <xs:element name=\\\'Generation\\\' type=\\\'xs:unsignedLong\\\' />\\n\', ses);\n"
"http (\'        <xs:sequence>\\n\', ses);\n"
"http (\'          <xs:element name=\\\'Offset\\\' type=\\\'xs:unsignedLong\\\' />\\n\', ses);\n"
"http (\'		  <xs:element name=\\\'Length\\\' type=\\\'xs:unsignedLong\\\' minOccurs=\\\'0\\\' />\\n\', ses);\n"
"http (\'        </xs:sequence>\\n\', ses);\n"
"http (\'      </xs:choice>\\n\', ses);\n"
"http (\'      <xs:element ref=\\\'wsse:Label\\\' minOccurs=\\\'0\\\' />\\n\', ses);\n"
"http (\'      <xs:element ref=\\\'wsse:Nonce\\\' minOccurs=\\\'0\\\' />\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute ref=\\\'wsu:Id\\\' />\\n\', ses);\n"
"http (\'    <xs:attribute name=\\\'Algorithm\\\' type=\\\'wsse:AlgorithmTypeOpenEnum\\\' form=\\\'qualified\\\' use=\\\'optional\\\' />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Label\\\' type=\\\'xs:string\\\' />\\n\', ses);\n"
"http (\'  <xs:element name=\\\'Name\\\' type=\\\'xs:anyURI\\\' />\\n\', ses);\n"
"http (\'  <xs:complexType name=\\\'PropertiesType\\\' >\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:any namespace=\\\'##any\\\' processContents=\\\'lax\\\' minOccurs=\\\'0\\\' maxOccurs=\\\'unbounded\\\' />\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:435\n";

static const char *proc248 = 
"CREATE PROCEDURE WSRM_WSA200403_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\"?>\\n\', ses);\n"
"http (\'<xs:schema xmlns:wsu=\"http://schemas.xmlsoap.org/ws/2002/07/utility\" xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/03/addressing\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" targetNamespace=\"http://schemas.xmlsoap.org/ws/2004/03/addressing\" elementFormDefault=\"qualified\" blockDefault=\"#all\" xmlns:wssu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\">\\n\', ses);\n"
"http (\'  <xs:element name=\"EndpointReference\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"EndpointReferenceType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element name=\"Address\" type=\"xs:anyURI\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"ReferenceProperties\" type=\"wsa:ReferencePropertiesType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"PortType\" type=\"wsa:AttributedQName\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"ServiceName\" type=\"wsa:ServiceNameType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute ref=\"wssu:Id\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"ReferencePropertiesType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:any processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"ServiceNameType\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:QName\">\\n\', ses);\n"
"http (\'        <xs:attribute name=\"PortName\" type=\"xs:NCName\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"AttributedURI\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:anyURI\">\\n\', ses);\n"
"http (\'        <xs:attribute ref=\"wssu:Id\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"MessageID\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"RelatesTo\" type=\"wsa:Relationship\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"To\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"Action\" type=\"wsa:AttributedURI\" nillable=\"false\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"From\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"ReplyTo\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"FaultTo\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"Recipient\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"Relationship\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:anyURI\">\\n\', ses);\n"
"http (\'        <xs:attribute name=\"RelationshipType\" type=\"xs:QName\" use=\"optional\"/>\\n\', ses);\n"
"http (\'        <xs:attribute ref=\"wssu:Id\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\"RelationshipTypeValues\">\\n\', ses);\n"
"http (\'    <xs:restriction base=\"xs:QName\">\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:Reply\"/>\\n\', ses);\n"
"http (\'    </xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"AttributedQName\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:QName\">\\n\', ses);\n"
"http (\'			</xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"ReplyAfter\"/>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\"FaultSubcodeValues\">\\n\', ses);\n"
"http (\'    <xs:restriction base=\"xs:QName\">\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:InvalidMessageInformationHeader\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:MessageInformationHeaderRequired\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:DestinationUnreachable\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:ActionNotSupported\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:EndpointUnavailable\"/>\\n\', ses);\n"
"http (\'    </xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:attribute name=\"Action\" type=\"xs:anyURI\"/>\\n\', ses);\n"
"http (\'</xs:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:903\n";

static const char *proc249 = 
"CREATE PROCEDURE WSRM_OASIS200401WSSUTILITY_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xsd:schema xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:wsu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\" xmlns=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\" targetNamespace=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\" elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\" version=\"0.1\">\\n\', ses);\n"
"http (\'  <xsd:simpleType name=\"tTimestampFault\">\\n\', ses);\n"
"http (\'    <xsd:restriction base=\"xsd:QName\">\\n\', ses);\n"
"http (\'      <xsd:enumeration value=\"wsu:MessageExpired\"/>\\n\', ses);\n"
"http (\'    </xsd:restriction>\\n\', ses);\n"
"http (\'  </xsd:simpleType>\\n\', ses);\n"
"http (\'  <xsd:attribute name=\"Id\" type=\"xsd:ID\" />\\n\', ses);\n"
"http (\'  <xsd:complexType name=\"AttributedDateTime\">\\n\', ses);\n"
"http (\'    <xsd:simpleContent>\\n\', ses);\n"
"http (\'      <xsd:extension base=\"xsd:string\">\\n\', ses);\n"
"http (\'    <xsd:attribute ref=\"wsu:Id\" use=\"optional\"/>\\n\', ses);\n"
"http (\'      </xsd:extension>\\n\', ses);\n"
"http (\'    </xsd:simpleContent>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'  <xsd:complexType name=\"AttributedURI\">\\n\', ses);\n"
"http (\'    <xsd:simpleContent>\\n\', ses);\n"
"http (\'      <xsd:extension base=\"xsd:anyURI\">\\n\', ses);\n"
"http (\'    <xsd:attribute ref=\"wsu:Id\" use=\"optional\"/>\\n\', ses);\n"
"http (\'      </xsd:extension>\\n\', ses);\n"
"http (\'    </xsd:simpleContent>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'  <xsd:complexType name=\"TimestampType\">\\n\', ses);\n"
"http (\'    <xsd:sequence>\\n\', ses);\n"
"http (\'      <xsd:element ref=\"wsu:Created\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xsd:element ref=\"wsu:Expires\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'    </xsd:sequence>\\n\', ses);\n"
"http (\'    <xsd:attribute ref=\"wsu:Id\" use=\"optional\"/>\\n\', ses);\n"
"http (\'  </xsd:complexType>\\n\', ses);\n"
"http (\'  <xsd:element name=\"Timestamp\" type=\"wsu:TimestampType\"/>\\n\', ses);\n"
"http (\'  <xsd:element name=\"Expires\" type=\"wsu:AttributedDateTime\"/>\\n\', ses);\n"
"http (\'  <xsd:element name=\"Created\" type=\"wsu:AttributedDateTime\"/>\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:984\n";

static const char *proc250 = 
"CREATE PROCEDURE WSRM_ORABPEL_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\"?>\\n\', ses);\n"
"http (\'<xsd:schema targetNamespace=\"http://schemas.oracle.com/bpel\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" elementFormDefault=\"qualified\">\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"rootId\" type=\"xsd:string\" />\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"parentId\" type=\"xsd:string\" />\\n\', ses);\n"
"http (\'	<xsd:attribute name=\"priority\" type=\"xsd:string\" />\\n\', ses);\n"
"http (\'</xsd:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:1028\n";

static const char *proc251 = 
"CREATE PROCEDURE WSRM_WSRM_2005_02_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\" encoding=\"UTF-8\"?>\\n\', ses);\n"
"http (\'<xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\"\\n\', ses);\n"
"http (\'	   xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\"\\n\', ses);\n"
"http (\'	   xmlns:wsrm=\"http://schemas.xmlsoap.org/ws/2005/02/rm\"\\n\', ses);\n"
"http (\'	   xmlns:wssu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\"\\n\', ses);\n"
"http (\'	   targetNamespace=\"http://schemas.xmlsoap.org/ws/2005/02/rm\"\\n\', ses);\n"
"http (\'	   elementFormDefault=\"qualified\"\\n\', ses);\n"
"http (\'	   attributeFormDefault=\"unqualified\">\\n\', ses);\n"
"http (\'  <xs:import namespace=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\"\\n\', ses);\n"
"http (\'	     schemaLocation=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"SequenceType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Identifier\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"MessageNumber\" type=\"xs:unsignedLong\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"LastMessage\" type=\"xs:ENTITY\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute ref=\"wssu:Id\" />\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"Sequence\" type=\"wsrm:SequenceType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"SequenceAcknowledgement\" type=\"wsrm:SequenceAcknowledgement_t\">\\n\', ses);\n"
"http (\'  </xs:element>\\n\', ses);\n"
"http (\'    <xs:complexType name=\"SequenceAcknowledgement_t\">\\n\', ses);\n"
"http (\'      <xs:sequence>\\n\', ses);\n"
"http (\'        <xs:element ref=\"wsrm:Identifier\"/>\\n\', ses);\n"
"http (\'          <xs:element name=\"AcknowledgementRange\" maxOccurs=\"unbounded\" type=\"wsrm:AcknowledgementRange_t\" minOccurs=\"0\">\\n\', ses);\n"
"http (\'          </xs:element>\\n\', ses);\n"
"http (\'          <xs:element name=\"Nack\" type=\"xs:unsignedLong\" maxOccurs=\"unbounded\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      </xs:sequence>\\n\', ses);\n"
"http (\'      <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'    </xs:complexType>\\n\', ses);\n"
"http (\'            <xs:complexType name=\"AcknowledgementRange_t\">\\n\', ses);\n"
"http (\'              <xs:sequence/>\\n\', ses);\n"
"http (\'              <xs:attribute name=\"Upper\" type=\"xs:unsignedLong\" use=\"required\"/>\\n\', ses);\n"
"http (\'              <xs:attribute name=\"Lower\" type=\"xs:unsignedLong\" use=\"required\"/>\\n\', ses);\n"
"http (\'              <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'            </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"AckRequestedType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Identifier\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"AckRequested\" type=\"wsrm:AckRequestedType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"Identifier\">\\n\', ses);\n"
"http (\'    <xs:complexType>\\n\', ses);\n"
"http (\'      <xs:simpleContent>\\n\', ses);\n"
"http (\'        <xs:extension base=\"xs:anyURI\">\\n\', ses);\n"
"http (\'        </xs:extension>\\n\', ses);\n"
"http (\'      </xs:simpleContent>\\n\', ses);\n"
"http (\'    </xs:complexType>\\n\', ses);\n"
"http (\'  </xs:element>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\"FaultCodes\">\\n\', ses);\n"
"http (\'    <xs:restriction base=\"xs:QName\">\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsrm:UnknownSequence\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsrm:SequenceTerminated\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsrm:InvalidAcknowledgement\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsrm:MessageNumberRollover\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsrm:CreateSequenceRefused\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsrm:LastMessageNumberExceeded\"/>\\n\', ses);\n"
"http (\'    </xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"SequenceFaultType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element name=\"FaultCode\" type=\"xs:QName\" minOccurs=\"0\" />\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:anyAttribute namespace=\"##any\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"SequenceFault\" type=\"wsrm:SequenceFaultType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"CreateSequence\" type=\"wsrm:CreateSequenceType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"CreateSequenceResponse\" type=\"wsrm:CreateSequenceResponseType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"TerminateSequence\" type=\"wsrm:TerminateSequenceType\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"CreateSequenceType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:AcksTo\"/>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Expires\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"Offer\" type=\"wsrm:OfferType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:any namespace=\"##other\" processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\">\\n\', ses);\n"
"http (\'      </xs:any>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"CreateSequenceResponseType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Identifier\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"Accept\" type=\"wsrm:AcceptType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Expires\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:any namespace=\"##other\" processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"TerminateSequenceType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Identifier\"/>\\n\', ses);\n"
"http (\'      <xs:any namespace=\"##other\" processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"AcksTo\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"OfferType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Identifier\"/>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:Expires\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:any namespace=\"##other\" processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"AcceptType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element ref=\"wsrm:AcksTo\"/>\\n\', ses);\n"
"http (\'      <xs:any namespace=\"##other\" processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"Expires\">\\n\', ses);\n"
"http (\'    <xs:complexType>\\n\', ses);\n"
"http (\'      <xs:simpleContent>\\n\', ses);\n"
"http (\'        <xs:extension base=\"xs:duration\">\\n\', ses);\n"
"http (\'          <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'        </xs:extension>\\n\', ses);\n"
"http (\'      </xs:simpleContent>\\n\', ses);\n"
"http (\'    </xs:complexType>\\n\', ses);\n"
"http (\'  </xs:element>\\n\', ses);\n"
"http (\'</xs:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:1045\n";

static const char *proc252 = 
"CREATE PROCEDURE WSRM_WSA200408_XSD ()\n"
"{\n"
"declare ses any;\n"
"ses := string_output ();\n"
"http (\'<?xml version=\"1.0\"?>\\n\', ses);\n"
"http (\'<xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" xmlns:wsa=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" targetNamespace=\"http://schemas.xmlsoap.org/ws/2004/08/addressing\" elementFormDefault=\"qualified\" blockDefault=\"#all\"\\n\', ses);\n"
"http (\'  xmlns:wssu=\"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\">\\n\', ses);\n"
"http (\'  <xs:element name=\"EndpointReference\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"EndpointReferenceType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:element name=\"Address\" type=\"xs:anyURI\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"ReferenceProperties\" type=\"wsa:ReferencePropertiesType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"ReferenceParameters\" type=\"wsa:ReferenceParametersType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"PortType\" type=\"wsa:AttributedQName\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'      <xs:element name=\"ServiceName\" type=\"wsa:ServiceNameType\" minOccurs=\"0\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'    <xs:attribute ref=\"wssu:Id\"/>\\n\', ses);\n"
"http (\'    <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"ReferencePropertiesType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:any processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"ReferenceParametersType\">\\n\', ses);\n"
"http (\'    <xs:sequence>\\n\', ses);\n"
"http (\'      <xs:any processContents=\"lax\" minOccurs=\"0\" maxOccurs=\"unbounded\"/>\\n\', ses);\n"
"http (\'    </xs:sequence>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"ServiceNameType\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:QName\">\\n\', ses);\n"
"http (\'        <xs:attribute name=\"PortName\" type=\"xs:NCName\"/>\\n\', ses);\n"
"http (\'        <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:element name=\"MessageID\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"RelatesTo\" type=\"wsa:Relationship\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"To\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"Action\" type=\"wsa:AttributedURI\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"From\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"ReplyTo\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:element name=\"FaultTo\" type=\"wsa:EndpointReferenceType\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"Relationship\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:anyURI\">\\n\', ses);\n"
"http (\'        <xs:attribute name=\"RelationshipType\" type=\"xs:QName\" use=\"optional\"/>\\n\', ses);\n"
"http (\'        <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\"RelationshipTypeValues\">\\n\', ses);\n"
"http (\'    <xs:restriction base=\"xs:QName\">\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:Reply\"/>\\n\', ses);\n"
"http (\'    </xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:element name=\"ReplyAfter\" type=\"wsa:ReplyAfterType\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"ReplyAfterType\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:nonNegativeInteger\">\\n\', ses);\n"
"http (\'        <xs:anyAttribute namespace=\"##other\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:simpleType name=\"FaultSubcodeValues\">\\n\', ses);\n"
"http (\'    <xs:restriction base=\"xs:QName\">\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:InvalidMessageInformationHeader\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:MessageInformationHeaderRequired\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:DestinationUnreachable\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:ActionNotSupported\"/>\\n\', ses);\n"
"http (\'      <xs:enumeration value=\"wsa:EndpointUnavailable\"/>\\n\', ses);\n"
"http (\'    </xs:restriction>\\n\', ses);\n"
"http (\'  </xs:simpleType>\\n\', ses);\n"
"http (\'  <xs:attribute name=\"Action\" type=\"xs:anyURI\"/>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"AttributedQName\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:QName\">\\n\', ses);\n"
"http (\'        <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'  <xs:complexType name=\"AttributedURI\">\\n\', ses);\n"
"http (\'    <xs:simpleContent>\\n\', ses);\n"
"http (\'      <xs:extension base=\"xs:anyURI\">\\n\', ses);\n"
"http (\'        <xs:anyAttribute namespace=\"##other\" processContents=\"lax\"/>\\n\', ses);\n"
"http (\'      </xs:extension>\\n\', ses);\n"
"http (\'    </xs:simpleContent>\\n\', ses);\n"
"http (\'  </xs:complexType>\\n\', ses);\n"
"http (\'</xs:schema>\\n\', ses);\n"
"return string_output_string (ses);\n"
"}\n"
"--src wsrm_xsd.sql:1178\n";

/* wsrmcli.sql */

static const char *udt4 = 
"create type wsrm_cli as\n"
"(\n"
"url varchar,\n"
"seq varchar,\n"
"msgno int default -1,\n"
"assurance varchar,\n"
"expiry datetime,\n"
"address WSA_CLI,\n"
"i_timeout int,\n"
"resend_intl int,\n"
"ack_intl int,\n"
"dirty int default 0,\n"
"is_last int default 0,\n"
"is_finish int default 0\n"
")\n"
"temporary self as ref\n"
"constructor method wsrm_cli (addr WSA_CLI, url varchar),\n"
"constructor method wsrm_cli (addr WSA_CLI, url varchar, seq varchar),\n"
"method create_sequence () returns any,\n"
"method send_message (req soap_client_req, last int) returns any,\n"
"method send_message (req soap_client_req) returns any,\n"
"method finish (req soap_client_req) returns any,\n"
"method check_state () returns any,\n"
"method cancel () returns any,\n"
"method set_parameter (name varchar, val any) returns any,\n"
"method current_ver () returns varchar,\n"
"method in_seq () returns any\n";

static const char *other154 = 
"create method current_ver () for wsrm_cli\n"
"{\n"
"return \'http://schemas.xmlsoap.org/ws/2004/03/rm\';\n"
"}\n";

static const char *other155 = 
"create method in_seq () for wsrm_cli\n"
"{\n"
"if (self.seq is null or self.msgno < 0)\n"
"signal (\'42000\', \'No sequence opened\');\n"
"}\n";

static const char *other156 = 
"create constructor method wsrm_cli (in addr WSA_CLI, in url varchar) for wsrm_cli\n"
"{\n"
"self.url := url;\n"
"self.dirty := 0;\n"
"self.create_sequence ();\n"
"self.address := addr;\n"
"\n"
"return self;\n"
"}\n";


static const char *other157 = 
" create constructor method wsrm_cli (in addr WSA_CLI, in url varchar, in seq varchar) for wsrm_cli\n"
"{\n"
"self.url := url;\n"
"self.seq := seq;\n"
"self.address := addr;\n"
"set isolation=\'committed\';\n"
"whenever not found goto ends;\n"
"\n"
"select WOS_DELIVERY_ASSURANCE, WOS_SEQUENCE_EXPIRATION, WOS_INACTIVITY_TIMEOUT,\n"
"WOS_RETRANSMISSION_INTERVAL,WOS_ACKNOWLEDGEMENT_INTERVAL, WOS_LAST_SENT\n"
"into self.assurance, self.expiry, self.i_timeout, self.resend_intl, self.ack_intl, self.is_last\n"
"from SYS_WSRM_OUT_SEQUENCES where WOS_IDENTIFIER = seq;\n"
"\n"
"if (self.is_last is null)\n"
"self.is_last := 0;\n"
"\n"
"self.msgno := coalesce ((select top 1 OML_MESSAGE_ID from SYS_WSRM_OUT_MESSAGE_LOG\n"
"where OML_INDENTIFIER = seq order by 1 desc), 0);\n"
"\n"
"self.dirty := 0;\n"
"return self;\n"
"\n"
"ends:\n"
"signal (\'22023\', \'Non existing sequence\');\n"
"}\n";

static const char *other158 = 
"create method create_sequence () for wsrm_cli\n"
"{\n"
"if (self.seq is not null)\n"
"signal (\'37000\', \'Sequence is alredy created, first cancel or finish\');\n"
"\n"
"self.seq := lower (\'UUID:\'||uuid ());\n"
"self.msgno := 0;\n"
"self.assurance := \'ExactlyOnce\';\n"
"self.expiry := dateadd (\'hour\', 1, now ());\n"
"self.i_timeout := 2000;\n"
"self.resend_intl := 10000;\n"
"self.ack_intl := 2000;\n"
"\n"
"insert into SYS_WSRM_OUT_SEQUENCES (\n"
"WOS_IDENTIFIER, WOS_VERSION, WOS_DELIVERY_ASSURANCE,\n"
"WOS_SEQUENCE_EXPIRATION, WOS_INACTIVITY_TIMEOUT, WOS_RETRANSMISSION_INTERVAL,\n"
"WOS_ACKNOWLEDGEMENT_INTERVAL)\n"
"values 	(self.seq, self.current_ver (), self.assurance, self.expiry,\n"
"self.i_timeout, self.resend_intl, self.ack_intl);\n"
"return self.seq;\n"
"}\n";

static const char *other159 = 
"create method finish (in req soap_client_req)\n"
"for wsrm_cli\n"
"{\n"
"self.send_message (req, 1);\n"
"}\n";

static const char *other160 = 
"create method send_message (in req soap_client_req)\n"
"for wsrm_cli\n"
"{\n"
"self.send_message (req, 0);\n"
"}\n";


static const char *other161 = 
" create method send_message (in req soap_client_req, in last int)\n"
"for wsrm_cli\n"
"{\n"
"declare cr cursor for select OML_MESSAGE_ID from SYS_WSRM_OUT_MESSAGE_LOG where OML_INDENTIFIER = self.seq\n"
"order by OML_MESSAGE_ID desc;\n"
"\n"
"self.in_seq ();\n"
"whenever not found goto nf;\n"
"open cr (exclusive, prefetch 1);\n"
"fetch cr into self.msgno;\n"
"nf:\n"
"close cr;\n"
"if (self.msgno is null)\n"
"self.msgno := 0;\n"
"self.msgno := self.msgno + 1;\n"
"\n"
"\n"
"\n"
"insert into SYS_WSRM_OUT_MESSAGE_LOG (OML_MESSAGE, OML_ADDRESS, OML_INDENTIFIER, OML_MESSAGE_ID, OML_STATE)\n"
"values (req, self.address, self.seq, self.msgno, -1);\n"
"\n"
"\n"
"\n"
"\n"
"WSRM_CLIENT (self, last, req);\n"
"\n"
"if (last)\n"
"update SYS_WSRM_OUT_SEQUENCES set WOS_LAST_SENT = 1 where WOS_IDENTIFIER = self.seq;\n"
"\n"
"self.dirty := 0;\n"
"return self.msgno;\n"
"}\n";

static const char *other162 = 
"create method check_state () for wsrm_cli\n"
"{\n"
"declare stru any;\n"
"declare _all_is_send integer;\n"
"self.in_seq ();\n"
"\n"
"if (self.is_finish)\n"
"return vector (1);\n"
"\n"
"set isolation=\'committed\';\n"
"if (not exists (select 1 from SYS_WSRM_OUT_MESSAGE_LOG where OML_STATE <> 3 and OML_INDENTIFIER = self.seq))\n"
"{\n"
"self.is_finish := 1;\n"
"return vector (1);\n"
"}\n"
"stru := WSRM_CLIENT_ACKREQUESTED (self);\n"
"WSRM_CLIENT_ERROR (stru);\n"
"stru := WSRM_UPDATE_CLIENT_TABLES (stru, self);\n"
"\n"
"if (self.is_last)\n"
"{\n"
"if (not exists (select 1 from SYS_WSRM_OUT_MESSAGE_LOG\n"
"where OML_STATE <> 3 and OML_INDENTIFIER = self.seq))\n"
"{\n"
"self.is_finish := 1;\n"
"return vector (1);\n"
"}\n"
"}\n"
"\n"
"return stru;\n"
"}\n";

static const char *other163 = 
"create method cancel () for wsrm_cli\n"
"{\n"
"self.in_seq ();\n"
"\n"
"WSRM_CLIENT_ACKTERMINATE (self);\n"
"\n"
"delete from SYS_WSRM_OUT_SEQUENCES where WOS_IDENTIFIER = self.seq;\n"
"delete from SYS_WSRM_OUT_MESSAGE_LOG where OML_INDENTIFIER = self.seq;\n"
"\n"
"self.seq := null;\n"
"self.msgno := -1;\n"
"self.dirty := 0;\n"
"return;\n"
"}\n";

static const char *other164 = 
"create method set_parameter (in name varchar, in val any := null) for wsrm_cli\n"
"{\n"
"self.in_seq ();\n"
"\n"
"if (name = \'Assurance\')\n"
"{\n"
"if (val not in (\'AtMostOnce\',\'AtLeastOnce\',\'ExactlyOnce\',\'InOrder\'))\n"
"signal (\'22023\', \'value must be AtMostOnce, AtLeastOnce, ExactlyOnce or InOrder\');\n"
"self.assurance := val;\n"
"}\n"
"else if (name = \'Expiry\')\n"
"{\n"
"self.expiry := val;\n"
"}\n"
"else if (name = \'Timeout\')\n"
"{\n"
"if (val <= 0) signal (\'22023\', \'Positive integer required\');\n"
"self.i_timeout := val;\n"
"}\n"
"else if (name = \'RetryInterval\')\n"
"{\n"
"if (val <= 0) signal (\'22023\', \'Positive integer required\');\n"
"self.resend_intl := val;\n"
"}\n"
"else if (name = \'AckInterval\')\n"
"{\n"
"if (val <= 0) signal (\'22023\', \'Positive integer required\');\n"
"self.ack_intl := val;\n"
"}\n"
"else\n"
"signal (\'22023\', \'Unknown parameter\');\n"
"\n"
"update SYS_WSRM_OUT_SEQUENCES set\n"
"WOS_DELIVERY_ASSURANCE =  self.assurance,\n"
"WOS_SEQUENCE_EXPIRATION = self.expiry,\n"
"WOS_INACTIVITY_TIMEOUT =  self.i_timeout,\n"
"WOS_RETRANSMISSION_INTERVAL = self.resend_intl,\n"
"WOS_ACKNOWLEDGEMENT_INTERVAL = self.ack_intl\n"
"where WOS_IDENTIFIER = self.seq;\n"
"\n"
"self.dirty := 1;\n"
"return self;\n"
"}\n";

static const char *proc253 = 
"create procedure WSRM_CLIENT_POLICY (inout state wsrm_cli)\n"
"{\n"
"declare policy, ind, ver, spec_v, del_ass, i_timeout, r_int, a_int soap_parameter;\n"
"\n"
"if (not state.dirty)\n"
"return null;\n"
"\n"
"policy := new soap_parameter ();\n"
"ind := new soap_parameter ();\n"
"ver := new soap_parameter ();\n"
"spec_v := new soap_parameter ();\n"
"r_int := new soap_parameter ();\n"
"a_int := new soap_parameter ();\n"
"del_ass := new soap_parameter ();\n"
"i_timeout := new soap_parameter ();\n"
"\n"
"policy.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/12/policy:PolicyAttachment\');\n"
"\n"
"ind.set_attribute (\'Identifier\', state.seq);\n"
"\n"
"policy.add_member (\'AppliesTo\', new soap_parameter (ind));\n"
"\n"
"ver.set_attribute (\'URI\', \'http://schemas.xmlsoap.org/ws/2004/03/rm\');\n"
"ver.set_attribute (\'Usage\', \'wsp:Required\');\n"
"\n"
"i_timeout.set_attribute (\'Milliseconds\', state.i_timeout);\n"
"\n"
"r_int.set_attribute (\'Milliseconds\', state.resend_intl);\n"
"\n"
"a_int.set_attribute (\'Milliseconds\', state.resend_intl);\n"
"\n"
"del_ass.set_attribute (\'Value\',\'wsrm:\' || state.assurance);\n"
"del_ass.set_attribute (\'Usage\',\'wsp:Required\');\n"
"\n"
"spec_v.add_member (\'SpecVersion\', ver);\n"
"spec_v.add_member (\'DeliveryAssurance\', del_ass);\n"
"spec_v.add_member (\'InactivityTimeout\', i_timeout);\n"
"spec_v.add_member (\'BaseRetransmissionInterval\', r_int);\n"
"spec_v.add_member (\'AcknowledgementInterval\', a_int);\n"
"spec_v.add_member (\'Expires\', state.expiry);\n"
"\n"
"policy.add_member (\'Policy\', spec_v);\n"
"\n"
"spec_v := new soap_parameter ();\n"
"spec_v.set_attribute (\'Ref\', \'http://schemas.xmlsoap.org/ws/2004/03/rm/baseTimingProfile.xml\');\n"
"\n"
"policy.add_member (\'PolicyReference\', spec_v);\n"
"\n"
"return policy;\n"
"}\n"
"--src wsrmcli.sql:278\n";

static const char *proc254 = 
"create procedure WSRM_CLIENT (in state wsrm_cli, in is_last integer, in req SOAP_CLIENT_REQ)\n"
"{\n"
"declare ret, wa, policy any;\n"
"declare st, pa soap_parameter;\n"
"declare identifier varchar;\n"
"declare retr integer;\n"
"declare vhdr any;\n"
"\n"
"if (req.style is null)\n"
"req.style := 1;\n"
"state.is_last := is_last;\n"
"identifier := state.seq;\n"
"retr := 0;\n"
"\n"
"st := new soap_parameter ();\n"
"pa := new soap_parameter ();\n"
"\n"
"st.set_xsd (\'http://schemas.xmlsoap.org/ws/2005/02/rm:Sequence\');\n"
"st.add_member (\'Identifier\', soap_parameter (identifier));\n"
"st.add_member (\'MessageNumber\', state.msgno);\n"
"st.set_attribute (\'Id\', uuid ());\n"
"\n"
"\n"
"\n"
"if (is_last)\n"
"st.add_member (\'LastMessage\', \'\');\n"
"\n"
"\n"
"\n"
"pa := WSRM_CLIENT_POLICY (state);\n"
"if (pa is not null)\n"
"policy := pa.get_call_param (\'\');\n"
"else\n"
"policy := vector ();\n"
"wa := WSA_REQ (state);\n"
"\n"
"vhdr := \'X-Virt-WSRM-ID: \' || registry_get (\'WSRMServerID\') || \';\'\n"
"|| identifier || \';\' || cast(state.msgno as varchar) || \'\\r\\n\';\n"
"\n"
"declare exit handler for sqlstate \'HTCLI\' {\n"
"update SYS_WSRM_OUT_MESSAGE_LOG set OML_STATE = 2\n"
"where OML_INDENTIFIER = identifier and  OML_MESSAGE_ID = state.msgno;\n"
"commit work;\n"
"retr := retr + 1;\n"
"if (retr > 3)\n"
"resignal;\n"
"\n"
"};\n"
"\n"
"commit work;\n"
"\n"
"\n"
"ret := SOAP_CLIENT (url=>req.url, operation=>req.operation, style=>(128+64+req.style),\n"
"headers=>vector_concat (wa, st.get_call_param (\'\'), policy, req.headers),\n"
"parameters=>req.parameters, direction=>(1),\n"
"target_namespace=>req.target_namespace,\n"
"soap_action=>req.soap_action,\n"
"attachments=>req.attachments,\n"
"ticket=>req.ticket,\n"
"passwd=>req.passwd,\n"
"user_name=>req.user_name,\n"
"user_password=>req.user_password,\n"
"auth_type=>req.auth_type,\n"
"security_type=>req.security_type,\n"
"template=>req.template,\n"
"version=>req.version,\n"
"security_schema=>req.security_schema,\n"
"http_header=>NULL);\n"
"\n"
"\n"
"whenever SQLSTATE \'*\' default;\n"
"\n"
"update SYS_WSRM_OUT_MESSAGE_LOG set OML_STATE = 1\n"
"where OML_INDENTIFIER = identifier and  OML_MESSAGE_ID = state.msgno and OML_STATE <> 3;\n"
"\n"
"\n"
"\n"
"if (ret is not null)\n"
"{\n"
"declare _all_is_send integer;\n"
"\n"
"update SYS_WSRM_OUT_MESSAGE_LOG set OML_RESPONSE = xml_tree_doc (ret)\n"
"where OML_INDENTIFIER = identifier and  OML_MESSAGE_ID = state.msgno;\n"
"\n"
"WSRM_CLIENT_ERROR (ret);\n"
"WSRM_UPDATE_CLIENT_TABLES (ret, state);\n"
"if (is_last)\n"
"{\n"
"select count (*) into _all_is_send from SYS_WSRM_OUT_MESSAGE_LOG\n"
"where OML_STATE <> 3 and OML_INDENTIFIER = identifier;\n"
"\n"
"if (_all_is_send = 0)\n"
"state.is_finish := 1;\n"
"}\n"
"}\n"
"\n"
"return 0;\n"
"}\n"
"--src wsrmcli.sql:331\n";

static const char *proc255 = 
"create procedure WSRM_CLIENT_ERROR (in err_vec any)\n"
"{\n"
"declare xt any;\n"
"if (err_vec is not NULL)\n"
"{\n"
"xt := xml_tree_doc (err_vec);\n"
"if (xpath_eval (\'[ xmlns:env=\"http://schemas.xmlsoap.org/soap/envelope/\" ] //env:Fault\', xt, 1) is not null)\n"
"{\n"
"declare error_text varchar;\n"
"error_text :=\n"
"xpath_eval (\'[ xmlns:env=\"http://schemas.xmlsoap.org/soap/envelope/\" ] //env:Fault/faultstring\',\n"
"xt, 1);\n"
"signal (\'WSRMC\', cast (error_text as varchar));\n"
"}\n"
"}\n"
"}\n"
"--src wsrmcli.sql:431\n";

static const char *proc256 = 
"create procedure WSRM_RESENDER (in identifier varchar)\n"
"{\n"
"declare ret, list any;\n"
"declare resend_message SOAP_CLIENT_REQ;\n"
"declare st, pa soap_parameter;\n"
"declare state wsrm_cli;\n"
"declare addr wsa_cli;\n"
"declare idx, len integer;\n"
"\n"
"set isolation=\'committed\';\n"
"list := vector ();\n"
"\n"
"for select OML_MESSAGE_ID, OML_MESSAGE, OML_ADDRESS from SYS_WSRM_OUT_MESSAGE_LOG\n"
"where OML_STATE <> 3 and OML_INDENTIFIER = identifier do\n"
"{\n"
"list := vector_concat (list, vector (vector (OML_MESSAGE_ID, OML_MESSAGE, OML_ADDRESS)));\n"
"}\n"
"\n"
"commit work;\n"
"\n"
"idx := 0;\n"
"len := length (list);\n"
"\n"
"while (idx < len)\n"
"{\n"
"declare policy any;\n"
"resend_message := list[idx][1];\n"
"addr := list[idx][2];\n"
"\n"
"state := new wsrm_cli (addr, addr.\"to\", identifier);\n"
"state.msgno := list[idx][0];\n"
"\n"
"WSRM_CLIENT (state, 0, resend_message);\n"
"\n"
"idx := idx + 1;\n"
"}\n"
"}\n"
"--src wsrmcli.sql:449\n";

static const char *proc257 = 
"create procedure WSRM_ACKNOWLEDGEMENT_PROCESS (in state wsrm_cli, in identifier varchar, in stru any)\n"
"{\n"
"declare my_max, idx, idx2, len2 integer;\n"
"declare list, dummy any;\n"
"declare cr cursor for select OML_MESSAGE_ID from SYS_WSRM_OUT_MESSAGE_LOG\n"
"where OML_INDENTIFIER = identifier;\n"
"list := vector ();\n"
"whenever not found goto ret;\n"
"open cr (exclusive);\n"
"fetch cr into dummy;\n"
"select count (*) into my_max from SYS_WSRM_OUT_MESSAGE_LOG where OML_INDENTIFIER = identifier;\n"
"\n"
"list := make_array (my_max + 1, \'any\');\n"
"idx := 0;\n"
"\n"
"while (idx <= my_max)\n"
"{\n"
"aset (list, idx, 0);\n"
"idx := idx + 1;\n"
"}\n"
"\n"
"aset (list, 0, state.is_finish);\n"
"\n"
"idx := 0;\n"
"\n"
"declare elm any;\n"
"while (elm := adm_next_keyword (\'AcknowledgementRange\', stru, idx))\n"
"{\n"
"\n"
"idx2 := get_keyword (\'Lower\', elm[1], 0);\n"
"len2 := get_keyword (\'Upper\', elm[1], 0);\n"
"\n"
"while (idx2 <= len2)\n"
"{\n"
"aset (list, idx2, 1);\n"
"idx2 := idx2 + 1;\n"
"}\n"
"}\n"
"\n"
"if (elm = 0)\n"
"update SYS_WSRM_OUT_MESSAGE_LOG set OML_STATE = 3\n"
"where OML_INDENTIFIER = identifier;\n"
"\n"
"\n"
"idx := 1;\n"
"\n"
"while (idx <= my_max)\n"
"{\n"
"if (list[idx])\n"
"{\n"
"update SYS_WSRM_OUT_MESSAGE_LOG set OML_STATE = 3\n"
"where OML_INDENTIFIER = identifier and OML_MESSAGE_ID = idx;\n"
"if (row_count () = 0)\n"
"{\n"
"signal (\'42000\', \'Error on WSRM Client. The WSRM Server have unsend message.\');\n"
"}\n"
"}\n"
"idx := idx + 1;\n"
"\n"
"}\n"
"ret:\n"
"close cr;\n"
"return list;\n"
"}\n"
"--src wsrmcli.sql:488\n";

static const char *proc258 = 
"create procedure WSRM_UPDATE_CLIENT_TABLES (in response any, in state wsrm_cli)\n"
"{\n"
"declare xt any;\n"
"declare s soap_parameter;\n"
"declare identifier varchar;\n"
"\n"
"xt := xml_tree_doc (response);\n"
"s := new soap_parameter ();\n"
"s.set_xsd (\'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceAcknowledgement_t\');\n"
"s.deserialize (xt, \'SequenceAcknowledgement[1]\');\n"
"\n"
"identifier := cast (xpath_eval (\'//Identifier\', xt, 1) as varchar);\n"
"\n"
"return WSRM_ACKNOWLEDGEMENT_PROCESS (state, identifier, s.s);\n"
"}\n"
"--src wsrmcli.sql:554\n";

static const char *proc259 = 
"create procedure WSRM_CLIENT_ACKREQUESTED (in req wsrm_cli)\n"
"{\n"
"declare _headers, wa, ack any;\n"
"declare identifier varchar;\n"
"declare n soap_parameter;\n"
"\n"
"identifier := req.seq;\n"
"\n"
"n := new soap_parameter (identifier);\n"
"ack := vector (vector (\'\', \'http://schemas.xmlsoap.org/ws/2005/02/rm:AckRequested\'), vector (n.s));\n"
"wa := WSA_REQ (req);\n"
"_headers := vector_concat (ack, wa);\n"
"\n"
"commit work;\n"
"return SOAP_CLIENT (url=>req.url, operation=>\'WSRMAckRequested\',\n"
"style=>(128+64+1), headers=>_headers, direction=>0);\n"
"}\n"
"--src wsrmcli.sql:572\n";

static const char *proc260 = 
"create procedure WSRM_CLIENT_ACKTERMINATE (in req wsrm_cli)\n"
"{\n"
"declare _headers any;\n"
"declare n soap_parameter;\n"
"declare identifier varchar;\n"
"\n"
"identifier := req.seq;\n"
"n := new soap_parameter (identifier);\n"
"\n"
"_headers := vector (vector (\'\', \'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceTerminate\'), vector (n.s));\n"
"\n"
"SOAP_CLIENT (url=>req.url, operation=>\'WSRMSequenceTerminate\', headers=>_headers, direction=>1);\n"
"}\n"
"--src wsrmcli.sql:593\n";

static const char *other165 = 
"insert soft SYS_SCHEDULED_EVENT (SE_NAME, SE_START, SE_SQL, SE_INTERVAL)\n"
"values (\'WSRM Client Scheduled Tasks\', now(), \'DB.DBA.WSRM_CLIENT_SCHEDULED_TASKS ()\', 100)\n";
static const char *proc261 = 
"create procedure WSRM_CLIENT_SCHEDULED_TASKS ()\n"
"{\n"
"\n"
"for (select WOS_IDENTIFIER, WOS_DELIVERY_ASSURANCE, WOS_SEQUENCE_EXPIRATION,\n"
"WOS_INACTIVITY_TIMEOUT, WOS_RETRANSMISSION_INTERVAL, WOS_ACKNOWLEDGEMENT_INTERVAL\n"
"from SYS_WSRM_OUT_SEQUENCES where WOS_IDENTIFIER = \'\') do\n"
"{\n"
"if ((WOS_ACKNOWLEDGEMENT_INTERVAL is not NULL)\n"
"and (datediff (\'seconds\', WOS_ACKNOWLEDGEMENT_INTERVAL, now ()) > 0))\n"
"{\n"
" ;\n"
"}\n"
"\n"
"if ((WOS_RETRANSMISSION_INTERVAL is not NULL)\n"
"and (datediff (\'seconds\', WOS_RETRANSMISSION_INTERVAL, now ()) > 0))\n"
"{\n"
" ;\n"
"}\n"
"}\n"
"\n"
"set isolation=\'committed\';\n"
"\n"
"for (select OML_INDENTIFIER from SYS_WSRM_OUT_MESSAGE_LOG where OML_STATE <> 3) do\n"
"{\n"
"WSRM_RESENDER (OML_INDENTIFIER);\n"
"}\n"
"}\n"
"--src wsrmcli.sql:614\n";

static const char *proc262 = 
"create procedure WSRM_GET_IDENTIFIER (in s any)\n"
"{\n"
"declare ret soap_parameter;\n"
"\n"
"ret := new soap_parameter ();\n"
"ret.set_struct (s);\n"
"return ret.get_value ();\n"
"}\n"
"--src wsrmcli.sql:643\n";

static const char *proc263 = 
"create procedure WSA_REQ (inout state wsrm_cli)\n"
"{\n"
"declare req, mid, mto, mac any;\n"
"declare mfrom, mreply, mfault soap_parameter;\n"
"\n"
"mfrom := new soap_parameter ();\n"
"mreply := new soap_parameter ();\n"
"mfault := new soap_parameter ();\n"
"\n"
"req := vector ();\n"
"mfrom.set_xsd (\'http://schemas.xmlsoap.org/ws/2004/08/addressing:From\');\n"
"if (state.address.\"from\" is not null)\n"
"mfrom.add_member (\'Address\', state.address.\"from\");\n"
"else\n"
"mfrom.add_member (\'Address\', \'http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous\');\n"
"mfrom.set_attribute (\'Id\', uuid ());\n"
"req := vector_concat (mfrom.get_call_param (\'\'));\n"
"\n"
"if (state.address.mid is not null)\n"
"{\n"
"mid := vector (vector (\'\', \'http://schemas.xmlsoap.org/ws/2004/08/addressing:MessageID\'),\n"
"vector (composite (), vector (\'Id\', uuid ()), state.address.mid));\n"
"req := vector_concat (req, mid);\n"
"}\n"
"\n"
"if (state.address.\"to\" is not null)\n"
"{\n"
"mto := vector (vector (\'\', \'http://schemas.xmlsoap.org/ws/2004/08/addressing:To\'),\n"
"vector (composite (), vector (\'Id\', uuid ()), state.address.\"to\"));\n"
"req := vector_concat (req, mto);\n"
"}\n"
"\n"
"if (state.address.action is not null)\n"
"{\n"
"mac := vector (vector (\'\', \'http://schemas.xmlsoap.org/ws/2004/08/addressing:Action\'),\n"
"vector (composite (), vector (\'Id\', uuid ()), state.address.action));\n"
"req := vector_concat (req, mac);\n"
"}\n"
"\n"
"if (state.address.reply_to is not null)\n"
"{\n"
"mreply.set_xsd (\'http://schemas.xmlsoap.org/ws/2004/08/addressing:ReplyTo\');\n"
"mreply.add_member (\'Address\', state.address.reply_to);\n"
"mreply.set_attribute (\'Id\', uuid ());\n"
"req := vector_concat (req, mreply.get_call_param (\'\'));\n"
"}\n"
"\n"
"if (state.address.fault_to is not null)\n"
"{\n"
"mfault.set_xsd (\'http://schemas.xmlsoap.org/ws/2004/08/addressing:FaultTo\');\n"
"mfault.add_member (\'Address\', state.address.fault_to);\n"
"mfault.set_attribute (\'Id\', uuid ());\n"
"req := vector_concat (req, mfault.get_call_param (\'\'));\n"
"}\n"
"\n"
"return req;\n"
"}\n"
"--src wsrmcli.sql:654\n";

/* wsrmsrv.sql */

static const char *proc264 = 
"create procedure WSRM_INIT ()\n"
"{\n"
"if (not isstring (registry_get (\'WSRMServerID\')))\n"
"registry_set (\'WSRMServerID\', uuid ());\n"
"}\n"
"--src wsrmsrv.sql:22\n";


static const char *other166 = 
" WSRM_INIT ()\n";
static const char *proc265 = 
"create procedure WSRMSequence\n"
"(\n"
"in  Sequence any __soap_header \'http://schemas.xmlsoap.org/ws/2005/02/rm:Sequence\',\n"
"in  PolicyAttachment any := null __soap_header \'http://schemas.xmlsoap.org/ws/2002/12/policy:PolicyAttachment\',\n"
"in  MessageID any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:MessageID\',\n"
"inout  \"To\" any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:To\',\n"
"inout  Action any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:Action\',\n"
"inout  \"From\" any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:From\',\n"
"in  ReplyTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:ReplyTo\',\n"
"in  FaultTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:FaultTo\',\n"
"in  Security any := null __soap_header \'http://schemas.xmlsoap.org/ws/2003/06/secext:Security\',\n"
"out RelatesTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:RelatesTo\',\n"
"out Acknowledgement any __soap_header \'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceAcknowledgement\',\n"
"out SequenceFault any __soap_fault \'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceFault\',\n"
"in  ws_soap_request any\n"
")\n"
"__soap_options (__soap_doc := \'__VOID__\', \"DefaultOperation\" := 1)\n"
"{\n"
"\n"
"declare _message_num, is_final, is_sync integer;\n"
"declare identifier, mto varchar;\n"
"declare _message, acknowled, res any;\n"
"declare s soap_parameter;\n"
"declare _from soap_parameter;\n"
"declare address WSA_CLI;\n"
"declare _addr varchar;\n"
"declare lines, pret, tmp any;\n"
"\n"
"\n"
"pret := null;\n"
"is_sync := 0;\n"
"\n"
"declare exit handler for sqlstate \'WSRM*\' {\n"
"\"From\" := null; \"To\" := null; Action := null;\n"
"SequenceFault := WSRM_SERVER_ERROR (__SQL_STATE, identifier);\n"
"connection_set (\'SOAPFault\', vector (\'300\', __SQL_MESSAGE));\n"
"return;\n"
"};\n"
"\n"
"lines := http_request_header ();\n"
"res := null; _addr := null;\n"
"s := new soap_parameter ();\n"
"_from := new soap_parameter ();\n"
"\n"
"if (\"From\" is not null)\n"
"{\n"
"_from.s := \"From\";\n"
"_addr := cast (_from.get_member (\'Address\') as varchar);\n"
"}\n"
"\n"
"\n"
"address := new wsa_cli ();\n"
"\n"
"s.s := Sequence;\n"
"identifier := WSRM_GET_IDENTIFIER (s.get_member (\'Identifier\'));\n"
"insert soft SYS_WSRM_IN_SEQUENCES (WIS_IDENTIFIER) values (identifier);\n"
"\n"
"\n"
"if ((MessageID is not NULL) and (Action is not NULL) and (\"From\" is not NULL) and (\"To\" is not NULL))\n"
"{\n"
"address.mid := MessageID;\n"
"address.action := Action;\n"
"address.\"from\" := _addr;\n"
"address.\"to\" := \"To\";\n"
"address.reply_to := ReplyTo;\n"
"address.fault_to := FaultTo;\n"
"\n"
"s.s := ReplyTo;\n"
"}\n"
"else\n"
"{\n"
"signal (\'WSRM1\', concat (\'The Sequence is terminated or address is not complete.\'));\n"
"}\n"
"\n"
"\n"
"\n"
"\n"
"if (PolicyAttachment is not NULL)\n"
"{\n"
"declare bri, i_timeout, acli, exp, del_ass, spec_ver any;\n"
"declare apl, pol soap_parameter;\n"
"\n"
"s := new soap_parameter();\n"
"s.s := PolicyAttachment;\n"
"apl := new soap_parameter ();\n"
"apl.s := s.get_member (\'AppliesTo\')[0];\n"
"pol := new soap_parameter ();\n"
"\n"
"identifier := apl.get_attribute(\'Identifier\');\n"
"\n"
"pol.s := s.get_member (\'Policy\');\n"
"i_timeout := pol.get_member(\'BaseRetransmissionInterval\')[1][1];\n"
"bri := pol.get_member(\'BaseRetransmissionInterval\')[1][1];\n"
"acli := pol.get_member(\'AcknowledgementInterval\')[1][1];\n"
"exp := pol.get_member(\'Expires\');\n"
"del_ass := pol.get_member(\'DeliveryAssurance\')[1][1];\n"
"spec_ver := pol.get_member(\'SpecVersion\')[1][1];\n"
"\n"
"update SYS_WSRM_IN_SEQUENCES set\n"
"WIS_VERSION = spec_ver,\n"
"WIS_DELIVERY_ASSURANCE = del_ass,\n"
"WIS_SEQUENCE_EXPIRATION = exp,\n"
"WIS_INACTIVITY_TIMEOUT = i_timeout,\n"
"WIS_RETRANSMISSION_INTERVAL = bri,\n"
"WIS_ACKNOWLEDGEMENT_INTERVAL = acli\n"
"where WIS_IDENTIFIER = identifier;\n"
"\n"
"}\n"
"\n"
"if (Sequence is not NULL)\n"
"{\n"
"declare opts any;\n"
"s.s := Sequence;\n"
"identifier := WSRM_GET_IDENTIFIER (s.get_member (\'Identifier\'));\n"
"_message_num := s.get_member (\'MessageNumber\');\n"
"is_final := s.get_member (\'LastMessage\');\n"
"\n"
"WSRM_CHECK_POLICY (identifier);\n"
"\n"
"_message := xml_tree_doc (ws_soap_request);\n"
"\n"
"if (is_final is null) is_final := -1;\n"
"\n"
"if ((is_final <> -1 and _addr is null) or\n"
"_addr = \'http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous\')\n"
"{\n"
"is_sync := 1;\n"
"}\n"
"else\n"
"{\n"
"http_rewrite ();\n"
"http_request_status (\'HTTP/1.1 202 Accepted\');\n"
"http_flush ();\n"
"}\n"
"\n"
"insert soft SYS_WSRM_IN_MESSAGE_LOG (IML_INDENTIFIER, IML_MESSAGE_ID, IML_MESSAGE, IML_ADDRES, IML_STATE)\n"
"values (identifier, _message_num, _message, address, is_final);\n"
"\n"
"opts := http_map_get (\'soap_opts\');\n"
"if (isarray (opts))\n"
"{\n"
"declare pname varchar;\n"
"declare nmsg any;\n"
"pname := get_keyword (\'WSRM-Callback\', opts);\n"
"if (length (pname) and __proc_exists (pname))\n"
"{\n"
"nmsg := xslt (\'http://local.virt/wsrmcall\', _message);\n"
"pret := call (pname) (nmsg, identifier, _message_num);\n"
"}\n"
"}\n"
"\n"
"commit work;\n"
"}\n"
"\n"
"\n"
"if (is_sync)\n"
"{\n"
"\n"
"\n"
"res := WSRM_ACKNOWLEDGEMENT (identifier);\n"
"\n"
"\n"
"if (res is not NULL)\n"
"{\n"
"Acknowledgement := res;\n"
"if (pret is not null and MessageID is not null)\n"
"{\n"
"declare _to, _from_addr any;\n"
"if (\"To\" is not null and \"From\" is not null)\n"
"{\n"
"_to := \"To\"[2];\n"
"_from_addr := get_keyword (\'Address\', \"From\");\n"
"\"To\" := vector (composite(), \'\', _from_addr); \"From\" := soap_box_structure (\'Address\', _to);\n"
"}\n"
"RelatesTo := vector (composite(), vector (\'RelationshipType\',\'wsa:Response\'), MessageID[2]);\n"
"}\n"
"else\n"
"{\n"
"\"From\" := vector (composite (), vector (\'Id\', \'Id-\'||uuid()), \'Address\', _addr);\n"
"\"To\" := vector (composite(), vector (\'Id\', \'Id-\'||uuid()), \'\');\n"
"}\n"
"return pret;\n"
"}\n"
"}\n"
"else\n"
"{\n"
"declare exit handler for sqlstate \'*\'\n"
"{\n"
"goto flushit;\n"
"};\n"
"WSRM_ASYNC_PROCESS (identifier);\n"
"flushit:;\n"
"}\n"
"}\n"
"--src wsrmsrv.sql:34\n";

static const char *proc266 = 
"create procedure\n"
"WSRMSequenceTerminate\n"
"(\n"
"in  SequenceTerminate any __soap_header \'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceTerminate\'\n"
")\n"
"__soap_options (__soap_doc := \'__VOID__\', DefaultOperation := 0)\n"
"{\n"
"declare identifier varchar;\n"
"\n"
"if (SequenceTerminate is not NULL)\n"
"{\n"
"identifier := cast (SequenceTerminate[0][2] as varchar);\n"
"\n"
"delete from SYS_WSRM_IN_MESSAGE_LOG where IML_INDENTIFIER = identifier;\n"
"delete from SYS_WSRM_IN_SEQUENCES where WIS_IDENTIFIER = identifier;\n"
"\n"
"commit work;\n"
"http_request_status (\'HTTP/1.1 202 Accepted\');\n"
"http_flush ();\n"
"http_request_status (\'reply sent\');\n"
"}\n"
"\n"
"return;\n"
"}\n"
"--src wsrmsrv.sql:231\n";

static const char *proc267 = 
"create procedure\n"
"WSRMAckRequested\n"
"(\n"
"in  AckRequested any __soap_header \'http://schemas.xmlsoap.org/ws/2005/02/rm:AckRequested\',\n"
"in  ws_soap_request any,\n"
"out SequenceFault any __soap_fault \'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceFault\',\n"
"out Acknowledgement any __soap_header \'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceAcknowledgement\'\n"
")\n"
"__soap_options (__soap_doc := \'__VOID__\', DefaultOperation := 0)\n"
"{\n"
"declare identifier varchar;\n"
"\n"
"declare exit handler for sqlstate \'WSRM*\' {\n"
"SequenceFault := WSRM_SERVER_ERROR (__SQL_STATE, identifier);\n"
"connection_set (\'SOAPFault\', vector (\'300\', __SQL_MESSAGE));\n"
"return;\n"
"};\n"
"\n"
"if (AckRequested is not NULL)\n"
"{\n"
"identifier := cast (AckRequested [0][2] as varchar);\n"
"WSRM_CHECK_POLICY (identifier);\n"
"Acknowledgement := WSRM_ACKNOWLEDGEMENT (identifier);\n"
"}\n"
"return;\n"
"}\n"
"--src wsrmsrv.sql:257\n";

static const char *proc268 = 
"create procedure WSRM_ACKNOWLEDGEMENT (in identifier varchar)\n"
"{\n"
"declare idx, max_exist, upper, lower, flag integer;\n"
"declare s, r soap_parameter;\n"
"declare _headers any;\n"
"\n"
"s := new soap_parameter ();\n"
"r := new soap_parameter ();\n"
"\n"
"s.add_member (\'Identifier\', soap_parameter (identifier));\n"
"\n"
"\n"
"idx := 1; lower := -1; flag := 0;\n"
"\n"
"select max (IML_MESSAGE_ID) into max_exist from SYS_WSRM_IN_MESSAGE_LOG where IML_INDENTIFIER = identifier;\n"
"\n"
"if (max_exist is NULL)\n"
"{\n"
"max_exist := 0;\n"
"lower := 0;\n"
"idx := 0;\n"
"}\n"
"\n"
"while (idx <= max_exist)\n"
"{\n"
"if (exists (select 1 from SYS_WSRM_IN_MESSAGE_LOG where\n"
"IML_INDENTIFIER = identifier and IML_MESSAGE_ID = idx))\n"
"{\n"
"if (flag <> 2)\n"
"lower := idx;\n"
"\n"
"upper := idx;\n"
"flag := 2;\n"
"}\n"
"else\n"
"flag := 1;\n"
"\n"
"if ((flag = 1 and lower > 0) or (idx = max_exist))\n"
"{\n"
"r := new soap_parameter ();\n"
"r.set_attribute (\'Upper\', upper);\n"
"r.set_attribute (\'Lower\', lower);\n"
"s.add_member (\'AcknowledgementRange\', r);\n"
"flag := 0; lower := -1;\n"
"}\n"
"\n"
"idx := idx + 1;\n"
"}\n"
"\n"
"\n"
"return s.s;\n"
"}\n"
"--src wsrmsrv.sql:285\n";

static const char *proc269 = 
"create procedure WSRM_SERVER_ERROR (in _state varchar, in identifier varchar)\n"
"{\n"
"declare f, ack soap_parameter;\n"
"f := soap_parameter ();\n"
"f.add_member (\'Identifier\', soap_parameter (identifier));\n"
"\n"
"if (_state = \'WSRM1\')\n"
"f.add_member (\'FaultCode\', soap_parameter (\'wsrm:SequenceTerminated\'));\n"
"else if (_state = \'WSRM2\')\n"
"f.add_member (\'FaultCode\', soap_parameter (\'wsrm:UnknownSequence\'));\n"
"else if (_state = \'WSRM5\')\n"
"f.add_member (\'FaultCode\', soap_parameter (\'wsrm:LastMessageNumberExceeded\'));\n"
"else\n"
"f.add_member (\'FaultCode\', soap_parameter (\'wsrm:SequenceRefused\'));\n"
"\n"
"if (0)\n"
"{\n"
"ack := soap_parameter ();\n"
"ack.set_attribute (\'Upper\', 1);\n"
"ack.set_attribute (\'Lower\', 10);\n"
"f.add_member (\'AcknowledgementRange\', ack);\n"
"}\n"
"return f.s;\n"
"\n"
"}\n"
"--src wsrmsrv.sql:339\n";

static const char *proc270 = 
"create procedure WSRM_CHECK_POLICY (in identifier varchar)\n"
"{\n"
"if (exists (select 1 from SYS_WSRM_IN_MESSAGE_LOG where IML_INDENTIFIER = identifier and\n"
"IML_STATE = 5))\n"
"{\n"
"signal (\'WSRM1\', concat (\'The Sequence is terminated (\',\n"
"cast (identifier as varchar), \')\'));\n"
"}\n"
"\n"
"if (exists (select 1 from SYS_WSRM_IN_MESSAGE_LOG where IML_INDENTIFIER = identifier and\n"
"IML_STATE = 1))\n"
"{\n"
"update SYS_WSRM_IN_MESSAGE_LOG set IML_STATE = 2 where IML_INDENTIFIER = identifier;\n"
"commit work;\n"
"signal (\'WSRM5\', concat (\'Last message number exceeded (\',\n"
"cast (identifier as varchar), \')\'));\n"
"}\n"
"\n"
"\n"
"if (not exists (select 1 from SYS_WSRM_IN_SEQUENCES where WIS_IDENTIFIER = identifier))\n"
"{\n"
"signal (\'WSRM2\', concat (\'The sequence not exists (\',\n"
"cast (identifier as varchar), \')\'));\n"
"}\n"
"}\n"
"--src wsrmsrv.sql:366\n";

static const char *proc271 = 
"create procedure WSRM_MAKE_RANGES (in arr any)\n"
"{\n"
"declare res, elm any;\n"
"declare i, l int;\n"
"res := vector ();\n"
"elm := vector (0, 0);\n"
"i := 0; l := length (arr);\n"
"while (i < l)\n"
"{\n"
"if (elm[0] = 0)\n"
"elm[0] := arr[i];\n"
"if (elm[1]+1 <> arr[i])\n"
"{\n"
"res := vector_concat (res, vector (elm));\n"
"elm := vector (arr[i], arr[i]);\n"
"}\n"
"elm[1] := arr[i];\n"
"\n"
"i := i + 1;\n"
"}\n"
"if (l = 1)\n"
"res := vector (elm);\n"
"else if (elm[0] <> 0)\n"
"res := vector_concat (res, vector (elm));\n"
"return res;\n"
"}\n"
"--src wsrmsrv.sql:393\n";

static const char *proc272 = 
"create procedure WSRM_ASYNC_ACK_SEND (in seq varchar, in address varchar, in range any)\n"
"{\n"
"\n"
"declare n, ack, ra soap_parameter;\n"
"declare req wsrm_cli;\n"
"declare addr wsa_cli;\n"
"declare i, l, retr int;\n"
"declare wa, ranges any;\n"
"declare vhdr any;\n"
"\n"
"\n"
"vhdr := \'X-Virt-WSRM-ID: \' || registry_get (\'WSRMServerID\') || \';\' || cast (seq as varchar) || \';\' ;\n"
"n := new soap_parameter (seq);\n"
"ack := new soap_parameter ();\n"
"\n"
"ack.add_member (\'Identifier\', n);\n"
"ack.set_xsd (\'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceAcknowledgement\');\n"
"\n"
"ranges := WSRM_MAKE_RANGES (range);\n"
"\n"
"i := 0; l := length (ranges); retr := 0;\n"
"\n"
"if (l = 0)\n"
"return;\n"
"\n"
"while (i < l)\n"
"{\n"
"ra := new soap_parameter ();\n"
"ra.set_attribute (\'Upper\', ranges[i][1]);\n"
"ra.set_attribute (\'Lower\', ranges[i][0]);\n"
"ack.add_member (\'AcknowledgementRange\', ra);\n"
"vhdr := vhdr || sprintf(\'%d-%d;\', ranges[i][0], ranges[i][1]);\n"
"i := i + 1;\n"
"}\n"
"\n"
"req := wsrm_cli ();\n"
"addr := wsa_cli ();\n"
"addr.\"from\" := \'http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous\';\n"
"addr.\"to\" := \'http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous\';\n"
"addr.action := \'http://schemas.xmlsoap.org/ws/2004/03/rm#SequenceAcknowledgement\';\n"
"req.address := addr;\n"
"\n"
"wa := WSA_REQ (req);\n"
"\n"
"vhdr := vhdr || \'\\r\\n\';\n"
"\n"
"declare exit handler for sqlstate \'HTCLI\' {\n"
"retr := retr + 1;\n"
"if (retr > 3)\n"
"resignal;\n"
"};\n"
"\n"
"commit work;\n"
"SOAP_CLIENT (url=>address, operation=>\'AcknowledgementRange\', style=>(128+64+1), direction=>1,\n"
"headers=>vector_concat (wa, ack.get_call_param(\'\')), http_header=>null);\n"
"}\n"
"--src wsrmsrv.sql:421\n";

static const char *proc273 = 
"create procedure WSRM_ASYNC_PROCESS (in seq varchar)\n"
"{\n"
"declare range varchar;\n"
"declare addr varchar;\n"
"\n"
"range := vector ();\n"
"addr := null;\n"
"\n"
"for select IML_MESSAGE_ID, IML_STATE, IML_ADDRES from SYS_WSRM_IN_MESSAGE_LOG where IML_INDENTIFIER = seq\n"
"do\n"
"{\n"
"if (IML_ADDRES is not null)\n"
"addr := (IML_ADDRES as wsa_cli).\"from\";\n"
"range := vector_concat (range, vector (IML_MESSAGE_ID));\n"
"}\n"
"\n"
"\n"
"\n"
"if (addr is not null)\n"
"WSRM_ASYNC_ACK_SEND (seq, addr, range);\n"
"\n"
"update SYS_WSRM_IN_SEQUENCES set WIS_ACK_SENT = 1 where WIS_IDENTIFIER = seq;\n"
"return;\n"
"}\n"
"--src wsrmsrv.sql:480\n";

static const char *other167 = 
"insert soft SYS_SCHEDULED_EVENT (SE_NAME, SE_START, SE_SQL, SE_INTERVAL)\n"
"values (\'WSRM Server Scheduled Tasks\', now(), \'DB.DBA.WSRM_SERVER_SCHEDULED_TASKS ()\', 100)\n";
static const char *proc274 = 
"create procedure WSRM_SERVER_SCHEDULED_TASKS ()\n"
"{\n"
"\n"
"declare idn varchar;\n"
"\n"
"\n"
"\n"
"declare cr1 cursor for select WIS_IDENTIFIER\n"
"from SYS_WSRM_IN_SEQUENCES where WIS_SEQUENCE_EXPIRATION < now ();\n"
"\n"
"whenever not found goto nf1;\n"
"open cr1 (prefetch 1);\n"
"\n"
"while (1)\n"
"{\n"
"fetch cr1 into idn;\n"
"delete from SYS_WSRM_IN_MESSAGE_LOG where IML_INDENTIFIER = idn;\n"
"delete from SYS_WSRM_IN_SEQUENCES where current of cr1;\n"
"}\n"
"\n"
"nf1:\n"
"close cr1;\n"
"\n"
"\n"
"\n"
"declare cr2 cursor for select IML_INDENTIFIER\n"
"from SYS_WSRM_IN_MESSAGE_LOG where IML_STATE = 6;\n"
"\n"
"whenever not found goto nf2;\n"
"open cr2 (prefetch 1);\n"
"\n"
"while (1)\n"
"{\n"
"fetch cr2 into idn;\n"
"delete from SYS_WSRM_IN_SEQUENCES where WIS_IDENTIFIER = idn;\n"
"delete from SYS_WSRM_IN_MESSAGE_LOG where current of cr1;\n"
"}\n"
"\n"
"nf2:\n"
"close cr2;\n"
"\n"
"}\n"
"--src wsrmsrv.sql:511\n";

static const char *proc275 = 
"create procedure WSRMSequenceAcknowledgement (\n"
"in  SequenceAcknowledgement any __soap_header \'http://schemas.xmlsoap.org/ws/2005/02/rm:SequenceAcknowledgement\',\n"
"in  MessageID any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:MessageID\',\n"
"in  \"To\" any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:To\',\n"
"in  Action any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:Action\',\n"
"in  \"From\" any __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:From\',\n"
"in  ReplyTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:ReplyTo\',\n"
"in  FaultTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:FaultTo\',\n"
"in  Security any := null __soap_header \'http://schemas.xmlsoap.org/ws/2003/06/secext:Security\',\n"
"in  ws_soap_request any\n"
")\n"
"__soap_options (__soap_doc := \'__VOID__\', DefaultOperation := 1)\n"
"{\n"
"declare s soap_parameter;\n"
"declare identifier varchar;\n"
"declare cli wsrm_cli;\n"
"declare lines any;\n"
"\n"
"lines := http_request_header ();\n"
"s := new soap_parameter ();\n"
"s.s := SequenceAcknowledgement;\n"
"identifier := cast (WSRM_GET_IDENTIFIER (s.get_member (\'Identifier\')) as varchar);\n"
"\n"
"\n"
"cli := new wsrm_cli (WSA_CLI(), \'\', identifier);\n"
"\n"
"WSRM_ACKNOWLEDGEMENT_PROCESS (cli, identifier, s.s);\n"
"\n"
"\n"
"\n"
"http_request_status (\'HTTP/1.1 202 Accepted\');\n"
"http_flush ();\n"
"http_request_status (\'reply sent\');\n"
"}\n"
"--src wsrmsrv.sql:556\n";

static const char *proc276 = 
"create procedure WSRMCreateSequence\n"
"(\n"
"in  CreateSequence any __soap_type \'http://schemas.xmlsoap.org/ws/2005/02/rm:CreateSequence\',\n"
"in  MessageID any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:MessageID\',\n"
"in  \"To\" any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:To\',\n"
"in  Action any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:Action\',\n"
"in  \"From\" any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:From\',\n"
"in  ReplyTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:ReplyTo\',\n"
"in  FaultTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:FaultTo\'\n"
")\n"
"__soap_doc \'http://schemas.xmlsoap.org/ws/2005/02/rm:CreateSequenceResponse\'\n"
"{\n"
"declare identifier any;\n"
"identifier := \'uuid:\' || lower (uuid ());\n"
"insert soft SYS_WSRM_IN_SEQUENCES (WIS_IDENTIFIER) values (identifier);\n"
"return soap_box_structure (\'Identifier\', vector (composite (), \'\', identifier));\n"
"}\n"
"--src wsrmsrv.sql:593\n";

static const char *proc277 = 
"create procedure TerminateSequence\n"
"(\n"
"in  TerminateSequence any __soap_type \'http://schemas.xmlsoap.org/ws/2005/02/rm:TerminateSequence\',\n"
"in  MessageID any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:MessageID\',\n"
"in  \"To\" any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:To\',\n"
"in  Action any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:Action\',\n"
"in  \"From\" any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:From\',\n"
"in  ReplyTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:ReplyTo\',\n"
"in  FaultTo any := null __soap_header \'http://schemas.xmlsoap.org/ws/2004/08/addressing:FaultTo\'\n"
")\n"
"__soap_doc \'__VOID__\'\n"
"{\n"
"delete from SYS_WSRM_IN_SEQUENCES where WIS_IDENTIFIER = TerminateSequence[0][2];\n"
"http_request_status (\'HTTP/1.1 202 Accepted\');\n"
"http_flush ();\n"
"http_request_status (\'reply sent\');\n"
"return;\n"
"}\n"
"--src wsrmsrv.sql:613\n";

/* wstr_ddl.sql */

static const char *udt5 = 
"create type POLICY_STRUCT as\n"
"(\n"
"usage varchar,\n"
"token_type varchar,\n"
"token_issuer varchar,\n"
"user_name varchar,\n"
"user_pass varchar,\n"
"debug integer default 0,\n"
"token varchar\n"
")\n";

static const char *tbl18 = 
"create table WST_SERVER_ISSUER_TOKENS\n"
"(\n"
"WSK_TOKEN_TYPE	varchar,\n"
"WSK_REQUEST_TYPE	varchar,\n"
"WSK_APPLIES_TO	varchar,\n"
"WSK_FROM		varchar,\n"
"WSK_SERVICE_NAME	varchar,\n"
"WSK_PORT_TYPE		varchar,\n"
"WSK_TOKEN		varchar,\n"
"PRIMARY KEY (WSK_TOKEN_TYPE, WSK_FROM, WSK_TOKEN)\n"
")\n";

/* wstrcli.sql */

static const char *proc278 = 
"create procedure WST_CLI (in req SOAP_CLIENT_REQ, in policy POLICY_STRUCT)\n"
"{\n"
"declare ret any;\n"
"\n"
"ret := WST_GETRST (req, policy);\n"
"\n"
"if (policy.debug = 1)\n"
"return ret;\n"
"\n"
"policy.token := ret;\n"
"\n"
"ret := WS_TRUST_REQ (req, policy);\n"
"\n"
"return ret;\n"
"}\n"
"--src wstrcli.sql:22\n";

static const char *proc279 = 
"create procedure WST_GETRST (in req SOAP_CLIENT_REQ, in policy POLICY_STRUCT)\n"
"{\n"
"declare ret any;\n"
"declare headers, param any;\n"
"declare wsa_from, wsu_time, par, created, expr, m_id, a_to, act soap_parameter;\n"
"declare rst SOAP_CLIENT_REQ;\n"
"declare style integer;\n"
"\n"
"rst := new SOAP_CLIENT_REQ ();\n"
"\n"
"rst.url := policy.token_issuer;\n"
"rst.operation := \'RequestSecurityToken\';\n"
"\n"
"wsa_from := new soap_parameter ();\n"
"wsa_from.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:From\');\n"
"wsa_from.add_member (\'Address\', \'http://schemas.xmlsoap.org/ws/2003/03/addressing/role/anonymous\');\n"
"wsa_from.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"created := new soap_parameter (dt_set_tz (now (), 0));\n"
"created.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Created\');\n"
"created.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"expr := new soap_parameter (dt_set_tz (dateadd (\'minute\', 5, now ()), 0));\n"
"expr.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Expires\');\n"
"expr.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"wsu_time := new soap_parameter ();\n"
"wsu_time.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Timestamp\');\n"
"wsu_time.add_member (\'Created\', created);\n"
"wsu_time.add_member (\'Expires\', expr);\n"
"\n"
"m_id := new soap_parameter (lower (\'UUID:\'||uuid ()));\n"
"m_id.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:MessageID\');\n"
"m_id.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"a_to := new soap_parameter (rst.url);\n"
"a_to.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:To\');\n"
"a_to.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"act := new soap_parameter (\'http://schemas.xmlsoap.org/security/RequestSecurityToken\');\n"
"act.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:Action\');\n"
"act.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"headers := vector_concat (act.get_call_param (\'\'), wsa_from.get_call_param (\'\'), m_id.get_call_param (\'\'),\n"
"a_to.get_call_param (\'\'), wsu_time.get_call_param (\'\'));\n"
"\n"
"connection_set (\'__soap_ws_trust_user\', policy.user_name);\n"
"connection_set (\'__soap_ws_trust_pass\', policy.user_pass);\n"
"\n"
"if (policy.debug = 1)\n"
"style := 1 + 2 + 16;\n"
"else\n"
"style := 1 + 16;\n"
"\n"
"param := vector (vector (\n"
"\'RequestSecurityToken\', \'http://schemas.xmlsoap.org/ws/2002/12/secext:RequestSecurityToken\'),\n"
"soap_box_structure (\'TokenType\', \'wsse:\' || policy.token_type,\n"
"\'RequestType\', \'wsse:\' || policy.usage));\n"
"\n"
"ret := SOAP_CLIENT (url=>rst.url, operation=>rst.operation, headers=>headers,\n"
"style=>style,\n"
"parameters=>param,\n"
"auth_type=>\'key\',\n"
"soap_action=>\'http://schemas.xmlsoap.org/security/RequestSecurityToken\',\n"
"template=>\'[func:DB.DBA.SOAP_WS_TRUST_XENC_TEMPLATE]\',\n"
"\n"
"security_type=>\'sign\');\n"
"\n"
"if (policy.debug = 1)\n"
"return ret;\n"
"\n"
"return cast(xpath_eval (\'/RequestSecurityTokenResponse/RequestedSecurityToken/BinarySecurityToken/text()\'\n"
", xml_tree_doc (ret)) as varchar);\n"
"}\n"
"--src wstrcli.sql:39\n";

static const char *proc280 = 
"create procedure WS_TRUST_REQ (in rst SOAP_CLIENT_REQ, in policy POLICY_STRUCT)\n"
"{\n"
"declare headers, ret, cli_cert_name any;\n"
"declare wsa_from, wsu_time, par, created, expr, m_id, a_to, act soap_parameter;\n"
"declare style integer;\n"
"\n"
"wsa_from := new soap_parameter ();\n"
"wsa_from.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:From\');\n"
"wsa_from.add_member (\'Address\', \'http://schemas.xmlsoap.org/ws/2003/03/addressing/role/anonymous\');\n"
"wsa_from.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"created := new soap_parameter (dt_set_tz (now (), 0));\n"
"created.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Created\');\n"
"created.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"expr := new soap_parameter (dt_set_tz (dateadd (\'minute\', 500, now ()), 0));\n"
"expr.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Expires\');\n"
"expr.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"wsu_time := new soap_parameter ();\n"
"wsu_time.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Timestamp\');\n"
"wsu_time.add_member (\'Created\', created);\n"
"wsu_time.add_member (\'Expires\', expr);\n"
"\n"
"m_id := new soap_parameter (lower (\'UUID:\'||uuid ()));\n"
"m_id.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:MessageID\');\n"
"m_id.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"a_to := new soap_parameter (rst.url);\n"
"a_to.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:To\');\n"
"a_to.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"act := new soap_parameter (\'http://weblogs.contoso.com/wse/samples/2003/07/AddEntry\');\n"
"act.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:Action\');\n"
"act.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"if (policy.debug = 2)\n"
"style := 1 + 2 + 16;\n"
"else\n"
"style := 1 + 16;\n"
"\n"
"cli_cert_name := get_certificate_info (8, decode_base64 (policy.token), 1);\n"
"\n"
"if (cli_cert_name is null)\n"
"signal (\'42000\', \'Cannot resolve issued security token.\');\n"
"\n"
"headers := vector_concat (act.get_call_param (\'\'), wsa_from.get_call_param (\'\'), m_id.get_call_param (\'\'),\n"
"a_to.get_call_param (\'\'), wsu_time.get_call_param (\'\'));\n"
"\n"
"return SOAP_CLIENT (url=>rst.url, operation=>rst.operation, headers=>headers, style=>style, security_type=>\'sign\',\n"
"parameters=>rst.parameters, auth_type=>\'key\', template=>\'[\' || cli_cert_name || \']\');\n"
"}\n"
"--src wstrcli.sql:116\n";

/* wstrsrv.sql */

static const char *proc281 = 
"create procedure WS.SOAP.RequestSecurityToken\n"
"(\n"
"in  \"RequestSecurityToken\" any := null __soap_type \'http://schemas.xmlsoap.org/ws/2002/12/secext:RequestSecurityToken\',\n"
"out RequestSecurityTokenResponse any __soap_type \'http://schemas.xmlsoap.org/ws/2002/12/secext:RequestSecurityTokenResponse\',\n"
"inout \"From\" any __soap_header \'http://schemas.xmlsoap.org/ws/2003/03/addressing:From\',\n"
"inout \"MessageID\" any __soap_header \'http://schemas.xmlsoap.org/ws/2003/03/addressing:MessageID\',\n"
"out \"RelatesTo\" any __soap_header \'http://schemas.xmlsoap.org/ws/2003/03/addressing:RelatesTo\',\n"
"out \"Timestamp\" any __soap_header \'http://schemas.xmlsoap.org/ws/2002/07/utility:Timestamp\',\n"
"inout \"To\" any __soap_header \'http://schemas.xmlsoap.org/ws/2003/03/addressing:To\'\n"
") __soap_doc \'__VOID__\'\n"
"\n"
"{\n"
"declare ret any;\n"
"declare in_m_id any;\n"
"declare param any;\n"
"declare mid, bsc_any any;\n"
"declare wsa_from, wsu_time, par, created, expr, m_id, a_to, releates_to, bsc, resp, headers soap_parameter;\n"
"\n"
"bsc_any := ws_trust_token_gen (\"From\", \"MessageID\", \"RequestSecurityToken\", \"Timestamp\", \"To\");\n"
"in_m_id := cast (\"MessageID\"[1][1] as varchar);\n"
"\n"
"wsa_from := new soap_parameter ();\n"
"wsa_from.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:From\');\n"
"wsa_from.add_member (\'Address\', \'http://\' || sys_connected_server_address () || http_map_get (\'domain\'));\n"
"wsa_from.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"created := new soap_parameter (dt_set_tz (now (), 0));\n"
"created.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Created\');\n"
"created.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"expr := new soap_parameter (dt_set_tz (dateadd (\'minute\', 500, now ()), 0));\n"
"expr.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Expires\');\n"
"expr.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"wsu_time := new soap_parameter ();\n"
"wsu_time.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/07/utility:Timestamp\');\n"
"wsu_time.add_member (\'Created\', created);\n"
"wsu_time.add_member (\'Expires\', expr);\n"
"\n"
"m_id := new soap_parameter (lower (\'UUID:\'||uuid ()));\n"
"m_id.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:MessageID\');\n"
"m_id.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"a_to := new soap_parameter (\'http://schemas.xmlsoap.org/ws/2003/03/addressing/role/anonymous\');\n"
"a_to.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:To\');\n"
"a_to.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"releates_to := new soap_parameter (in_m_id);\n"
"releates_to.set_xsd (\'http://schemas.xmlsoap.org/ws/2003/03/addressing:RelatesTo\');\n"
"releates_to.set_attribute (\'RelationshipType\', \'wsa:Response\' || uuid());\n"
"releates_to.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"bsc := new soap_parameter (bsc_any);\n"
"bsc.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/12/secext:BinarySecurityTokenType\');\n"
"bsc.set_attribute (\'ValueType\', \'wsse:X509v3\');\n"
"bsc.set_attribute (\'EncodingType\', \'wsse:Base64Binary\');\n"
"bsc.set_attribute (\'Id\', \'Id-\' || uuid());\n"
"\n"
"resp := new soap_parameter ();\n"
"resp.set_xsd (\'http://schemas.xmlsoap.org/ws/2002/12/secext:RequestSecurityTokenResponse\');\n"
"resp.add_member (\'TokenType\', \'wsse:X509v3\');\n"
"resp.add_member (\'RequestedSecurityToken\', vector (bsc.s));\n"
"\n"
"RequestSecurityTokenResponse := resp.s;\n"
"\"From\" := wsa_from.s;\n"
"\"MessageID\" := m_id.s;\n"
"\"Timestamp\" := wsu_time.s;\n"
"\"RelatesTo\" := releates_to.s;\n"
"\"To\" := a_to.s;\n"
"}\n"
"--src wstrsrv.sql:23\n";

static const char *other168 = 
"SOAP_LOAD_SCH (WSRM_WSS0212_XSD (), null, 0, 0)\n";
static const char *proc282 = 
"create procedure  DB.DBA.WS_TRUST_TOKEN_GEN (in \"From\" any, in \"MessageID\" any, in \"RequestSecurityToken\" any,\n"
"in \"Timestamp\" any, in \"To\" any)\n"
"{\n"
"declare ret any;\n"
"declare t_type, r_type, l_from varchar;\n"
"\n"
"if (__proc_exists (\'DB.DBA.WST_GET_SECURITY_TOKEN\'))\n"
"{\n"
"ret := call (\'DB.DBA.WST_GET_SECURITY_TOKEN\') (\"From\", \"MessageID\", \"RequestSecurityToken\", \"Timestamp\", \"To\");\n"
"return ret;\n"
"}\n"
"\n"
"t_type := cast (\"RequestSecurityToken\"[3] as varchar);\n"
"r_type := cast (\"RequestSecurityToken\"[5] as varchar);\n"
"l_from := cast (\"From\"[3] as varchar);\n"
"\n"
"select WSK_TOKEN into ret from WST_SERVER_ISSUER_TOKENS\n"
"where WSK_TOKEN_TYPE = t_type and WSK_REQUEST_TYPE = r_type and WSK_FROM = l_from;\n"
"\n"
"return ret;\n"
"}\n"
"--src wstrsrv.sql:98\n";

/* wsrmcall.xsl */

static const char *xsl27[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -  \n"
" -  $Id: wsrmcall.xsl,v 1.2 2006/08/15 22:09:21 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -  \n"
" -  Copyright (C) 1998-2006 OpenLink Software\n"
" -  \n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -  \n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -  \n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -  \n"
" -  \n"
"-->\n"
"<!DOCTYPE xsl:stylesheet [\n"
"<!ENTITY soapencuri \"http://schemas.xmlsoap.org/soap/encoding/\">\n"
"<!ENTITY soapenv \"http://schemas.xmlsoap.org/soap/envelope/\">\n"
"<!ENTITY xsiuri \"http://www.w3.org/2001/XMLSchema-instance\">\n"
"<!ENTITY xsduri \"http://www.w3.org/2001/XMLSchema\">\n"
"<!ENTITY wsa \"http://schemas.xmlsoap.org/ws/2003/03/addressing\">\n"
"<!ENTITY wsa1 \"http://schemas.xmlsoap.org/ws/2004/03/addressing\">\n"
"<!ENTITY wsa2 \"http://schemas.xmlsoap.org/ws/2004/08/addressing\">\n"
"<!ENTITY wsu \"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd\">\n"
"<!ENTITY wsse \"http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd\">\n"
"<!ENTITY ds \"http://www.w3.org/2000/09/xmldsig#\">\n"
"<!ENTITY xenc \"http://www.w3.org/2001/04/xmlenc#\">\n"
"]>\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\"\n"
"    xmlns:wsrm=\"http://schemas.xmlsoap.org/ws/2005/02/rm\"\n"
"    xmlns:soapenc=\"&soapencuri;\"\n"
"    xmlns:SOAP=\"&soapenv;\"\n"
"    xmlns:wsa=\"&wsa;\"\n"
"    xmlns:wsa1=\"&wsa1;\"\n"
"    xmlns:wsa2=\"&wsa2;\"\n"
"    xmlns:xsd=\"&xsduri;\"\n"
"    xmlns:xsi=\"&xsiuri;\"\n"
"    xmlns:wsu=\"&wsu;\"\n"
"    xmlns:wsse=\"&wsse;\"\n"
"    xmlns:ds=\"&ds;\"\n"
"    xmlns:xenc=\"&xenc;\"\n"
"    >\n"
"<xsl:output method=\"xml\" indent=\"yes\" omit-xml-declaration=\"yes\"/>\n"
"  <xsl:template match=\"/\">\n"
"    <xsl:apply-templates />\n"
"  </xsl:template>\n"
"  <xsl:template match=\"wsrm:*\" />\n"
"  <xsl:template match=\"*\">\n"
"    <xsl:copy>\n"
"      <xsl:copy-of select=\"@*\" />\n"
"      <xsl:apply-templates />\n"
"    </xsl:copy>\n"
"  </xsl:template>\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

/* cov_report.xsl */

static const char *xsl28[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: cov_report.xsl,v 1.3 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\" >\n"
"<xsl:output method=\"text\" indent=\"yes\" />\n"
"<xsl:param name=\"file_name\" />\n"
"<xsl:variable name=\"pad\" select=\"'        '\"/>\n"
"<xsl:template match=\"/\">\n"
"Lines: <xsl:value-of select=\"count (pl_stats/*[@file = $file_name]/line)\"/>\n"
"TotalLines: <xsl:value-of  select=\"sum (pl_stats/*[@file = $file_name]/@lct)\" />\n"
"Coverage: <xsl:value-of select=\"(100 * count (pl_stats/*[@file = $file_name]/line[number(@ctr) > 0])) div sum (pl_stats/*[@file = $file_name]/@lct)\" /> %\n"
"<xsl:text>\n"
"</xsl:text>\n"
"\n"
"<xsl:for-each select=\"pl_stats/*[@file = $file_name]\">\n"
"<xsl:sort select=\"concat(@file,line[1]/@no)\" order=\"ascending\"/>\n"
"<xsl:text>\n"
"</xsl:text>\n"
"<xsl:variable name=\"pcalls\" select=\"number(@calls)\" />\n"
"<xsl:value-of select=\"substring ($pad, 1, 8 - string-length ($pcalls))\"/>\n"
"<xsl:value-of select=\"$pcalls\"/> : <xsl:value-of select=\"@name\"/> <xsl:call-template name=\"cls_name\"/>: (<xsl:value-of select=\"@time\"/> msec)\n"
"<xsl:text>\n"
"        </xsl:text>\n"
"<xsl:for-each select=\"line\">\n"
"<xsl:sort select=\"@no\"/>\n"
"<xsl:variable name=\"lineno\" select=\"number(@no)\" />\n"
"<xsl:variable name=\"linectr\" select=\"number(@ctr)\" />\n"
"<xsl:value-of select=\"substring ($pad, 1, 6 - string-length ($lineno))\"/>\n"
"<xsl:choose>\n"
"<xsl:when test=\"number(@ctr) > 0\">\n"
"<xsl:value-of select=\"$lineno\"/> : <xsl:value-of select=\"substring ($pad, 1, 6 - string-length ($linectr))\"/><xsl:value-of select=\"$linectr\"/> : <xsl:value-of select=\".\"/>\n"
"<xsl:text>\n"
"        </xsl:text>\n"
"</xsl:when>\n"
"<xsl:otherwise>\n"
"<xsl:value-of select=\"$lineno\"/> :     ## : <xsl:value-of select=\".\"/><xsl:text>\n"
"        </xsl:text>\n"
"</xsl:otherwise>\n"
"</xsl:choose>\n"
"</xsl:for-each>\n"
"<xsl:text>\n"
"        </xsl:text>\n"
"<xsl:for-each select=\"caller\">\n"
"<xsl:sort select=\"@ct\"/>\n"
"<xsl:variable name=\"pct\" select=\"number(@ct)\" />\n"
"<xsl:value-of select=\"substring ($pad, 1, 6 - string-length ($pct))\"/>\n"
"<xsl:value-of select=\"$pct\"/> : <xsl:value-of select=\"@name\"/>\n"
"<xsl:text>\n"
"        </xsl:text>\n"
"</xsl:for-each>\n"
"</xsl:for-each>\n"
"</xsl:template>\n"
"<xsl:template name=\"cls_name\">\n"
"    <xsl:if test=\"@class\">\n"
"	<xsl:text> of </xsl:text> <xsl:value-of select=\"@class\"/><xsl:text> </xsl:text>\n"
"    </xsl:if>\n"
"</xsl:template>\n"
"</xsl:stylesheet>\n"
"\n"
"\n"
,
 NULL };

/* cov_time.xsl */

static const char *xsl29[]= {
"<?xml version=\"1.0\"?>\n"
"<!--\n"
" -\n"
" -  $Id: cov_time.xsl,v 1.4 2007/03/16 09:56:12 source Exp $\n"
" -\n"
" -  This file is part of the OpenLink Software Virtuoso Open-Source (VOS)\n"
" -  project.\n"
" -\n"
" -  Copyright (C) 1998-2007 OpenLink Software\n"
" -\n"
" -  This project is free software; you can redistribute it and/or modify it\n"
" -  under the terms of the GNU General Public License as published by the\n"
" -  Free Software Foundation; only version 2 of the License, dated June 1991.\n"
" -\n"
" -  This program is distributed in the hope that it will be useful, but\n"
" -  WITHOUT ANY WARRANTY; without even the implied warranty of\n"
" -  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n"
" -  General Public License for more details.\n"
" -\n"
" -  You should have received a copy of the GNU General Public License along\n"
" -  with this program; if not, write to the Free Software Foundation, Inc.,\n"
" -  51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA\n"
" -\n"
"-->\n"
"<xsl:stylesheet xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" version=\"1.0\" >\n"
"<xsl:output method=\"text\" indent=\"no\" />\n"
"<xsl:param name=\"files\"/>\n"
"<xsl:variable name=\"pad\" select=\"'              '\"/>\n"
"<xsl:variable name=\"lpad\" select=\"'                        '\"/>\n"
"<xsl:template match=\"/\">\n"
"    <xsl:text/> Flat profile (by self):<xsl:text>&#10;</xsl:text>\n"
"    <xsl:text/>    self                calls  name (average)<xsl:text>&#10;</xsl:text>\n"
"    <xsl:text/>    -----------------------------------------<xsl:text>&#10;</xsl:text>\n"
"<xsl:for-each select=\"pl_stats/proc|pl_stats/method\">\n"
"<xsl:sort select=\"format-number(number (@self), '000000000000.')\" order=\"descending\"/>\n"
"<xsl:variable name=\"tim\" select=\"format-number(number (@self), '.')\" />\n"
"<xsl:variable name=\"avg\" select=\"format-number(number (@self) div number (@calls), '.0000')\" />\n"
"<xsl:variable name=\"pcalls\" select=\"number(@calls)\" />\n"
"<xsl:value-of select=\"substring ($pad, 1, 14 - string-length ($tim))\"/>\n"
"<xsl:value-of select=\"$tim\"/>\n"
"<xsl:value-of select=\"substring ($pad, 1, 14 - string-length ($pcalls))\"/>\n"
"<xsl:value-of select=\"$pcalls\"/> : <xsl:value-of select=\"@name\"/> <xsl:call-template name=\"cls_name\"/> : (<xsl:value-of select=\"$avg\"/> msec)<xsl:text/><xsl:text>&#10;</xsl:text>\n"
"</xsl:for-each>\n"
"    <xsl:text>&#10;</xsl:text>\n"
"    <xsl:text>&#10;</xsl:text>\n"
"    <xsl:text/> Flat profile (by cumulative):<xsl:text>&#10;</xsl:text>\n"
"    <xsl:text/>    cumulative          calls  name (average)<xsl:text>&#10;</xsl:text>\n"
"    <xsl:text/>    -----------------------------------------<xsl:text>&#10;</xsl:text>\n"
"<xsl:for-each select=\"pl_stats/proc|pl_stats/method\">\n"
"<xsl:sort select=\"format-number(number (@time), '000000000000.')\" order=\"descending\"/>\n"
"<xsl:variable name=\"tim\" select=\"format-number(number (@time), '.')\" />\n"
"<xsl:variable name=\"avg\" select=\"format-number(number (@time) div number (@calls), '.0000')\" />\n"
"<xsl:variable name=\"pcalls\" select=\"number(@calls)\" />\n"
"<xsl:value-of select=\"substring ($pad, 1, 14 - string-length ($tim))\"/>\n"
"<xsl:value-of select=\"$tim\"/>\n"
"<xsl:value-of select=\"substring ($pad, 1, 14 - string-length ($pcalls))\"/>\n"
"<xsl:value-of select=\"$pcalls\"/> : <xsl:value-of select=\"@name\"/> <xsl:call-template name=\"cls_name\"/> : (<xsl:value-of select=\"$avg\"/> msec)<xsl:text/><xsl:text>&#10;</xsl:text>\n"
"</xsl:for-each>\n"
"\n"
"Coverage:\n"
"<xsl:variable name=\"src\" select=\".\"/>\n"
"file                             lines         total      coverage (%)\n"
"----------------------------------------------------------------------\n"
"<xsl:for-each select=\"$files/files/file\" >\n"
"    <xsl:variable name=\"file\" select=\"@name\"/>\n"
"    <xsl:variable name=\"lines\" select=\"count ($src/pl_stats/*[@file = $file]/line[number(@ctr) > 0])\"/>\n"
"    <xsl:variable name=\"total\" select=\"sum ($src/pl_stats/*[@file = $file]/@lct)\"/>\n"
"    <xsl:variable name=\"pct\" select=\"format-number((100 * $lines div $total), '.0000')\"/>\n"
"    <xsl:text/><xsl:value-of select=\"$file\"/>\n"
"    <xsl:value-of select=\"substring ($lpad, 1, 24 - string-length ($file))\"/>\n"
"    <xsl:text/>\n"
"    <xsl:value-of select=\"substring ($pad, 1, 14 - string-length ($lines))\"/>\n"
"    <xsl:value-of select=\"$lines\"/>\n"
"    <xsl:text/>\n"
"    <xsl:value-of select=\"substring ($pad, 1, 14 - string-length ($lines))\"/>\n"
"    <xsl:value-of  select=\"$total\" />\n"
"    <xsl:text/>\n"
"    <xsl:value-of select=\"substring ($pad, 1, 14 - string-length ($pct))\"/>\n"
"    <xsl:value-of select=\"$pct\" /><xsl:text>&#10;</xsl:text>\n"
"</xsl:for-each>\n"
"----------------------------------------------------------------------\n"
"</xsl:template>\n"
"<xsl:template name=\"cls_name\">\n"
"    <xsl:if test=\"@class\">\n"
"	<xsl:text> of </xsl:text> <xsl:value-of select=\"@class\"/><xsl:text> </xsl:text>\n"
"    </xsl:if>\n"
"</xsl:template>\n"
"<xsl:template match=\"*|@*|text()\"/>\n"
"</xsl:stylesheet>\n"
"\n"
,
 NULL };

static const char * xslt_define = "xslt_sheet (?, xtree_doc (?, 128, ?, 'LATIN-1', 'x-any', 'BuildStandalone=ENABLE'))";
static query_t *xslt_define_qr;

#define XSLT_DEFINE(name, text1) \
  { \
    caddr_t text = NULL;\
    static const char *elm;\
    int inx, len = 0;\
    for (inx = 0; ; inx++) { \
        elm = text1[inx];\
        if (!elm) break;\
        len += (int) strlen (elm);\
      }\
    text = dk_alloc_box (len + 1, DV_STRING);\
    text[0] = 0;\
    for (inx = 0; ; inx++) { \
        elm = text1[inx];\
        if (!elm) break;\
        strcat_box_ck (text, elm);\
      }\
    \
    if (!xslt_define_qr) \
      xslt_define_qr = sql_compile (xslt_define, bootstrap_cli, NULL, SQLC_DEFAULT); \
    if (xslt_define_qr) \
      { \
        caddr_t err = NULL; \
        err = qr_quick_exec (xslt_define_qr, bootstrap_cli, NULL, NULL, 3, \
               ":0", name, QRP_STR, ":1", text, QRP_STR, ":2", name, QRP_STR); \
        if (err) { \
          log_error ("Error executing a server init statement : %s: %s -- %.50s", \
          ((caddr_t *) err)[QC_ERRNO], ((caddr_t *) err)[QC_ERROR_STRING], \
                      text); \
          dk_free_tree (err); \
	    } \
	  local_commit (bootstrap_cli); \
      } \
    dk_free_box (text);\
  }

static int
sch_proc_def_exists (client_connection_t *cli, const char *proc_name)
{
  query_t *proc = NULL;
  char *full_name = sch_full_proc_name (isp_schema(NULL), proc_name,
	cli->cli_qualifier, CLI_OWNER (cli));
  if (full_name)
    proc = sch_proc_def (isp_schema(NULL), full_name);
  return (proc != NULL);
}

#define DEFINE_PROC(name, proc) \
   if (!sch_proc_def_exists (bootstrap_cli, (name))) \
     ddl_std_proc_1 (proc, 0x0, 1)


#define DEFINE_PUBLIC_PROC(name, proc) \
   if (!sch_proc_def_exists (bootstrap_cli, (name))) \
     ddl_std_proc_1 (proc, 0x1, 1)


#define DEFINE_OVERWRITE_PROC(name, proc) \
   ddl_std_proc_1 (proc, 0x1, 1)


static int
sch_udt_def_exists (client_connection_t *cli, const char *udt_name)
{
  sql_class_t *udt = sch_name_to_type (isp_schema (NULL), udt_name);
  if (udt &&  UDT_IS_INSTANTIABLE(udt))
    {
      return 1;
    }
  return 0;
}

#define DEFINE_UDT(name, udt) \
   if (!sch_udt_def_exists (bootstrap_cli, (name))) \
     ddl_ensure_table ("do this always", udt);


static void
udt_ensure_attribute (const char * udt_name, const char * attr, const char * text)
{
  sql_class_t *udt = sch_name_to_type (isp_schema (NULL), udt_name);
  if (udt &&  UDT_IS_INSTANTIABLE(udt))
    {
      caddr_t attr1 = sqlp_box_id_upcase (attr);
      if (-1 == udt_find_field (udt->scl_member_map, attr1))
        ddl_ensure_table ("do this always", text);
      dk_free_box (attr1);
    }
}
void
sqls_define (void)
{
  dbe_table_t *macro_tb;

  /* vsp_auth.sql */

  DEFINE_PROC ("islwsp", proc0);
  DEFINE_PROC ("issep", proc1);
  DEFINE_PROC ("skip_lwsp", proc2);
  DEFINE_PROC ("skip_sep", proc3);
  DEFINE_PROC ("skip_quote", proc4);
  DEFINE_PROC ("vsp_auth_next_tok", proc5);
  DEFINE_PROC ("vsp_auth_vec_compose", proc6); 
  DEFINE_PUBLIC_PROC ("vsp_auth_vec", proc7);
  DEFINE_PROC ("vsp_ua_skip_lwsp", proc8);
  DEFINE_PROC ("vsp_ua_match_hdr", proc9);
  DEFINE_PROC ("vsp_ua_prop_init", proc10); 
  DEFINE_PUBLIC_PROC ("vsp_calculate_digest", proc11);
  DEFINE_PROC ("vsp_ua_vec_init", proc12);
  DEFINE_PROC ("vsp_ua_get_prop", proc13); 
  DEFINE_PUBLIC_PROC ("vsp_ua_get_props", proc14);
  DEFINE_PROC ("vsp_ua_get_prop_list", proc15);
  DEFINE_PROC ("inc", proc16);
  DEFINE_PROC ("vsp_ua_prop_tbl", proc17);
  DEFINE_PROC ("vsp_ua_id", proc18);
  DEFINE_PROC ("vsp_ua_match_hdr_1", proc19);
  DEFINE_PROC ("vsp_ua_get_cookie_str", proc20);
  DEFINE_PROC ("vsp_ua_next_cookie", proc21); 
  DEFINE_PUBLIC_PROC ("vsp_ua_set_cookie", proc22);
  DEFINE_PROC ("vsp_ua_app_cookie", proc23); 
  DEFINE_PUBLIC_PROC ("vsp_auth_get", proc24); 
  DEFINE_PUBLIC_PROC ("vsp_auth_verify_pass", proc25);
  DEFINE_PROC ("vsp_ua_next_tok", proc26); 
  DEFINE_PUBLIC_PROC ("vsp_ua_get_cookie_vec", proc27); 
  DEFINE_PUBLIC_PROC ("vsp_ua_make_cookie", proc28);

  /* snapshot_repl.sql */

  ddl_ensure_table ("DB.DBA.SYS_SNAPSHOT", tbl0);
  ddl_ensure_column ("SYS_SNAPSHOT", "SN_LAST_UPD_BM", alter0, 0);
  ddl_ensure_table ("DB.DBA.SYS_SNAPSHOT_LOG", tbl1);
  DEFINE_PROC ("repl_undot_name", proc29);
  DEFINE_PROC ("REPL_OFFSET_TIME", proc30);
  DEFINE_PROC ("REPL_FQNAME", proc31);
  DEFINE_PROC ("REPL_ORIGIN", proc32);
  DEFINE_PROC ("REPL_SET_ORIGIN", proc33);
  ddl_ensure_table ("DB.DBA.SYS_SNAPSHOT_PUB", tbl2);
  ddl_ensure_table ("do this always", other0);
  ddl_ensure_table ("DB.DBA.SYS_SNAPSHOT_SUB", tbl3);
  ddl_ensure_table ("do this always", other1);
  ddl_ensure_table ("DB.DBA.SYS_SNAPSHOT_CR", tbl4);
  ddl_ensure_table ("do this always", other2);
  ddl_ensure_table ("DB.DBA.SYS_DAV_CR", tbl5);
  ddl_ensure_table ("do this always", other3);
  ddl_ensure_table ("DB.DBA.SYS_REPL_POSTPONED_RES", tbl6);
  DEFINE_PROC ("REPL_COLTYPE_PS", proc34);
  DEFINE_PROC ("REPL_COLTYPE", proc35);
  DEFINE_PROC ("REPL_REMOTE_TYPES_RAW", proc36);
  DEFINE_PROC ("REPL_REMOTE_TYPES", proc37);
  DEFINE_PROC ("REPL_PK_COLS", proc38);
  DEFINE_PROC ("REPL_ALL_COLS", proc39);
  DEFINE_PROC ("REPL_TBL_COLS", proc40);
  DEFINE_PROC ("REPL_COMPLETE_COLNAME", proc41);
  ddl_ensure_table ("WS.WS.RPLOG_SYS_DAV_RES", tbl7);
  DEFINE_PROC ("REPL_DAV_STORE_RES_INT", proc42);
  DEFINE_PROC ("REPL_DAV_STORE_RES", proc43);
  ddl_std_proc (trig0, 0x0);
  DEFINE_PROC ("REPL_DAV_SAVE_BACKUP", proc44);

  /* system.sql */

  ddl_ensure_table ("DB.DBA.SYS_VT_INDEX", tbl8); 
  DEFINE_PUBLIC_PROC ("SQL_PROCEDURE_COLUMNS", proc45); 
  DEFINE_PUBLIC_PROC ("XML_URI_RESOLVE_LIKE_GET", proc46);
  DEFINE_PROC ("XML_URI_GET_AND_CACHE", proc47); 
  DEFINE_PUBLIC_PROC ("XML_URI_PARSE_VIRT", proc48);
  DEFINE_PROC ("XML_URI_GET", proc49);
  DEFINE_PROC ("XML_URI_GET_STRING", proc50);
  DEFINE_PROC ("XML_URI_GET_STRING_OR_ENT", proc51);
  DEFINE_PROC ("XML_COLLECTION_DIR_LIST_LOCAL", proc52);
  DEFINE_PROC ("XML_COLLECTION_DIR_LIST_TABLE", proc53);
  DEFINE_PROC ("HTTP_GET_AUTH_INFO", proc54);
  DEFINE_PROC ("XML_COLLECTION_DIR_LIST_REMOTE", proc55);
  DEFINE_PROC ("XML_COLLECTION_DIR_LIST", proc56);
  ddl_ensure_table ("do this always", other4);
  DEFINE_PROC ("SYS_ALFANUM_NAME", proc57); 
  DEFINE_PUBLIC_PROC ("SYS_COPY_TABLE", proc58); 
  DEFINE_PUBLIC_PROC ("ddl_pk_fill_pk_parts", proc59); 
  DEFINE_PUBLIC_PROC ("ddl_pk_copy_inx", proc60); 
  DEFINE_PUBLIC_PROC ("ddl_pk_change_1", proc61); 
  DEFINE_PUBLIC_PROC ("ddl_pk_change_final", proc62); 
  DEFINE_PUBLIC_PROC ("ddl_pk_modify_check", proc63); 
  DEFINE_PUBLIC_PROC ("ddl_pk_is_changed", proc64); 
  DEFINE_PUBLIC_PROC ("ddl_pk_modify", proc65);
  DEFINE_PROC ("DB.DBA.fk_check_input_values", proc66);
  ddl_ensure_table ("do this always", other5);
  DEFINE_PROC ("DB.DBA.ddl_check_constraint", proc67);
  DEFINE_PROC ("ddl_fk_modify", proc68); 
  DEFINE_PUBLIC_PROC ("ddl_alter_constr", proc69);
  DEFINE_PROC ("ddl_unq_modify", proc70);
  DEFINE_PROC ("ddl_check_modify", proc71);
  DEFINE_PROC ("__HTTP_XSLT", proc72);
  DEFINE_PROC ("DB.DBA.ddl_fk_rules", proc73);
  DEFINE_PROC ("DB.DBA.ddl_pk_check_input", proc74);
  DEFINE_PROC ("execstr1", proc75);
  DEFINE_PROC ("DB.DBA.ddl_fk_check_input", proc76);
  DEFINE_PROC ("DB.DBA.col_check", proc77);
  ddl_ensure_table ("do this always", other6);
  ddl_ensure_table ("do this always", other7);
  ddl_ensure_table ("do this always", other8);
  ddl_ensure_table ("do this always", other9);
  ddl_ensure_table ("do this always", other10);
  ddl_ensure_table ("do this always", other11);
  ddl_ensure_table ("do this always", other12);
  ddl_ensure_table ("do this always", other13);
  ddl_ensure_table ("do this always", other14);
  ddl_ensure_table ("do this always", other15);
  ddl_ensure_table ("do this always", other16);
  ddl_ensure_table ("do this always", other17);
  ddl_ensure_table ("do this always", other18);
  ddl_ensure_table ("do this always", other19);
  ddl_ensure_table ("do this always", other20);
  ddl_ensure_table ("do this always", other21);
  ddl_ensure_table ("do this always", other22);
  ddl_ensure_table ("do this always", other23);
  ddl_ensure_table ("do this always", other24);
  ddl_ensure_table ("do this always", other25);
  ddl_ensure_table ("do this always", other26);
  ddl_ensure_table ("do this always", other27);
  ddl_ensure_table ("do this always", other28);
  ddl_ensure_table ("do this always", other29);
  ddl_ensure_table ("do this always", other30);
  ddl_ensure_table ("do this always", other31);
  ddl_ensure_table ("do this always", other32);
  ddl_ensure_table ("do this always", other33);
  ddl_ensure_table ("do this always", other34);
  ddl_ensure_table ("do this always", other35);
  ddl_ensure_table ("do this always", other36);
  ddl_ensure_table ("do this always", other37);
  ddl_ensure_table ("do this always", other38);
  ddl_ensure_table ("do this always", other39);
  ddl_ensure_table ("do this always", other40);
  DEFINE_PROC ("scheduler_init", proc78);
  ddl_ensure_table ("do this always", other41); 
  DEFINE_PUBLIC_PROC ("SYS_GENERATE_ALL_OPS", proc79); 
  DEFINE_PUBLIC_PROC ("SYS_GENERATE_ALL_VARS", proc80);
  ddl_ensure_table ("DB.DBA.SYS_STAT_VDB_MAPPERS", tbl9);/* AWK macro AWK AFTER*/
  ddl_ensure_table ("do this always", other42);/* AWK macro AWK AFTER*/
  ddl_ensure_table ("do this always", other43);
  DEFINE_PROC ("DB.DBA.__ORACLE_SYS_COL_STAT", proc81);
  DEFINE_PROC ("DB.DBA.__VIRTUOSO_SYS_COL_STAT", proc82);/* AWK macro AWK AFTER*/
  ddl_ensure_table ("do this always", other44);
  DEFINE_PROC ("DB.DBA.__INFORMIX_SYS_COL_STAT", proc83);
  DEFINE_PROC ("SYS_STAT_VDB_SYNC", proc84); 
  DEFINE_PUBLIC_PROC ("SYS_STAT_ANALYZE_VDB", proc85); 
  DEFINE_PUBLIC_PROC ("SYS_STAT_ANALYZE", proc86); 
  DEFINE_PUBLIC_PROC ("SYS_DB_STAT", proc87); 
  DEFINE_PUBLIC_PROC ("SYS_STAT_HISTOGRAM", proc88);
  ddl_ensure_table ("DB.DBA.SYS_SOAP_DATATYPES", tbl10);
  macro_tb = sch_name_to_table (isp_schema(NULL), "DB.DBA.SYS_SOAP_DATATYPES");
  if (macro_tb && tb_name_to_column (macro_tb, "SDT_TYPE"))  
  DEFINE_PROC ("soap_dt_define", proc90); 
  DEFINE_PUBLIC_PROC ("SET_IDENTITY_COLUMN", proc91); 
  DEFINE_PUBLIC_PROC ("GET_IDENTITY_COLUMN", proc92);
  ddl_ensure_table ("do this always", other46);
  DEFINE_PROC ("DAV_USER_SET_PASSWORD", proc93);/* AWK macro AWK PLBIF http_client*/
  DEFINE_PUBLIC_PROC ("DB.DBA.HTTP_CLIENT", proc94);/* AWK macro AWK PLBIF http_client_ext*/
  DEFINE_PUBLIC_PROC ("DB.DBA.HTTP_CLIENT_EXT", proc95);
  DEFINE_PROC ("vsmx_user_check", proc96); 
  DEFINE_PUBLIC_PROC ("DB.DBA.SOAP_VSMX", proc97);
  DEFINE_PROC ("WSDL_EXPAND", proc98); 
  DEFINE_PUBLIC_PROC ("DB.DBA.SOAP_WSDL_IMPORT", proc99);
  DEFINE_PROC ("FIND_WSDL", proc100);
  DEFINE_PROC ("WSDL_GET", proc101); 
  DEFINE_PUBLIC_PROC ("SQL_PROCEDURE_COLUMNSW", proc102);
  DEFINE_PROC ("DB.DBA.__XML_TEMPLATE", proc103); 
  DEFINE_PUBLIC_PROC ("DB.DBA.XQ_TEMPLATE", proc106); 
  DEFINE_PUBLIC_PROC ("DB.DBA.SQLX_OR_SPARQL_TEMPLATE", proc107);
  DEFINE_PROC ("cov_store", proc108);
  DEFINE_PROC ("cov_load", proc109);
  DEFINE_PROC ("cov_report", proc110);
  DEFINE_PROC ("vd_remote_proc_wrapper", proc111);
  ddl_ensure_table ("do this always", other50);
  DEFINE_PROC ("EXEC_STMT", proc112); 
  DEFINE_PUBLIC_PROC ("RSTMTEXEC", proc113);
  DEFINE_PROC ("WS.WS.DIR_INDEX_MAKE_XML", proc114);
  ddl_ensure_table ("do this always", other51);
  DEFINE_PROC ("WS.WS.DIR_INDEX_XML", proc115);
  DEFINE_PROC ("FTI_MAKE_SEARCH_STRING_INNER", proc116);
  DEFINE_PROC ("FTI_MAKE_SEARCH_STRING", proc117);
  ddl_ensure_table ("DB.DBA.CLR_VAC", tbl11);
  DEFINE_PROC ("exec_quiet", proc118); 
  DEFINE_UDT (case_mode == CM_UPPER ? "XMLTYPE" : "XMLType", udt0);
  ddl_ensure_table ("do this always", other53);
  ddl_ensure_table ("do this always", other54);
  ddl_ensure_table ("do this always", other55);
  ddl_ensure_table ("do this always", other56);
  ddl_ensure_table ("do this always", other57);
  ddl_ensure_table ("do this always", other58);
  ddl_ensure_table ("do this always", other59);
  ddl_ensure_table ("do this always", other60);
  ddl_ensure_table ("do this always", other61);
  ddl_ensure_table ("do this always", other62);
  ddl_ensure_table ("do this always", other63);
  ddl_ensure_table ("do this always", other64);
  ddl_ensure_table ("do this always", other65);
  ddl_ensure_table ("do this always", other66);
  ddl_ensure_table ("do this always", other67);
  ddl_ensure_table ("do this always", other68);
  ddl_ensure_table ("do this always", other69);
  ddl_ensure_table ("do this always", other70);
  ddl_ensure_table ("do this always", other71);
  ddl_ensure_table ("do this always", other72);
  ddl_ensure_table ("do this always", other73);
  ddl_ensure_table ("do this always", other74);
  ddl_ensure_table ("do this always", other75);
  ddl_ensure_table ("do this always", other76);
  ddl_ensure_table ("do this always", other77);
  ddl_ensure_table ("do this always", other78);
  ddl_ensure_table ("do this always", other79);
  ddl_ensure_table ("do this always", other80);
  ddl_ensure_table ("do this always", other81);
  ddl_ensure_table ("do this always", other82);
  ddl_ensure_table ("do this always", other83);
  ddl_ensure_table ("do this always", other84);
  ddl_ensure_table ("do this always", other85);
  ddl_ensure_table ("do this always", other86);
  ddl_ensure_table ("do this always", other87);
  ddl_ensure_table ("do this always", other88);
  ddl_ensure_table ("do this always", other89);
  ddl_ensure_table ("do this always", other90);
  ddl_ensure_table ("do this always", other91);
  DEFINE_PUBLIC_PROC ("createXML", proc119);
  ddl_ensure_table ("do this always", other92); 
  DEFINE_PUBLIC_PROC ("DB.DBA.SYS_CREATE_XML_SCHEMA", proc120); 
  DEFINE_PUBLIC_PROC ("DB.DBA.XML_COLUMN_SCHEMA_VALIDATE", proc121); 
  DEFINE_PUBLIC_PROC ("SYS_TREE_OF_ARRAYS_CONTAINS", proc122); 
  DEFINE_PUBLIC_PROC ("DB.DBA.SYS_DROP_XML_SCHEMA", proc123);/* AWK macro AWK PLBIF regexp_like*/
  DEFINE_PUBLIC_PROC ("REGEXP_LIKE", proc124);/* AWK macro AWK PLBIF regexp_replace*/
  DEFINE_PUBLIC_PROC ("REGEXP_REPLACE", proc125);/* AWK macro AWK PLBIF regexp_instr*/
  DEFINE_PUBLIC_PROC ("REGEXP_INSTR", proc126);/* AWK macro AWK PLBIF http_requested_url*/
  DEFINE_PUBLIC_PROC ("HTTP_REQUESTED_URL", proc127);/* AWK macro AWK PLBIF http_url_handler*/
  DEFINE_PUBLIC_PROC ("HTTP_URL_HANDLER", proc128);
  DEFINE_PROC ("DB.DBA.SERVICES_WSIL", proc129);
  DEFINE_PROC ("DB.DBA.SCHEDULER_NOTIFY", proc130);
  DEFINE_PROC ("SYS_CHECK_OLD_BLOG", proc131);
  ddl_ensure_table ("do this always", other93); 
  DEFINE_PUBLIC_PROC ("HTTP_GET_HOST", proc132); 
  DEFINE_PUBLIC_PROC ("date_rfc1123", proc133); 
  DEFINE_PUBLIC_PROC ("date_iso8601", proc134);
  DEFINE_PROC ("DB.DBA.INSTALLER_VAD", proc135);
  DEFINE_PROC ("DB.DBA.VACUUM", proc136);
  DEFINE_PROC ("tc_result", proc137);
  DEFINE_PROC ("tc_stat", proc138);

  /* system2.sql */

  DEFINE_PROC ("DB.DBA.SYS_INDEX_SPACE_STATS_PROC", proc139);
  ddl_ensure_table ("DB.DBA.SYS_INDEX_SPACE_STATS", view0); 
  DEFINE_PUBLIC_PROC ("DB.DBA.__VD_GET_SQLSTATS_COUNT", proc140); 
  DEFINE_PUBLIC_PROC ("DB.DBA.VD_STATISTICS", proc141); 
  DEFINE_PUBLIC_PROC ("DB.DBA.TABLE_SET_POLICY", proc142); 
  DEFINE_PUBLIC_PROC ("DB.DBA.TABLE_DROP_POLICY", proc143);
  ddl_ensure_table ("DB.DBA.ALL_COL_STAT", view1);
  ddl_ensure_table ("do this always", other94);
  ddl_ensure_table ("DB.DBA.USER_COL_STAT", view2);
  ddl_ensure_table ("do this always", other95);
  ddl_ensure_table ("DB.DBA.ALL_COL_HIST", view3);
  ddl_ensure_table ("do this always", other96);
  ddl_ensure_table ("DB.DBA.USER_COL_HIST", view4);
  ddl_ensure_table ("do this always", other97);
  DEFINE_PROC ("SINV_CREATE_INVERSE", proc144);
  DEFINE_PROC ("SINV_DROP_INVERSE", proc145);
  DEFINE_PROC ("SINV_CREATE_KEY_MAPPING", proc146);
  DEFINE_PROC ("SYS_CREATE_TABLE_AS", proc147);

  /* soap.sql */
 
  DEFINE_PUBLIC_PROC ("SOAP_CLIENT", proc148); 
  DEFINE_PUBLIC_PROC ("SOAP_ASYNC_CLIENT", proc149);
  DEFINE_PROC ("WSSE_GET_NS_INFO", proc150); 
  DEFINE_PUBLIC_PROC ("WSSE_OASIS_URI", proc151); 
  DEFINE_PUBLIC_PROC ("WSSU_OASIS_URI", proc152);
  DEFINE_PROC ("SOAP_DEFAULT_XENC_TEMPLATE", proc153);
  DEFINE_PROC ("SOAP_CLIENT_WSS", proc154); 
  DEFINE_PUBLIC_PROC ("wsrp_error", proc155);
  DEFINE_PROC ("WS_SOAP_GET_KEYINFO", proc156);
  DEFINE_PROC ("WS_SECURITY_CHECK", proc157);
  DEFINE_PROC ("WS_SECURITY_ADD", proc158); 
  DEFINE_PUBLIC_PROC ("WS_SOAP", proc159);
  ddl_ensure_table ("DB.DBA.WS_REFERRALS", tbl12);
  ddl_ensure_column ("DB.DBA.WS_REFERRALS", "R_STATIC", alter6, 0);
  DEFINE_PROC ("DB.DBA.WS_SOAP_RF_HEADER", proc160);
  DEFINE_PROC ("DB.DBA.WS_SOAP_RF_MESSAGE", proc161);
  DEFINE_PROC ("SOAP_LOAD_SCH", proc162); 
  DEFINE_PUBLIC_PROC ("DB.DBA.WSDL_SPLIT_NAME", proc163);
  ddl_ensure_table ("do this always", other98);
  ddl_ensure_table ("do this always", other99);
  DEFINE_PROC ("WSDL_IMPORT_TYPES", proc164);
  DEFINE_PROC ("EXECUTE_SCRIPT", proc165);
  DEFINE_PROC ("WSDL_IMPORT_UDT", proc166); 
  DEFINE_PUBLIC_PROC ("DB.DBA.XML_RPC_GET_PARAM_NAME", proc167);
  ddl_ensure_table ("do this always", other100);
  ddl_ensure_table ("do this always", other101); 
  DEFINE_PUBLIC_PROC ("DB.DBA.XML_RPC_DATE_CVT", proc168);
  ddl_ensure_table ("do this always", other102);
  ddl_ensure_table ("do this always", other103);
  DEFINE_PROC ("XMLRPC_MAKE_ERROR", proc169); 
  DEFINE_PUBLIC_PROC ("XMLRPC_SERVER", proc170);
  DEFINE_PROC ("XMLRPC2SOAP", proc171);
  DEFINE_PROC ("SOAP2XMLRPC", proc172); 
  DEFINE_PUBLIC_PROC ("XMLRPC_CALL", proc173); 
  DEFINE_PUBLIC_PROC ("SOAP12_ROUTER", proc174);
  DEFINE_PROC ("DB.DBA.SOAP_WS_TRUST_XENC_TEMPLATE", proc175);
  ddl_ensure_table ("DB.DBA.SYS_SOAP_UDT_PUB", tbl13);
  ddl_std_proc (trig1, 0x0);
  ddl_std_proc (trig2, 0x0);
  ddl_std_proc (trig3, 0x0);
  ddl_std_proc (trig4, 0x0); 
  DEFINE_PUBLIC_PROC ("GET_XSD_EXTENSION", proc176);
  ddl_ensure_table ("do this always", other104);
  ddl_ensure_table ("do this always", other105);
  DEFINE_PROC ("DB.DBA.WS_MIME_ENV", proc177);
  DEFINE_PROC ("DB.DBA.WS_MIME_RESP_C", proc178);
  DEFINE_PROC ("DB.DBA.WS_MIME_RESP", proc179);
  ddl_ensure_table ("do this always", other106);
  ddl_ensure_table ("do this always", other107);

  /* wsrp_ultim.xsl */

  XSLT_DEFINE ("http://local.virt/wsrp_ultim", xsl6);

  /* wsrp_resp.xsl */

  XSLT_DEFINE ("http://local.virt/wsrp_resp", xsl7);

  /* wsrp_interm.xsl */

  XSLT_DEFINE ("http://local.virt/wsrp_interm", xsl8);

  /* wsrp_error.xsl */

  XSLT_DEFINE ("http://local.virt/wsrp_error", xsl9);

  /* soap_sch.xsl */

  XSLT_DEFINE ("http://local.virt/soap_sch", xsl10);

  /* soap_import_sch.xsl */

  XSLT_DEFINE ("http://local.virt/soap_import_sch", xsl11);

  /* odbccat.sql */

  DEFINE_PROC ("sql_normalize_qon", proc180);
  DEFINE_PROC ("sql_filter_qon", proc181);
  DEFINE_PROC ("sql_columns", proc182);
  DEFINE_PROC ("sql_tables", proc183);
  DEFINE_PROC ("sql_primary_keys", proc184);
  DEFINE_PROC ("sql_statistics", proc185);
  DEFINE_PROC ("sql_procedures", proc186);
  DEFINE_PROC ("sql_procedure_cols", proc187);
  DEFINE_PROC ("__virt_sql_qon_is_oracle_oracle", proc188);
  DEFINE_PROC ("sql_normalize_qon_oracle_oracle", proc189);
  DEFINE_PROC ("sql_filter_qon_oracle_oracle", proc190);
  DEFINE_PROC ("sql_normalize_qon_oracle_msora", proc191);
  DEFINE_PROC ("sql_normalize_qon_infohub_dcsyb30", proc192);
  DEFINE_PROC ("sql_tables_pre_infohub_dcsyb30", proc193);
  DEFINE_PROC ("sql_tables_post_infohub_dcsyb30", proc194);
  DEFINE_PROC ("sql_columns_post_oracle_openlink", proc195);
  DEFINE_PROC ("sql_tables_post_progress_win_openlink", proc196);
  DEFINE_PROC ("sql_tables_post_excel_drv", proc197);
  DEFINE_PROC ("sql_tables_pre_excel_drv", proc198);
  DEFINE_PROC ("sql_normalize_qon_viaserv_opl", proc199);

  /* useraggr.sql */
 
  DEFINE_PUBLIC_PROC ("STD_COUNT", proc200); 
  DEFINE_PUBLIC_PROC ("STD11_INIT", proc201); 
  DEFINE_PUBLIC_PROC ("STD12_INIT", proc202); 
  DEFINE_PUBLIC_PROC ("STD13_INIT", proc203); 
  DEFINE_PUBLIC_PROC ("VAR_ACC", proc204); 
  DEFINE_PUBLIC_PROC ("VAR_POP_FIN", proc205); 
  DEFINE_PUBLIC_PROC ("VAR_SAMP_FIN", proc206); 
  DEFINE_PUBLIC_PROC ("VAR_FIN", proc207); 
  DEFINE_PUBLIC_PROC ("STDDEV_POP_FIN", proc208); 
  DEFINE_PUBLIC_PROC ("STDDEV_SAMP_FIN", proc209); 
  DEFINE_PUBLIC_PROC ("STDDEV_FIN", proc210); 
  DEFINE_PUBLIC_PROC ("COVAR_ACC", proc211); 
  DEFINE_PUBLIC_PROC ("COVAR_SAMP_FIN", proc212); 
  DEFINE_PUBLIC_PROC ("COVAR_POP_FIN", proc213); 
  DEFINE_PUBLIC_PROC ("COVAR_FIN", proc214);
  ddl_ensure_table ("do this always", other108);
  ddl_ensure_table ("do this always", other109);
  ddl_ensure_table ("do this always", other110);
  ddl_ensure_table ("do this always", other111);
  ddl_ensure_table ("do this always", other112);
  ddl_ensure_table ("do this always", other113);
  ddl_ensure_table ("do this always", other114);
  ddl_ensure_table ("do this always", other115);
  ddl_ensure_table ("do this always", other116); 
  DEFINE_PUBLIC_PROC ("REGR_SLOPE_INIT", proc215); 
  DEFINE_PUBLIC_PROC ("REGR_SLOPE_ACC", proc216); 
  DEFINE_PUBLIC_PROC ("REGR_SLOPE_FIN", proc217);
  ddl_ensure_table ("do this always", other117); 
  DEFINE_PUBLIC_PROC ("REGR_INTERCEPT_INIT", proc218); 
  DEFINE_PUBLIC_PROC ("REGR_INTERCEPT_ACC", proc219); 
  DEFINE_PUBLIC_PROC ("REGR_INTERCEPT_FIN", proc220);
  ddl_ensure_table ("do this always", other118); 
  DEFINE_PUBLIC_PROC ("REGR_COUNT_INIT", proc221); 
  DEFINE_PUBLIC_PROC ("REGR_COUNT_ACC", proc222); 
  DEFINE_PUBLIC_PROC ("REGR_COUNT_FIN", proc223); 
  DEFINE_PUBLIC_PROC ("REGR_COUNT_MERGE", proc224);
  ddl_ensure_table ("do this always", other119); 
  DEFINE_PUBLIC_PROC ("REGR_AVG_ACC", proc225); 
  DEFINE_PUBLIC_PROC ("REGR_AVGX_FIN", proc226); 
  DEFINE_PUBLIC_PROC ("REGR_AVGY_FIN", proc227);
  ddl_ensure_table ("do this always", other120);
  ddl_ensure_table ("do this always", other121); 
  DEFINE_PUBLIC_PROC ("CORR_INIT", proc228); 
  DEFINE_PUBLIC_PROC ("CORR_ACC", proc229); 
  DEFINE_PUBLIC_PROC ("CORR_FIN", proc230);
  ddl_ensure_table ("do this always", other122); 
  DEFINE_PUBLIC_PROC ("REGR_R2_INIT", proc231); 
  DEFINE_PUBLIC_PROC ("REGR_R2_ACC", proc232); 
  DEFINE_PUBLIC_PROC ("REGR_R2_FIN", proc233);
  ddl_ensure_table ("do this always", other123); 
  DEFINE_PUBLIC_PROC ("REGR_SXX_ACC", proc234); 
  DEFINE_PUBLIC_PROC ("REGR_SYY_ACC", proc235); 
  DEFINE_PUBLIC_PROC ("REGR_SXY_ACC", proc236); 
  DEFINE_PUBLIC_PROC ("REGR_S___FIN", proc237); 
  DEFINE_PUBLIC_PROC ("REGR_SXY_FIN", proc238);
  ddl_ensure_table ("do this always", other124);
  ddl_ensure_table ("do this always", other125);
  ddl_ensure_table ("do this always", other126); 
  DEFINE_PUBLIC_PROC ("xte_nodebld_final_root", proc239);
  ddl_ensure_table ("do this always", other127);
  ddl_ensure_table ("do this always", other128);
  ddl_ensure_table ("do this always", other129);
  ddl_ensure_table ("do this always", other130);

  /* wsdl_expand.xsl */

  XSLT_DEFINE ("http://local.virt/wsdl_expand", xsl14);

  /* wsdl_parts.xsl */

  XSLT_DEFINE ("http://local.virt/wsdl_parts", xsl15);

  /* wsdl_import.xsl */

  XSLT_DEFINE ("http://local.virt/wsdl_import", xsl16);

  /* xmlrpc_soap.xsl */

  XSLT_DEFINE ("http://local.virt/xmlrpc_soap", xsl17);

  /* soap_xmlrpc.xsl */

  XSLT_DEFINE ("http://local.virt/soap_xmlrpc", xsl18);

  /* soap12_router.xsl */

  XSLT_DEFINE ("http://local.virt/soap12_router", xsl19);

  /* wsrm_ddl.sql */

  DEFINE_UDT ("SOAP_CLIENT_REQ", udt1);
  DEFINE_UDT ("WSA_CLI", udt2);
  ddl_ensure_table ("do this always", other131);
  ddl_ensure_table ("DB.DBA.SYS_WSRM_IN_MESSAGE_LOG", tbl14);
  ddl_ensure_table ("DB.DBA.SYS_WSRM_IN_SEQUENCES", tbl15);
  ddl_std_proc (trig5, 0x0);
  ddl_ensure_table ("DB.DBA.SYS_WSRM_OUT_MESSAGE_LOG", tbl16);
  ddl_ensure_table ("DB.DBA.SYS_WSRM_OUT_SEQUENCES", tbl17);
  ddl_std_proc (trig6, 0x0);
  DEFINE_UDT (case_mode == CM_UPPER ? "SOAP_PARAMETER" : "soap_parameter", udt3);
  ddl_ensure_table ("do this always", other132);
  ddl_ensure_table ("do this always", other133);
  ddl_ensure_table ("do this always", other134);
  ddl_ensure_table ("do this always", other135);
  ddl_ensure_table ("do this always", other136);
  ddl_ensure_table ("do this always", other137);
  ddl_ensure_table ("do this always", other138);
  ddl_ensure_table ("do this always", other139);
  ddl_ensure_table ("do this always", other140);
  ddl_ensure_table ("do this always", other141);
  ddl_ensure_table ("do this always", other142);
  ddl_ensure_table ("do this always", other143);
  ddl_ensure_table ("do this always", other144);
  ddl_ensure_table ("do this always", other145);
  ddl_ensure_table ("do this always", other146);
  ddl_ensure_table ("do this always", other147);
  ddl_ensure_table ("do this always", other148);
  ddl_ensure_table ("do this always", other149);
  ddl_ensure_table ("do this always", other150);
  ddl_ensure_table ("do this always", other151);
  ddl_ensure_table ("do this always", other152);
  DEFINE_PROC ("WSRM_ENSURE_SCH", proc240);

  /* wsrm_xsd.sql */

  DEFINE_PROC ("WSRM_WSRM_XSD", proc241);
  DEFINE_PROC ("WSRM_WSP_XSD", proc242);
  DEFINE_PROC ("WSRM_WSA_XSD", proc243);
  DEFINE_PROC ("WSRM_UTILITY_XSD", proc244);
  DEFINE_PROC ("WSRM_UTILITY200306_XSD", proc245);
  DEFINE_PROC ("WSRM_WSS_XSD", proc246);
  DEFINE_PROC ("WSRM_WSS0212_XSD", proc247);
  DEFINE_PROC ("WSRM_WSA200403_XSD", proc248);
  DEFINE_PROC ("WSRM_OASIS200401WSSUTILITY_XSD", proc249);
  DEFINE_PROC ("WSRM_ORABPEL_XSD", proc250);
  DEFINE_PROC ("WSRM_WSRM_2005_02_XSD", proc251);
  DEFINE_PROC ("WSRM_WSA200408_XSD", proc252);

  /* wsrmcli.sql */

  DEFINE_UDT (case_mode == CM_UPPER ? "WSRM_CLI" : "wsrm_cli", udt4);
  ddl_ensure_table ("do this always", other154);
  ddl_ensure_table ("do this always", other155);
  ddl_ensure_table ("do this always", other156);
  macro_tb = sch_name_to_table (isp_schema(NULL), "DB.DBA.SYS_WSRM_OUT_SEQUENCES");
  if (macro_tb && tb_name_to_column (macro_tb, "WOS_LAST_SENT"))  
  ddl_ensure_table ("do this always", other157);
  ddl_ensure_table ("do this always", other158);
  ddl_ensure_table ("do this always", other159);
  ddl_ensure_table ("do this always", other160);
  macro_tb = sch_name_to_table (isp_schema(NULL), "DB.DBA.SYS_WSRM_OUT_SEQUENCES");
  if (macro_tb && tb_name_to_column (macro_tb, "WOS_LAST_SENT"))  
  ddl_ensure_table ("do this always", other161);
  ddl_ensure_table ("do this always", other162);
  ddl_ensure_table ("do this always", other163);
  ddl_ensure_table ("do this always", other164);
  DEFINE_PROC ("WSRM_CLIENT_POLICY", proc253);
  DEFINE_PROC ("WSRM_CLIENT", proc254);
  DEFINE_PROC ("WSRM_CLIENT_ERROR", proc255);
  DEFINE_PROC ("WSRM_RESENDER", proc256);
  DEFINE_PROC ("WSRM_ACKNOWLEDGEMENT_PROCESS", proc257);
  DEFINE_PROC ("WSRM_UPDATE_CLIENT_TABLES", proc258);
  DEFINE_PROC ("WSRM_CLIENT_ACKREQUESTED", proc259);
  DEFINE_PROC ("WSRM_CLIENT_ACKTERMINATE", proc260);
  ddl_ensure_table ("do this always", other165);
  DEFINE_PROC ("WSRM_CLIENT_SCHEDULED_TASKS", proc261);
  DEFINE_PROC ("WSRM_GET_IDENTIFIER", proc262);
  DEFINE_PROC ("WSA_REQ", proc263);

  /* wsrmsrv.sql */

  DEFINE_PROC ("WSRM_INIT", proc264);
  DEFINE_PROC ("WSRMSequence", proc265);
  DEFINE_PROC ("WSRMSequenceTerminate", proc266);
  DEFINE_PROC ("WSRMAckRequested", proc267);
  DEFINE_PROC ("WSRM_ACKNOWLEDGEMENT", proc268);
  DEFINE_PROC ("WSRM_SERVER_ERROR", proc269);
  DEFINE_PROC ("WSRM_CHECK_POLICY", proc270);
  DEFINE_PROC ("WSRM_MAKE_RANGES", proc271);
  DEFINE_PROC ("WSRM_ASYNC_ACK_SEND", proc272);
  DEFINE_PROC ("WSRM_ASYNC_PROCESS", proc273);
  ddl_ensure_table ("do this always", other167);
  DEFINE_PROC ("WSRM_SERVER_SCHEDULED_TASKS", proc274);
  DEFINE_PROC ("WSRMSequenceAcknowledgement", proc275);
  DEFINE_PROC ("WSRMCreateSequence", proc276);
  DEFINE_PROC ("TerminateSequence", proc277);

  /* wstr_ddl.sql */

  DEFINE_UDT ("POLICY_STRUCT", udt5);
  ddl_ensure_table ("DB.DBA.WST_SERVER_ISSUER_TOKENS", tbl18);

  /* wstrcli.sql */

  DEFINE_PROC ("WST_CLI", proc278);
  DEFINE_PROC ("WST_GETRST", proc279);
  DEFINE_PROC ("WS_TRUST_REQ", proc280);

  /* wstrsrv.sql */

  DEFINE_PROC ("WS.SOAP.RequestSecurityToken", proc281);
  ddl_ensure_table ("do this always", other168);
  DEFINE_PROC ("DB.DBA.WS_TRUST_TOKEN_GEN", proc282);

  /* wsrmcall.xsl */

  XSLT_DEFINE ("http://local.virt/wsrmcall", xsl27);

  /* cov_report.xsl */

  XSLT_DEFINE ("http://local.virt/cov_report", xsl28);

  /* cov_time.xsl */

  XSLT_DEFINE ("http://local.virt/cov_time", xsl29);
}


void
sqls_arfw_define (void)
{
  /* system.sql */

  ddl_ensure_column ("DB.DBA.SYS_VT_INDEX", "VI_ID_CONSTR", alter1, 0);
  ddl_ensure_column ("DB.DBA.SYS_VT_INDEX", "VI_OFFBAND_COLS", alter2, 0);
  ddl_ensure_column ("DB.DBA.SYS_VT_INDEX", "VI_OPTIONS", alter3, 0);
  ddl_ensure_column ("DB.DBA.SYS_VT_INDEX", "VI_LANGUAGE", alter4, 0);
  ddl_ensure_column ("DB.DBA.SYS_VT_INDEX", "VI_ENCODING", alter5, 0);
  DEFINE_PROC ("DB.DBA.SOAP_DATATYPES_UPGRADE", proc89);
  ddl_ensure_table ("do this always", other45);
  DEFINE_PROC ("soap_dt_define", proc90);
  ddl_ensure_table ("do this always", other47);
  DEFINE_PROC ("vt_upgrade_text_index", proc104);
  DEFINE_PROC ("VT_INDEX_UPGRADE", proc105);
  ddl_ensure_table ("do this always", other48);
  ddl_ensure_table ("do this always", other49);
  ddl_ensure_table ("do this always", other52);

  /* wsrm_ddl.sql */

  udt_ensure_attribute ("SOAP_CLIENT_REQ", "security_schema", alter7);
  ddl_ensure_column ("SYS_WSRM_OUT_MESSAGE_LOG", "OML_RESPONSE", alter8, 0);
  ddl_ensure_column ("SYS_WSRM_OUT_SEQUENCES", "WOS_LAST_SENT", alter9, 0);
  ddl_ensure_table ("do this always", other153);

  /* wsrmcli.sql */

  ddl_ensure_table ("do this always", other157);
  ddl_ensure_table ("do this always", other161);

  /* wsrmsrv.sql */

  ddl_ensure_table ("do this always", other166);

}


void
sqls_bif_init (void)
{

  pl_bif_name_define ("http_client");
  pl_bif_name_define ("http_client_ext");
  pl_bif_name_define ("regexp_like");
  pl_bif_name_define ("regexp_replace");
  pl_bif_name_define ("regexp_instr");
  pl_bif_name_define ("http_requested_url");
  pl_bif_name_define ("http_url_handler");
}
